Imports System.Data.OleDb
Imports System.IO
Imports TCV.Common
Imports System.Globalization
Imports System.Runtime.InteropServices

''' ---------------------------------------------
''' <summary>
''' ڍsc[
''' </summary>
''' <remarks>
''' Copyright 2010 FUJITSU SHIKOKU SYSTEMS LIMITED All rights reserved.<BR/>
''' FUJITSU SHIKOKU SYSTEMS LIMITED CONFIDENTIAL<BR/>
''' </remarks>
''' ---------------------------------------------
Public Class TCV010F010

#Region "ϐ"

	Private manager As Manager	'ǗNX

	Private Delegate Sub WriteLogDelegate(ByVal msg As String)			'Oo̓fQ[g
	Private logDelegate As WriteLogDelegate
	Private Delegate Sub SetProgressDelegate(ByVal value As Integer)	'is󋵐ݒfQ[g
	Private progressDelegate As SetProgressDelegate

	Private Shared _mutex As System.Threading.Mutex						'dN֎~Mutex
	Private Shared _appName As String = "Global\BT4TCV"					'V

'(A) STR V4-14027-000 016 20130510 ID)(f[^ڍsOf[^`FbNǉ)
	''' <summary>
	''' obNOEh[J敪i0=sA1=ڍssA2=f[^`FbNsj
	''' </summary>
	''' <remarks></remarks>
	Private Enum enumBackgroundWorker As Integer
		None = 0
		Convert = 1
		CheckData = 2
	End Enum
	Private eBackgroundWorker As enumBackgroundWorker = enumBackgroundWorker.None
	' G[f[^e[u
	Public Shared SyncLockObject As New Object
	Public Shared dtErrorTable As DataTable
	Public ReadOnly CST_ERRORITEM() As String = {"", "敪", "Ҕԍ", "", "Ȕ", "e[u", "tB[h", "e", "ϊOl", "ϊl", "e[uR"}
'(A) END V4-14027-000 016 20130510

#End Region

#Region "RXgN^"

	''' -------------------------------------------
	''' <summary>
	''' RXgN^
	''' </summary>
	''' <remarks>
	''' 2010/11/25 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' -------------------------------------------
	Public Sub New()
		' ̌ĂяóAWindows tH[ fUCiŕKvłB
		InitializeComponent()

		' InitializeComponent() Ăяǒŏǉ܂B

		txt013TCV010F010.ReadOnly = True					'T[o
		txt015TCV010F010.ReadOnly = True					'pX[h

		logDelegate = New WriteLogDelegate(AddressOf writeLog)
		progressDelegate = New SetProgressDelegate(AddressOf setProgress)
	End Sub

#End Region

#Region "Win32 API"

	<DllImport("USER32.DLL")> _
	Private Shared Function _
 GetSystemMenu(ByVal hWnd As IntPtr, ByVal bRevert As Integer) As IntPtr
	End Function

	<DllImport("USER32.DLL")> _
	Private Shared Function _
 RemoveMenu(ByVal hMenu As IntPtr, ByVal nPosition As Integer, ByVal wFlags As Integer) As Integer
	End Function

#End Region

#Region "Cxg"

	''' -------------------------------------------
	''' <summary>
	''' tH[N[WO
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/25 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' -------------------------------------------
	Private Sub TCV010F010_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
		Try
'(M) STR V4-14027-000 006 20130510 ID)(f[^ڍsOf[^`FbNǉ)
'			If manager IsNot Nothing AndAlso manager.isWorkerBusy() Then
			If manager IsNot Nothing AndAlso
				((eBackgroundWorker = enumBackgroundWorker.Convert AndAlso manager.isWorkerBusy()) OrElse
				 (eBackgroundWorker = enumBackgroundWorker.CheckData AndAlso manager.isCWorkerBusy())) Then
'(M) END V4-14027-000 006 20130510
				If MessageBox.Show("łBLZāAʂ܂B낵łH", "mFbZ[W", MessageBoxButtons.OKCancel) = Windows.Forms.DialogResult.Cancel Then
					e.Cancel = True
					Exit Sub
				End If
			End If
		Catch ex As Exception
			MessageBox.Show(ex.Message & vbCrLf & ex.StackTrace)
		End Try
	End Sub

	''' -------------------------------------------
	''' <summary>
	''' [hCxg
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/25 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' -------------------------------------------
	Private Sub TCV010F010_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		Try
			'2dN`FbN
			If chkMutex() = False Then											'Mutex`FbN
				MsgBox("AvP[V𑽏dNł܂(X0003)")
				Me.Close()
			End If

			'u~v{^𖳌邽߂̒l
			Dim SC_CLOSE As Integer = &HF060
			Dim MF_BYCOMMAND As Integer = &H0
			' Rg[{bNX́mn{^̖
			Dim hMenu As IntPtr = GetSystemMenu(Me.Handle, 0)
			RemoveMenu(hMenu, SC_CLOSE, MF_BYCOMMAND)

			'ǗNX
			Me.manager = New Manager(Me)

			'V3DBfBNgݒ
			Dim v3dir As String = Me.manager.getV3dir()
			If Directory.Exists(v3dir) Then
				Me.txt008TCV010F010.Text = v3dir
			End If

			'Configt@Cǂݍ
			Dim loadSetting As Boolean = True
			Me.manager.loadConfig()
			If Me.manager.BT4Config Is Nothing Then
				MessageBox.Show("ɕKvȃt@C݂Ȃ߁Ał܂" & _
				 "Kvȃt@CF" & clsTCVConfig.getConfigPath, "G[")
				loadSetting = False
			Else
				If String.IsNullOrEmpty(Me.manager.BT4Config.DS) OrElse String.IsNullOrEmpty(Me.manager.BT4Config.IC) Then
					MessageBox.Show("ɕKvȏ񂪂Ȃ߁Ał܂" & _
					 "KvȏFf[^x[X")
					loadSetting = False
				End If
			End If

			'ǂݍ񂾐ݒlʂɔf
			If loadSetting Then
				Me.initCtl()
				Me.txt013TCV010F010.Text = Me.manager.BT4Config.DS
				Me.txt015TCV010F010.Text = Me.manager.BT4Config.IC
				My.Application.Log.DefaultFileLogWriter.CustomLocation = Me.manager.BT4Config.LogDir
			Else
				Me.btn004TCV010F010.Enabled = False
				Me.btn020TCV010F010.Enabled = False
'(A) STR V4-14027-000 005 20130510 ID)(f[^ڍsOf[^`FbNǉ)
				Me.chk024TCV010F010.Enabled = False
				Me.chk025TCV010F010.Enabled = False
				Me.btn026TCV010F010.Enabled = True
'(A) END V4-14027-000 005 20130510
				Me.lbl018TCV010F010.Text = ""
			End If

			'tH_I{^C[Wݒ
			Dim clibmp As New clsTCVBmp
			Me.btn009TCV010F010.Image = clibmp.getBmp(clsTCVBmp.Enum_BmpType.OpenFolder)

			'^Cgݒ
			Me.setTitle()
		Catch ex As Exception
			MessageBox.Show(ex.Message & vbCrLf & ex.StackTrace)
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' [a叫uRf[^i[挟]
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/25 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btn009TCV010F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn009TCV010F010.Click
		Dim cliTcvCom As clsTCVCom = Nothing
		Try
			cliTcvCom = New clsTCVCom
			If cliTcvCom.setFolderDialog(Me.txt008TCV010F010) = Windows.Forms.DialogResult.OK Then
				'manager.setV3Dir(Me.txt008TCV010F010.Text)
			End If
		Catch ex As Exception
			MessageBox.Show(ex.Message & vbCrLf & ex.StackTrace)
		Finally
			cliTcvCom = Nothing
		End Try
	End Sub

'(A) STR V4-14027-000 026 20130510 ID)(f[^ڍsOf[^`FbNǉ)
	''' ---------------------------------------------
	''' <summary>
	''' [f[^`FbN]
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2013/05/10 VK쐬@ID)<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btn026TCV010F010_Click(sender As System.Object, e As System.EventArgs) Handles btn026TCV010F010.Click
		Try
			' G[e[u
			dtErrorTable = New DataTable
			For Each Str As String In CST_ERRORITEM
				dtErrorTable.Columns.Add(Str)
			Next
			' f[^`FbN
			Me.checkProc()
		Catch ex As Exception
			Me.initCtl()
			MessageBox.Show(ex.Message & vbCrLf & ex.StackTrace)
		End Try
	End Sub
'(A) END V4-14027-000 026 20130510

	''' ---------------------------------------------
	''' <summary>
	''' [ϊ]
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/25 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btn004TCV010F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn004TCV010F010.Click
		Try
			Me.ExecProc()
		Catch ex As Exception
			MessageBox.Show(ex.Message & vbCrLf & ex.StackTrace)
'(A) STR V4-14027-000 003 20130510 ID)(f[^ڍsOf[^`FbNǉ)
			Me.initCtl()
'(A) END V4-14027-000 003 20130510
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' [LZ]
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/25 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btn020TCV010F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn020TCV010F010.Click
		Try
			If MessageBox.Show("łBLZ܂H", "mFbZ[W", MessageBoxButtons.OKCancel) = Windows.Forms.DialogResult.OK Then
				cancelCtl()
'(M) STR V4-14027-000 008 20130510 ID)(f[^ڍsOf[^`FbNǉ)
'				manager.convertCancel()
				If eBackgroundWorker = enumBackgroundWorker.Convert Then
					manager.convertCancel()
				ElseIf eBackgroundWorker = enumBackgroundWorker.CheckData Then
					manager.CheckDataCancel()
				End If
'(M) END V4-14027-000 008 20130510
			End If
		Catch ex As Exception
			MessageBox.Show(ex.Message & vbCrLf & ex.StackTrace)
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' [I]
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/25 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btn005TCV010F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn005TCV010F010.Click
		Try
			Me.EndProc()
		Catch ex As Exception
			MessageBox.Show(ex.Message & vbCrLf & ex.StackTrace)
		End Try
	End Sub

#End Region

#Region "\bh"

	''' ---------------------------------------------
	''' <summary>
	''' Rg[\
	''' </summary>
	''' <remarks>
	''' 2010/11/25 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub initCtl()
		Try
			lbl018TCV010F010.Text = "IĂ"
			pgb019TCV010F010.Value = 0

			btn009TCV010F010.Enabled = True						'V23tH_I
'(M) STR V4-14027-000 013 20130510 ID)(f[^ڍsOf[^`FbNǉ)
'			btn004TCV010F010.Enabled = True						'V23DB
			If manager.BT4Config IsNot Nothing Then
				btn004TCV010F010.Enabled = True					'V23DB
				Me.chk024TCV010F010.Enabled = True
				Me.chk025TCV010F010.Enabled = True
			Else
				btn004TCV010F010.Enabled = False				'V23DB
				Me.chk024TCV010F010.Enabled = False
				Me.chk025TCV010F010.Enabled = False
			End If
			btn026TCV010F010.Enabled = True						'f[^`FbN
'(M) END V4-14027-000 013 20130510

			btn020TCV010F010.Enabled = False					'LZ
			btn005TCV010F010.Enabled = True						'I
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ----------------------------------------------
	''' <summary>
	''' MutexɂdN`FbN
	''' </summary>
	''' <returns>
	''' True=OK
	''' False=NG
	''' </returns>
	''' <remarks>
	''' 2011/01/04 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' ----------------------------------------------
	Private Function chkMutex() As Boolean
		Dim bRet As Boolean = True

		Try
			_mutex = New System.Threading.Mutex(False, _appName)
			If _mutex.WaitOne(0, False) = True Then							'
				bRet = True
			Else															'dN
				bRet = False
			End If
			GC.KeepAlive(_mutex)											'AvI܂Mutexێ
		Catch ex As Exception												'dN
			bRet = False
		End Try

		Return bRet
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' ̃Rg[\
	''' </summary>
	''' <remarks>
	''' 2010/11/25 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub actionCtl()
		Try
			lbl018TCV010F010.Text = ""
			txt021TCV010F010.Clear()

			btn009TCV010F010.Enabled = False					'V23tH_I
			btn004TCV010F010.Enabled = False					'V23DB
'(A) STR V4-14027-000 005 20130510 ID)(f[^ڍsOf[^`FbNǉ)
			chk024TCV010F010.Enabled = False
			chk025TCV010F010.Enabled = False
			btn026TCV010F010.Enabled = False					'f[^`FbN
'(A) END V4-14027-000 005 20130510

			btn020TCV010F010.Enabled = True						'LZ
			btn005TCV010F010.Enabled = False					'I
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' Rg[̖
	''' </summary>
	''' <remarks>
	''' 2010/11/25 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub cancelCtl()
		Try
			lbl018TCV010F010.Text = "LZ"

			btn009TCV010F010.Enabled = False					'V23tH_I
			btn004TCV010F010.Enabled = False					'V23DB
'(A) STR V4-14027-000 005 20130510 ID)(f[^ڍsOf[^`FbNǉ)
			chk024TCV010F010.Enabled = False
			chk025TCV010F010.Enabled = False
			btn026TCV010F010.Enabled = False					'f[^`FbN
'(A) END V4-14027-000 005 20130510

			btn020TCV010F010.Enabled = False					'LZ
			btn005TCV010F010.Enabled = False					'I
		Catch ex As Exception
			Throw
		End Try
	End Sub

'(A) STR V4-14027-000 048 20130510 ID)(f[^ڍsOf[^`FbNǉ)
	''' ---------------------------------------------
	''' <summary>
	''' ̓`FbNif[^`FbNj
	''' </summary>
	''' <returns>G[΁Afalse</returns>
	''' <remarks>
	''' 2013/05/10 VK쐬@ID)<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function ChkDataBeforeConvert() As Boolean
		Try
			If String.IsNullOrEmpty(Me.txt008TCV010F010.Text) Then
				MessageBox.Show("a叫uR̃f[^i[w肵Ă")
				Return False
			Else
				If Not Directory.Exists(Me.txt008TCV010F010.Text) Then
					MessageBox.Show("a叫uR̃f[^i[œ͂pX݂܂")
					Return False
				Else
					If Not File.Exists(My.Computer.FileSystem.CombinePath(Me.txt008TCV010F010.Text, "BT3DINF1.mdb")) OrElse _
					   Not File.Exists(My.Computer.FileSystem.CombinePath(Me.txt008TCV010F010.Text, "BT3DINF2.mdb")) OrElse _
					   Not File.Exists(My.Computer.FileSystem.CombinePath(Me.txt008TCV010F010.Text, "BT3DINF3.mdb")) OrElse _
					   Not File.Exists(My.Computer.FileSystem.CombinePath(Me.txt008TCV010F010.Text, "BT3DMAST.mdb")) OrElse _
					   Not File.Exists(My.Computer.FileSystem.CombinePath(Me.txt008TCV010F010.Text, "BT3DKSDS.mdb")) OrElse _
					   Not File.Exists(My.Computer.FileSystem.CombinePath(Me.txt008TCV010F010.Text, clsTCVIni.CST_BT3INI_FILENAME)) Then
						MessageBox.Show("uRf[^i[ɕKvȃt@C݂܂" & vbCrLf & _
						 "[BT3DINF1.mdb],[BT3DINF2.mdb],[BT3DINF3.mdb],[BT3DMAST.mdb],[BT3DKSDS.mdb],[" & clsTCVIni.CST_BT3INI_FILENAME & "]")
						Return False
					End If
				End If
			End If
			If manager.tableCheck() = False Then
				MessageBox.Show("a叫uR̃f[^ɕKvȃe[u݂܂")
				Return False
			End If
			If MessageBox.Show("a叫uR̃f[^`FbNs܂B낵łH", "mFbZ[W", MessageBoxButtons.OKCancel) = Windows.Forms.DialogResult.Cancel Then
				'LZ
				Return False
			End If

			'
			Return True
		Catch ex As Exception
			Throw
		End Try
	End Function
'(A) END V4-14027-000 048 20130510

	''' ---------------------------------------------
	''' <summary>
	''' ̓`FbN
	''' </summary>
	''' <returns>G[΁Afalse</returns>
	''' <remarks>
	''' 2010/11/25 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function ChkData() As Boolean
		Try
			If String.IsNullOrEmpty(Me.txt008TCV010F010.Text) Then
				MessageBox.Show("a叫uR̃f[^i[w肵Ă")
				Return False
			Else
				If Not Directory.Exists(Me.txt008TCV010F010.Text) Then
					MessageBox.Show("a叫uR̃f[^i[œ͂pX݂܂")
					Return False
				Else
'(M) STR V4-11019-000 018 20110812 FJSK)r XXX a叫V4PKG_No93 obNAbvǉiBT4Backup.Config,BT3.INI)Ή
'					If Not File.Exists(My.Computer.FileSystem.CombinePath(Me.txt008TCV010F010.Text, "BT3DINF1.mdb")) OrElse _
'					   Not File.Exists(My.Computer.FileSystem.CombinePath(Me.txt008TCV010F010.Text, "BT3DINF2.mdb")) OrElse _
'					   Not File.Exists(My.Computer.FileSystem.CombinePath(Me.txt008TCV010F010.Text, "BT3DINF3.mdb")) OrElse _
'					   Not File.Exists(My.Computer.FileSystem.CombinePath(Me.txt008TCV010F010.Text, "BT3DMAST.mdb")) OrElse _
'					   Not File.Exists(My.Computer.FileSystem.CombinePath(Me.txt008TCV010F010.Text, "BT3DKSDS.mdb")) OrElse _
'					   Not File.Exists(My.Computer.FileSystem.CombinePath(Me.txt008TCV010F010.Text, "BT3.INI")) Then
					If Not File.Exists(My.Computer.FileSystem.CombinePath(Me.txt008TCV010F010.Text, "BT3DINF1.mdb")) OrElse _
					   Not File.Exists(My.Computer.FileSystem.CombinePath(Me.txt008TCV010F010.Text, "BT3DINF2.mdb")) OrElse _
					   Not File.Exists(My.Computer.FileSystem.CombinePath(Me.txt008TCV010F010.Text, "BT3DINF3.mdb")) OrElse _
					   Not File.Exists(My.Computer.FileSystem.CombinePath(Me.txt008TCV010F010.Text, "BT3DMAST.mdb")) OrElse _
					   Not File.Exists(My.Computer.FileSystem.CombinePath(Me.txt008TCV010F010.Text, "BT3DKSDS.mdb")) OrElse _
					   Not File.Exists(My.Computer.FileSystem.CombinePath(Me.txt008TCV010F010.Text, clsTCVIni.CST_BT3INI_FILENAME)) Then
						'MessageBox.Show("uRf[^i[ɕKvȃt@C݂܂" & vbCrLf & _
						' "[BT3DINF1.mdb],[BT3DINF2.mdb],[BT3DINF3.mdb],[BT3DMAST.mdb],[BT3DKSDS.mdb],[BT3.INI]")
						MessageBox.Show("uRf[^i[ɕKvȃt@C݂܂" & vbCrLf & _
						 "[BT3DINF1.mdb],[BT3DINF2.mdb],[BT3DINF3.mdb],[BT3DMAST.mdb],[BT3DKSDS.mdb],[" & clsTCVIni.CST_BT3INI_FILENAME & "]")
'(M) END V4-11019-000 018 20110812
						Return False
					End If
				End If
			End If
'(A) STR V4-14021-000 007 20130423 ID)(ڍsΏہif[^A}X^jI\ƂΉ)
			If Not Me.chk024TCV010F010.Checked AndAlso _
				Not Me.chk025TCV010F010.Checked Then
				MessageBox.Show("ڍsΏۂIĂ܂")
				Return False
			End If
'(A) END V4-14021-000 007 20130423

			If manager.tableCheck() = False Then
				MessageBox.Show("a叫uR̃f[^ɕKvȃe[u݂܂")
				Return False
			End If

			If MessageBox.Show("uRuSɃf[^ڍs܂B낵łH", "mFbZ[W", MessageBoxButtons.OKCancel) = Windows.Forms.DialogResult.Cancel Then
				'LZ
				Return False
			End If

			'
			Return True
		Catch ex As Exception
			Throw
		End Try
	End Function

'(A) STR V4-14027-000 046 20130510 ID)(f[^ڍsOf[^`FbNǉ)
	''' ---------------------------------------------
	''' <summary>
	''' f[^`FbN̊s
	''' </summary>
	''' <param name="isCancel">LZł΁AtrueiftHgFfalsej</param>
	''' <remarks>
	''' 2013/05/10 VK쐬@ID)<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Sub CheckDataCompleted(Optional ByVal isCancel As Boolean = False)
		Try
			eBackgroundWorker = enumBackgroundWorker.None
			Me.initCtl()

			If isCancel Then
				Me.btn026TCV010F010.Focus()
				MessageBox.Show("a叫uR̃f[^`FbNLZ܂B")
			Else
				Me.btn005TCV010F010.Focus()
				' G[H
				If dtErrorTable IsNot Nothing AndAlso dtErrorTable.Rows.Count > 0 Then
					Dim strCsvPath As String
					Dim strDefaultCsvPath As String = Path.GetDirectoryName(Application.StartupPath) & "\CSV"
					If Directory.Exists(strDefaultCsvPath) Then
						'CSVtH_[݂ꍇ
						strCsvPath = strDefaultCsvPath
					Else
						'CSVtH_[݂ȂꍇExepX
						strCsvPath = Path.GetDirectoryName(Application.ExecutablePath)
					End If
					' brut@Co
					WriteCsvFile("ConvertWarningList.CSV", strCsvPath)
				Else
					MessageBox.Show("a叫uR̃f[^`FbNI")
				End If
			End If
		Catch ex As IOException
			MessageBox.Show(ex.Message & vbCrLf & ex.StackTrace)
			Me.initCtl()
		Catch ex As Exception
			MessageBox.Show(ex.Message & vbCrLf & ex.StackTrace)
			Me.initCtl()
		End Try
	End Sub
'(A) END V4-14027-000 046 20130510

	''' ---------------------------------------------
	''' <summary>
	''' ϊ̊s
	''' </summary>
	''' <param name="isCancel">LZł΁AtrueiftHgFfalsej</param>
	''' <remarks>
	''' 2010/11/25 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Sub convertCompleted(Optional ByVal isCancel As Boolean = False)
		Try
'(A) STR V4-14027-000 003 20130510 ID)(f[^ڍsOf[^`FbNǉ)
			eBackgroundWorker = enumBackgroundWorker.None
'(A) END V4-14027-000 003 20130510
			Me.initCtl()

'(M) STR V4-14006-000 018 20130410 ID)(IƃLZĨbZ[W𕪂)
'			If isCancel Then
'				Me.btn004TCV010F010.Focus()
'			Else
'				Me.btn005TCV010F010.Focus()
'			End If

'			MessageBox.Show("f[^ڍsI܂B")
			If isCancel Then
				Me.btn004TCV010F010.Focus()
'(M) STR V4-14027-001 008 20130704 ID)(f[^ڍsOf[^`FbNǉ)
'				MessageBox.Show("f[^ڍsLZ܂B" & ControlChars.CrLf & ControlChars.CrLf &
'								"ӁI@f[^x[Xɂ͎s̃f[^cĂ܂B" & ControlChars.CrLf &
'								"ĎsɏčĈڍs܂B")
				MessageBox.Show("ڍsLZ܂B" & ControlChars.CrLf & ControlChars.CrLf &
								"ӁI@f[^x[Xɂ͎s̃f[^cĂ܂B" & ControlChars.CrLf &
								"ĎsɏčĈڍs܂B")
'(M) END V4-14027-001 008 20130704
			Else
				Me.btn005TCV010F010.Focus()
'(M) STR V4-14027-001 004 20130704 ID)(f[^ڍsOf[^`FbNǉ)
'				MessageBox.Show("f[^ڍsI܂B")
				MessageBox.Show("ڍsI܂B")
'(M) END V4-14027-001 004 20130704
			End If
'(M) END V4-14006-000 018 20130410
		Catch ex As Exception
'(M) STR V4-14027-000 004 20130514 ID)(f[^ڍsOf[^`FbNǉ)
'			Throw
			MessageBox.Show(ex.Message & vbCrLf & ex.StackTrace)
'(M) END V4-14027-000 004 20130514
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' ʂɃOo͂
	''' </summary>
	''' <param name="msg">bZ[W</param>
	''' <remarks>
	''' 2010/11/25 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Sub writeLog(ByVal msg As String)
		Try
			If InvokeRequired Then
				Invoke(logDelegate, New Object() {msg})
				Return
			End If
			Me.txt021TCV010F010.AppendText(msg)
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' is󋵂ݒ肷
	''' </summary>
	''' <param name="value">ϊς݂̃f[u</param>
	''' <remarks>
	''' 2010/11/25 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Sub setProgress(ByVal value As Integer)
		Try
			If InvokeRequired Then
				Invoke(progressDelegate, New Object() {value})
				Return
			End If
			Me.pgb019TCV010F010.Value = value
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' is󋵂
	''' </summary>
	''' <param name="max">vOXo[̍ől</param>
	''' <remarks>
	''' 2010/11/25 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Sub initProgress(ByVal max As Integer)
		Try
			Me.pgb019TCV010F010.Minimum = 0
			Me.pgb019TCV010F010.Maximum = max
			Me.pgb019TCV010F010.Value = 0
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' ^Cg̐ݒ
	''' </summary>
	''' <remarks>
	''' 2010/11/25 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub setTitle()
		Try
			Me.lbl002TCV010F010.Text = Me.Text
			Me.lbl002TCV010F010.Invalidate()
			Me.pct003TCV010F010.Height = Me.lbl002TCV010F010.Height
			Me.pct003TCV010F010.Width = Me.lbl002TCV010F010.Width
			Me.pct003TCV010F010.Location = New Point(Me.lbl002TCV010F010.Location.X + 3, Me.lbl002TCV010F010.Location.Y + 3)
			Me.pct003TCV010F010.Invalidate()
		Catch ex As Exception
			Throw
		End Try
	End Sub

'(A) STR V4-14027-000 027 20130510 ID)(f[^ڍsOf[^`FbNǉ)
	''' ---------------------------------------------
	''' <summary>
	''' f[^ڍsO`FbN
	''' </summary>
	''' <remarks>
	''' 2013/05/10 VK쐬@ID)<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub checkProc()
		Try
			eBackgroundWorker = enumBackgroundWorker.CheckData
			If Not ChkDataBeforeConvert() Then
				eBackgroundWorker = enumBackgroundWorker.None
				Exit Sub
			Else
				Me.txt021TCV010F010.Focus()
				'V3f[^i[w肷
				manager.setV3Dir(Me.txt008TCV010F010.Text)
				actionCtl()
				manager.checkData(True, True)
			End If
		Catch ex As Exception
			Throw
		End Try
	End Sub
'(A) END V4-14027-000 027 20130510

	''' ---------------------------------------------
	''' <summary>
	''' ϊ
	''' </summary>
	''' <remarks>
	''' 2011/01/11 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub ExecProc()
		Try
'(A) STR V4-14027-000 003 20130510 ID)(f[^ڍsOf[^`FbNǉ)
			eBackgroundWorker = enumBackgroundWorker.Convert
'(A) END V4-14027-000 003 20130510
			If Not ChkData() Then
'(A) STR V4-14027-000 003 20130510 ID)(f[^ڍsOf[^`FbNǉ)
				eBackgroundWorker = enumBackgroundWorker.None
'(A) END V4-14027-000 003 20130510
				Exit Sub
			Else
'(A) STR V4-14027-000 003 20130510 ID)(f[^ڍsOf[^`FbNǉ)
				Me.txt021TCV010F010.Focus()
'(A) END V4-14027-000 003 20130510
				'V3f[^i[w肷
				manager.setV3Dir(Me.txt008TCV010F010.Text)

				actionCtl()
'(M) STR V4-14021-000 004 20130423 ID)(ڍsΏہif[^A}X^jI\ƂΉ)
'				manager.convert()
				manager.convert(Me.chk024TCV010F010.Checked, Me.chk025TCV010F010.Checked)
'(M) END V4-14021-000 004 20130423
			End If
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' I
	''' </summary>
	''' <remarks>
	''' 2010/11/25 VK쐬 FJSK)r<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub EndProc()
		Try
			Me.Close()
		Catch ex As Exception
			Throw
		End Try
	End Sub

'(A) STR V4-14027-000 125 20130510 ID)(f[^ڍsOf[^`FbNǉ)
	''' ---------------------------------------------
	''' <summary>
	''' brut@Co
	''' </summary>
	''' <param name="pDefaultFile">\̃t@C</param>
	''' <param name="pDefaultPath">\̃fBNg</param>
	''' <remarks>
	''' 2013/05/10 VK쐬@ID)<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub WriteCsvFile(ByVal pDefaultFile As String, ByVal pDefaultPath As String)
		Dim retFile As String = Nothing
		Dim bUse As Boolean = False
		Try
			Do
				Using fDialog As New SaveFileDialog
					With fDialog
						.FileName = pDefaultFile						't@C
						If FileIO.FileSystem.DirectoryExists(pDefaultPath) Then	'fBNgݒ
							.InitialDirectory = pDefaultPath
						Else
							.InitialDirectory = Path.GetDirectoryName(Application.StartupPath)
						End If

						.Filter = "CSVt@C |*.csv"
						.Title = "G[݂܂BۑEt@Cw肵Ă"
																		'^Cgݒ
						.RestoreDirectory = True						'_CAO{bNXOɌ݂̃fBNg𕜌悤ɂ
						.OverwritePrompt = False						'ɑ݂t@Cw肵ƂxȂ
						.CheckPathExists = True							'݂ȂpXw肳ꂽƂx\

						If .ShowDialog <> DialogResult.OK Then
							Return
						End If
						retFile = fDialog.FileName
					End With
				End Using
				bUse = CheckFileUsing(retFile)
				If bUse Then
					MessageBox.Show("w̃t@C͌ݎgpłBJĂt@C邩Aʂ̃t@Cw肵ĉB", "CSVo")
				End If
			Loop Until Not bUse	' gpLZ܂Loop
			' CSVt@C쐬
			Dim enc As System.Text.Encoding = System.Text.Encoding.GetEncoding("Shift-JIS")
			Dim strAllBuffer As New System.Text.StringBuilder
			Dim strBuffer As String = String.Empty
			Dim strValue As String = String.Empty
			Dim dtTmp As Date = Nothing
			Dim iIndex As Integer = 0
			' wb_ҏW
			For i As Integer = 0 To CST_ERRORITEM.GetUpperBound(0) - 1
				strBuffer &= """" & CST_ERRORITEM(i) & ""","
			Next
			strBuffer = strBuffer.Substring(0, strBuffer.Length - 1)
			strAllBuffer.Append(strBuffer & ControlChars.CrLf)
			' f[^ҏW
			If dtErrorTable IsNot Nothing Then
				' \[g
				dtErrorTable.DefaultView.Sort = "敪, e[uR DESC, Ҕԍ, , Ȕ"
				dtErrorTable = dtErrorTable.DefaultView.ToTable()
				For Each drow As DataRow In dtErrorTable.Rows
					strBuffer = String.Empty
					iIndex += 1
					strBuffer &= iIndex.ToString & ","
					For i As Integer = 1 To CST_ERRORITEM.GetUpperBound(0) - 1
						strValue = drow(CST_ERRORITEM(i)).ToString.Replace("""", """""")
						If Date.TryParse(strValue, dtTmp) Then
							' t^
							If dtTmp.Hour = 0 AndAlso
								dtTmp.Minute = 0 AndAlso
								dtTmp.Second = 0 Then
								' t̂
								strValue = dtTmp.ToString("yyyy/MM/dd")
							End If
						End If
						strBuffer &= """" & strValue & ""","
					Next
					strBuffer = strBuffer.Substring(0, strBuffer.Length - 1)
					strAllBuffer.Append(strBuffer & ControlChars.CrLf)
				Next
			End If
			My.Computer.FileSystem.WriteAllText(retFile, strAllBuffer.ToString, False, enc)
			strAllBuffer = Nothing
			MessageBox.Show("a叫uR̃f[^`FbNʂۑ܂Bi" & retFile & "j")
		Catch ex As IOException
			Throw
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' t@C̎gp𔻒
	''' </summary>
	''' <param name="vstrFilePath"></param>
	''' <returns></returns>
	''' <remarks>
	''' 2013/05/13 VK쐬@ID)<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function CheckFileUsing(ByVal vstrFilePath As String) As Boolean

		Dim f As New FileInfo(vstrFilePath)
		Dim strFileNameBK As String = f.Name

		If Not f.Exists Then
			't@C݂Ȃ΁Agpł͂Ȃ
			Return False
		End If
		Try
			't@CύXāAgp`FbN
			f.MoveTo(Path.Combine(f.DirectoryName, f.Name & ".BK"))
			't@Cɖ߂
			f.MoveTo(Path.Combine(f.DirectoryName, strFileNameBK))
			't@C̕ύX̂ŁAgpł͂Ȃ
			Return False
		Catch ex As Exception
			't@CύXłȂ̂ŁAgpƂ
			Return True
		End Try
	End Function
'(A) END V4-14027-000 125 20130510

#End Region

#Region "I[o[Ch\bh(L[֘A)"

	Private Const WM_KEYDOWN As Integer = &H100		'KeyDownbZ[W
	Private Const WM_SYSKEYDOWN As Integer = &H104

	'''---------------------------------------------
	''' <summary>
	''' R}hL[@Enter^uړiShift+EnterBack^uj
	''' </summary>
	''' <param name="msg"></param>
	''' <param name="KeyData"></param>
	''' <returns></returns>
	''' <remarks>
	''' 2009/11/23 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Protected Overrides Function ProcessCmdKey(ByRef msg As Message, ByVal KeyData As Keys) As Boolean
		Try
			If msg.Msg = WM_KEYDOWN OrElse msg.Msg = WM_SYSKEYDOWN Then	'KEYDOWN
				Dim key As Keys = KeyData And Keys.KeyCode
				Select Case True
					Case KeyData.Equals(Keys.F1)
						Return F1KeyProc()
					Case KeyData.Equals(Keys.F2)
						Return F2KeyProc()
					Case KeyData.Equals(Keys.F3)
						Return F3KeyProc()
					Case KeyData.Equals(Keys.Alt Or Keys.F4)
						'Alt+F4ꂽꍇValidate𑖂点ɉʂI
						Me.AutoValidate = Windows.Forms.AutoValidate.Disable
					Case KeyData.Equals(Keys.F4)
						Return F4KeyProc()
					Case KeyData.Equals(Keys.F5)
						Return F5KeyProc()
					Case KeyData.Equals(Keys.F6)
						Return F6KeyProc()
					Case KeyData.Equals(Keys.F7)
						Return F7KeyProc()
					Case KeyData.Equals(Keys.F8)
						Return F8KeyProc()
					Case KeyData.Equals(Keys.F9)
						Return F9KeyProc()
					Case KeyData.Equals(Keys.F10)
						Return F10KeyProc()
					Case KeyData.Equals(Keys.F11)
						Return F11KeyProc()
					Case KeyData.Equals(Keys.F12)
						Return F12KeyProc()
					Case KeyData.Equals(Keys.F12 Or Keys.Shift)
						Return ShiftF12KeyProc()
					Case KeyData.Equals(Keys.Enter)
						Return EnterProc()
					Case KeyData.Equals(Keys.Enter Or Keys.Shift)
						Return ShiftEnterProc()
				End Select
			End If
		Catch ex As Exception
			MessageBox.Show(ex.Message & vbCrLf & ex.StackTrace)
		End Try
		Return MyBase.ProcessCmdKey(msg, KeyData)

	End Function

	'''---------------------------------------------
	''' <summary>
	''' F1KeỹI[o[ChpEʕ\
	''' </summary>
	''' <returns></returns>
	''' <remarks>
	''' 2009/12/22 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function StaffFormProc() As Boolean
	End Function

	'''---------------------------------------------
	''' <summary>
	''' F1
	''' </summary>
	''' <remarks>
	''' 2009/11/23 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function F1KeyProc() As Boolean
		Return False
	End Function

	'''---------------------------------------------
	''' <summary>
	''' F2
	''' </summary>
	''' <remarks>
	''' 2009/11/23 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function F2KeyProc() As Boolean
		Return False
	End Function

	'''---------------------------------------------
	''' <summary>
	''' F3
	''' </summary>
	''' <remarks>
	''' 2009/11/23 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Function F3KeyProc() As Boolean
		Return False
	End Function

	'''---------------------------------------------
	''' <summary>
	''' F4
	''' </summary>
	''' <remarks>
	''' 2009/11/23 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function F4KeyProc() As Boolean
		Return False
	End Function

	'''---------------------------------------------
	''' <summary>
	''' F5
	''' </summary>
	''' <remarks>
	''' 2009/11/23 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function F5KeyProc() As Boolean
		Return False
	End Function

	'''---------------------------------------------
	''' <summary>
	''' F6
	''' </summary>
	''' <remarks>
	''' 2009/11/23 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function F6KeyProc() As Boolean
		Return False
	End Function

	'''---------------------------------------------
	''' <summary>
	''' F7
	''' </summary>
	''' <remarks>
	''' 2009/11/23 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function F7KeyProc() As Boolean
		Try
			'ϊ
			Me.ExecProc()
			Return True
		Catch ex As Exception
'(A) STR V4-14027-000 003 20130510 ID)(f[^ڍsOf[^`FbNǉ)
			Me.initCtl()
'(A) END V4-14027-000 003 20130510
			Throw
		End Try
	End Function

	'''---------------------------------------------
	''' <summary>
	''' F8
	''' </summary>
	''' <remarks>
	''' 2009/11/23 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function F8KeyProc() As Boolean
		Return False
	End Function

	'''---------------------------------------------
	''' <summary>
	''' F9
	''' </summary>
	''' <remarks>
	''' 2009/11/23 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function F9KeyProc() As Boolean
		Return False
	End Function

	'''---------------------------------------------
	''' <summary>
	''' F10
	''' </summary>
	''' <remarks>
	''' 2009/11/23 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function F10KeyProc() As Boolean
		Return False
	End Function

	'''---------------------------------------------
	''' <summary>
	''' F11
	''' </summary>
	''' <remarks>
	''' 2009/11/23 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function F11KeyProc() As Boolean
		Return False
	End Function

	'''---------------------------------------------
	''' <summary>
	''' F12
	''' </summary>
	''' <remarks>
	''' 2009/11/23 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function F12KeyProc() As Boolean
		Try
			'ϊ
			Me.EndProc()
			Return True
		Catch ex As Exception
			Throw
		End Try
	End Function

	'''---------------------------------------------
	''' <summary>
	''' F12
	''' </summary>
	''' <remarks>
	''' 2010/03/15 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function ShiftF12KeyProc() As Boolean
		Return False
	End Function

	'''---------------------------------------------
	''' <summary>
	''' Enter
	''' </summary>
	''' <remarks>
	''' 2009/12/09 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function EnterProc() As Boolean
		Try
			' ̃Rg[փtH[JXړ
			Me.SelectNextControl(Me.ActiveControl, True, True, True, True)
			'Return False
			Return True
		Catch ex As Exception
			Throw
		End Try
	End Function

	'''---------------------------------------------
	''' <summary>
	''' Shift+Enter
	''' </summary>
	''' <remarks>
	''' 2009/12/09 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function ShiftEnterProc() As Boolean
		Try
			' ÕRg[փtH[JXړ
			Me.SelectNextControl(Me.ActiveControl, False, True, True, True)
			'Return False
			Return True
		Catch ex As Exception
			Throw
		End Try
	End Function

#End Region

End Class
