Imports System
Imports System.Data.SqlClient
Imports System.Reflection
Imports System.Configuration
Imports System.Text

''' ============================================================
''' <summary>
''' DBANZX̐ڑ^bpNX
''' (̃p[^ݒSELECT,UPDATE,INSERT,DELETEA
''' ̃p[^ݒŔrSELECT)
''' </summary>
''' <remarks>
''' 2007/8/9 VK쐬 FJSK)ї<BR/>
''' </remarks>
''' ============================================================
Public Class clsDB
	Implements IDisposable

	Private Url As String = Nothing								'DBڑq
	Private STimeOut As String = Nothing						'SQL^CAEg(b)

	Private con As SqlConnection = Nothing						'ڑ
	Private sqlCmd As SqlCommand = Nothing						'SQLR}h
	Private sqlDa As SqlDataAdapter = Nothing					'SQLf[^A_v^

    Private forUpdTran As Boolean = False                       'True=forUpdatẽgUNV

	Private dbRetryCnt As Integer = 30							'gC
    Private dbRetryTime As Integer = 1000                       'gCԊu

	Private Const NOTCONNECT As String = "ڑmĂ܂"

	Public Const forupdate As String = " WITH(UPDLOCK,ROWLOCK,NOWAIT) "	'qg(select for update)

	Public Enum Enum_TranMode As Integer
		Begin = 0		'gUNVJn
		Commit = 1		'R~bg
		RollBack = 2	'[obN
	End Enum

	'''---------------------------------------------
	''' <summary>
	''' DB typew
	''' </summary>
	''' <remarks>
	''' 2008/09/29 C FJSK) dbNVarCharǉ<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Enum Enum_dbType As Integer
		dbInt = 0
		'dbVarChar = 1
		dbDateTime = 2
		dbNumeric = 3
		dbNull = 4
		dbNVarChar = 5
		dbFloat = 6
	End Enum

	'''---------------------------------------------
	''' <summary>
	''' SQL[hw
	''' </summary>
	''' <remarks>
	''' 2010/02/08 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Enum Enum_sqlMode As Integer
		sqlSel = 1
		sqlIns = 2
		sqlUpd = 3
		sqlDel = 4
    End Enum

    '''---------------------------------------------
    ''' <summary>
    ''' Retryݒ
    ''' </summary>
    ''' <remarks>
    ''' 2010/05/28 VK쐬@CS)r<BR/>
    ''' </remarks>
    '''---------------------------------------------
    Public Enum Enum_Retry As Integer
        Retry = 0
        NonRetry = 1
    End Enum

	'''---------------------------------------------
	''' <summary>
	''' RXgN^iDBڑqݒ肷j
	''' </summary>
	''' <param name="pCfg">ConfigNX</param>
	''' <param name="pLogin">True:[ULogin,False:ȊO</param>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Sub New(ByVal pCfg As datConfig, Optional ByVal pLogin As Boolean = False)
		If pLogin = True Then
			Url = getXMLurl(pCfg, True)							 'ڑq擾
		Else
			Url = getXMLurl(pCfg)								 'ڑq擾
		End If
		STimeOut = pCfg.STimeOut.ToString
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' fXgN^
	''' </summary>
	''' <remarks></remarks>
	'''---------------------------------------------
	Protected Overrides Sub Finalize()
		MyBase.Finalize()
		initSqlDa()												'sqlDa
		initSqlCmd()											'sqlCommand
		initCon()												'con
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' lt@CURLǂݍ
	''' </summary>
	''' <returns></returns>
	''' <remarks></remarks>
	'''---------------------------------------------
	Private Function getXMLurl(ByVal pCfg As datConfig, Optional ByVal pLogin As Boolean = False) As String
		Dim sRet As String = Nothing
		Dim confDS As String = pCfg.DS		'f[^\[X
		Dim confIC As String = pCfg.IC		'DB
		Dim confUI As String = pCfg.UI		'[UID
		Dim confPW As String = confUI & "p"		'pX[h

		Try
			If confDS IsNot Nothing AndAlso confIC IsNot Nothing AndAlso confUI IsNot Nothing AndAlso confPW IsNot Nothing Then
				sRet = "Data Source=" & confDS & ";Initial Catalog=" & confIC & ";User ID=" & confUI & ";Password=" & confPW
				If pLogin = True Then
					If pCfg.LTimeOut >= 0 Then
						sRet = sRet & ";Connect Timeout=" & pCfg.LTimeOut.ToString	'OC^CAEgԂt
					End If
				Else
					If pCfg.RTimeOut >= 0 Then
						sRet = sRet & ";Connect Timeout=" & pCfg.RTimeOut.ToString	'[obN^CAEgԂt
					End If
				End If
			End If

			Return sRet
		Catch ex As Exception
			Throw
		End Try
	End Function

	'''---------------------------------------------
	''' <summary>
	''' rpkR}h^CAEgԂfds
	''' </summary>
	''' <returns></returns>
	''' <remarks>
	''' 2008/04/23 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function getSTimeOut() As Integer
		Dim iRet As Integer = -1
		Try
			iRet = Integer.Parse(STimeOut)
		Catch ex As Exception
			iRet = -1
		End Try
		Return iRet
	End Function

	'''---------------------------------------------
	''' <summary>
	''' con(SqlConnection)̏
	''' </summary>
	''' <remarks></remarks>
	'''---------------------------------------------
	Private Sub initCon()
		If con IsNot Nothing Then								'congĂ
			Try
				con.Dispose()									'\[XJ
			Catch ex As Exception								'O͏Ȃ
			Finally
				con = Nothing									'ϐ
			End Try
		End If
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' sqlCmd(SqlCommand)̏
	''' </summary>
	''' <remarks></remarks>
	'''---------------------------------------------
	Private Sub initSqlCmd()
		If sqlCmd IsNot Nothing Then							'sqlCmdgĂ
			Try
				If forUpdTran = True AndAlso sqlCmd.Transaction IsNot Nothing Then	'for UpdatẽgUNVȂ
					sqlCmd.Transaction.Rollback()				'[obN
				End If
				sqlCmd.Dispose()								'\[XJ
			Catch ex As Exception								'O͏Ȃ
			Finally
				sqlCmd = Nothing								'ϐ
				forUpdTran = False								'for UpdatẽgUNVłȂ
			End Try
		End If
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' sqlDa(SqlDataAdapter)̏
	''' </summary>
	''' <remarks></remarks>
	'''---------------------------------------------
	Private Sub initSqlDa()
		If sqlDa IsNot Nothing Then								'sqlDagĂ
			Try
				sqlDa.Dispose()									'\[XJ
			Catch ex As Exception								'O͏Ȃ
			Finally
				sqlDa = Nothing									'ϐ
			End Try
		End If
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SELECT,UPDATE,INSERT,DELETEݒ肷
	''' </summary>
	''' <param name="str">ݒ肷SQL</param>
	''' <param name="retryFlg">̐ڑATrue=؂AFalse=؂Ȃ</param>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Sub setSQL(ByVal str As String, Optional ByVal retryFlg As Boolean = False)
		Try
			If retryFlg = True Then									'ڑOɐ؂ꍇ
				initSqlCmd()										'sqlCmd
				initCon()											'con
			End If

			If con Is Nothing Then								'ڑȂꍇ
				con = New SqlConnection(Url)					'ڑ
				con.Open()
				sqlCmd = New SqlCommand(str, con)
			Else												'ڑꍇ
				If sqlCmd IsNot Nothing Then						'sqlCommandꍇAėp
					sqlCmd.CommandText = str
					sqlCmd.Parameters.Clear()
				Else												'sqlCommandȂꍇA쐬
					sqlCmd = New SqlCommand(str, con)
				End If
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' sqlDataAdapterpSELECTݒ肷
	''' </summary>
	''' <param name="str">ݒ肷SQL</param>
	''' <param name="retryFlg">̐ڑATrue=؂AFalse=؂Ȃ</param>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Sub setSQLDa(ByVal str As String, Optional ByVal retryFlg As Boolean = False)
		Try
			If retryFlg = True Then									'ڑOɐ؂ꍇ
				initSqlDa()											'sqlCmd
				initCon()											'con
			End If

			If con Is Nothing Then								'ڑȂꍇ
				con = New SqlConnection(Url)					'ڑ
				con.Open()
				sqlDa = New SqlDataAdapter()
				sqlDa.SelectCommand = New SqlCommand(str, con)
			Else												'ڑꍇ
				If sqlDa IsNot Nothing Then							'sqlDaꍇAėp
					sqlDa.SelectCommand.CommandText = str
					sqlDa.SelectCommand.Parameters.Clear()
				Else												'sqlDaȂꍇA쐬
					sqlDa = New SqlDataAdapter()
					sqlDa.SelectCommand = New SqlCommand(str, con)
				End If
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	''' <summary>
	''' RlNVڑ`FbN
	''' </summary>
	''' <returns></returns>
	''' <remarks>
	''' 2011/02/24 VK쐬 FJSK)r<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Function chkConnection() As Boolean
		Try
			con = New SqlConnection(Url)					'ڑ
			con.Open()
			con.Close()

			'ڑOK
			Return True
		Catch ex As Exception
			'ڑs
			Return False
		Finally
			initCon()
		End Try
	End Function

	'''---------------------------------------------
	''' <summary>
	''' sqlDataAdapterpSELECTݒ肷
	''' </summary>
	''' <param name="str">ݒ肷SQL</param>
	''' <param name="retryFlg">̐ڑATrue=؂AFalse=؂Ȃ</param>
	''' <remarks>
	''' 2010/02/08 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Sub setSQLDa(ByVal str As String, ByVal mode As Enum_sqlMode, Optional ByVal retryFlg As Boolean = False)
		Try
			If retryFlg = True Then									'ڑOɐ؂ꍇ
				initSqlDa()											'sqlCmd
				initCon()											'con
			End If

			If con Is Nothing Then								'ڑȂꍇ
				con = New SqlConnection(Url)					'ڑ
				con.Open()
			Else												'ڑꍇ
				If sqlDa IsNot Nothing Then						'sqlDaꍇANA
					initSqlDa()									'sqlDa
				End If
			End If
			sqlDa = New SqlDataAdapter()
			Select Case mode
				Case Enum_sqlMode.sqlSel
					sqlDa.SelectCommand = New SqlCommand(str, con)
				Case Enum_sqlMode.sqlIns
					sqlDa.InsertCommand = New SqlCommand(str, con)
				Case Enum_sqlMode.sqlUpd
					sqlDa.UpdateCommand = New SqlCommand(str, con)
				Case Enum_sqlMode.sqlDel
					sqlDa.DeleteCommand = New SqlCommand(str, con)
			End Select
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^ݒ
	''' </summary>
	''' <param name="str">p[^</param>
	''' <param name="dbTypeNo">p[^̌^</param>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Sub setParam(ByVal str As String, ByVal dbTypeNo As Integer)
		Try
			If con Is Nothing OrElse sqlCmd Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			sqlCmd.Parameters.Add(str, getDBtype(dbTypeNo))
		Catch ex As Exception									'ʂ֓`d
			Throw
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^ݒ(sqlDataAdapterp)
	''' </summary>
	''' <param name="str">p[^</param>
	''' <param name="dbTypeNo">p[^̌^</param>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Sub setParamDa(ByVal str As String, ByVal dbTypeNo As Integer)
		Try
			If con Is Nothing OrElse sqlDa Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			sqlDa.SelectCommand.Parameters.Add(str, getDBtype(dbTypeNo))
		Catch ex As Exception									'ʂ֓`d
			Throw
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^ݒ(sqlDataAdapterp)
	''' </summary>
	''' <param name="str">p[^</param>
	''' <param name="dbTypeNo">p[^̌^</param>
	''' <param name="size">TCY</param>
	''' <param name="colstr"></param>
	''' <remarks>
	''' 2010/02/16 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Sub setParamDa(ByVal str As String, ByVal dbTypeNo As Integer, ByVal size As Integer, ByVal colstr As String)
		Try
			If con Is Nothing OrElse sqlDa Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			Dim cmd As SqlCommand = Nothing
			Select Case True
				Case sqlDa.InsertCommand IsNot Nothing
					cmd = sqlDa.InsertCommand
				Case sqlDa.UpdateCommand IsNot Nothing
					cmd = sqlDa.UpdateCommand
				Case sqlDa.DeleteCommand IsNot Nothing
					cmd = sqlDa.DeleteCommand
			End Select
			cmd.Parameters.Add(str, getDBtype(dbTypeNo), size, colstr)
		Catch ex As Exception									'ʂ֓`d
			Throw
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SqlDbType̎擾
	''' </summary>
	''' <param name="dbNo"></param>
	''' <returns></returns>
	''' <remarks>
	''' 2008/09/29 C FJSK) NVarCharǉ<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Function getDBtype(ByVal dbNo As Integer) As SqlDbType
		Try
			Dim _dbType() As SqlDbType = {SqlDbType.Int, SqlDbType.VarChar, SqlDbType.DateTime, SqlDbType.Decimal, SqlDbType.Int, SqlDbType.NVarChar, SqlDbType.Float}	 'DBtype
			Return _dbType(dbNo)
		Catch ex As Exception
			Throw
		End Try
	End Function

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ
	''' </summary>
	''' <param name="strPrm">p[^</param>
	''' <param name="strVal">l</param>
	''' <remarks>^̐ݒ</remarks>
	'''---------------------------------------------
	Public Overloads Sub setVal(ByVal strPrm As String, ByVal strVal As String)
		Try
			If con Is Nothing OrElse sqlCmd Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If strVal Is Nothing OrElse strVal.Equals(String.Empty) Then
				sqlCmd.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlCmd.Parameters(strPrm).Value = strVal
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ
	''' </summary>
	''' <param name="strPrm"></param>
	''' <param name="strVal"></param>
	''' <param name="nullFlg"></param>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Overloads Sub setVal(ByVal strPrm As String, ByVal strVal As String, ByVal nullFlg As Boolean)
		Try
			If con Is Nothing OrElse sqlCmd Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If nullFlg = True Then
				sqlCmd.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlCmd.Parameters(strPrm).Value = strVal
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ
	''' </summary>
	''' <param name="strPrm">p[^</param>
	''' <param name="intVal">l</param>
	''' <remarks>l^̐ݒ</remarks>
	'''---------------------------------------------
	Public Overloads Sub setVal(ByVal strPrm As String, ByVal intVal As Integer)
		Try
			If con Is Nothing OrElse sqlCmd Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If intVal = Nothing Then
				sqlCmd.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlCmd.Parameters(strPrm).Value = intVal
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ
	''' </summary>
	''' <param name="strPrm"></param>
	''' <param name="intVal"></param>
	''' <param name="nullFlg"></param>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Overloads Sub setVal(ByVal strPrm As String, ByVal intVal As Integer, ByVal nullFlg As Boolean)
		Try
			If con Is Nothing OrElse sqlCmd Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If nullFlg = True Then
				sqlCmd.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlCmd.Parameters(strPrm).Value = intVal
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ
	''' </summary>
	''' <param name="strPrm"></param>
	''' <param name="numericVal"></param>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Overloads Sub setVal(ByVal strPrm As String, ByVal numericVal As Decimal)
		Try
			If con Is Nothing OrElse sqlCmd Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If numericVal = Nothing Then
				sqlCmd.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlCmd.Parameters(strPrm).Value = numericVal
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ
	''' </summary>
	''' <param name="strPrm"></param>
	''' <param name="numericVal">ݒ肷l</param>
	''' <param name="nullFlg">true=Nothing,false=notNothing</param>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Overloads Sub setVal(ByVal strPrm As String, ByVal numericVal As Decimal, ByVal nullFlg As Boolean)
		Try
			If con Is Nothing OrElse sqlCmd Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If nullFlg = True Then
				sqlCmd.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlCmd.Parameters(strPrm).Value = numericVal
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ
	''' </summary>
	''' <param name="strPrm"></param>
	''' <param name="dblval"></param>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Overloads Sub setVal(ByVal strPrm As String, ByVal dblval As Double)
		Try
			If con Is Nothing OrElse sqlCmd Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If dblval = Nothing Then
				sqlCmd.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlCmd.Parameters(strPrm).Value = dblval
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ
	''' </summary>
	''' <param name="strPrm"></param>
	''' <param name="dblval">ݒ肷l</param>
	''' <param name="nullFlg">true=Nothing,false=notNothing</param>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Overloads Sub setVal(ByVal strPrm As String, ByVal dblval As Double, ByVal nullFlg As Boolean)
		Try
			If con Is Nothing OrElse sqlCmd Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If nullFlg = True Then
				sqlCmd.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlCmd.Parameters(strPrm).Value = dblval
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub


	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ
	''' </summary>
	''' <param name="strPrm"></param>
	''' <param name="dtVal"></param>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Overloads Sub setVal(ByVal strPrm As String, ByVal dtVal As DateTime)
		Try
			If con Is Nothing OrElse sqlCmd Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If dtVal = Nothing Then
				sqlCmd.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlCmd.Parameters(strPrm).Value = dtVal
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ
	''' </summary>
	''' <param name="strPrm"></param>
	''' <param name="dtVal"></param>
	''' <param name="nullFlg"></param>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Overloads Sub setVal(ByVal strPrm As String, ByVal dtVal As DateTime, ByVal nullFlg As Boolean)
		Try
			If con Is Nothing OrElse sqlCmd Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If nullFlg = True Then
				sqlCmd.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlCmd.Parameters(strPrm).Value = dtVal
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lNULLݒ肷
	''' </summary>
	''' <param name="strPrm"></param>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Overloads Sub setVal(ByVal strPrm As String)
		Try
			If con Is Nothing OrElse sqlCmd Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			sqlCmd.Parameters(strPrm).Value = DBNull.Value
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ(sqlDataAdapterp)
	''' </summary>
	''' <param name="strPrm">p[^</param>
	''' <param name="strVal">l</param>
	''' <remarks>^̐ݒ</remarks>
	'''---------------------------------------------
	Public Overloads Sub setValDa(ByVal strPrm As String, ByVal strVal As String)
		Try
			If con Is Nothing OrElse sqlDa Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If strVal Is Nothing OrElse strVal.Equals(String.Empty) Then
				sqlDa.SelectCommand.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlDa.SelectCommand.Parameters(strPrm).Value = strVal
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ(sqlDataAdapterp)
	''' </summary>
	''' <param name="strPrm">p[^</param>
	''' <param name="strVal">l</param>
	''' <param name="nullFlg">True:BDNullZbg,False:strValZbg</param>
	''' <remarks>^̐ݒ</remarks>
	'''---------------------------------------------
	Public Overloads Sub setValDa(ByVal strPrm As String, ByVal strVal As String, ByVal nullFlg As Boolean)
		Try
			If con Is Nothing OrElse sqlDa Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If nullFlg = True Then
				sqlDa.SelectCommand.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlDa.SelectCommand.Parameters(strPrm).Value = strVal
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ(sqlDataAdapterp)
	''' </summary>
	''' <param name="strPrm">p[^</param>
	''' <param name="intVal">l</param>
	''' <remarks>int^̐ݒ</remarks>
	'''---------------------------------------------
	Public Overloads Sub setValDa(ByVal strPrm As String, ByVal intVal As Integer)
		Try
			If con Is Nothing OrElse sqlDa Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If intVal = Nothing Then
				sqlDa.SelectCommand.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlDa.SelectCommand.Parameters(strPrm).Value = intVal
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ(sqlDataAdapterp)
	''' </summary>
	''' <param name="strPrm">p[^</param>
	''' <param name="intVal">l</param>
	''' <param name="nullFlg">True:BDNullZbg,False:intValZbg</param>
	''' <remarks>int^̐ݒ</remarks>
	'''---------------------------------------------
	Public Overloads Sub setValDa(ByVal strPrm As String, ByVal intVal As Integer, ByVal nullFlg As Boolean)
		Try
			If con Is Nothing OrElse sqlDa Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If nullFlg = True Then
				sqlDa.SelectCommand.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlDa.SelectCommand.Parameters(strPrm).Value = intVal
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ(sqlDataAdapterp)
	''' </summary>
	''' <param name="strPrm">p[^</param>
	''' <param name="numericVal">l</param>
	''' <remarks>Decimal^̐ݒ</remarks>
	'''---------------------------------------------
	Public Overloads Sub setValDa(ByVal strPrm As String, ByVal numericVal As Decimal)
		Try
			If con Is Nothing OrElse sqlDa Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If numericVal = Nothing Then
				sqlDa.SelectCommand.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlDa.SelectCommand.Parameters(strPrm).Value = numericVal
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ(sqlDataAdapterp)
	''' </summary>
	''' <param name="strPrm">p[^</param>
	''' <param name="numericVal">l</param>
	''' <param name="nullFlg">True:BDNullZbg,False:numericValZbg</param>
	''' <remarks>Decimal^̐ݒ</remarks>
	'''---------------------------------------------
	Public Overloads Sub setValDa(ByVal strPrm As String, ByVal numericVal As Decimal, ByVal nullFlg As Boolean)
		Try
			If con Is Nothing OrElse sqlDa Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If nullFlg = True Then
				sqlDa.SelectCommand.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlDa.SelectCommand.Parameters(strPrm).Value = numericVal
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ(sqlDataAdapterp)
	''' </summary>
	''' <param name="strPrm">p[^</param>
	''' <param name="dtVal">tl</param>
	''' <remarks>DataTime^̐ݒ</remarks>
	'''---------------------------------------------
	Public Overloads Sub setValDa(ByVal strPrm As String, ByVal dtVal As DateTime)
		Try
			If con Is Nothing OrElse sqlDa Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If dtVal = Nothing Then
				sqlDa.SelectCommand.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlDa.SelectCommand.Parameters(strPrm).Value = dtVal
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ(sqlDataAdapterp)
	''' </summary>
	''' <param name="strPrm">p[^</param>
	''' <param name="dtVal">tl</param>
	''' <param name="nullFlg">True:BDNullZbg,False:dtValZbg</param>
	''' <remarks>DataTime^̐ݒ</remarks>
	'''---------------------------------------------
	Public Overloads Sub setValDa(ByVal strPrm As String, ByVal dtVal As DateTime, ByVal nullFlg As Boolean)
		Try
			If con Is Nothing OrElse sqlDa Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If nullFlg = True Then
				sqlDa.SelectCommand.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlDa.SelectCommand.Parameters(strPrm).Value = dtVal
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ(sqlDataAdapterp)
	''' </summary>
	''' <param name="strPrm">p[^</param>
	''' <param name="dblval">l</param>
	''' <remarks>Double^̐ݒ</remarks>
	'''---------------------------------------------
	Public Overloads Sub setValDa(ByVal strPrm As String, ByVal dblval As Double)
		Try
			If con Is Nothing OrElse sqlDa Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If dblval = Nothing Then
				sqlDa.SelectCommand.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlDa.SelectCommand.Parameters(strPrm).Value = dblval
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		Finally
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lݒ(sqlDataAdapterp)
	''' </summary>
	''' <param name="strPrm">p[^</param>
	''' <param name="dblval">l</param>
	''' <param name="nullFlg">True:BDNullZbg,False:dblvalZbg</param>
	''' <remarks>Double^̐ݒ</remarks>
	'''---------------------------------------------
	Public Overloads Sub setValDa(ByVal strPrm As String, ByVal dblval As Double, ByVal nullFlg As Boolean)
		Try
			If con Is Nothing OrElse sqlDa Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			If nullFlg = True Then
				sqlDa.SelectCommand.Parameters(strPrm).Value = DBNull.Value
			Else
				sqlDa.SelectCommand.Parameters(strPrm).Value = dblval
			End If
		Catch ex As Exception									'ʂ֓`d
			Throw
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQL̃p[^lNULLݒ肷(sqlDataAdapterp)
	''' </summary>
	''' <param name="strPrm">p[^</param>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Overloads Sub setValDa(ByVal strPrm As String)
		Try
			If con Is Nothing OrElse sqlDa Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return
			End If

			sqlDa.SelectCommand.Parameters(strPrm).Value = DBNull.Value
		Catch ex As Exception									'ʂ֓`d
			Throw
		End Try
	End Sub

    ''''---------------------------------------------
    '''' <summary>
    '''' SELECTs
    '''' </summary>
    '''' <param name="t">SELECTʂ擾NX</param>
    '''' <param name="ar">SELECTʂ̔z</param>
    '''' <returns>ʂ̃R[h</returns>
    '''' <remarks></remarks>
    ''''---------------------------------------------
    'Public Function execQuery(ByVal t As Type, ByRef ar As ArrayList) As Integer
    '	Dim forUpdFlg As Boolean = False						'True=for Update

    '	If con Is Nothing OrElse sqlCmd Is Nothing Then
    '		Throw New Exception(NOTCONNECT)						'ڑmĂȂ
    '		Return -1
    '	End If

    '	Dim fieldName As New ArrayList							'NXɑ݂tB[hiDB񖼁j
    '	Dim str As String
    '	Dim strSQL As String

    '	Dim fields As FieldInfo() = t.GetFields(BindingFlags.Public Or BindingFlags.Instance Or BindingFlags.DeclaredOnly)
    '	Dim f As FieldInfo
    '	For Each f In fields									'tB[h̎擾
    '		fieldName.Add(f.Name)
    '	Next

    '	Dim iNum As Integer = 0
    '	strSQL = sqlCmd.CommandText								'SQL
    '	If strSQL.IndexOf(forupdate) > 0 Then					'SQL̒ forUpdate qg傪
    '		forUpdFlg = True
    '	End If

    '	Try
    '		If forUpdFlg = True Then							'for UpdatȅꍇAgUNVJn
    '			sqlCmd.Transaction = con.BeginTransaction()
    '			forUpdTran = True								'for UpdatẽgUNV
    '		End If

    '		Dim iTimeOut As Integer = getSTimeOut()
    '		If iTimeOut > -1 Then
    '			sqlCmd.CommandTimeout = iTimeOut
    '		End If

    '		Using dr As SqlDataReader = sqlCmd.ExecuteReader()
    '			Do While (dr.Read())
    '				Dim newObj As Object = Activator.CreateInstance(t)				'CX^X
    '				For Each str In fieldName
    '					If dr.Item(str) IsNot DBNull.Value Then						'NULLłȂΒl
    '						newObj.GetType().InvokeMember(str, BindingFlags.Public Or BindingFlags.Instance Or BindingFlags.SetField, Nothing, newObj, New Object() {dr.Item(str)})
    '					End If
    '				Next
    '				ar.Add(newObj)								'Xgɒǉ
    '				iNum += 1
    '			Loop
    '			dr.Close()
    '		End Using
    '	Catch ex As Exception							'ʂ֓`d
    '		If forUpdTran = True Then					'for UpdateŗOꍇAgUNVI
    '			sqlCmd.Transaction.Rollback()
    '			forUpdTran = False
    '		End If
    '		putLog()
    '		Throw
    '	Finally
    '		If iNum < 0 Then							'G[AԒlNA
    '			ar.Clear()
    '		End If
    '	End Try

    '	fieldName.Clear()
    '	Return iNum
    'End Function

	'''---------------------------------------------
	''' <summary>
	''' SELECTs
	''' </summary>
	''' <param name="t">SELECTʂ擾NX</param>
	''' <param name="ar">SELECTʂ̔z</param>
	''' <param name="autoTran">
	''' True:TRANSACTION\bhɔC<BR/>
	''' False:TRANSACTIONsȂ(͌ďoōs)<BR/>
	''' </param>
    ''' <returns>ʂ̃R[h</returns>
    ''' <remarks>
    ''' 2010/05/28 ύX CS)r<BR/>
    ''' </remarks>
	'''---------------------------------------------
    Public Function execQuery(ByVal t As Type, ByRef ar As ArrayList, Optional ByVal autoTran As Boolean = True) As Integer
		Dim forUpdFlg As Boolean = False						'True=for Update
		Dim fieldName As ArrayList = Nothing				'NXɑ݂tB[hiDB񖼁j
        Dim str As String
		Dim strSQL As String
		Dim fields As FieldInfo() = _
		 t.GetFields(BindingFlags.Public Or BindingFlags.Instance Or BindingFlags.DeclaredOnly)
		Dim f As FieldInfo
		Dim iNum As Integer = 0
		Dim strdt As DateTime = Nothing

		Try
			fieldName = New ArrayList

			If con Is Nothing OrElse sqlCmd Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return -1
			End If

			For Each f In fields									'tB[h̎擾
				fieldName.Add(f.Name)
			Next

			strSQL = sqlCmd.CommandText								'SQL
			If strSQL.IndexOf(forupdate) > 0 Then					'SQL̒ forUpdate qg傪
				forUpdFlg = True
			End If

			If forUpdFlg = True AndAlso autoTran = True Then	'for UpdatȅꍇAgUNVJn
				sqlCmd.Transaction = con.BeginTransaction()
				forUpdTran = True								'for UpdatẽgUNV
			End If

			Dim iTimeOut As Integer = getSTimeOut()
			If iTimeOut > -1 Then
				sqlCmd.CommandTimeout = iTimeOut
			End If

			strdt = Now

			Using dr As SqlDataReader = sqlCmd.ExecuteReader()
				Do While (dr.Read())
					Dim newObj As Object = Activator.CreateInstance(t)				'CX^X
					For Each str In fieldName
						If dr.Item(str) IsNot DBNull.Value Then						'NULLłȂΒl
							newObj.GetType().InvokeMember(str, BindingFlags.Public Or BindingFlags.Instance Or BindingFlags.SetField, Nothing, newObj, New Object() {dr.Item(str)})
						End If
					Next
					ar.Add(newObj)								'Xgɒǉ
					iNum += 1
				Loop
				dr.Close()
			End Using

			'If clsSysMst.logMode = clsSysMst.logLevel.DBG Then
			'	'fobO[hȂoߎԂOɏo͂
			'	clsSysMst.logEx(clsSysMst.logLevel.DBG, "-", "-", "-", "-", "-", _
			'	 DateDiff(DateInterval.Second, strdt, Now) & sqlCmd.CommandText)
			'End If
		Catch ex As Exception							'ʂ֓`d
			If forUpdTran = True Then					'for UpdateŗOꍇAgUNVI
				sqlCmd.Transaction.Rollback()
				forUpdTran = False
			End If
			putLog()
			Throw
		Finally
			If iNum < 0 Then							'G[AԒlNA
				ar.Clear()
			End If
		End Try

        fieldName.Clear()
        Return iNum
    End Function

    '''---------------------------------------------
    ''' <summary>
    ''' SELECTsiRetrywj
    ''' </summary>
    ''' <param name="t">SELECTʂ擾NX</param>
    ''' <param name="ar">SELECTʂ̔z</param>
    ''' <param name="pRetry">RetryFgC{,NonRetryFgC{Ȃ</param>
    ''' <param name="autoTran">
    ''' True:TRANSACTION\bhɔC<BR/>
    ''' False:TRANSACTIONsȂ(͌ďoōs)<BR/>
    ''' </param>
    ''' <returns>ʂ̃R[h</returns>
    ''' <remarks>
    ''' 2010/05/28 VK쐬 CS)r<BR/>
    ''' </remarks>
    '''---------------------------------------------
    Public Function execQuery(ByVal t As Type, ByRef ar As ArrayList, ByVal pRetry As Enum_Retry, Optional ByVal autoTran As Boolean = True) As Integer
        Dim forUpdFlg As Boolean = False                        'True=for Update
        Dim RetryCnt As Integer = 1
        Dim RetryTime As Integer = 0

        If con Is Nothing OrElse sqlCmd Is Nothing Then
            Throw New Exception(NOTCONNECT)                     'ڑmĂȂ
            Return -1
        End If

        Dim fieldName As New ArrayList                          'NXɑ݂tB[hiDB񖼁j
        Dim str As String
		Dim strSQL As String
		Dim strdt As DateTime = Nothing

        Dim fields As FieldInfo() = t.GetFields(BindingFlags.Public Or BindingFlags.Instance Or BindingFlags.DeclaredOnly)
        Dim f As FieldInfo
        For Each f In fields                                    'tB[h̎擾
            fieldName.Add(f.Name)
        Next

        Dim iNum As Integer = 0
        strSQL = sqlCmd.CommandText                             'SQL
        If strSQL.IndexOf(forupdate) > 0 Then                   'SQL̒ forUpdate qg傪
            forUpdFlg = True
        End If

        If pRetry = Enum_Retry.Retry Then
            RetryCnt = Me.dbRetryCnt
            RetryTime = Me.dbRetryTime
        End If

        ' for UpdatȅꍇAgC񐔕JԂ
        For retryidx As Integer = 1 To RetryCnt
            Try
                ' gUNVJn̏ꍇ͍ŏ̂݃gUNVJn邩肷
                If retryidx = 1 AndAlso forUpdFlg = True AndAlso autoTran = True Then    'for UpdatȅꍇAgUNVJn
                    sqlCmd.Transaction = con.BeginTransaction()
                    forUpdTran = True                               'for UpdatẽgUNV
                End If

                Dim iTimeOut As Integer = getSTimeOut()
                If iTimeOut > -1 Then
                    sqlCmd.CommandTimeout = iTimeOut
				End If

				strdt = Now

                Using dr As SqlDataReader = sqlCmd.ExecuteReader()
                    Do While (dr.Read())
                        Dim newObj As Object = Activator.CreateInstance(t)              'CX^X
                        For Each str In fieldName
                            If dr.Item(str) IsNot DBNull.Value Then                     'NULLłȂΒl
                                newObj.GetType().InvokeMember(str, BindingFlags.Public Or BindingFlags.Instance Or BindingFlags.SetField, Nothing, newObj, New Object() {dr.Item(str)})
                            End If
                        Next
                        ar.Add(newObj)                              'Xgɒǉ
                        iNum += 1
                    Loop
                    dr.Close()
				End Using

				'If clsSysMst.logMode = clsSysMst.logLevel.DBG Then
				'	'fobO[hȂoߎԂOɏo͂
				'	clsSysMst.logEx(clsSysMst.logLevel.DBG, "-", "-", "-", "-", "-", _
				'	 DateDiff(DateInterval.Second, strdt, Now) & sqlCmd.CommandText)
				'End If

                'ɏł̂ŏ[v𔲂
                Exit For
            Catch SqlEx As SqlClient.SqlException
                If SqlEx.Number = clsSysMst.sqlErrCode.RowLock Then
                    'bN̏ꍇ̂݃gCf
                    If retryidx <> RetryCnt AndAlso pRetry = Enum_Retry.Retry Then
                        'w肵~b҂
                        System.Threading.Thread.Sleep(RetryTime)
                        Continue For
                    End If
                End If
                'gCw񐔕să_G[ƂĕԂ
                If forUpdTran = True Then                   'for UpdateŗOꍇAgUNVI
                    sqlCmd.Transaction.Rollback()
                    forUpdTran = False
                End If
                putLog()
                Throw
            Catch ex As Exception                           'ʂ֓`d
                If forUpdTran = True Then                   'for UpdateŗOꍇAgUNVI
                    sqlCmd.Transaction.Rollback()
                    forUpdTran = False
                End If
                putLog()
                Throw
            Finally
                If iNum < 0 Then                            'G[AԒlNA
                    ar.Clear()
                End If
            End Try
        Next

        fieldName.Clear()
        Return iNum
    End Function

	'''---------------------------------------------
	''' <summary>
	''' INSERT,UPDATE,DELETEs
	''' </summary>
	''' <returns>-1=G[An=ʂ̃R[h</returns>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Overloads Function execNonQuery() As Integer
		Dim iNum As Integer = 0
		Dim str As DateTime = Nothing
		Try
			If con Is Nothing OrElse sqlCmd Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return -1
			End If

			If forUpdTran = False Then							'for UpdateȊO̓gUNVJn
				sqlCmd.Transaction = con.BeginTransaction()
			End If

			Dim iTimeOut As Integer = getSTimeOut()
			If iTimeOut > -1 Then
				sqlCmd.CommandTimeout = iTimeOut
			End If

			str = Now

			iNum = sqlCmd.ExecuteNonQuery()

			'If clsSysMst.logMode = clsSysMst.logLevel.DBG Then
			'	'fobO[hȂoߎԂOɏo͂
			'	clsSysMst.logEx(clsSysMst.logLevel.DBG, "-", "-", "-", "-", "-", _
			'	 DateDiff(DateInterval.Second, str, Now) & sqlCmd.CommandText)
			'End If

			sqlCmd.Transaction.Commit()							'R~bg
		Catch ex As Exception									'ʂ֓`d
			iNum = -1
			If sqlCmd.Transaction IsNot Nothing Then
				sqlCmd.Transaction.Rollback()						'O̓[obN
			End If
			putLog()
			Throw
		Finally
			forUpdTran = False									'for Update͂ǂ̃P[XłgUNVI
		End Try

		Return iNum
	End Function

	'''---------------------------------------------
	''' <summary>
	''' INSERT,UPDATE,DELETEs
	''' </summary>
	''' <param name="autoTran">
	''' True:TRANSACTION\bhɔC<BR/>
	''' False:TRANSACTIONsȂ(͌ďoōs)<BR/>
	''' </param>
	''' <returns>-1=G[An=ʂ̃R[h</returns>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Overloads Function execNonQuery(ByVal autoTran As Boolean) As Integer
		Dim iNum As Integer = 0
		Dim str As DateTime = Nothing
		Try
			If con Is Nothing OrElse sqlCmd Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return -1
			End If

			If forUpdTran = False AndAlso autoTran = True Then	'for UpdateȊO̓gUNVJn
				sqlCmd.Transaction = con.BeginTransaction()
			End If

			Dim iTimeOut As Integer = getSTimeOut()
			If iTimeOut > -1 Then
				sqlCmd.CommandTimeout = iTimeOut
			End If

			Str = Now

			iNum = sqlCmd.ExecuteNonQuery()

			'If clsSysMst.logMode = clsSysMst.logLevel.DBG Then
			'	'fobO[hȂoߎԂOɏo͂
			'	clsSysMst.logEx(clsSysMst.logLevel.DBG, "-", "-", "-", "-", "-", _
			'	 DateDiff(DateInterval.Second, str, Now) & sqlCmd.CommandText)
			'End If

			If autoTran = True Then
				sqlCmd.Transaction.Commit()						'R~bg
			End If
		Catch ex As Exception									'ʂ֓`d
			iNum = -1
			If sqlCmd.Transaction IsNot Nothing AndAlso autoTran = True Then
				sqlCmd.Transaction.Rollback()					'O̓[obN
			End If
			putLog()
			Throw
		Finally
			forUpdTran = False									'for Update͂ǂ̃P[XłgUNVI
		End Try

		Return iNum
	End Function

	'''---------------------------------------------
	''' <summary>
	''' SELECTsAʂp[^œnꂽDataTable֊i[
	''' </summary>
	''' <param name="tbl">ʊi[pDataTable</param>
	''' <remarks>
	''' 2007/10/11 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Sub execQueryDa(ByVal tbl As DataTable)
		Dim str As DateTime = Nothing
		Try
			If con Is Nothing Then								'ڑȂꍇ
				con = New SqlConnection(Url)					'ڑ
				con.Open()
			End If

			Dim iTimeOut As Integer = getSTimeOut()
			If iTimeOut > -1 Then
				sqlDa.SelectCommand.CommandTimeout = iTimeOut
			End If

			str = Now

			sqlDa.Fill(tbl)

			'If clsSysMst.logMode = clsSysMst.logLevel.DBG Then
			'	'fobO[hȂoߎԂOɏo͂
			'	Select Case True
			'		Case sqlDa.SelectCommand IsNot Nothing
			'			clsSysMst.logEx(clsSysMst.logLevel.DBG, "-", "-", "-", "-", "-", _
			'			 DateDiff(DateInterval.Second, str, Now) & sqlDa.SelectCommand.CommandText())
			'		Case sqlDa.InsertCommand IsNot Nothing
			'			clsSysMst.logEx(clsSysMst.logLevel.DBG, "-", "-", "-", "-", "-", _
			'			 DateDiff(DateInterval.Second, str, Now) & sqlDa.InsertCommand.CommandText())
			'		Case sqlDa.UpdateCommand IsNot Nothing
			'			clsSysMst.logEx(clsSysMst.logLevel.DBG, "-", "-", "-", "-", "-", _
			'			 DateDiff(DateInterval.Second, str, Now) & sqlDa.UpdateCommand.CommandText())
			'		Case sqlDa.DeleteCommand IsNot Nothing
			'			clsSysMst.logEx(clsSysMst.logLevel.DBG, "-", "-", "-", "-", "-", _
			'			 DateDiff(DateInterval.Second, str, Now) & sqlDa.DeleteCommand.CommandText())
			'		Case Else
			'	End Select
			'End If
		Catch ex As Exception
			putLogDa()
			Throw
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' INSERT,UPDATE,DELETEs
	''' </summary>
	''' <param name="tbl"></param>
	''' <param name="autoTran"></param>
	''' <returns></returns>
	''' <remarks>
	''' 2010/02/08 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Overloads Function execNonQueryDa(ByVal tbl As DataTable, ByVal autoTran As Boolean) As Integer

		Dim iNum As Integer = 0
		Dim cmd As SqlCommand = Nothing
		Dim str As DateTime = Nothing
		Try
			If con Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return -1
			End If

			Select Case True
				Case sqlDa.InsertCommand IsNot Nothing
					cmd = sqlDa.InsertCommand
				Case sqlDa.UpdateCommand IsNot Nothing
					cmd = sqlDa.UpdateCommand
				Case sqlDa.DeleteCommand IsNot Nothing
					cmd = sqlDa.DeleteCommand
			End Select

			If forUpdTran = False AndAlso autoTran = True Then	'for UpdateȊO̓gUNVJn
				cmd.Transaction = con.BeginTransaction()
			End If

			Dim iTimeOut As Integer = getSTimeOut()
			If iTimeOut > -1 Then
				cmd.CommandTimeout = iTimeOut
			End If

			str = Now

			iNum = sqlDa.Update(tbl)

			'If clsSysMst.logMode = clsSysMst.logLevel.DBG Then
			'	'fobO[hȂoߎԂOɏo͂
			'	Select Case True
			'		Case sqlDa.SelectCommand IsNot Nothing
			'			clsSysMst.logEx(clsSysMst.logLevel.DBG, "-", "-", "-", "-", "-", _
			'			 DateDiff(DateInterval.Second, str, Now) & sqlDa.SelectCommand.CommandText())
			'		Case sqlDa.InsertCommand IsNot Nothing
			'			clsSysMst.logEx(clsSysMst.logLevel.DBG, "-", "-", "-", "-", "-", _
			'			 DateDiff(DateInterval.Second, str, Now) & sqlDa.InsertCommand.CommandText())
			'		Case sqlDa.UpdateCommand IsNot Nothing
			'			clsSysMst.logEx(clsSysMst.logLevel.DBG, "-", "-", "-", "-", "-", _
			'			 DateDiff(DateInterval.Second, str, Now) & sqlDa.UpdateCommand.CommandText())
			'		Case sqlDa.DeleteCommand IsNot Nothing
			'			clsSysMst.logEx(clsSysMst.logLevel.DBG, "-", "-", "-", "-", "-", _
			'			 DateDiff(DateInterval.Second, str, Now) & sqlDa.DeleteCommand.CommandText())
			'		Case Else
			'	End Select
			'End If

			If autoTran = True Then
				cmd.Transaction.Commit()						'R~bg
			End If
		Catch ex As Exception									'ʂ֓`d
			iNum = -1
			If cmd.Transaction IsNot Nothing AndAlso autoTran = True Then
				cmd.Transaction.Rollback()						'O̓[obN
			End If
			putLogDa()
			Throw
		Finally
			forUpdTran = False									'for Update͂ǂ̃P[XłgUNVI
		End Try

		Return iNum
	End Function

	'''---------------------------------------------
	''' <summary>
	''' XgAhvV[W\̎s
	''' </summary>
	''' <returns>-1=G[An=ʂ̃R[h</returns>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Overloads Function execStoredProc() As Integer
		Dim iNum As Integer = 0
		Dim str As DateTime = Nothing
		Try
			If con Is Nothing OrElse sqlCmd Is Nothing Then
				Throw New Exception(NOTCONNECT)						'ڑmĂȂ
				Return -1
			End If

			If forUpdTran = False Then							'for UpdateȊO̓gUNVJn
				sqlCmd.Transaction = con.BeginTransaction()
			End If

			Dim iTimeOut As Integer = getSTimeOut()
			If iTimeOut > -1 Then
				sqlCmd.CommandTimeout = iTimeOut
			End If

			str = Now

			sqlCmd.CommandType = CommandType.StoredProcedure
			iNum = sqlCmd.ExecuteNonQuery()

			'If clsSysMst.logMode = clsSysMst.logLevel.DBG Then
			'	'fobO[hȂoߎԂOɏo͂
			'	clsSysMst.logEx(clsSysMst.logLevel.DBG, "-", "-", "-", "-", "-", _
			'	 DateDiff(DateInterval.Second, str, Now) & sqlCmd.CommandText)
			'End If

			If statTran() Then sqlCmd.Transaction.Commit() 'R~bg
		Catch ex As Exception									'ʂ֓`d
			iNum = -1
			If statTran() Then
				sqlCmd.Transaction.Rollback()						'O̓[obN
			End If
			putLog()
			Throw
		Finally
			forUpdTran = False									'for Update͂ǂ̃P[XłgUNVI
		End Try

		Return iNum
	End Function

	'''---------------------------------------------
	''' <summary>
	''' gUNV̊JnAR~bgA[obNs
	''' </summary>
	''' <param name="mode">
	''' Enum_TranMode.Begin:0:gUNVJn
	''' Enum_TranMode.Commit:1:R~bg
	''' Enum_TranMode.RollBack:2:[obN
	''' </param>
	''' <remarks></remarks>
	'''---------------------------------------------
	Public Sub ctlTran(ByVal mode As Integer, Optional ByVal retryFlg As Boolean = False)
		Try
			If retryFlg = True Then									'ڑOɐ؂ꍇ
				initSqlCmd()										'sqlCmd
				initCon()											'con
			End If

			If con Is Nothing Then								'ڑȂꍇ
				con = New SqlConnection(Url)					'ڑ
				con.Open()
				sqlCmd = New SqlCommand(DBNull.Value.ToString, con)
			Else												'ڑꍇ
				If sqlCmd Is Nothing Then						'sqlCommandȂꍇA쐬
					sqlCmd = New SqlCommand(DBNull.Value.ToString, con)
				End If
			End If

			Select Case mode
				Case Enum_TranMode.Begin
					sqlCmd.Transaction = con.BeginTransaction()		'gUNVJn
				Case Enum_TranMode.Commit
					sqlCmd.Transaction.Commit()						'R~bg
				Case Enum_TranMode.RollBack
					sqlCmd.Transaction.Rollback()				'[obN
				Case Else
			End Select
		Catch ex As Exception									'ʂ֓`d
			Throw
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' gUNVԂԂ
	''' </summary>
	''' <returns></returns>
	''' <remarks>
	''' 2009/11/12 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Function statTran() As Boolean
		Try
			If sqlCmd Is Nothing OrElse sqlCmd.Transaction Is Nothing Then
				Return False
			Else
				Return True
			End If
			'Return IIf(sqlCmd.Transaction Is Nothing, False, True)
		Catch ex As Exception
			Throw
		End Try
	End Function

	'''---------------------------------------------
	''' <summary>
	''' NULLNULLłȂ
	''' </summary>
	''' <param name="iStr"></param>
	''' <returns></returns>
	''' <remarks>
	''' 2009/11/12 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Function isNull(ByVal iStr As String) As Boolean

		If iStr IsNot Nothing AndAlso iStr.Equals(String.Empty) = False Then
			Return False
		Else
			Return True
		End If

	End Function

	'''---------------------------------------------
	''' <summary>
	''' Decimal^ւ̕ϊ
	''' </summary>
	''' <param name="iStr"></param>
	''' <returns></returns>
	''' <remarks>
	''' 2009/11/12 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Function chgNumeric(ByVal iStr As String) As Decimal
		Dim ret As Decimal = Nothing

		If iStr IsNot Nothing AndAlso iStr.Equals(String.Empty) = False Then
			Try
				ret = Decimal.Parse(iStr)
			Catch ex As Exception
			End Try
		End If
		Return ret
	End Function

	'''---------------------------------------------
	''' <summary>
	''' Integer^ւ̕ϊ
	''' </summary>
	''' <param name="iStr"></param>
	''' <returns></returns>
	''' <remarks>
	''' 2009/11/12 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Function chgInt(ByVal iStr As String) As Integer
		Dim ret As Integer = Nothing

		If iStr IsNot Nothing AndAlso iStr.Equals(String.Empty) = False Then
			Try
				ret = Integer.Parse(iStr)
			Catch ex As Exception
			End Try
		End If
		Return ret
	End Function

	'''---------------------------------------------
	''' <summary>
	''' String^ւ̕ϊ
	''' </summary>
	''' <param name="iStr"></param>
	''' <returns></returns>
	''' <remarks>
	''' 2009/11/12 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Function chgStr(ByVal iStr As String) As String
		Dim ret As String = Nothing

		If iStr IsNot Nothing AndAlso iStr.Equals(String.Empty) = False Then
			Try
				ret = iStr
			Catch ex As Exception
			End Try
		End If
		Return ret
	End Function

	'''---------------------------------------------
	''' <summary>
	''' ݒ肵SQLQƂ
	''' </summary>
	''' <returns>SQL</returns>
	''' <remarks>
	''' 2011/05/17 VK쐬 FJSK)r<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Function getSQL() As String
		Try
			If sqlCmd IsNot Nothing Then
				Return sqlCmd.CommandText()
			End If
			Return Nothing
		Catch ex As Exception
			Throw
		End Try
	End Function

	'''---------------------------------------------
	''' <summary>
	''' SQLsŗOSQLуp[^Oɏo͂
	''' </summary>
	''' <remarks>
	''' 2010/01/25 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub putLog(Optional ByVal str As String = Nothing)
		Dim sBuilder As New StringBuilder()
		Dim gID As String = Me.GetType.Assembly.GetName.Name
		Dim fID As String = Me.GetType.Name
		Dim sWork1 As String
		Dim sWork2 As String
		Try
			'sSQL
			If str Is Nothing Then
				sWork1 = sqlCmd.CommandText()
			Else
				sWork1 = str
			End If
			While sWork1.Length > 0
				sWork2 = clsMisc.fMidB(sWork1, 0, 1024)
				clsSysMst.logEx(clsSysMst.logLevel.ERR, gID, fID, "-", "-", "-", sWork2)
				sWork1 = sWork1.Substring(sWork2.Length)
			End While

			'Cƃp[^l
			For i As Integer = 0 To sqlCmd.Parameters.Count - 1
				sBuilder.Append(sqlCmd.Parameters(i).ParameterName + "=")
				sBuilder.Append(sqlCmd.Parameters(i).Value.ToString() + ",")
			Next i
			If sBuilder.Length > 0 Then
				sBuilder.Remove(sBuilder.Length - 1, 1)	'Ō̃J}폜
				sWork1 = sBuilder.ToString
				While sWork1.Length > 0
					sWork2 = clsMisc.fMidB(sWork1, 0, 1024)
					clsSysMst.logEx(clsSysMst.logLevel.ERR, gID, fID, "-", "-", "-", sWork2)
					sWork1 = sWork1.Substring(sWork2.Length)
				End While
			End If
		Catch ex As Exception
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' SQLsŗOSQLуp[^Oɏo͂
	''' </summary>
	''' <remarks>
	''' 2010/01/25 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub putLogDa()
		Dim sBuilder As StringBuilder = Nothing
		Dim gID As String = Me.GetType.Assembly.GetName.Name
		Dim fID As String = Me.GetType.Name
		Dim sWork1 As String
		Dim sWork2 As String
		Try
			sBuilder = New StringBuilder

			'sSQL
			'sWork1 = sqlDa.SelectCommand.CommandText()
			Select Case True
				Case sqlDa.SelectCommand IsNot Nothing
					sWork1 = sqlDa.SelectCommand.CommandText()
				Case sqlDa.InsertCommand IsNot Nothing
					sWork1 = sqlDa.InsertCommand.CommandText()
				Case sqlDa.UpdateCommand IsNot Nothing
					sWork1 = sqlDa.UpdateCommand.CommandText()
				Case sqlDa.DeleteCommand IsNot Nothing
					sWork1 = sqlDa.DeleteCommand.CommandText()
				Case Else
					sWork1 = Nothing
			End Select

			While sWork1.Length > 0
				sWork2 = clsMisc.fMidB(sWork1, 0, 1000)
				clsSysMst.logEx(clsSysMst.logLevel.ERR, gID, fID, "-", "-", "-", sWork2)
				sWork1 = sWork1.Substring(sWork2.Length)
			End While

			'Cƃp[^l
			For i As Integer = 0 To sqlDa.SelectCommand.Parameters.Count - 1
				sBuilder.Append(sqlDa.SelectCommand.Parameters(i).ParameterName + "=")
				sBuilder.Append(sqlDa.SelectCommand.Parameters(i).Value.ToString() + ",")
			Next i
			If sBuilder.Length > 0 Then
				sBuilder.Remove(sBuilder.Length - 1, 1)	'Ō̃J}폜
				sWork1 = sBuilder.ToString
				While sWork1.Length > 0
					sWork2 = clsMisc.fMidB(sWork1, 0, 1000)
					clsSysMst.logEx(clsSysMst.logLevel.ERR, gID, fID, "-", "-", "-", sWork2)
					sWork1 = sWork1.Substring(sWork2.Length)
				End While
			End If
		Catch ex As Exception
		End Try
	End Sub

	'-----------------------------------------
	'ȉAIDisposableŎǉȂ
	' Implements IDisposableǉ琶R[h
	'Rsy
	'-----------------------------------------
	Private disposedValue As Boolean = False		' dĂяooɂ

	' IDisposable
	Protected Overridable Sub Dispose(ByVal disposing As Boolean)
		If Not Me.disposedValue Then
			If disposing Then
				' TODO: IɌĂяoꂽƂɃ}l[W \[X܂
				Try
					initSqlCmd()											'sqlCommand
					initCon()												'con
				Catch ex As Exception
				End Try
			End If

			' TODO: L̃A}l[W \[X܂
		End If
		Me.disposedValue = True
	End Sub

#Region " IDisposable Support "
	' ̃R[h́Aj\ȃp^[𐳂ł悤 Visual Basic ɂĒǉ܂B
	Public Sub Dispose() Implements IDisposable.Dispose
		' ̃R[hύXȂłBN[Abv R[h Dispose(ByVal disposing As Boolean) ɋLq܂B
		Dispose(True)
		GC.SuppressFinalize(Me)
	End Sub
#End Region

End Class
