﻿Imports XCM

''' ---------------------------------------------
''' <summary>
''' 管理物明細情報一覧クラス　新規作成（修正番号：V4-14030）
''' </summary>
''' <remarks>
''' Copyright 2013 FUJITSU SYSTEMS WEST LIMITED All rights reserved.<BR/>
''' FUJITSU SYSTEMS WEST LIMITED CONFIDENTIAL<BR/>
''' </remarks>
''' ---------------------------------------------
Public Class XSI030R020
	Inherits XSI010R000

#Region "コンスタント"

	Private Const CST_LOG_CLASS As String = "患者基本一覧"

#End Region

#Region "コンストラクタ"

	''' ---------------------------------------------
	''' <summary>
	''' コンストラクタ
	''' </summary>
	''' <param name="pForm">呼出画面</param>
	''' <remarks>
	''' 2013/08/16 新規作成　ID)平井<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Sub New(ByVal pForm As frmBase)
		'IN項目引き継ぎ
		MyBase.New(pForm)
	End Sub

#End Region

#Region "メソッド"

	''' ---------------------------------------------
	''' <summary>
	''' ワークデータ確認
	''' </summary>
	''' <param name="pDb"></param>
	''' <returns></returns>
	''' <remarks>
	''' 2013/08/16 新規作成　ID)平井<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Protected Overrides Function getWorkData(ByVal pDb As clsDB) As Boolean
		clsSysMst.logEx(clsSysMst.logLevel.DBG, Me.GetType.Assembly.GetName.Name, Me.GetType.Name, "getWorkData", CST_LOG_PRODUCT, CST_LOG_CLASS, "ワークデータ確認 START")
		Dim result As Boolean
		Try
			result = False
			pDb.setSQLDa(sqlXSI030R020.sqlSel_MTT_IMP_LOG_MNGITEMINFO)
			'エラーフラグ
			pDb.setParamDa(sqlXSI030R020.prmERR_FLG, clsDB.Enum_dbType.dbInt)
			'正常
			If result = False AndAlso Me.pOkPrint = True Then
				pDb.setValDa(sqlXSI030R020.prmERR_FLG, 0, False)
				Using dt As New DataTable()
					pDb.execQueryDa(dt)
					If dt.Rows.Count > 0 Then result = True
				End Using
			End If
			'エラー
			If result = False AndAlso Me.pErrprint = True Then
				pDb.setValDa(sqlXSI030R020.prmERR_FLG, 1, False)
				Using dt As New DataTable()
					pDb.execQueryDa(dt)
					If dt.Rows.Count > 0 Then result = True
				End Using
			End If
			'軽度
			If result = False AndAlso Me.pSlightErrPrint = True Then
				pDb.setValDa(sqlXSI030R020.prmERR_FLG, 2, False)
				Using dt As New DataTable()
					pDb.execQueryDa(dt)
					If dt.Rows.Count > 0 Then result = True
				End Using
			End If

			Return result
		Catch ex As Exception
			Throw
		End Try
	End Function

#End Region

End Class
