﻿''' ---------------------------------------------
''' <summary>
''' システム連携（貸出管理）ＳＱＬクラス　新規作成（修正番号：V4-14030）
''' </summary>
''' <remarks>
''' Copyright 2013 FUJITSU SYSTEMS WEST LIMITED All rights reserved.<BR/>
''' FUJITSU SYSTEMS WEST LIMITED CONFIDENTIAL<BR/>
''' </remarks>
''' ---------------------------------------------
Public Class sqlXSI030F010

#Region "項目名"

	Public Const itmSELECTED As String = "SELECTED"							'選択
	Public Const itmMNGITEM_CD As String = "MNGITEM_CD"						'管理物コード
	Public Const itmMNGITEM_NM As String = "MNGITEM_NM"						'管理物
	Public Const itmALL_COUNT As String = "ALL_COUNT"						'有効件数
	Public Const itmNORMAL_COUNT As String = "NORMAL_COUNT"					'正常件数
	Public Const itmERROR_COUNT As String = "ERROR_COUNT"					'エラー件数
	Public Const itmSLIGHT_COUNT As String = "SLIGHT_COUNT"					'軽度等
	Public Const itmDATATYPE_CD As String = "DATATYPE_CD"					'データ種別
	Public Const itmPRE_CD As String = "PRE_CD"								'作成元
	Public Const itmUNIT_CD As String = "UNIT_CD"							'管理単位
	Public Const itmSERIAL_NO As String = "SERIAL_NO"						'連番

#End Region

#Region "パラメータ"

	Public Const prmPRE_CD As String = "@PRE_CD"							'作成元
	Public Const prmPATIENT_NO As String = "@PATIENT_NO"					'患者番号
	Public Const prmMNGITEM_CD As String = "@MNGITEM_CD"					'管理物コード
	Public Const prmDIV1_CD As String = "@DIV1_CD"							'区分１コード
	Public Const prmDIV2_CD As String = "@DIV2_CD"							'区分２コード
	Public Const prmVOLUMEKEY As String = "@VOLUMEKEY"						'分冊キー
	Public Const prmREG_DT As String = "@REG_DT"							'登録日時

	Public Const prmSERIAL_NO As String = "@SERIAL_NO"						'連番
	Public Const prmERR_FLG As String = "@ERR_FLG"							'エラーフラグ
	Public Const prmDATA_TYPE As String = "@DATA_TYPE"						'データ種別
	Public Const prmVOLUME_SERIAL_NO As String = "@VOLUME_SERIAL_NO"		'分冊連番
	Public Const prmFIRSTRECEIVING_DT As String = "@FIRSTRECEIVING_DT"		'初回受領日
	Public Const prmLASTRECEIVING_DT As String = "@LASTRECEIVING_DT"		'最終受領日
	Public Const prmRECIPIENT_CD As String = "@RECIPIENT_CD"				'受領者コード
	Public Const prmKEEPLCT_CD As String = "@KEEPLCT_CD"					'保管場所コード
	Public Const prmMNGSTATUS_CD As String = "@MNGSTATUS_CD"				'管理状況コード
	Public Const prmPERM_PRESERV_FLG As String = "@PERM_PRESERV_FLG"		'永久保存フラグ
	Public Const prmBYOREKI_NO As String = "@BYOREKI_NO"					'物番号
	Public Const prmDATE1 As String = "@DATE1"								'日付１
	Public Const prmDATE2 As String = "@DATE2"								'日付２
	Public Const prmDOCTOR_CD As String = "@DOCTOR_CD"						'医師コード
	Public Const prmMNGITEMCMB1 As String = "@MNGITEMCMB1"					'コンボ１コード
	Public Const prmMNGITEMCMB2 As String = "@MNGITEMCMB2"					'コンボ２コード
	Public Const prmMNGITEMTEXT1 As String = "@MNGITEMTEXT1"				'テキスト１
	Public Const prmMNGITEMTEXT2 As String = "@MNGITEMTEXT2"				'テキスト２
	Public Const prmMNGITEMTEXT3 As String = "@MNGITEMTEXT3"				'テキスト３
	Public Const prmMNGITEMCHK1 As String = "@MNGITEMCHK1"					'チェック１
	Public Const prmMNGITEMCHK2 As String = "@MNGITEMCHK2"					'チェック２
	Public Const prmMNGITEMCHK3 As String = "@MNGITEMCHK3"					'チェック３
	Public Const prmMNGITEMCHK4 As String = "@MNGITEMCHK4"					'チェック４
	Public Const prmSPARE01 As String = "@SPARE01"							'予備１
	Public Const prmSPARE02 As String = "@SPARE02"							'予備２
	Public Const prmSPARE03 As String = "@SPARE03"							'予備３
	Public Const prmSPARE04 As String = "@SPARE04"							'予備４
	Public Const prmSPARE05 As String = "@SPARE05"							'予備５
	Public Const prmMODULE_CD As String = "@MODULE_CD"						'モジュールコード
	Public Const prmERR_CD As String = "@ERR_CD"							'エラーコード
	Public Const prmMESSAGE As String = "@MESSAGE"							'メッセージ
	Public Const prmLASTUPDUSER_CD As String = "@LASTUPDUSER_CD"			'更新者コード
	Public Const prmLASTUPD_DT As String = "@LASTUPD_DT"					'更新日
	Public Const prmREMARKS As String = "@REMARKS"							'備考

	Public Const prmPATIENT_NM As String = "@PATIENT_NM"					'氏名
	Public Const prmPATIENT_KNM As String = "@PATIENT_KNM"					'氏名カナ
	Public Const prmGENDER_CD As String = "@GENDER_CD"						'性別コード
	Public Const prmBIRTH_DT As String = "@BIRTH_DT"						'生年月日
	Public Const prmBLOODTYPE_CD As String = "@BLOODTYPE_CD"				'血液型コード
	Public Const prmRH_CD As String = "@RH_CD"								'Ｒｈコード
	Public Const prmDEPT_CD As String = "@DEPT_CD"							'診療科コード
	Public Const prmMAIN_DPM_FLG As String = "@MAIN_DPM_FLG"				'主科フラグ
	Public Const prmHSP_CNL_CD As String = "@HSP_CNL_CD"					'入院経路コード
	Public Const prmHSP_DT As String = "@HSP_DT"							'入院日
	Public Const prmHSP_FLG As String = "@HSP_FLG"							'入院フラグ
	Public Const prmHSP_TIME As String = "@HSP_TIME"						'入院時刻
	Public Const prmOUT_HSP_DT As String = "@OUT_HSP_DT"					'退院日
	Public Const prmOUT_HSP_FLG As String = "@OUT_HSP_FLG"					'退院フラグ
	Public Const prmOUT_HSP_TIME As String = "@OUT_HSP_TIME"				'退院時刻
	Public Const prmOUT_HSP_CNL_CD As String = "@OUT_HSP_CNL_CD"			'退院経路コード
	Public Const prmOUT_HSP_OUTCOME_CD As String = "@OUT_HSP_OUTCOME_CD"	'退院転帰コード
	Public Const prmWARD_CD As String = "@WARD_CD"							'病棟コード
	Public Const prmMAIN_WARD_FLG As String = "@MAIN_WARD_FLG"				'主病棟フラグ
	Public Const prmDOCTOR_DIV As String = "@DOCTOR_DIV"					'医師区分コード
	Public Const prmATTEND_START_DT As String = "@ATTEND_START_DT"			'担当開始日
	Public Const prmATTEND_END_DT As String = "@ATTEND_END_DT"				'担当終了日
	Public Const prmTAKE_AMBULANCE_CHK As String = "@TAKE_AMBULANCE_CHK"	'救急車有無コード
	Public Const prmINTRODUCTION_CHK As String = "@INTRODUCTION_CHK"		'紹介状有無コード
	Public Const prmZIP_CD As String = "@ZIP_CD"							'郵便番号
	Public Const prmAREA_CD As String = "@AREA_CD"							'診療圏コード
	Public Const prmADDRESS_NM As String = "@ADDRESS_NM"					'住所
	Public Const prmTELNUMBER As String = "@TELNUMBER"						'電話番号
	Public Const prmNATIONALITY_CD As String = "@NATIONALITY_CD"			'国籍コード
	Public Const prmDOMICILE_ADDRESS_CD As String = "@DOMICILE_ADDRESS_CD"	'出生地コード
	Public Const prmDOMICILE_ADDRESS As String = "@DOMICILE_ADDRESS"		'本籍住所
	Public Const prmINSURANCE_CD1 As String = "@INSURANCE_CD1"				'保険コード１
	Public Const prmINSURANCE_CD2 As String = "@INSURANCE_CD2"				'保険コード２
	Public Const prmINSURANCE_CD3 As String = "@INSURANCE_CD3"				'保険コード３
	Public Const prmFIRST_DIAGNOSIS_DT As String = "@FIRST_DIAGNOSIS_DT"	'初診日
	Public Const prmRELATION_PATIENT_NO As String = "@RELATION_PATIENT_NO"	'関連患者番号
	Public Const prmHOUSEHOLDER_NM As String = "@HOUSEHOLDER_NM"			'世帯主名
	Public Const prmRELATION_CD As String = "@RELATION_CD"					'続柄コード
	Public Const prmTO_DEPT_DOCTOR_DIV As String = "@TO_DEPT_DOCTOR_DIV"	'転科先医師区分コード
	Public Const prmTO_DEPT_DOCTOR_CD As String = "@TO_DEPT_DOCTOR_CD"		'転科先医師コード
	Public Const prmTO_DEPT_BYOREKI_NO As String = "@TO_DEPT_BYOREKI_NO"	'転科先病歴番号
	Public Const prmDPC_HSP As String = "@DPC_HSP"							'ＤＰＣ入退院歴

	Public Const prmSTART_DT As String = "@START_DT"						'開始日
	Public Const prmEND_DT As String = "@END_DT"							'終了日

#End Region

#Region "ＳＱＬ文"

	'XTI_基本情報　取得
	Public Const sqlSel_XTI_BASICINFO As String =
	" SELECT " _
	& " PATIENT_NO" _
	& " FROM XTI_BASICINFO" _
	& " WHERE PATIENT_NO = " & prmPATIENT_NO

	'管理物情報　取得
	Public Const sqlSel_LTI_MNGITEMINFO As String =
	" SELECT TOP 1" _
	& " PATIENT_NO" _
	& " FROM LTI_MNGITEMINFO" _
	& " WHERE PATIENT_NO = " & prmPATIENT_NO _
	& "   AND MNGITEM_CD = " & prmMNGITEM_CD

	'管理物情報　WHERE 区分１
	Public Const sqlSel_LTI_MNGITEMINFO_WHERE_DIV1_CD As String =
	"   AND DIV1_CD = " & prmDIV1_CD

	'管理物情報　WHERE 区分２
	Public Const sqlSel_LTI_MNGITEMINFO_WHERE_DIV2_CD As String =
	"   AND DIV2_CD = " & prmDIV2_CD

	'管理物情報　WHERE 分冊キー
	Public Const sqlSel_LTI_MNGITEMINFO_WHERE_VOLUMEKEY As String =
	"   AND VOLUMEKEY = " & prmVOLUMEKEY

	'管理物情報　WHERE 分冊キーNULL
	Public Const sqlSel_LTI_MNGITEMINFO_WHERE_VOLUMEKEY_NULL As String =
	"   AND VOLUMEKEY IS NULL"

	' 最大連番取得
	Public Const strSql_MaxSerialNo As String = _
	"SELECT ISNULL(MAX(SERIAL_NO), 0) AS SERIAL_NO" _
	& " FROM LTI_MNGITEMINFO" _
	& " WHERE PATIENT_NO = " & prmPATIENT_NO _
	& "   AND MNGITEM_CD = " & prmMNGITEM_CD

	' 入退院情報取得
	Public Const strSql_Sel_Hsp As String = _
	"SELECT" _
	& " PATIENT_NO," _
	& " HSP_HISTORY_NO," _
	& " BYOREKI_NO," _
	& " DEPT_CD," _
	& " WARD_CD," _
	& " DOCTOR_CD," _
	& " HSP_CNL_CD," _
	& " READMISSION_FLG," _
	& " HSP_AIM_CD," _
	& " HSP_FORM_CD," _
	& " HSP_DT," _
	& " HSP_TIME," _
	& " HSP_AGE," _
	& " HSP_MONTH_AGE," _
	& " HSP_DAY_AGE," _
	& " OUT_HSP_DT," _
	& " OUT_HSP_TIME," _
	& " OUT_HSP_AGE," _
	& " OUT_HSP_MONTH_AGE," _
	& " OUT_HSP_DAY_AGE," _
	& " OUT_HSP_CNL_CD," _
	& " OUT_HSP_OUTCOME_CD," _
	& " HSP_DAYS," _
	& " CHANGE_DEPT_CHK," _
	& " HOLD_DEPT_CHK," _
	& " TAKE_AMBULANCE_CHK," _
	& " PLAN_EMERGENCY_CD," _
	& " CLINICAL_TRIAL_CHK," _
	& " LAST_SELF_OTHER_HSP_DIV," _
	& " LAST_OUT_HSP_DT," _
	& " DPC_NO," _
	& " TOTAL_MED_COST," _
	& " MED_COST_COUNT," _
	& " EXCLUDE_STATISTICS_FLG," _
	& " SAME_DISEASE_LAST_HSP_DT," _
	& " REMARKS," _
	& " HSP_INFECTION_CHK," _
	& " HSP_FREEITEM1," _
	& " HSP_FREEITEM2," _
	& " HSP_FREEITEM3," _
	& " HSP_FREEITEM4," _
	& " HSP_FREEITEM5," _
	& " HSP_FREEITEM6," _
	& " DISEASE_READMISSION_FLG," _
	& " STATURE," _
	& " WEIGHT," _
	& " TIME_OUT_FLG," _
	& " DATA_CAPTURE_DT," _
	& " NEW_REG_DT" _
	& " FROM MTI_HSP" _
	& " WHERE PATIENT_NO = " & prmPATIENT_NO _
	& "   AND DEPT_CD = " & prmDEPT_CD

	' 入退院情報取得（WHERE 入院日）
	Public Const strSql_Sel_Hsp_Where_Hsp_Dt As String = _
	"   AND HSP_DT = " & prmHSP_DT

	' 入退院情報取得（WHERE 退院日）
	Public Const strSql_Sel_Hsp_Where_Out_Hsp_Dt As String = _
	"   AND OUT_HSP_DT = " & prmOUT_HSP_DT

	' 入退院情報取得（ORDER）
	Public Const strSql_Sel_Hsp_Order As String = _
	" ORDER BY PATIENT_NO, HSP_HISTORY_NO"

	' 科歴情報取得
	Public Const strSql_Sel_Ch As String = _
	"SELECT" _
	& " PATIENT_NO," _
	& " HSP_HISTORY_NO," _
	& " CH_NO," _
	& " BYOREKI_NO," _
	& " DEPT_CD," _
	& " WARD_CD," _
	& " DOCTOR_CD," _
	& " HSP_FLG," _
	& " OUT_HSP_FLG," _
	& " MAIN_DPM_FLG," _
	& " ZIP_CD," _
	& " AREA_CD," _
	& " ADDRESS_NM," _
	& " TELNUMBER," _
	& " READMISSION_FLG," _
	& " HSP_AIM_CD," _
	& " HSP_FORM_CD," _
	& " INTRODUCED_CD," _
	& " INTRODUCED_NM," _
	& " INTRODUCED_DOCTOR_NM," _
	& " INTRODUCED_REMARKS," _
	& " REFERENCE_CD," _
	& " REFERENCE_NM," _
	& " REFERENCE_DOCTOR_NM," _
	& " REFERENCE_REMARKS," _
	& " START_CNL_CD," _
	& " START_DT," _
	& " START_TIME," _
	& " START_AGE," _
	& " START_MONTH_AGE," _
	& " START_DAY_AGE," _
	& " END_DT," _
	& " END_TIME," _
	& " END_AGE," _
	& " END_MONTH_AGE," _
	& " END_DAY_AGE," _
	& " HSP_DAYS," _
	& " END_CNL_CD," _
	& " END_OUTCOME_CD," _
	& " STATURE," _
	& " WEIGHT," _
	& " INSURANCE_CD1," _
	& " INSURANCE_CD2," _
	& " INSURANCE_CD3," _
	& " CURRENT_JOB_CD," _
	& " FIRST_DIAGNOSIS_DT," _
	& " OTHER_DEPT_CHK," _
	& " BLOOD_TRAN_CHK," _
	& " OPE_CHK," _
	& " DPC_CD," _
	& " TOTAL_MED_COST," _
	& " INFECTION1," _
	& " INFECTION2," _
	& " INFECTION3," _
	& " INFECTION4," _
	& " INFECTION5," _
	& " INFECTION6," _
	& " OTHER_INFECTION," _
	& " ALLERGY1," _
	& " ALLERGY2," _
	& " ALLERGY3," _
	& " ALLERGY4," _
	& " ALLERGY5," _
	& " ALLERGY6," _
	& " OTHER_ALLERGY," _
	& " LAST_OUT_HSP_DT," _
	& " LAST_SELF_OTHER_HSP_DIV," _
	& " COMMENT," _
	& " EXCLUDE_STATISTICS_FLG," _
	& " REG_STATUS_CD," _
	& " REG_FINISHED_DT," _
	& " REG_PERSON_CD," _
	& " DISEASE_COUNT," _
	& " OPE_COUNT," _
	& " CARE_COUNT," _
	& " TEST_COUNT," _
	& " ASST_ITM1_COUNT," _
	& " ASST_ITM2_COUNT," _
	& " CB_COUNT," _
	& " EMERGENCY_COUNT," _
	& " OTHER_DEPT_COUNT," _
	& " MED_COST_COUNT," _
	& " HOUSEHOLDER_NM," _
	& " RELATION_CD," _
	& " TAKE_AMBULANCE_CHK," _
	& " PLAN_EMERGENCY_CD," _
	& " CLINICAL_TRIAL_CHK," _
	& " CNR_REG_COUNT," _
	& " CNR_REG_EXPECTED_COUNT," _
	& " SAME_DISEASE_LAST_HSP_DT," _
	& " REMARKS," _
	& " HSP_INFECTION_CHK," _
	& " DISEASE_READMISSION_FLG," _
	& " PATH_COUNT," _
	& " PAST_JOB_CD," _
	& " LIVE_TOGETHER_STATE_CD," _
	& " INTRODUCTION_CHK," _
	& " TIME_OUT_FLG," _
	& " DATA_CAPTURE_DT," _
	& " NEW_REG_DT" _
	& " FROM MTI_CH" _
	& " WHERE PATIENT_NO = " & prmPATIENT_NO _
	& "   AND DEPT_CD = " & prmDEPT_CD

	' 科歴情報取得（WHERE 開始日）
	Public Const strSql_Sel_Ch_Where_Start_Dt As String = _
	"   AND START_DT = " & prmSTART_DT

	' 科歴情報取得（WHERE 囚虜日）
	Public Const strSql_Sel_Ch_Where_End_Dt As String = _
	"   AND END_DT = " & prmEND_DT

	' 科歴情報取得（ORDER）
	Public Const strSql_Sel_Ch_Order As String = _
	" ORDER BY PATIENT_NO, HSP_HISTORY_NO, CH_NO"

	' 基本情報取得
	Public Const strSql_Sel_BasicInfo As String = _
	"SELECT" _
	 & " PATIENT_NO," _
	 & " PATIENT_NM," _
	 & " PATIENT_KNM," _
	 & " PREVIOUS1_NM," _
	 & " PREVIOUS1_KNM," _
	 & " PREVIOUS2_NM," _
	 & " PREVIOUS2_KNM," _
	 & " GENDER_CD," _
	 & " BIRTH_DT," _
	 & " BLOODTYPE_CD," _
	 & " RH_CD," _
	 & " BLOOD_TRAN_CHK," _
	 & " RELATION_PATIENT_NO," _
	 & " SMOKING_CHK," _
	 & " SMOKING_START_AGE," _
	 & " SMOKING_END_AGE," _
	 & " SMOKING_COUNT," _
	 & " SMOKING_AGE," _
	 & " DRINKING_CHK," _
	 & " PREGNANCY_CHK," _
	 & " PREGNANCY_COUNT," _
	 & " CB_CHK," _
	 & " CB_COUNT," _
	 & " MENARCHE_AGE," _
	 & " MENOPAUSE_AGE," _
	 & " REMARKS," _
	 & " FIRSTHSPVST_DT," _
	 & " LASTHSPVST_DT," _
	 & " LASTDEPT_CD," _
	 & " LASTLEFTHSP_DT," _
	 & " NATIONALITY_CD," _
	 & " DOMICILE_ADDRESS_CD," _
	 & " DOMICILE_ADDRESS," _
	 & " CONTACT_PATIENT_NM," _
	 & " CONTACT_RELATION," _
	 & " CONTACT_ZIP_CD," _
	 & " CONTACT_TELNUMBER," _
	 & " CONTACT_ADDRESS" _
	 & " FROM XTI_BASICINFO" _
	 & " WHERE PATIENT_NO = " & prmPATIENT_NO

#End Region

#Region "システム連携_管理物情報SQLクラス"

	''' ---------------------------------------------
	''' <summary>
	''' 管理物情報登録
	''' </summary>
	''' ---------------------------------------------
	Public Const sqlIns_LTI_MNGITEMINFO As String =
		" INSERT INTO LTI_MNGITEMINFO (" _
		& " PATIENT_NO," _
		& " MNGITEM_CD," _
		& " SERIAL_NO," _
		& " BYOREKI_NO," _
		& " DIV1_CD," _
		& " DIV2_CD," _
		& " FIRSTRECEIVING_DT," _
		& " LASTRECEIVING_DT," _
		& " RECIPIENT_CD," _
		& " KEEPLCT_CD," _
		& " MNGSTATUS_CD," _
		& " REMARKS," _
		& " DATE1," _
		& " DATE2," _
		& " DOCTOR_CD," _
		& " MNGITEMCMB1," _
		& " MNGITEMCMB2," _
		& " MNGITEMTEXT1," _
		& " MNGITEMTEXT2," _
		& " MNGITEMCHK1," _
		& " MNGITEMCHK2," _
		& " MNGITEMCHK3," _
		& " MNGITEMCHK4," _
		& " VOLUMEKEY," _
		& " LASTUPDUSER_CD," _
		& " LASTUPD_DT" _
		& ") VALUES (" _
		& prmPATIENT_NO & "," _
		& prmMNGITEM_CD & "," _
		& "(" _
		& "  SELECT ISNULL(MAX(SERIAL_NO) + 1, 1) AS SERIAL_NO" _
		& "   FROM LTI_MNGITEMINFO" _
		& "  WHERE PATIENT_NO = " & prmPATIENT_NO & " AND MNGITEM_CD = " & prmMNGITEM_CD _
		& ")," _
		& prmBYOREKI_NO & "," _
		& prmDIV1_CD & "," _
		& prmDIV2_CD & "," _
		& prmFIRSTRECEIVING_DT & "," _
		& prmLASTRECEIVING_DT & "," _
		& prmRECIPIENT_CD & "," _
		& prmKEEPLCT_CD & "," _
		& prmMNGSTATUS_CD & "," _
		& prmREMARKS & "," _
		& prmDATE1 & "," _
		& prmDATE2 & "," _
		& prmDOCTOR_CD & "," _
		& prmMNGITEMCMB1 & "," _
		& prmMNGITEMCMB2 & "," _
		& prmMNGITEMTEXT1 & "," _
		& prmMNGITEMTEXT2 & "," _
		& prmMNGITEMCHK1 & "," _
		& prmMNGITEMCHK2 & "," _
		& prmMNGITEMCHK3 & "," _
		& prmMNGITEMCHK4 & "," _
		& prmVOLUMEKEY & "," _
		& prmLASTUPDUSER_CD & "," _
		& prmLASTUPD_DT _
		& ")"

#End Region

#Region "システム連携_【管理物明細情報】ログSQLクラス"

#Region "パラメータ"

#End Region

#Region "INSERT"

	''' ---------------------------------------------
	''' <summary>
	''' 【基本情報】ログ追加SQL
	''' </summary>
	''' ---------------------------------------------
	Public Const sqlIns_LTT_IMP_LOG_MNGITEMINFO As String =
		" INSERT INTO LTT_IMP_LOG_MNGITEMINFO (" _
		& " REG_DT," _
		& " SERIAL_NO," _
		& " ERR_FLG," _
		& " DATA_TYPE," _
		& " PATIENT_NO," _
		& " MNGITEM_CD," _
		& " DIV1_CD," _
		& " DIV2_CD," _
		& " VOLUME_SERIAL_NO," _
		& " FIRSTRECEIVING_DT," _
		& " LASTRECEIVING_DT," _
		& " RECIPIENT_CD," _
		& " KEEPLCT_CD," _
		& " MNGSTATUS_CD," _
		& " PERM_PRESERV_FLG," _
		& " BYOREKI_NO," _
		& " DATE1," _
		& " DATE2," _
		& " DOCTOR_CD," _
		& " MNGITEMCMB1," _
		& " MNGITEMCMB2," _
		& " MNGITEMTEXT1," _
		& " MNGITEMTEXT2," _
		& " MNGITEMTEXT3," _
		& " MNGITEMCHK1," _
		& " MNGITEMCHK2," _
		& " MNGITEMCHK3," _
		& " MNGITEMCHK4," _
		& " SPARE01," _
		& " SPARE02," _
		& " SPARE03," _
		& " SPARE04," _
		& " SPARE05," _
		& " MODULE_CD," _
		& " ERR_CD," _
		& " MESSAGE," _
		& " LASTUPDUSER_CD," _
		& " LASTUPD_DT" _
		& ") VALUES (" _
		& prmREG_DT & "," _
		& prmSERIAL_NO & "," _
		& prmERR_FLG & "," _
		& prmDATA_TYPE & "," _
		& prmPATIENT_NO & "," _
		& prmMNGITEM_CD & "," _
		& prmDIV1_CD & "," _
		& prmDIV2_CD & "," _
		& prmVOLUME_SERIAL_NO & "," _
		& prmFIRSTRECEIVING_DT & "," _
		& prmLASTRECEIVING_DT & "," _
		& prmRECIPIENT_CD & "," _
		& prmKEEPLCT_CD & "," _
		& prmMNGSTATUS_CD & "," _
		& prmPERM_PRESERV_FLG & "," _
		& prmBYOREKI_NO & "," _
		& prmDATE1 & "," _
		& prmDATE2 & "," _
		& prmDOCTOR_CD & "," _
		& prmMNGITEMCMB1 & "," _
		& prmMNGITEMCMB2 & "," _
		& prmMNGITEMTEXT1 & "," _
		& prmMNGITEMTEXT2 & "," _
		& prmMNGITEMTEXT3 & "," _
		& prmMNGITEMCHK1 & "," _
		& prmMNGITEMCHK2 & "," _
		& prmMNGITEMCHK3 & "," _
		& prmMNGITEMCHK4 & "," _
		& prmSPARE01 & "," _
		& prmSPARE02 & "," _
		& prmSPARE03 & "," _
		& prmSPARE04 & "," _
		& prmSPARE05 & "," _
		& prmMODULE_CD & "," _
		& prmERR_CD & "," _
		& prmMESSAGE & "," _
		& prmLASTUPDUSER_CD & "," _
		& prmLASTUPD_DT _
		& ")"

#End Region

#Region "DELETE"

	''' ---------------------------------------------
	''' <summary>
	''' 【基本情報】ログ削除SQL
	''' </summary>
	''' ---------------------------------------------
	Public Const sqlDel_LTT_IMP_LOG_MNGITEMINFO As String = "DELETE FROM LTT_IMP_LOG_MNGITEMINFO "

#End Region

#End Region

#Region "システム連携_【患者入退院歴から】ログSQLクラス"

#Region "パラメータ"

#End Region

#Region "INSERT"

	''' ---------------------------------------------
	''' <summary>
	''' 【患者入退院歴から】ログ追加SQL
	''' </summary>
	''' ---------------------------------------------
	Public Const sqlIns_LTT_IMP_LOG_BASIC_HSP As String =
		" INSERT INTO LTT_IMP_LOG_BASIC_HSP (" _
		& " REG_DT," _
		& " SERIAL_NO," _
		& " ERR_FLG," _
		& " DATA_TYPE," _
		& " MNGITEM_CD," _
		& " PATIENT_NO," _
		& " PATIENT_NM," _
		& " PATIENT_KNM," _
		& " GENDER_CD," _
		& " BIRTH_DT," _
		& " BLOODTYPE_CD," _
		& " RH_CD," _
		& " BYOREKI_NO," _
		& " DEPT_CD," _
		& " MAIN_DPM_FLG," _
		& " HSP_CNL_CD," _
		& " HSP_DT," _
		& " HSP_FLG," _
		& " HSP_TIME," _
		& " OUT_HSP_DT," _
		& " OUT_HSP_FLG," _
		& " OUT_HSP_TIME," _
		& " OUT_HSP_CNL_CD," _
		& " OUT_HSP_OUTCOME_CD," _
		& " WARD_CD," _
		& " MAIN_WARD_FLG," _
		& " DOCTOR_DIV," _
		& " DOCTOR_CD," _
		& " ATTEND_START_DT," _
		& " ATTEND_END_DT," _
		& " TAKE_AMBULANCE_CHK," _
		& " INTRODUCTION_CHK," _
		& " ZIP_CD," _
		& " AREA_CD," _
		& " ADDRESS_NM," _
		& " TELNUMBER," _
		& " NATIONALITY_CD," _
		& " DOMICILE_ADDRESS_CD," _
		& " DOMICILE_ADDRESS," _
		& " INSURANCE_CD1," _
		& " INSURANCE_CD2," _
		& " INSURANCE_CD3," _
		& " FIRST_DIAGNOSIS_DT," _
		& " RELATION_PATIENT_NO," _
		& " HOUSEHOLDER_NM," _
		& " RELATION_CD," _
		& " TO_DEPT_DOCTOR_DIV," _
		& " TO_DEPT_DOCTOR_CD," _
		& " TO_DEPT_BYOREKI_NO," _
		& " DPC_HSP," _
		& " SPARE01," _
		& " SPARE02," _
		& " SPARE03," _
		& " SPARE04," _
		& " MODULE_CD," _
		& " ERR_CD," _
		& " MESSAGE," _
		& " LASTUPDUSER_CD," _
		& " LASTUPD_DT" _
		& ") VALUES (" _
		& prmREG_DT & "," _
		& prmSERIAL_NO & "," _
		& prmERR_FLG & "," _
		& prmDATA_TYPE & "," _
		& prmMNGITEM_CD & "," _
		& prmPATIENT_NO & "," _
		& prmPATIENT_NM & "," _
		& prmPATIENT_KNM & "," _
		& prmGENDER_CD & "," _
		& prmBIRTH_DT & "," _
		& prmBLOODTYPE_CD & "," _
		& prmRH_CD & "," _
		& prmBYOREKI_NO & "," _
		& prmDEPT_CD & "," _
		& prmMAIN_DPM_FLG & "," _
		& prmHSP_CNL_CD & "," _
		& prmHSP_DT & "," _
		& prmHSP_FLG & "," _
		& prmHSP_TIME & "," _
		& prmOUT_HSP_DT & "," _
		& prmOUT_HSP_FLG & "," _
		& prmOUT_HSP_TIME & "," _
		& prmOUT_HSP_CNL_CD & "," _
		& prmOUT_HSP_OUTCOME_CD & "," _
		& prmWARD_CD & "," _
		& prmMAIN_WARD_FLG & "," _
		& prmDOCTOR_DIV & "," _
		& prmDOCTOR_CD & "," _
		& prmATTEND_START_DT & "," _
		& prmATTEND_END_DT & "," _
		& prmTAKE_AMBULANCE_CHK & "," _
		& prmINTRODUCTION_CHK & "," _
		& prmZIP_CD & "," _
		& prmAREA_CD & "," _
		& prmADDRESS_NM & "," _
		& prmTELNUMBER & "," _
		& prmNATIONALITY_CD & "," _
		& prmDOMICILE_ADDRESS_CD & "," _
		& prmDOMICILE_ADDRESS & "," _
		& prmINSURANCE_CD1 & "," _
		& prmINSURANCE_CD2 & "," _
		& prmINSURANCE_CD3 & "," _
		& prmFIRST_DIAGNOSIS_DT & "," _
		& prmRELATION_PATIENT_NO & "," _
		& prmHOUSEHOLDER_NM & "," _
		& prmRELATION_CD & "," _
		& prmTO_DEPT_DOCTOR_DIV & "," _
		& prmTO_DEPT_DOCTOR_CD & "," _
		& prmTO_DEPT_BYOREKI_NO & "," _
		& prmDPC_HSP & "," _
		& prmSPARE01 & "," _
		& prmSPARE02 & "," _
		& prmSPARE03 & "," _
		& prmSPARE04 & "," _
		& prmMODULE_CD & "," _
		& prmERR_CD & "," _
		& prmMESSAGE & "," _
		& prmLASTUPDUSER_CD & "," _
		& prmLASTUPD_DT _
		& ")"

#End Region

#Region "DELETE"

	''' ---------------------------------------------
	''' <summary>
	''' 【患者入退院歴から】ログ削除SQL
	''' </summary>
	''' ---------------------------------------------
	Public Const sqlDel_LTT_IMP_LOG_BASIC_HSP As String = "DELETE FROM LTT_IMP_LOG_BASIC_HSP "

#End Region

#End Region

End Class
