Imports System.Windows.Forms
Imports System.ComponentModel
Imports XCM
Imports XSP

''' ---------------------------------------------
''' <summary>
''' Zʏ
''' </summary>
''' <remarks>
''' Copyright 2010 FUJITSU SHIKOKU SYSTEMS LIMITED All rights reserved.<BR/>
''' FUJITSU SHIKOKU SYSTEMS LIMITED CONFIDENTIAL<BR/>
''' </remarks>
''' ---------------------------------------------
Public Class XSP090F010

#Region "RX^g"

	Private Const WILDCARDCHAR As String = "%"	'ChJ[h
	Private Const C_PREFECTURE_CD As String = "c01022XSP090F010"
	Private Const C_MUNICIPALITY_CD As String = "c01023XSP090F010"

#End Region

#Region "ϐ"

	'Ol擾EۑRg[
	Private LastValueCtl() As String = { _
	"tab003XSP090F010", "cmb002XSP090F010", _
	"chk005XSP090F010", "chk008XSP090F010", "chk011XSP090F010", "chk014XSP090F010", "chk017XSP090F010", _
	"lik016XSP090F010", "lik019XSP090F010" _
	}

	Private _PREFECTURE_CD As String							's{R[h
	Private _MUNICIPALITY_CD As String							's撬R[h
	Private _DISTRICT_CD As String								'nR[h
	Private _MTM_ADDRESS_OneRec As DictionaryEntry				'Z{PR[h
	Private _OwnerCtl As String = Nothing						'eʂ̍
	Private fret As Enum_FormReturn = Enum_FormReturn.CANSEL	'ʖ߂l
	Private OwnerForm As frmBase								'OwnerForm擾
	Private cliGridSort As clsGridSort							'ObhƎ\[gNX
	Private cliGridStyle As clsGridStyle						'ObhX^CNX
	Private DataMTM_ADDRESS As DataTable						'Z}X^ʃe[u
	Private DataMTM_ADDRESS_MUNICIPALITY_CD As DataTable		'Z}X^s撬R[hʃe[u
	Private cliCom As clsCom									'ʃ\bh
	Private cliCombo As clsComboCom								'R{쐬pNX
	Private Shown_Flg As Boolean = False						'l\tO

#End Region

#Region "RXgN^"

	''' ---------------------------------------------
	''' <summary>
	''' RXgN^
	''' </summary>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Sub New(ByVal OwnerCtl As String)

		' ̌ĂяóAWindows tH[ fUCiŕKvłB
		InitializeComponent()

		' InitializeComponent() Ăяǒŏǉ܂B

		_OwnerCtl = OwnerCtl

	End Sub

#End Region

#Region "Cxg"

	''' ---------------------------------------------
	''' <summary>
	''' ZʁQ\
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/21 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub XSP090F010_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
		log(clsSysMst.logLevel.NRM, "XSP090F010_Load", "ZʁQ\ Start")
		Try
			cliCom = New clsCom
			cliGridSort = New clsGridSort
			cliGridStyle = New clsGridStyle
			_MTM_ADDRESS_OneRec = New DictionaryEntry
			_MTM_ADDRESS_OneRec.Key = _OwnerCtl
			OwnerForm = Me.Owner		'OwnerForm擾
			DataMTM_ADDRESS = getMTM_ADDRESS_ALL()
			DataMTM_ADDRESS_MUNICIPALITY_CD = getMTM_ADDRESS_MUNICIPALITY_CD()
			cliCombo = New clsComboCom

			'fÌO[v,s{O[vR{ݒ
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				Me.cmb009XSP090F010.DataSource = cliCombo.getCombo(db, clsComboCom.Enum_ComboType.Enum_M_Area)
				Me.cmb012XSP090F010.DataSource = cliCombo.getCombo(db, clsComboCom.Enum_ComboType.Enum_M_Address)
			End Using

			'㏑O[vR{
			cmb002XSP090F010.DataSource = clsConst.getOverWrite

			'ZꗗGridݒ
			cliGridStyle.setGridHeight(Me.dgv022XSP090F010)		'ObhPs̍ݒ
			cliGridStyle.setGridHeight(Me.dgv023XSP090F010)		'ObhPs̍ݒ
			cliGridStyle.setGridHeight(Me.dgv024XSP090F010)		'ObhPs̍ݒ
			Me.dgv022XSP090F010.AutoGenerateColumns = False
			Me.dgv023XSP090F010.AutoGenerateColumns = False
			Me.dgv024XSP090F010.AutoGenerateColumns = False
			setGridSortCriteria()
			Me.lik016XSP090F010.MatchingCriteria = BT_Like.Enum_MatchingCriteria.PrefixMatch
			Me.lik019XSP090F010.MatchingCriteria = BT_Like.Enum_MatchingCriteria.PrefixMatch

		Catch ex As Exception
			ErrorProc(ex)						'G[
			Me.OwnerForm.setCancelFlg(True)		'LoadɋIɉʂꍇɕKv
			EndProc()							'I
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' ZʁQl\
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/21 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub XSP090F010_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
		log(clsSysMst.logLevel.NRM, "XSP090F010_Load", "ZʁQl\ Start")
		Try
			LoadLastValue(LastValueCtl, _OwnerCtl)	'Olݒ
			Me.lbl025XSP090F010.Text = Nothing					'NA
			' s{@ݒ
			Me.dgv022XSP090F010.DataSource = getMTM_ADDRESS_PREFECTURE_CD()
			'tH[JXݒ
			SetFocus()
			Me.dgv022XSP090F010.ClearSelection()

			Shown_Flg = True
		Catch ex As Exception
			ErrorProc(ex)						'G[	
			EndProc()							'I	
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' ZʁQI
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/21 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub XSP090F010_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
		log(clsSysMst.logLevel.NRM, "XSP090F010_FormClosing", "ZʁQI Start")
		Dim FirstException As Exception = Nothing
		Try
			If Shown_Flg Then
				Try
					SaveLastValue(LastValueCtl, _OwnerCtl)	'Olۑ
				Catch ex As Exception
					' G[͂P̂
					FirstException = ex
				End Try

				' G[͉ʂɂƂǂ܂
				If FirstException IsNot Nothing Then
					e.Cancel = True
					Exit Sub
				End If

				Try
					OwnerForm.backForm(False, fret, _MTM_ADDRESS_OneRec)
					setCloseFlg()							'Close
				Catch ex As Exception
					' G[͉ʂɂƂǂ܂
					e.Cancel = True
					Throw
				End Try
			Else
				setCloseFlg()	'Close
				OwnerForm.setCancelFlg(True)
				OwnerForm.backForm(False)
			End If

			Me.dgv022XSP090F010.DataSource = Nothing
			Me.dgv023XSP090F010.DataSource = Nothing
			Me.dgv024XSP090F010.DataSource = Nothing

			If DataMTM_ADDRESS IsNot Nothing Then DataMTM_ADDRESS.Dispose()
			If DataMTM_ADDRESS_MUNICIPALITY_CD IsNot Nothing Then DataMTM_ADDRESS_MUNICIPALITY_CD.Dispose()
		Catch ex As Exception
			' G[͂P̂
			FirstException = ex
		Finally
			If FirstException IsNot Nothing Then
				' G[
				ErrorProc(FirstException)
			End If
			FirstException = Nothing
			If Not e.Cancel Then
				DataMTM_ADDRESS = Nothing
				DataMTM_ADDRESS_MUNICIPALITY_CD = Nothing
				cliCom = Nothing
				cliCombo = Nothing
				cliGridSort = Nothing
				cliGridStyle = Nothing
			End If
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' m{^NbN
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btn004XSP000F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn004XSP000F010.Click
		log(clsSysMst.logLevel.NRM, "btn004XSP000F010_Click", "m{^NbN Start")
		Try
			UpdProc()
		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' {^NbN
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btn005XSP000F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn005XSP000F010.Click
		log(clsSysMst.logLevel.NRM, "btn005XSP000F010_Click", "{^NbN Start")
		Try
			EndProc()
		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' {^NbN
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub btn020XSP090F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn020XSP090F010.Click
		log(clsSysMst.logLevel.NRM, "btn020XSP090F010_Click", "{^NbN Start")
		Try
			SearchProc()
			Me.dgv024XSP090F010.Focus()
		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' s{R[hꗗObheύX
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub dgv022XSP090F010_SelectionChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dgv022XSP090F010.SelectionChanged
		log(clsSysMst.logLevel.NRM, "dgv022XSP090F010_SelectionChanged", "s{R[hꗗObheύX Start")
		Try
			If dgv022XSP090F010.CurrentRow Is Nothing OrElse dgv022XSP090F010.CurrentRow.Index < 0 Then Exit Sub
			Dim drPREFECTURE_CD() As DataRow = DataMTM_ADDRESS_MUNICIPALITY_CD.Select(sqlXSP090F010.itmPREFECTURE_CD & " = '" & cliCom.getDtItmValue(Me.dgv022XSP090F010.Rows(Me.dgv022XSP090F010.CurrentRow.Index).Cells(C_PREFECTURE_CD).Value.ToString) & "'")
			If dgv022XSP090F010.SelectedRows Is Nothing OrElse dgv022XSP090F010.SelectedRows.Count = 0 Then
				Me.dgv023XSP090F010.DataSource = DataMTM_ADDRESS_MUNICIPALITY_CD.Clone
			Else
				Me.dgv023XSP090F010.DataSource = cliCom.getTableFromRows(DataMTM_ADDRESS_MUNICIPALITY_CD, drPREFECTURE_CD)
			End If
			Me.dgv023XSP090F010.ClearSelection()

		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' s撬R[hꗗObheύX
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub dgv023XSP090F010_SelectionChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles dgv023XSP090F010.SelectionChanged
		log(clsSysMst.logLevel.NRM, "dgv023XSP090F010_SelectionChanged", "s撬R[hꗗObheύX Start")
		Try
			If dgv023XSP090F010.CurrentRow Is Nothing OrElse dgv023XSP090F010.CurrentRow.Index < 0 Then Exit Sub
			If dgv022XSP090F010.CurrentRow Is Nothing OrElse dgv022XSP090F010.CurrentRow.Index < 0 Then Exit Sub
			Me.lbl025XSP090F010.Text = Nothing					'NA
			Dim drMUNICIPALITY_CD() As DataRow = DataMTM_ADDRESS.Select((sqlXSP090F010.itmPREFECTURE_CD & " = '" & cliCom.getDtItmValue(Me.dgv022XSP090F010.Rows(Me.dgv022XSP090F010.CurrentRow.Index).Cells(C_PREFECTURE_CD).Value.ToString) & "'") & " And " & (sqlXSP090F010.itmMUNICIPALITY_CD & " = '" & cliCom.getDtItmValue(Me.dgv023XSP090F010.Rows(Me.dgv023XSP090F010.CurrentRow.Index).Cells(C_MUNICIPALITY_CD).Value.ToString) & "'"))
			If dgv023XSP090F010.SelectedRows Is Nothing OrElse dgv023XSP090F010.SelectedRows.Count = 0 Then
				Me.dgv024XSP090F010.DataSource = DataMTM_ADDRESS.Clone
			Else
				Me.dgv024XSP090F010.DataSource = cliCom.getTableFromRows(DataMTM_ADDRESS, drMUNICIPALITY_CD)
				If CType(Me.dgv024XSP090F010.DataSource, DataTable).Rows.Count = 0 Then
					showMsg("E0010")		'ɑ΂Yf[^݂܂B
				End If
			End If
			Me.dgv024XSP090F010.ClearSelection()
			Me.lbl025XSP090F010.Text = CType(Me.dgv024XSP090F010.DataSource, DataTable).Rows.Count.ToString(clsConst.CST_KENSU_FORMAT)	'Zbg
		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' ZʈꗗObh_uNbN
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub dgv024XSP090F010_CellDoubleClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgv024XSP090F010.CellDoubleClick
		log(clsSysMst.logLevel.NRM, "dgv024XSP090F010_CellDoubleClick", "ZʈꗗObh_uNbN Start")
		Try
			If e.RowIndex < 0 Then Exit Sub
			UpdProc()
		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' ^uύX
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub tab003XSP090F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tab003XSP090F010.Click
		log(clsSysMst.logLevel.NRM, "tab003XSP090F010_Click", "^uύX Start")
		Try
			SetFocus()
		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

#End Region

#Region "\bh"

	''' ---------------------------------------------
	''' <summary>
	''' Z}X^ꗗf[^擾
	''' </summary>
	''' <returns></returns>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function getMTM_ADDRESS() As DataTable
		log(clsSysMst.logLevel.DBG, "getMTM_ADDRESS", "Z}X^ꗗf[^擾 Start")
		Dim dtData As DataTable
		Try
			dtData = New DataTable
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				db.setSQLDa(sqlXSP090F010.sqlMTM_ADDRESS)
				setSqlPara(db)				'SQLp[^Zbg
				db.execQueryDa(dtData)
			End Using
		Catch ex As Exception
			Throw
		End Try
		Return dtData
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Z}X^ꗗf[^S擾
	''' </summary>
	''' <returns></returns>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function getMTM_ADDRESS_ALL() As DataTable
		log(clsSysMst.logLevel.DBG, "getMTM_ADDRESS_ALL", "Z}X^ꗗf[^S擾 Start")
		Dim dtData As DataTable
		Try
			dtData = New DataTable
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				db.setSQLDa(sqlXSP090F010.sqlMTM_ADDRESS_ALL)
				db.execQueryDa(dtData)
			End Using
		Catch ex As Exception
			Throw
		End Try
		Return dtData
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Z}X^s{R[hꗗf[^擾
	''' </summary>
	''' <returns></returns>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function getMTM_ADDRESS_PREFECTURE_CD() As DataTable
		log(clsSysMst.logLevel.DBG, "getMTM_ADDRESS_PREFECTURE_CD", "Z}X^s{R[hꗗf[^擾 Start")
		Dim dtData As DataTable
		Try
			dtData = New DataTable
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				db.setSQLDa(sqlXSP090F010.sqlMTM_ADDRESS_PREFECTURE_CD)
				db.execQueryDa(dtData)
			End Using
		Catch ex As Exception
			Throw
		End Try
		Return dtData
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Z}X^s撬R[hꗗf[^擾
	''' </summary>
	''' <returns></returns>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function getMTM_ADDRESS_MUNICIPALITY_CD() As DataTable
		log(clsSysMst.logLevel.DBG, "getMTM_ADDRESS_MUNICIPALITY_CD", "Z}X^s撬R[hꗗf[^擾 Start")
		Dim dtData As DataTable
		Try
			dtData = New DataTable
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				db.setSQLDa(sqlXSP090F010.sqlMTM_ADDRESS_MUNICIPALITY_CD)
				db.execQueryDa(dtData)
			End Using
		Catch ex As Exception
			Throw
		End Try
		Return dtData
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' SQLp[^Zbg
	''' </summary>
	''' <param name="db"></param>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub setSqlPara(ByVal db As clsDB)
		log(clsSysMst.logLevel.DBG, "setSqlPara", "SQLp[^Zbg Start")
		Dim MUNFowardChar As String = Nothing
		Dim DISFowardChar As String = Nothing
		Dim MUNBackwardChar As String = Nothing
		Dim DISBackwardChar As String = Nothing
		Try
			'p[^ݒ
			db.setParamDa(sqlXSP090F010.prmPREFECTURE_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setParamDa(sqlXSP090F010.prmPREFECTURE_CD_CHK, clsDB.Enum_dbType.dbNVarChar)
			db.setParamDa(sqlXSP090F010.prmMUNICIPALITY_NM, clsDB.Enum_dbType.dbNVarChar)
			db.setParamDa(sqlXSP090F010.prmMUNICIPALITY_NM_CHK, clsDB.Enum_dbType.dbNVarChar)
			db.setParamDa(sqlXSP090F010.prmDISTRICT_NM, clsDB.Enum_dbType.dbNVarChar)
			db.setParamDa(sqlXSP090F010.prmDISTRICT_NM_CHK, clsDB.Enum_dbType.dbNVarChar)
			db.setParamDa(sqlXSP090F010.prmZIP_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setParamDa(sqlXSP090F010.prmZIP_CD_CHK, clsDB.Enum_dbType.dbNVarChar)
			db.setParamDa(sqlXSP090F010.prmAREA_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setParamDa(sqlXSP090F010.prmAREA_CD_CHK, clsDB.Enum_dbType.dbNVarChar)

			'ChJ[hݒ

			Select Case True
				Case Me.lik016XSP090F010.MatchingCriteria = BT_Like.Enum_MatchingCriteria.PrefixMatch
					MUNBackwardChar = WILDCARDCHAR
				Case Me.lik016XSP090F010.MatchingCriteria = BT_Like.Enum_MatchingCriteria.BackwardMatch
					MUNFowardChar = WILDCARDCHAR
				Case Me.lik016XSP090F010.MatchingCriteria = BT_Like.Enum_MatchingCriteria.BroadMatch
					MUNFowardChar = WILDCARDCHAR
					MUNBackwardChar = WILDCARDCHAR
				Case Me.lik016XSP090F010.MatchingCriteria = BT_Like.Enum_MatchingCriteria.ExactMatch
				Case Else
			End Select

			Select Case True
				Case Me.lik019XSP090F010.MatchingCriteria = BT_Like.Enum_MatchingCriteria.PrefixMatch
					DISBackwardChar = WILDCARDCHAR
				Case Me.lik019XSP090F010.MatchingCriteria = BT_Like.Enum_MatchingCriteria.BackwardMatch
					DISFowardChar = WILDCARDCHAR
				Case Me.lik019XSP090F010.MatchingCriteria = BT_Like.Enum_MatchingCriteria.BroadMatch
					DISFowardChar = WILDCARDCHAR
					DISBackwardChar = WILDCARDCHAR
				Case Me.lik019XSP090F010.MatchingCriteria = BT_Like.Enum_MatchingCriteria.ExactMatch
				Case Else
			End Select

			'lݒ
			db.setValDa(sqlXSP090F010.prmZIP_CD, Me.txt006XSP090F010.Text & WILDCARDCHAR, String.IsNullOrEmpty(Me.txt006XSP090F010.Text))
			db.setValDa(sqlXSP090F010.prmAREA_CD, Me.cmb009XSP090F010.Text, String.IsNullOrEmpty(Me.cmb009XSP090F010.Text))
			db.setValDa(sqlXSP090F010.prmPREFECTURE_CD, Me.cmb012XSP090F010.Text, String.IsNullOrEmpty(Me.cmb012XSP090F010.Text))
			db.setValDa(sqlXSP090F010.prmMUNICIPALITY_NM, MUNFowardChar & Me.txt015XSP090F010.Text & MUNBackwardChar, String.IsNullOrEmpty(Me.txt015XSP090F010.Text))
			db.setValDa(sqlXSP090F010.prmDISTRICT_NM, DISFowardChar & Me.txt018XSP090F010.Text & DISBackwardChar, String.IsNullOrEmpty(Me.txt018XSP090F010.Text))
			db.setValDa(sqlXSP090F010.prmZIP_CD_CHK, IIf(Me.chk005XSP090F010.Checked = True, CType(clsConst.Enum_CheckBox_Flg.CheckOn, String), String.Empty), Not Me.chk005XSP090F010.Checked)
			db.setValDa(sqlXSP090F010.prmAREA_CD_CHK, IIf(Me.chk008XSP090F010.Checked = True, CType(clsConst.Enum_CheckBox_Flg.CheckOn, String), String.Empty), Not Me.chk008XSP090F010.Checked)
			db.setValDa(sqlXSP090F010.prmPREFECTURE_CD_CHK, IIf(Me.chk011XSP090F010.Checked = True, CType(clsConst.Enum_CheckBox_Flg.CheckOn, String), String.Empty), Not Me.chk011XSP090F010.Checked)
			db.setValDa(sqlXSP090F010.prmMUNICIPALITY_NM_CHK, IIf(Me.chk014XSP090F010.Checked = True, CType(clsConst.Enum_CheckBox_Flg.CheckOn, String), String.Empty), Not Me.chk014XSP090F010.Checked)
			db.setValDa(sqlXSP090F010.prmDISTRICT_NM_CHK, IIf(Me.chk017XSP090F010.Checked = True, CType(clsConst.Enum_CheckBox_Flg.CheckOn, String), String.Empty), Not Me.chk017XSP090F010.Checked)
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' ^uZ
	''' </summary>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub SearchProc()
		log(clsSysMst.logLevel.DBG, "SearchProc", "^uZ Start")
		Try
			If Me.ValidateChildren() Then		'tER{̓̓`FbN
				System.Windows.Forms.Cursor.Current = Cursors.WaitCursor	'J[\v
				Me.lbl025XSP090F010.Text = Nothing					'NA

				'ʂZꗗDataGridɐݒ
				Me.dgv024XSP090F010.DataSource = getMTM_ADDRESS()

				Me.lbl025XSP090F010.Text = CType(Me.dgv024XSP090F010.DataSource, DataTable).Rows.Count.ToString(clsConst.CST_KENSU_FORMAT)	'Zbg

				If CType(Me.dgv024XSP090F010.DataSource, DataTable).Rows.Count = 0 Then
					showMsg("E0010")		'ɑ΂Yf[^݂܂B
				End If
			End If
		Catch ex As Exception
			Throw
		Finally
			System.Windows.Forms.Cursor.Current = Cursors.Default	'J[\ftHg
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' m菈
	''' </summary>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub UpdProc()
		log(clsSysMst.logLevel.DBG, "UpdProc", "m菈 Start")
		Try
			If Me.ValidateChildren() Then		'tER{̓̓`FbN
				If Me.dgv024XSP090F010.CurrentCell Is Nothing OrElse Me.dgv024XSP090F010.CurrentCell.ColumnIndex < 0 Then
					fret = Enum_FormReturn.CANSEL
					showMsg("E0005")			'Ώۃf[^IĂ܂B
				Else
					fret = Enum_FormReturn.OK
					getReturnADDRESS()
					Me.Close()
				End If
			End If
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' tH[JX
	''' </summary>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub SetFocus()
		log(clsSysMst.logLevel.DBG, "SetFocus", "tH[JX Start")
		Try
			Select Case True
				Case Me.tab003XSP090F010.SelectedIndex = 0
					Select Case True
						Case Me.txt006XSP090F010.Enabled = True
							Me.txt006XSP090F010.Focus()
						Case Me.cmb009XSP090F010.Enabled = True
							Me.cmb009XSP090F010.Focus()
						Case Me.cmb012XSP090F010.Enabled = True
							Me.cmb012XSP090F010.Focus()
						Case Me.txt015XSP090F010.Enabled = True
							Me.txt015XSP090F010.Focus()
						Case Me.txt018XSP090F010.Enabled = True
							Me.txt018XSP090F010.Focus()
						Case Else
							Me.btn020XSP090F010.Focus()
					End Select
				Case Me.tab003XSP090F010.SelectedIndex = 1
					Me.dgv022XSP090F010.Focus()
			End Select
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' ߂lpZ}X^擾
	''' </summary>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub getReturnADDRESS()
		log(clsSysMst.logLevel.DBG, "getReturnADDRESS", "߂lpZ}X^擾 Start")
		Dim ret As datMTM_ADDRESS_OneRec = Nothing
		Dim clsMTM_ADDRESS As clsMTM_ADDRESS
		Dim ar As ArrayList
		Try
			ar = New ArrayList
			If Me.dgv024XSP090F010.CurrentCell Is Nothing OrElse Me.dgv024XSP090F010.CurrentCell.ColumnIndex < 0 Then Exit Sub
			For Each col As DataGridViewColumn In Me.dgv024XSP090F010.Columns
				If col.DataPropertyName = sqlXSP090F010.itmPREFECTURE_CD Then
					_PREFECTURE_CD = Me.dgv024XSP090F010.Rows(Me.dgv024XSP090F010.CurrentRow.Index).Cells(col.Index).Value
				End If
			Next
			For Each col As DataGridViewColumn In Me.dgv024XSP090F010.Columns
				If col.DataPropertyName = sqlXSP090F010.itmMUNICIPALITY_CD Then
					_MUNICIPALITY_CD = Me.dgv024XSP090F010.Rows(Me.dgv024XSP090F010.CurrentRow.Index).Cells(col.Index).Value
				End If
			Next
			For Each col As DataGridViewColumn In Me.dgv024XSP090F010.Columns
				If col.DataPropertyName = sqlXSP090F010.itmDISTRICT_CD Then
					_DISTRICT_CD = Me.dgv024XSP090F010.Rows(Me.dgv024XSP090F010.CurrentRow.Index).Cells(col.Index).Value
					clsMTM_ADDRESS = New clsMTM_ADDRESS
					ret = clsMTM_ADDRESS.getMTM_ADDRESS_OneRec(_PREFECTURE_CD, _MUNICIPALITY_CD, _DISTRICT_CD)
					ar.Add(Me.cmb002XSP090F010.SelectedValue)
					ar.Add(ret)
					_MTM_ADDRESS_OneRec.Value = ar
					Exit For
				End If
			Next
		Catch ex As Exception
			Throw
		Finally
			clsMTM_ADDRESS = Nothing
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' Ǝ\[g쐬
	''' </summary>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub setGridSortCriteria()
		log(clsSysMst.logLevel.DBG, "setGridSortCriteria", "Ǝ\[g쐬 Start")
		Try
			Dim arData As ArrayList

			'ZƎ\[g쐬
			arData = New ArrayList
			arData.Add(New DictionaryEntry(sqlXSP090F010.itmPREFECTURE_CD, clsGridSort.Enum_SortType.SortNone))
			cliGridSort.Add(sqlXSP090F010.itmMUNICIPALITY_CD, arData)
			cliGridSort.Add(sqlXSP090F010.itmDISTRICT_CD, arData)
		Catch ex As Exception
			Throw
		End Try
	End Sub

#End Region

#Region "I[o[Ch\bh"

	''' ---------------------------------------------
	''' <summary>
	''' eVL[ɂm
	''' </summary>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Overrides Function F7KeyProc() As Boolean
		log(clsSysMst.logLevel.NRM, "F7KeyProc", "eVL[ Start")
		Try
			MyBase.F7KeyProc()
			UpdProc()	'm菈
		Catch ex As Exception
			Throw
		End Try
		Return True
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' ePOL[ɂ^uJ
	''' </summary>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Overrides Function F10KeyProc() As Boolean
		log(clsSysMst.logLevel.NRM, "F10KeyProc", "ePOL[ Start")
		Try
			MyBase.F10KeyProc()
			Select Case True
				Case Me.tab003XSP090F010.SelectedIndex = 0
					Me.tab003XSP090F010.SelectedIndex = 1
				Case Me.tab003XSP090F010.SelectedIndex = 1
					Me.tab003XSP090F010.SelectedIndex = 0
			End Select
		Catch ex As Exception
			Throw
		End Try
		Return True
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' ePQL[ɂI
	''' </summary>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Overrides Function F12KeyProc() As Boolean
		log(clsSysMst.logLevel.NRM, "F12KeyProc", "ePQL[ Start")
		Try
			MyBase.F12KeyProc()
			Me.AutoValidate = Windows.Forms.AutoValidate.Disable
			EndProc()	'I
		Catch ex As Exception
			Throw
		End Try
		Return True
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' ePPL[ɂ錟
	''' </summary>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Overrides Function F11KeyProc() As Boolean
		log(clsSysMst.logLevel.NRM, "F11KeyProc", "ePPL[ Start")
		Try
			MyBase.F11KeyProc()
			Select Case True
				Case Me.tab003XSP090F010.SelectedIndex = 0
					SearchProc()	'^u
				Case Me.tab003XSP090F010.SelectedIndex = 1
			End Select
		Catch ex As Exception
			Throw
		End Try
		Return True
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' dmsdqL[ɂ鏈
	''' </summary>
	''' <returns></returns>
	''' <remarks>
	''' 2010/10/20 VK쐬@CS)Xc<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Overrides Function EnterProc() As Boolean
		log(clsSysMst.logLevel.NRM, "EnterProc", "dmsdqL[ Start")
		Try
			Select Case True
				Case Me.ActiveControl.Name = Me.dgv022XSP090F010.Name
					If Me.dgv023XSP090F010.CurrentRow IsNot Nothing Then
						Me.dgv023XSP090F010.Focus()
						Me.dgv023XSP090F010.CurrentRow.Selected = True
					End If
				Case Me.ActiveControl.Name = Me.dgv023XSP090F010.Name
					If Me.dgv024XSP090F010.CurrentRow IsNot Nothing Then
						Me.dgv024XSP090F010.Focus()
						Me.dgv024XSP090F010.CurrentRow.Selected = True
					End If
				Case Me.ActiveControl.Name = Me.dgv024XSP090F010.Name
					If Me.dgv024XSP090F010.CurrentCell Is Nothing OrElse Me.dgv024XSP090F010.CurrentCell.ColumnIndex < 0 Then
						Return MyBase.EnterProc()
					Else
						UpdProc()	'm菈
						Return True
					End If
				Case Else
					Return MyBase.EnterProc()
			End Select
		Catch ex As Exception
			Throw
		End Try
	End Function

#End Region

End Class
