Imports System.Windows.Forms
'''---------------------------------------------
''' <summary>
''' DataGridViewƎ\[gNX
''' </summary>
''' <remarks>
''' Copyright 2009 FUJITSU SHIKOKU SYSTEMS LIMITED All rights reserved.<BR/>
''' FUJITSU SHIKOKU SYSTEMS LIMITED CONFIDENTIAL<BR/>
''' </remarks>
'''---------------------------------------------
Public Class clsGridSort

#Region "ϐ"

	Private _CriteriaList As New SortedList

	'''---------------------------------------------
	''' <summary>
	''' ftHg\[g
	''' </summary>
	''' <remarks>
	''' 2010/01/26 VK쐬@CS)r<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Enum Enum_SortType
		'''---------------------------------------------
		''' <summary>
		''' W\[giŒłȂj
		''' </summary>
		''' <remarks>
		''' 2010/01/26 VK쐬@CS)r<BR/>
		''' </remarks>
		'''---------------------------------------------
		SortNone = 0
		'''---------------------------------------------
		''' <summary>
		''' \[giŒj
		''' </summary>
		''' <remarks>
		''' 2010/01/26 VK쐬@CS)r<BR/>
		''' </remarks>
		'''---------------------------------------------
		SortAsc = 1
		'''---------------------------------------------
		''' <summary>
		''' ~\[giŒj
		''' </summary>
		''' <remarks>
		''' 2010/01/26 VK쐬@CS)r<BR/>
		''' </remarks>
		'''---------------------------------------------
		SortDesc = 2
	End Enum

#End Region

#Region "\bh"

	'''---------------------------------------------
	''' <summary>
	''' \[gNA
	''' </summary>
	''' <remarks>
	''' 2009/12/04 VK쐬@FJSK)<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Sub Clear()
		Try
			_CriteriaList.Clear()
		Catch ex As Exception
			Throw
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' \[gǉ
	''' </summary>
	''' <param name="key">NbN[DataPropertyName]</param>
	''' <param name="arData">\[gݒiDictionaryEntryiږA\[g^Cv[Enum_SortType]j</param>
	''' <remarks>
	''' 2009/12/04 VK쐬@FJSK)<BR/>
	''' 2010/01/26 ύX@@@CS)r<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Sub Add(ByVal key As String, ByVal arData As ArrayList)
		Try
			_CriteriaList.Add(key, arData)
		Catch ex As Exception
			Throw
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' \[g擾
	''' </summary>
	''' <param name="key">NbN</param>
	''' <returns></returns>
	''' <remarks>
	''' 2010/01/26 VK쐬@CS)r<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Function getItm(ByVal key As String) As ArrayList
		Try
			Return _CriteriaList(key)
		Catch ex As Exception
			Throw
		End Try
	End Function

	'''---------------------------------------------
	''' <summary>
	''' \[gs
	''' </summary>
	''' <param name="dgv"></param>
	''' <param name="itemname"></param>
	''' <param name="colidx"></param>
	''' <remarks>
	''' 2009/12/04 VK쐬@FJSK)<BR/>
	''' 2010/01/26 ύX@@@CS)r<BR/>
	''' </remarks>
	'''---------------------------------------------
	Public Sub SortRow(ByVal dgv As DataGridView, ByVal itemname As String, ByVal colidx As Integer)
		Dim dt As DataTable
		Dim dv As DataView
		Dim ar As ArrayList
		Dim OrderString As String = Nothing
		Dim SortGlyph As SortOrder = SortOrder.None
		Try
			If dgv.Rows.Count <= 0 Then Exit Sub
			If dgv.Columns(colidx).SortMode <> DataGridViewColumnSortMode.Programmatic Then Exit Sub

			dt = dgv.DataSource
			dv = dt.DefaultView
			With dgv.Columns(colidx)
				ar = _CriteriaList(itemname)	'\[g擾
				If Not (TypeOf ar Is ArrayList) OrElse CType(ar, ArrayList).Count = 0 Then Exit Sub
				For Each dicDat As DictionaryEntry In ar
					'\[g^Cvŕ򂵂ă\[gݒ
					Select Case dicDat.Value
						Case Enum_SortType.SortNone
							If dicDat.Value = Enum_SortType.SortNone Then
								If .HeaderCell.SortGlyphDirection = SortOrder.Ascending Then	'\[gt\[gɂ
									OrderString = OrderString & dicDat.Key & " DESC,"
								Else															'\[głȂ珇\[gɂ
									OrderString = OrderString & dicDat.Key & ","
								End If
							End If
						Case Enum_SortType.SortAsc
							'Œ
							OrderString = OrderString & dicDat.Key & ","
						Case Enum_SortType.SortDesc
							'~Œ
							OrderString = OrderString & dicDat.Key & " DESC,"
					End Select
				Next
				'Ot擾
				If .HeaderCell.SortGlyphDirection = SortOrder.Ascending Then
					SortGlyph = SortOrder.Descending
				Else
					SortGlyph = SortOrder.Ascending
				End If
				OrderString = OrderString.Substring(0, OrderString.Length - 1)		'Ō,Jbg
				dv.Sort = OrderString
				.HeaderCell.SortGlyphDirection = SortGlyph							'Ot\
			End With

			With dgv
				'Obh̐擪sZNg
				If .Rows.Count > 0 Then
					.CurrentCell = .Rows(0).Cells(0)									'݂̃Zŏ㍶ɐݒ
					.FirstDisplayedScrollingRowIndex = 0								'擪s
					.Select()															'tH[JXړ
				End If
			End With
		Catch ex As Exception
			Throw
		End Try
	End Sub

#End Region

End Class
