﻿
''' ---------------------------------------------
''' <summary>
''' 貸出物管理状況マスタ_ＳＱＬクラス
''' </summary>
''' <remarks>
''' Copyright 2010 FUJITSU SHIKOKU SYSTEMS LIMITED All rights reserved.<BR/>
''' FUJITSU SHIKOKU SYSTEMS LIMITED CONFIDENTIAL<BR/>
''' </remarks>
''' ---------------------------------------------
Public NotInheritable Class sqlMTM_LENDITEM_MNGSTATUS
    ' 項目名
    Public Const itmLENDITEM_CD As String = "LENDITEM_CD"                   '貸出物コード
    Public Const itmMNGSTATUS_CD As String = "MNGSTATUS_CD"                 '管理状況コード
	Public Const itmMNGSTATUS_NM As String = "MNGSTATUS_NM"					'管理状況
	Public Const itmMNGSTATUS1_RNM As String = "MNGSTATUS1_RNM"				'略称名１
	Public Const itmMNGSTATUS2_RNM As String = "MNGSTATUS2_RNM"				'略称名２
	Public Const itmFIXED_CD1 As String = "FIXED_CD1"						'固定コード１
    Public Const itmFIXED_CD2 As String = "FIXED_CD2"                       '固定コード２
    ' パラメータ
    Public Const prmLENDITEM_CD As String = "@LENDITEM_CD"                  '貸出物コード
    Public Const prmMNGSTATUS_CD As String = "@MNGSTATUS_CD"                '管理状況コード

    ' 全件取得ＳＱＬ
    Public Const sqlSelAll As String = _
        "SELECT" _
        & "  MNGSTATUS_CD," _
        & "  MNGSTATUS_NM," _
        & "  LENDITEM_CD," _
        & "  MNGSTATUS1_RNM," _
        & "  MNGSTATUS2_RNM," _
        & "  FIXED_CD1," _
        & "  FIXED_CD2," _
        & "  COLOR_CD_R," _
        & "  COLOR_CD_G," _
        & "  COLOR_CD_B" _
        & " FROM MTM_LENDITEM_MNGSTATUS" _
        & " ORDER BY DSPORDER, MNGSTATUS_CD"
End Class
