﻿Imports XCM
Imports System.Reflection
Imports System.IO
Imports XSP

''' ---------------------------------------------
''' <summary>
''' 動作環境設定
''' </summary>
''' <remarks>
''' Copyright 2010 FUJITSU SHIKOKU SYSTEMS LIMITED All rights reserved.<BR/>
''' FUJITSU SHIKOKU SYSTEMS LIMITED CONFIDENTIAL<BR/>
''' </remarks>
''' ---------------------------------------------
Public Class XSY050F010

#Region "コンスタント"

	'レポートID
	Private Const CST_XSY050R010_ID As String = "XSY050R010"			'レポートID

	'設定値入力コンボ
	Private Const CST_SET_VAL_CD As String = "SET_VAL_CD"				'設定値入力コンボのDisplayMember OR ValueMember
	Private Const CST_SET_VAL_NM As String = "SET_VAL_NM"				'設定値入力コンボのDisplayMemberEx

	'テキスト入力
	Private Const CST_TEXT_MAXLENGTH As Integer = 200					'テキストボックスの最大入力文字数

	'グリッド
	Public Const CST_PRD_NM_KYOTUU As String = "共通"					'製品名で共通を指す

	'INIファイル
	Private Const CST_BT3OPTION_SECTION As String = "BT3OPTION"				'オプションセクション
'(A) STR V4-12031-000 003 2012/06/07 ID)平井 DPC2012対応
	Private Const CST_BT3DPC12_SECTION As String = "BT3DPC12"				'DPC2012セクション
'(A) END V4-12031-000 003 2012/06/07 ID)平井 DPC2012対応
	Private Const CST_BT3DPC10_SECTION As String = "BT3DPC10"				'DPC2010セクション
	Private Const CST_BT3DPC08_SECTION As String = "BT3DPC08"				'DPC2008セクション
	Private Const CST_ICD9_SECTION As String = "ICD9"						'ICD9セクション
	Private Const CST_RENKE_SECTION As String = "RENKE"						'RENKEセクション

	Private Const CST_TENKAREKI_ITEM As String = "TENKAREKI"				'貸出票の転科歴
	Private Const CST_BCPRDATE_ITEM As String = "BCPRDATE"					'バーコードの日付
	Private Const CST_BCPRINI_ITEM As String = "BCPRINI"					'バーコードの１０桁設定
	Private Const CST_BCPRID_ITEM As String = "BCPRID"						'バーコードのＩＤ桁数
	Private Const CST_BCPRJUN_ITEM As String = "BCPRJUN"					'バーコードの並び
	Private Const CST_BCPRJYU_ITEM As String = "BCPRJYU"					'受領処理のバーコード
	Private Const CST_SYU_EXP_KBN_ITEM As String = "SYU_EXP_KBN"			'抽出手術区分
	Private Const CST_INPUT_ITEM As String = "INPUT"						'ＤＰＣ９入力
	Private Const CST_CSV_ITEM As String = "CSV"							'CSV
	Private Const CST_TOKEI_ZERO_ITEM As String = "TOKEI_ZERO"				'統計の「-」「空白」表示選択
	Private Const CST_TENKATIME_ITEM As String = "TENKATIME"				'転科時間
	Private Const CST_TENKAMENTE_ITEM As String = "TENKAMENTE"				'転科修正不可か可能か
	Private Const CST_SAMARIREKI_ITEM As String = "SAMARIREKI"				'サマリ履歴の表示

	Private byorekiScreen() As String = { _
	 "MSR040F010", "MSR050F010", "MSR060F010", "MSR070F010", "MSR080F010", "MSR090F010", "MSR100F010", "MSR110F010", "MSR120F010", "MSR130F010", _
	 "MSR140F010", "MSR150F010", "MSR160F010", "MSR160F010", "MSR160F010", "MSR160F010", "MSR160F010", "MSR170F010", "MSR170F010", "MSR170F010", _
	 "MSR170F010", "MSR170F010", "MSR180F010"}

	Private byorekiGrid() As String = { _
	 "dgv001MSR040F010", "dgv001MSR050F010", "dgv001MSR060F010", "dgv001MSR070F010", "dgv001MSR080F010", _
	 "dgv001MSR090F010", "dgv001MSR100F010", "dgv001MSR110F010", "dgv001MSR120F010", "dgv001MSR130F010", _
	 "dgv001MSR140F010", "dgv001MSR150F010", "1", "2", "3", "4", "5", "1", "2", "3", "4", "5", "dgv001MSR180F010"}

	Private byorekiKey() As String = { _
	 "c17001MSR040F010", "c23001MSR050F010", "c20001MSR060F010", "c20001MSR070F010", "c20001MSR080F010", _
	 "c20001MSR090F010", "c20001MSR100F010", "c20001MSR110F010", "c20001MSR120F010", "c20001MSR130F010", _
	 "c20001MSR140F010", "c20001MSR150F010", "c20001MSR160F010", "c20001MSR160F010", "c20001MSR160F010", _
	 "c20001MSR160F010", "c20001MSR160F010", "c14001MSR170F010", "c14001MSR170F010", "c14001MSR170F010", _
	 "c14001MSR170F010", "c14001MSR170F010", "c20001MSR180F010"}

	Private CST_BYOREKI_NO As String = "BYOREKI_NO"

	'一覧に表示しないコード
	'[00092]ﾊﾞｰｺｰﾄﾞ順　"IKD"の組合せ3文字
	'[00008]○入退院歴在院日数の計算
	'[00081]ICD9の使用可否
	'[00014]連携(重複)
	'[00074]連携初期取込先（貸出物）
	'[00075]連携初期取込先（貸出）
	'[00100]2006年度版の適用開始日（退院日）
	'[00085]2008年度版の適用開始日（退院日）
	'[00086]2010年度版の適用開始日（退院日）
	'[00101]2012年度版の適用開始日（退院日）
	'[00097]転科有無の修正有無
	'[00090]ﾊﾞｰｺｰﾄﾞ10桁 ﾊﾞｰｺｰﾄﾞの桁数が10桁（患者番号＝7桁、病歴番号＝3桁）
	'[00091]ﾊﾞｰｺｰﾄﾞ患者番号桁数
	'[00055]検索表示件数のMAX行数
	'[00049]貸出票の転科歴（患者単位は無効）
	'[00093]ﾊﾞｰｺｰﾄﾞ受領画面印刷 （受領画面で印刷ﾎﾞﾀﾝ表示有無）
	'[00099]貸出票のｻﾏﾘ履歴の表示
	'[00077]ﾊﾞｰｺｰﾄﾞに含める日付の選択
	'[00076]抽出対象手術区分の選択
	'[00103]ﾊﾞｰｺｰﾄﾞ使用（貸出情報）
	'[00104]ﾊﾞｰｺｰﾄﾞ明細登録画面印刷表示有無
	'[00105]ﾊﾞｰｺｰﾄ順 "MI"の組合せ
	'[00106]ﾊﾞｰｺｰﾄﾞ患者番号開始位置
	'[00107]ﾊﾞｰｺｰﾄﾞ患者番号終了位置
'(M) STR V4-12031-000 014 2012/06/07 ID)平井 DPC2012対応
	'Private ReadOnly NonDspOPERATING_SET_CD() As String = { _
	'"00008", "00014", "00049", "00055", _
	'"00074", "00075", "00076", "00077", _
	'"00081", "00085", "00086", "00090", _
	'"00091", "00092", "00093", "00097", _
	'"00099", "00100"}
'(M) STR V4-12064-000 015 20121227 ID)平井(貸出管理バーコード対応)
	'Private ReadOnly NonDspOPERATING_SET_CD() As String = { _
	'"00008", "00014", "00049", "00055", _
	'"00074", "00075", "00076", "00077", _
	'"00081", "00085", "00086", "00090", _
	'"00091", "00092", "00093", "00097", _
	'"00099", "00100", "00101"}
'(M) STR V4-12072-000 014 20130201 ID)平井(バーコード項目をすべて表示)
	'Private ReadOnly NonDspOPERATING_SET_CD() As String = { _
	'"00008", "00014", "00049", "00055", _
	'"00074", "00075", "00076", "00077", _
	'"00081", "00085", "00086", "00090", _
	'"00091", "00092", "00093", "00097", _
	'"00099", "00100", "00101", "00104", _
	'"00105", "00106", "00107"}
	Private ReadOnly NonDspOPERATING_SET_CD() As String = { _
	"00008", "00014", "00049", "00055", _
	"00074", "00075", "00076", "00081", _
	"00085", "00086", "00097", "00099", _
	"00100", "00101"}
'(M) END V4-12072-000 014 20130201
'(M) END V4-12064-000 015 20121227
'(M) END V4-12031-000 014 2012/06/07 ID)平井 DPC2012対応
'(A) STR V4-14024-000 006 20130426 ID)平井(診療情報管理のバーコード関連表示をライセンス有無で表示切替を行うよう修正。)
	' バーコード関連配列
	Private ReadOnly NonDspOPERATING_SET_CD_BARCODE() As String = { _
	"00002", "00077", "00090", "00091", _
	"00092", "00093"}
'(A) END V4-14024-000 006 20130426

	Private arNonDspCd As ArrayList = Nothing

#End Region

#Region "変数"

	'アクセスクラス
	Private cliCom As clsCom = Nothing
	Private cliGridStyle As clsGridStyle = Nothing
	Private cliGridSort As clsGridSort
	Private cliMTM_LENDITEM As clsMTM_LENDITEM = Nothing
	Private cliXTM_PRODUCT As clsXTM_PRODUCT = Nothing
	Private cliIni As clsIni = Nothing

	'起動状況確認用変数
	Private pbExclusive As Boolean = False

	'選択した情報
	Private selEnvCd As String = Nothing
	Private selEnvInputType As Enum_EnvInputType
	Private selDgv As DataGridView = Nothing
	Private selTpg As TabPage = Nothing

	'''---------------------------------------------
	''' <summary>
	''' 動作環境の分類コード
	''' </summary>
	''' <remarks>
	''' 2010/11/18 新規作成 FJSK)荒川<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Enum Enum_Group
		'''---------------------------------------------
		''' <summary>基本情報タブ</summary>
		'''---------------------------------------------
		GrpBasic = 1
		'''---------------------------------------------
		''' <summary>入力設定タブ</summary>
		'''---------------------------------------------
		GrpInput = 2
		'''---------------------------------------------
		''' <summary>表示・出力制御タブ</summary>
		'''---------------------------------------------
		GrpView = 3
		'''---------------------------------------------
		''' <summary>入力チェック制御タブ</summary>
		'''---------------------------------------------
		GrpInputCheck = 4
	End Enum

	'''---------------------------------------------
	''' <summary>
	''' 動作環境の入力タイプ
	''' </summary>
	''' <remarks>
	''' 2010/11/18 新規作成 FJSK)荒川<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Enum Enum_EnvInputType
		'''---------------------------------------------
		''' <summary>コンボ入力</summary>
		'''---------------------------------------------
		InputCmb = 0
		'''---------------------------------------------
		''' <summary>テキスト入力</summary>
		'''---------------------------------------------
		InputText = 1
		'''---------------------------------------------
		''' <summary>数値入力</summary>
		'''---------------------------------------------
		InputNum = 2
		'''---------------------------------------------
		''' <summary>ファイルパス入力</summary>
		'''---------------------------------------------
		InputFilePath = 3
		'''---------------------------------------------
		''' <summary>フルパス入力</summary>
		'''---------------------------------------------
		InputPath = 4
		'''---------------------------------------------
		''' <summary>日付入力</summary>
		'''---------------------------------------------
		InputDate = 5
	End Enum

#End Region

#Region "コンストラクタ"

	''' ---------------------------------------------
	''' <summary>
	''' コンストラクタ
	''' </summary>
	''' <remarks>
	''' 2010/11/16 新規作成 FJSK)荒川<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Sub New()
		' この呼び出しはデザイナーで必要です。
		InitializeComponent()
		' InitializeComponent() 呼び出しの後で初期化を追加します。
	End Sub

#End Region

#Region "イベント"

	'''---------------------------------------------
	''' <summary>
	''' 画面ロード
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/16 新規作成 FJSK)荒川
	''' </remarks>
	'''---------------------------------------------
	Private Sub XSY050F010_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
		log(clsSysMst.logLevel.NRM, MethodBase.GetCurrentMethod.Name, "画面ロード START")
		Dim cliBmp As clsBmp = Nothing
		Me.SuspendLayout()
		Try
			'アクセスクラスのインスタンス化
			Me.cliCom = New clsCom
			Me.cliGridStyle = New clsGridStyle
			Me.cliGridSort = New clsGridSort
			Me.cliMTM_LENDITEM = New clsMTM_LENDITEM
			Me.cliXTM_PRODUCT = New clsXTM_PRODUCT
			Me.cliIni = New clsIni

			cliBmp = New clsBmp

			' 排他制御登録
			If Me.setStartStatus(False) = False Then
				'排他中フラグ設定
				Me.pbExclusive = True
				Me.EndProc()
				Exit Sub
			End If

			'アイコン設定
			Me.btn001XSY050F010.Image = cliBmp.getBmp(clsBmp.Enum_BmpType.PrintPreview)
			Me.btn002XSY050F010.Image = cliBmp.getBmp(clsBmp.Enum_BmpType.Print)
			Me.btn018XSY050F010.Image = cliBmp.getBmp(clsBmp.Enum_BmpType.OpenFolder)
			Me.btn030XSY050F010.Image = cliBmp.getBmp(clsBmp.Enum_BmpType.OpenFolder)

			'グリッドの高さを設定する
			Me.cliGridStyle.setGridHeight(Me.dgv021XSY050F010)
			Me.cliGridStyle.setGridHeight(Me.dgv023XSY050F010)
			Me.cliGridStyle.setGridHeight(Me.dgv025XSY050F010)
			Me.cliGridStyle.setGridHeight(Me.dgv027XSY050F010)

			'表示しないコード群の作成
			arNonDspCd = New ArrayList
			For nondspidx As Integer = 0 To NonDspOPERATING_SET_CD.GetUpperBound(0)
				Select Case NonDspOPERATING_SET_CD(nondspidx)
					Case "00042"
						' 起動環境設定より、画面項目の表示の有無を決定する
						With clsSysMst.ctlConfigData
							' がん登録
							If String.IsNullOrEmpty(.BtgDir) OrElse Not System.IO.Directory.Exists(.BtgDir) Then
								' がん登録パスが存在しない場合、がん登録ボタンを非表示にするので表示しないコード群に登録
							Else
								' がん登録パスが存在する場合、表示するので表示しないコード群に登録しない
								Continue For
							End If
						End With
					Case Else
				End Select
				arNonDspCd.Add(NonDspOPERATING_SET_CD(nondspidx))
			Next
'(A) STR V4-14024-000 010 20130426 ID)平井(診療情報管理のバーコード関連表示をライセンス有無で表示切替を行うよう修正。)
			'表示しないコード群の作成（バーコード）
			Using cliXTM_PRODUCT As New clsXTM_PRODUCT
				If Not cliXTM_PRODUCT.chkLicense(clsXTM_PRODUCT.Enum_Product_No.BARCODE) Then
					For nondspidx As Integer = 0 To NonDspOPERATING_SET_CD_BARCODE.GetUpperBound(0)
						arNonDspCd.Add(NonDspOPERATING_SET_CD_BARCODE(nondspidx))
					Next
				End If
			End Using
'(A) END V4-14024-000 010 20130426

			'グリッド設定
			Me.setGrid()
			Me.setGridSortCriteria()

			'コンボに空白を設定する
			Me.SetCmb()

			'コンボを表示する
			Me.SetInputStatus(Enum_EnvInputType.InputCmb)
		Catch ex As Exception
			ErrorProc(ex)
			Me.EndProc()
		Finally
			Me.ResumeLayout()
			cliBmp = Nothing
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' フォームクロージング
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/16 新規作成 FJSK)荒川
	''' </remarks>
	'''---------------------------------------------
	Private Sub XSY050F010_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
		log(clsSysMst.logLevel.NRM, MethodBase.GetCurrentMethod.Name, "フォームクロージング START")
		Try
			' 排他制御削除（排他エラー時は削除しない）
			If Not Me.pbExclusive Then
				Me.delStartStatus()
			End If

			'レポート結果を削除
			Using db As New clsDB(clsSysMst.ctlConfigData), cliReportFunc As New clsReportFunc(Me, String.Empty, Me.GetType.Name, True)
				cliReportFunc.exeWorkDel(db, CST_XSY050R010_ID, sqlXSY050R010.sqlDelWork, sqlXSY050R010.prmPRT_ID, sqlXSY050R010.prmHOST_NM)
			End Using
		Catch ex As Exception
			ErrorProc(ex)
		Finally
			'画面を閉じる
			Me.setCloseFlg()

			'アクセスクラス
			cliCom = Nothing
			cliGridStyle = Nothing
			cliMTM_LENDITEM = Nothing
			cliXTM_PRODUCT = Nothing
			cliIni = Nothing

			'選択した情報
			selEnvCd = Nothing
			selDgv = Nothing
			selTpg = Nothing

			'その他
			arNonDspCd = Nothing
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' プレビューボタン
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/16 新規作成 FJSK)荒川
	''' </remarks>
	'''---------------------------------------------
	Private Sub btn001XSY050F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn001XSY050F010.Click
		log(clsSysMst.logLevel.NRM, MethodBase.GetCurrentMethod.Name, "プレビューボタン START")
		Dim dgv As DataGridView() = {Me.dgv021XSY050F010, Me.dgv023XSY050F010, Me.dgv025XSY050F010, Me.dgv027XSY050F010}
		Cursor = Cursors.WaitCursor
		Try
			Using cliXSY050R010 As New XSY050R010(Me, arNonDspCd)
				cliXSY050R010.exePrint(dgv, False, Me.tab019XSY050F010)
			End Using
		Catch ex As Exception
			ErrorProc(ex)
		Finally
			dgv = Nothing
			Cursor = Cursors.Default
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 印刷ボタン
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/16 新規作成 FJSK)荒川
	''' </remarks>
	'''---------------------------------------------
	Private Sub btn002XSY050F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn002XSY050F010.Click
		log(clsSysMst.logLevel.NRM, MethodBase.GetCurrentMethod.Name, "印刷ボタン START")
		Dim dgv As DataGridView() = {Me.dgv021XSY050F010, Me.dgv023XSY050F010, Me.dgv025XSY050F010, Me.dgv027XSY050F010}
		Cursor = Cursors.WaitCursor
		Try
			Using cliXSY050R010 As New XSY050R010(Me, arNonDspCd)
				cliXSY050R010.exePrint(dgv, True, Me.tab019XSY050F010)
			End Using
		Catch ex As Exception
			ErrorProc(ex)
		Finally
			dgv = Nothing
			Cursor = Cursors.Default
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 保存(F7)ボタン
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/16 新規作成 FJSK)荒川
	''' </remarks>
	'''---------------------------------------------
	Private Sub btn003XSY050F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn003XSY050F010.Click
		log(clsSysMst.logLevel.NRM, MethodBase.GetCurrentMethod.Name, "保存(F7)ボタン START")
		Try
			Me.UpdProc()
		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' タブ変更イベント
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/10/26 新規作成 CS)荒川 <BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Sub tab019XSY050F010_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tab019XSY050F010.SelectedIndexChanged
		If Me.tab019XSY050F010.CanFocus = True Then
			log(clsSysMst.logLevel.NRM, MethodBase.GetCurrentMethod.Name, "タブページ変更イベント")
		Else
			log(clsSysMst.logLevel.DBG, MethodBase.GetCurrentMethod.Name, "タブページ変更イベント")
		End If
		Try
			Select Case True
				Case Me.tab019XSY050F010.SelectedTab.Equals(Me.tpg020XSY050F010)
					Me.dgv021XSY050F010.Focus()
				Case Me.tab019XSY050F010.SelectedTab.Equals(Me.tpg022XSY050F010)
					Me.dgv023XSY050F010.Focus()
				Case Me.tab019XSY050F010.SelectedTab.Equals(Me.tpg024XSY050F010)
					Me.dgv025XSY050F010.Focus()
				Case Me.tab019XSY050F010.SelectedTab.Equals(Me.tpg026XSY050F010)
					Me.dgv027XSY050F010.Focus()
			End Select
		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 終了(F12)ボタン
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/16 新規作成 FJSK)荒川
	''' </remarks>
	'''---------------------------------------------
	Private Sub btn004XSY000F010_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn004XSY000F010.Click
		log(clsSysMst.logLevel.NRM, MethodBase.GetCurrentMethod.Name, "終了(F12)ボタン START")
		Try
			Me.EndProc()
		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 一覧ダブルクリック
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/16 新規作成 FJSK)荒川
	''' </remarks>
	'''---------------------------------------------
	Private Sub dgv_CellDoubleClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles _
	 dgv021XSY050F010.CellDoubleClick, _
	 dgv023XSY050F010.CellDoubleClick, _
	 dgv025XSY050F010.CellDoubleClick, _
	 dgv027XSY050F010.CellDoubleClick
		log(clsSysMst.logLevel.NRM, MethodBase.GetCurrentMethod.Name, "一覧ダブルクリック START")
		Try
			If e.RowIndex = -1 Then Exit Sub
			Me.SetRowData(CType(sender, DataGridView))
		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' ファイルダイアログ
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/16 新規作成 FJSK)荒川
	''' </remarks>
	'''---------------------------------------------
	Private Sub btn018XSY050F010_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btn018XSY050F010.Click
		log(clsSysMst.logLevel.NRM, MethodBase.GetCurrentMethod.Name, "ファイルダイアログ START")
		Try
			Me.cliCom.setFileDialog(Me, Me.txt017XSY050F010, clsCom.Enum_FileDialogType.eCSV)
		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' パスダイアログ
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/16 新規作成 FJSK)荒川
	''' </remarks>
	'''---------------------------------------------
	Private Sub btn030XSY050F010_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btn030XSY050F010.Click
		log(clsSysMst.logLevel.NRM, MethodBase.GetCurrentMethod.Name, "ファイルダイアログ START")
		Try
			Me.cliCom.setFolderDialog(Me.txt029XSY050F010)
		Catch ex As Exception
			ErrorProc(ex)
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' グリッドソート
	''' </summary>
	''' <param name="sender"></param>
	''' <param name="e"></param>
	''' <remarks>
	''' 2010/11/17 新規作成 FJSK)荒川<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub dgv021XSY050F010_ColumnHeaderMouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellMouseEventArgs) Handles _
	 dgv021XSY050F010.ColumnHeaderMouseClick, _
	 dgv023XSY050F010.ColumnHeaderMouseClick, _
	 dgv025XSY050F010.ColumnHeaderMouseClick, _
	 dgv027XSY050F010.ColumnHeaderMouseClick
		log(clsSysMst.logLevel.DBG, MethodBase.GetCurrentMethod.Name, "グリッドソート Start")
		Me.Cursor = Cursors.WaitCursor
		Try
			If CType(sender, DataGridView).Rows.Count <= 0 Then Exit Sub
			If CType(sender, DataGridView).Columns(e.ColumnIndex).SortMode <> DataGridViewColumnSortMode.Programmatic Then Exit Sub
			Me.cliGridSort.SortRow(sender, CType(sender, DataGridView).Columns(e.ColumnIndex).DataPropertyName, e.ColumnIndex)
		Catch ex As Exception
			ErrorProc(ex)
		Finally
			Me.Cursor = Cursors.Default
		End Try
	End Sub

#End Region

#Region "メソッド"

	'''---------------------------------------------
	''' <summary>
	''' 独自ソート条件作成
	''' </summary>
	''' <remarks>
	''' 2010/08/24 新規作成 CS)荒川<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub setGridSortCriteria()
		log(clsSysMst.logLevel.DBG, MethodBase.GetCurrentMethod.Name, "独自ソート条件作成 Start")
		Try
			Dim arData As ArrayList

			'コード独自ソート条件作成
			arData = New ArrayList
			arData.Add(New DictionaryEntry(sqlXSY050F010.itmDSP_CD, clsGridSort.Enum_SortType.SortNone))
			Me.cliGridSort.Add(sqlXSY050F010.itmDSP_CD, arData)

			'製品名独自ソート条件作成
			arData = New ArrayList
			arData.Add(New DictionaryEntry(sqlXSY050F010.itmPRD_NO, clsGridSort.Enum_SortType.SortNone))
			arData.Add(New DictionaryEntry(sqlXSY050F010.itmDSP_CD, clsGridSort.Enum_SortType.SortNone))
			Me.cliGridSort.Add(sqlXSY050F010.itmPRD_NM, arData)

			'区分名独自ソート条件作成
			arData = New ArrayList
			arData.Add(New DictionaryEntry(sqlXSY050F010.itmGRP2_NM, clsGridSort.Enum_SortType.SortNone))
			arData.Add(New DictionaryEntry(sqlXSY050F010.itmDSP_CD, clsGridSort.Enum_SortType.SortNone))
			Me.cliGridSort.Add(sqlXSY050F010.itmGRP2_NM, arData)

			'設定名独自ソート条件作成
			arData = New ArrayList
			arData.Add(New DictionaryEntry(sqlXSY050F010.itmSET_NM, clsGridSort.Enum_SortType.SortNone))
			arData.Add(New DictionaryEntry(sqlXSY050F010.itmDSP_CD, clsGridSort.Enum_SortType.SortNone))
			Me.cliGridSort.Add(sqlXSY050F010.itmSET_NM, arData)

			'設定値独自ソート条件作成
			arData = New ArrayList
			arData.Add(New DictionaryEntry(sqlXSY050F010.itmSET_VAL, clsGridSort.Enum_SortType.SortNone))
			arData.Add(New DictionaryEntry(sqlXSY050F010.itmDSP_CD, clsGridSort.Enum_SortType.SortNone))
			Me.cliGridSort.Add(sqlXSY050F010.itmSET_VAL, arData)

			'説明独自ソート条件作成
			arData = New ArrayList
			arData.Add(New DictionaryEntry(sqlXSY050F010.itmEXPLANATION, clsGridSort.Enum_SortType.SortNone))
			arData.Add(New DictionaryEntry(sqlXSY050F010.itmDSP_CD, clsGridSort.Enum_SortType.SortNone))
			Me.cliGridSort.Add(sqlXSY050F010.itmEXPLANATION, arData)
		Catch ex As Exception
			Throw
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' グリッド情報設定
	''' </summary>
	''' <remarks>
	''' 2010/11/17 新規作成 FJSK)荒川<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub setGrid()
		log(clsSysMst.logLevel.DBG, MethodBase.GetCurrentMethod.Name, "グリッド情報設定 START")
		Dim dtData As DataTable = Nothing
		Dim arLicenceData As ArrayList = Nothing
		Dim strJouken As String = String.Empty
		Dim strJouken2 As String = String.Empty
		Try
			Using db As New clsDB(clsSysMst.ctlConfigData)
				'表示できる製品一覧を取得する
				arLicenceData = cliXTM_PRODUCT.getLicense
				With db
					'製品の条件部分を構成する
					strJouken &= sqlXSY050F010.prmJknPRD_NO & "0"
					For Each prdNo As Integer In arLicenceData
						If Not String.IsNullOrEmpty(strJouken) Then strJouken &= ","
						strJouken &= sqlXSY050F010.prmJknPRD_NO & prdNo
					Next

					'表示しない動作環境設定コードの条件部分を構成する
					For nondspidx As Integer = 0 To arNonDspCd.Count - 1
						If Not String.IsNullOrEmpty(strJouken2) Then strJouken2 &= ","
						strJouken2 &= sqlXSY050F010.prmJkn2OPERATING_SET_CD & nondspidx
					Next

					'SQL設定
					'①ライセンスキーが必須でインストール端末管理にホスト名が登録されていない製品以外をすべて取得
					'②「①」の条件にヒットする製品からさらにライセンスチェックして正しいと判断された製品のみ抽出取得
					'ちなみに共通はかならず表示する。
					.setSQLDa(sqlXSY050F010.sqlSelList.Replace(sqlXSY050F010.strJouken, strJouken).Replace(sqlXSY050F010.strJouken2, strJouken2))
					.setParamDa(sqlXSY050F010.prmGRP_CD, clsDB.Enum_dbType.dbNVarChar)		'分類コード
					.setParamDa(sqlXSY050F010.prmPRD_NM, clsDB.Enum_dbType.dbNVarChar)		'製品名

					'表示する製品Noのパラメータ
					.setParamDa(sqlXSY050F010.prmJknPRD_NO & "0", clsDB.Enum_dbType.dbNVarChar)
					For Each prdNo As Integer In arLicenceData
						.setParamDa(sqlXSY050F010.prmJknPRD_NO & prdNo, clsDB.Enum_dbType.dbNVarChar)
					Next

					'表示しない動作環境コードのパラメータ
					For nondspidx As Integer = 0 To arNonDspCd.Count - 1
						.setParamDa(sqlXSY050F010.prmJkn2OPERATING_SET_CD & nondspidx, clsDB.Enum_dbType.dbNVarChar)
					Next

					For Each enum_menber As Enum_Group In [Enum].GetValues(GetType(Enum_Group))
						'分類コードのパラメータ設定
						.setValDa(sqlXSY050F010.prmGRP_CD, enum_menber, False)			'分類コード
						.setValDa(sqlXSY050F010.prmPRD_NM, CST_PRD_NM_KYOTUU)			'製品名

						'表示する製品No
						.setValDa(sqlXSY050F010.prmJknPRD_NO & "0", 0, False)
						For Each prdNo As Integer In arLicenceData
							.setValDa(sqlXSY050F010.prmJknPRD_NO & prdNo, prdNo, False)
						Next

						'表示しない動作環境コードのパラメータ
						For nondspidx As Integer = 0 To arNonDspCd.Count - 1
							.setValDa(sqlXSY050F010.prmJkn2OPERATING_SET_CD & nondspidx, arNonDspCd(nondspidx))
						Next

						'検索
						dtData = New DataTable
						.execQueryDa(dtData)

						Select Case enum_menber
							Case Enum_Group.GrpBasic
								'基本設定タブ設定
								Me.dgv021XSY050F010.AutoGenerateColumns = False
								Me.dgv021XSY050F010.DataSource = dtData.Copy
							Case Enum_Group.GrpInput
								'入力設定タブ設定
								Me.dgv023XSY050F010.AutoGenerateColumns = False
								Me.dgv023XSY050F010.DataSource = dtData.Copy
							Case Enum_Group.GrpView
								'表示・出力制御タブ設定
								Me.dgv025XSY050F010.AutoGenerateColumns = False
								Me.dgv025XSY050F010.DataSource = dtData.Copy
							Case Enum_Group.GrpInputCheck
								'入力チェック制御タブ設定
								Me.dgv027XSY050F010.AutoGenerateColumns = False
								Me.dgv027XSY050F010.DataSource = dtData.Copy
						End Select

						If dtData IsNot Nothing Then dtData.Dispose()
						dtData = Nothing
					Next
				End With
			End Using

			If Me.dgv021XSY050F010.Rows.Count = 0 AndAlso _
			 Me.dgv023XSY050F010.Rows.Count = 0 AndAlso _
			 Me.dgv025XSY050F010.Rows.Count = 0 AndAlso _
			 Me.dgv027XSY050F010.Rows.Count = 0 Then
				'１件もデータがなければ非表示
				Me.btn001XSY050F010.Enabled = False
				Me.btn002XSY050F010.Enabled = False
			Else
				'１件以上データがあれば表示
				Me.btn001XSY050F010.Enabled = True
				Me.btn002XSY050F010.Enabled = True
			End If
		Catch ex As Exception
			Throw
		Finally
			dtData = Nothing
			arLicenceData = Nothing
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 引数で指定された入力区分のフィールドを表示する
	''' </summary>
	''' <param name="einput">入力区分</param>
	''' <remarks>
	''' 2010/11/17 新規作成 FJSK)荒川<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub SetInputStatus(ByVal einput As Enum_EnvInputType)
		log(clsSysMst.logLevel.NRM, MethodBase.GetCurrentMethod.Name, "ファイルダイアログ START")
		Try
			Me.pnl009XSY050F010.Visible = IIf(einput = Enum_EnvInputType.InputCmb, True, False)
			Me.pnl012XSY050F010.Visible = IIf(einput = Enum_EnvInputType.InputText, True, False)
			Me.pnl014XSY050F010.Visible = IIf(einput = Enum_EnvInputType.InputNum, True, False)
			Me.pnl016XSY050F010.Visible = IIf(einput = Enum_EnvInputType.InputFilePath, True, False)
			Me.pnl028XSY050F010.Visible = IIf(einput = Enum_EnvInputType.InputPath, True, False)
			Me.pnl031XSY050F010.Visible = IIf(einput = Enum_EnvInputType.InputDate, True, False)
		Catch ex As Exception
			Throw
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 入力チェック
	''' </summary>
	''' <returns>TRUE:正常 FALSE:異常</returns>
	''' <remarks>
	''' 2010/11/16 新規作成 FJSK)荒川
	''' </remarks>
	'''---------------------------------------------
	Private Function ChkData() As Boolean
		log(clsSysMst.logLevel.DBG, MethodBase.GetCurrentMethod.Name, "入力チェック START")
		Dim dtRet As DataTable = Nothing
		Try
			'Validatedのチェック
			If Me.ValidateChildren() = False Then
				Return False
			End If

			'個別チェック
			Select Case Me.selEnvCd
'(M) STR V4-14030-000 026 20130628 ID)平井(貸出管理レベルアップ１次開発（システム連携）)
				'Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00015), _
				' clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00016), _
				' clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00017), _
				' clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00018), _
				' clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00019), _
				' clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00020), _
				' clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00021), _
				' clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00022), _
				' clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00023), _
				' clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00074), _
				' clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00075)
				Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00015), _
				 clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00016), _
				 clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00017), _
				 clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00018), _
				 clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00019), _
				 clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00020), _
				 clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00021), _
				 clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00022), _
				 clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00023), _
				 clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00074), _
				 clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00075), _
				 clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00108), _
				 clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00109)
'(M) END V4-14030-000 026 20130628
					'取込ファイルの初期設定
					'If Not File.Exists(getSetVal()) Then
					'	Me.addErrList("E0023", Me.getSetValCtl.Name, lbl008XSY050F010.Text, "パスが存在しない", "保存", Nothing)
					'End If

				Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00082)
					'出力先フォルダのデフォルト設定
					If Not Directory.Exists(getSetVal()) Then
						Me.addErrList("E0003", Me.getSetValCtl.Name, lbl008XSY050F010.Text, "パスが存在しない", "保存", Nothing)
					End If

				Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00092)
					Dim reg As New System.Text.RegularExpressions.Regex("([IKD])([IKD])([IKD])")
					Dim match As System.Text.RegularExpressions.Match = reg.Match(Me.getSetVal)
					Try
						If match.Success Then
							'match.Groups(0) :一致した文字列
							'match.Groups(1) :一番目に一致した文字列「([IKD])」
							'match.Groups(2) :二番目に一致した文字列「([IKD])」
							'match.Groups(3) :三番目に一致した文字列「([IKD])」
							Dim I_Cnt As Integer = 0
							Dim K_Cnt As Integer = 0
							Dim D_Cnt As Integer = 0
							For grpIdx As Integer = 1 To match.Groups.Count - 1
								Select Case match.Groups(grpIdx).Value
									Case "I" : I_Cnt += 1
									Case "K" : K_Cnt += 1
									Case "D" : D_Cnt += 1
									Case Else
								End Select
							Next
							If I_Cnt <> 1 OrElse K_Cnt <> 1 OrElse D_Cnt <> 1 Then
								'エラー
								Me.addErrList("E0037", Me.getSetValCtl.Name, lbl008XSY050F010.Text, "[I][K][D]の組み合わせ", Nothing)
							End If
						Else
							'エラー
							Me.addErrList("E0020", Me.getSetValCtl.Name, lbl008XSY050F010.Text, "[I][K][D]の組み合わせ（重複なし）で入力", Nothing)
						End If
					Catch ex As Exception
						Throw
					Finally
						reg = Nothing
					End Try

				Case Else
					If Me.chkNullSetVal Then
						Me.addErrList("E0001", Me.getSetValCtl.Name, lbl008XSY050F010.Text, Nothing)
					End If

					If Me.selEnvCd = clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00026) AndAlso Not Me.chkNullSetVal Then
						'診療録返納基準日（１入院１診療科の場合は１を設定）の場合
						'貸出物コード１で取得できる貸出物レコードの管理単位を取得。
						'取得した管理単位が１（診療録単位）ならメッセージを出力して、１を設定する。
						dtRet = cliMTM_LENDITEM.getLendItemOneRecDa(clsConst.Enum_Lenditem.MedicalRecord)
						If dtRet IsNot Nothing AndAlso dtRet.Rows.Count > 0 Then
							If dtRet.Rows(0).Item(sqlMTM_LENDITEM.itmUNIT_CD).ToString = CStr(clsConst.Enum_LendUnit.Each_Hosp) Then
								If getSetVal() = CStr(clsConst.Enum_LendItemReturnDt.LendItemRetDtEnd) Then
									showMsg("I0013", dtRet.Rows(0).Item(sqlMTM_LENDITEM.itmLENDITEM_NM).ToString & _
									  "が１入院１診療録のため、「1（退院日）」で", Nothing)
								End If
							End If
						End If
					End If
			End Select

			'エラーがある場合、エラー画面表示
			If Me.getErrCount() > 0 Then
				Me.nextErrForm()
				Return False
			End If

			'正常終了
			Return True
		Catch ex As Exception
			Throw
		Finally
			dtRet = Nothing
		End Try
	End Function

	'''---------------------------------------------
	''' <summary>
	''' 更新処理
	''' </summary>
	''' <remarks>
	''' 2010/11/16 新規作成 FJSK)荒川
	''' </remarks>
	'''---------------------------------------------
	Private Sub UpdProc()
		log(clsSysMst.logLevel.DBG, MethodBase.GetCurrentMethod.Name, "更新処理 START")
		Dim dtRet As DataTable = Nothing
		Dim updVal As String = Nothing
		Try
			'選択中の情報がなければ処理しない
			If Me.selDgv Is Nothing Then
				showMsg("E0005")
				Exit Sub
			End If

			'入力チェック
			If Not ChkData() Then
				Exit Sub
			End If

			'更新処理
			Using db As New clsDB(clsSysMst.ctlConfigData)
				With db
					Try
						'トランザクション開始
						.ctlTran(clsDB.Enum_TranMode.Begin)

						.setSQL(sqlXSY050F010.sqlUpdEnv)
						.setParam(sqlXSY050F010.prmOPERATING_SET_CD, clsDB.Enum_dbType.dbNVarChar)
						.setParam(sqlXSY050F010.prmSET_VAL, clsDB.Enum_dbType.dbNVarChar)
						.setParam(sqlXSY050F010.prmLASTUPDUSER_CD, clsDB.Enum_dbType.dbNVarChar)
						.setParam(sqlXSY050F010.prmLASTUPD_DT, clsDB.Enum_dbType.dbDateTime)

						.setVal(sqlXSY050F010.prmOPERATING_SET_CD, Me.selEnvCd)

						'設定値
						updVal = Me.getSetVal
						If Me.selEnvCd = clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00026) AndAlso Not Me.chkNullSetVal Then
							'診療録返納基準日（１入院１診療科の場合は１を設定）の場合
							'貸出物コード１で取得できる貸出物レコードの管理単位を取得。
							'取得した管理単位が１（診療録単位）ならメッセージを出力して、１を設定する。
							dtRet = cliMTM_LENDITEM.getLendItemOneRecDa(clsConst.Enum_Lenditem.MedicalRecord)
							If dtRet IsNot Nothing AndAlso dtRet.Rows.Count > 0 Then
								If dtRet.Rows(0).Item(sqlMTM_LENDITEM.itmUNIT_CD).ToString = CStr(clsConst.Enum_LendUnit.Each_Hosp) Then
									If updVal = CStr(clsConst.Enum_LendItemReturnDt.LendItemRetDtEnd) Then
										updVal = "1"
									End If
								End If
							End If
						End If
						.setVal(sqlXSY050F010.prmSET_VAL, updVal)

						.setVal(sqlXSY050F010.prmLASTUPDUSER_CD, Me._userID)
						.setVal(sqlXSY050F010.prmLASTUPD_DT, Now)

						'更新処理
						.execNonQuery(False)

						Select Case Me.selEnvCd
							Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00001)
								'病歴番号のタイトルが変更された場合はマスタも変更する
								Me.UpdByorekiNo(db)
						End Select

						'更新確定
						.ctlTran(clsDB.Enum_TranMode.Commit)
					Catch ex As Exception
						'ロールバック
						If .statTran() Then .ctlTran(clsDB.Enum_TranMode.RollBack)
						Throw
					End Try
				End With
			End Using

			'INIファイルへの更新
			Select Case Me.selEnvCd
				Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00049)
					'[BT3OPTION]-[TENKARENKEI]]
					cliIni.PutIni(CST_BT3OPTION_SECTION, CST_TENKAREKI_ITEM, Me.getSetVal())

				Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00076)
					''[BT3DPC08 , [BT3DPC10] - [SYU_EXP_KBN]
					'[BT3DPC08 , [BT3DPC10] , [BT3DPC12] - [SYU_EXP_KBN]
					cliIni.PutIni(CST_BT3DPC08_SECTION, CST_SYU_EXP_KBN_ITEM, Me.getSetVal())
					cliIni.PutIni(CST_BT3DPC10_SECTION, CST_SYU_EXP_KBN_ITEM, Me.getSetVal())
'(A) STR V4-12031-000 003 2012/06/07 ID)平井 DPC2012対応
					cliIni.PutIni(CST_BT3DPC12_SECTION, CST_SYU_EXP_KBN_ITEM, Me.getSetVal())
'(A) END V4-12031-000 003 2012/06/07 ID)平井 DPC2012対応

				Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00077)
					'[BT3OPTION]-[BCPRDATE]
					cliIni.PutIni(CST_BT3OPTION_SECTION, CST_BCPRDATE_ITEM, Me.getSetVal())

				Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00081)
					'[ICD9]-[INPUT]
					cliIni.PutIni(CST_ICD9_SECTION, CST_INPUT_ITEM, Me.getSetVal())

				Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00082)
					'[BT3OPTION]-[CSV]
					cliIni.PutIni(CST_BT3OPTION_SECTION, CST_CSV_ITEM, Me.getSetVal())

				Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00089)
					'[BT3OPTION]-[TOKEI_ZERO]
					cliIni.PutIni(CST_BT3OPTION_SECTION, CST_TOKEI_ZERO_ITEM, Me.getSetVal())

				Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00090)
					'[BT3OPTION]-[BCPRINI]
					cliIni.PutIni(CST_BT3OPTION_SECTION, CST_BCPRINI_ITEM, Me.getSetVal())

				Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00091)
					'[BT3OPTION]-[BCPRID]
					cliIni.PutIni(CST_BT3OPTION_SECTION, CST_BCPRID_ITEM, Me.getSetVal())

				Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00092)
					'[BT3OPTION]-[BCPRJUN]
					cliIni.PutIni(CST_BT3OPTION_SECTION, CST_BCPRJUN_ITEM, Me.getSetVal())

				Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00093)
					'[BT3OPTION]-[BCPRJYU]
					cliIni.PutIni(CST_BT3OPTION_SECTION, CST_BCPRJYU_ITEM, Me.getSetVal())

				Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00095)
					'[RENKE]-[TENKATIME]
					cliIni.PutIni(CST_RENKE_SECTION, CST_TENKATIME_ITEM, Me.getSetVal())

				Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00097)
					'[BT3OPTION]-[TENKAMENTE]
					cliIni.PutIni(CST_BT3OPTION_SECTION, CST_TENKAMENTE_ITEM, Me.getSetVal())

				Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00099)
					'[BT3OPTION]-[SAMARIREKI]
					cliIni.PutIni(CST_BT3OPTION_SECTION, CST_SAMARIREKI_ITEM, Me.getSetVal())
				Case Else
			End Select

			'更新後の画面表示
			Me.SetUpdedScreen()

			'選択中の情報をクリアする
			Me.selDgv = Nothing
			Me.selEnvCd = Nothing
			Me.selTpg = Nothing
			Me.selEnvInputType = Nothing
		Catch ex As Exception
			Throw
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 病歴番号変更処理
	''' </summary>
	''' <param name="db"></param>
	''' <remarks>
	''' 2011/03/18 新規作成 FJSK)荒川<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub UpdByorekiNo(ByVal db As clsDB)
		log(clsSysMst.logLevel.DBG, MethodBase.GetCurrentMethod.Name, "病歴番号変更処理 START")
		Dim prm As String = Nothing
		Try
			With db
				'「病歴番号タイトル変更」→検索条件フィールド変更
				.setSQL(sqlXSY050F010.sqlUpdByorekiNo_MTM_SEARCH_FIELD)
				.setParam(sqlXSY050F010.prmSET_VAL, clsDB.Enum_dbType.dbNVarChar)
				.setParam(sqlXSY050F010.prmJKNBYOREKI, clsDB.Enum_dbType.dbNVarChar)

				.setVal(sqlXSY050F010.prmSET_VAL, Me.getSetVal)
				.setVal(sqlXSY050F010.prmJKNBYOREKI, CST_BYOREKI_NO)
				.execNonQuery(False)

				'「病歴番号タイトル変更」→検索CSVフィールド変更
				.setSQL(sqlXSY050F010.sqlUpdByorekiNo_MTM_SEARCH_CSV_FIELD)
				.setParam(sqlXSY050F010.prmSET_VAL, clsDB.Enum_dbType.dbNVarChar)
				.setParam(sqlXSY050F010.prmJKNBYOREKI, clsDB.Enum_dbType.dbNVarChar)

				.setVal(sqlXSY050F010.prmSET_VAL, Me.getSetVal)
				.setVal(sqlXSY050F010.prmJKNBYOREKI, CST_BYOREKI_NO)
				.execNonQuery(False)

				'「病歴番号タイトル変更」→表示項目選択表示項目名変更
				.setSQL(sqlXSY050F010.sqlUpdByorekiNo_XTM_ITEMLIST)
				.setParam(sqlXSY050F010.prmSET_VAL, clsDB.Enum_dbType.dbNVarChar)
				.setVal(sqlXSY050F010.prmSET_VAL, Me.getSetVal)

				'条件のパラメータ設定
				For prmIdx As Integer = 1 To byorekiScreen.GetUpperBound(0) + 1
					'SCREEN_CD条件設定
					'パラメータ設定と値設定
					prm = String.Format(sqlXSY050F010.prmJKNSCREEN, prmIdx.ToString("00"))
					.setParam(prm, clsDB.Enum_dbType.dbNVarChar)
					.setVal(prm, byorekiScreen(prmIdx - 1))

					'GRID_CD条件設定
					'パラメータ設定と値設定
					prm = String.Format(sqlXSY050F010.prmJKNGRID, prmIdx.ToString("00"))
					.setParam(prm, clsDB.Enum_dbType.dbNVarChar)
					.setVal(prm, byorekiGrid(prmIdx - 1))

					'KEY条件設定
					'パラメータ設定と値設定
					prm = String.Format(sqlXSY050F010.prmJKNKEY, prmIdx.ToString("00"))
					.setParam(prm, clsDB.Enum_dbType.dbNVarChar)
					.setVal(prm, byorekiKey(prmIdx - 1))
				Next

				.execNonQuery(False)
			End With
		Catch ex As Exception
			Throw
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 選択した動作環境設定コードを上部に表示する
	''' </summary>
	''' <remarks>
	''' 2010/11/16 新規作成 FJSK)荒川
	''' </remarks>
	'''---------------------------------------------
	Private Sub SetRowData(ByVal dgv As DataGridView)
		log(clsSysMst.logLevel.DBG, MethodBase.GetCurrentMethod.Name, "更新処理 START")
		Try
			Me.selTpg = Me.tab019XSY050F010.SelectedTab										'選択時のタブページ
			Me.selDgv = dgv																	'選択時のデータグリッド

			With CType(dgv.CurrentRow.DataBoundItem, DataRowView).Row
				Me.selEnvCd = .Item(sqlXSY050F010.itmOPERATING_SET_CD).ToString				'選択時の動作環境設定コード
				Me.lbl005XSY050F010.Text = .Item(sqlXSY050F010.itmSET_NM).ToString			'選択時の設定名
				Me.lbl007XSY050F010.Text = .Item(sqlXSY050F010.itmEXPLANATION).ToString		'選択時の説明
				Me.selEnvInputType = CInt(.Item(sqlXSY050F010.itmINPUT_DIV).ToString)		'選択時の入力区分
				Me.SetInputStatus(Me.selEnvInputType)										'選択時の入力区分を判断して、表示するコントロールを制御する

				'コントロールの設定を行う
				Select Case Me.selEnvInputType
					Case Enum_EnvInputType.InputCmb
						'選択時の入力区分がコンボボックスの場合、コンボボックスを再設定する
						Me.SetCmb(dgv.CurrentRow)
					Case Enum_EnvInputType.InputText
						Select Case Me.selEnvCd
							Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00001)
								'病歴番号のタイトル[00001]
								Me.txt013XSY050F010.ImeMode = Windows.Forms.ImeMode.On
								Me.txt013XSY050F010.MaxLength = 4

							Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00056), _
							  clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00057)
								'分冊マーク＿親[00056]
								'分冊マーク＿子[00057]
								Me.txt013XSY050F010.ImeMode = Windows.Forms.ImeMode.On
								Me.txt013XSY050F010.MaxLength = 1

							Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00076)
								'ＤＰＣ手術区分[00076]
								Me.txt013XSY050F010.ImeMode = Windows.Forms.ImeMode.Disable
								Me.txt013XSY050F010.MaxLength = 2

							Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00083)
								'出血量・輸血量の単位[00083]
								Me.txt013XSY050F010.ImeMode = Windows.Forms.ImeMode.Disable
								Me.txt013XSY050F010.MaxLength = 4

							Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00087), _
							 clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00088)
								'入院（開始）経路コードが空白の時の設定コード[00087]
								'退院（終了）経路コードが空白の時の設定コード[00088]
								Me.txt013XSY050F010.ImeMode = Windows.Forms.ImeMode.Off
								Me.txt013XSY050F010.MaxLength = 2

							Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00092)
								'バーコード順　"IKD"の組合せ３文字[00092]
								Me.txt013XSY050F010.ImeMode = Windows.Forms.ImeMode.Disable
								Me.txt013XSY050F010.MaxLength = 3

							Case Else
								Me.txt013XSY050F010.ImeMode = Windows.Forms.ImeMode.On
								Me.txt013XSY050F010.MaxLength = CST_TEXT_MAXLENGTH
						End Select
					Case Enum_EnvInputType.InputNum
						Select Case Me.selEnvCd
							Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00029), _
							  clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00030)
								'患者番号をもとに病歴番号を設定（設定しない場合は０を設定）[00029]
								'患者番号をもとに病歴番号を設定[00030]
								Me.nud015XSY050F010.Minimum = 0
								Me.nud015XSY050F010.Maximum = 10

							Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00055)
								'検索表示件数のＭＡＸ行数[00055]
								Me.nud015XSY050F010.Minimum = 50000
								Me.nud015XSY050F010.Maximum = 100000

							Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00073)
								'パスワード有効期間[00073]
'(M) STR V4-11002-000 004 20110809 FJSK)荒川 XXX号 病歴大将V4PKG問題点No10 パスワード有効期間無効化対応
'								Me.nud015XSY050F010.Minimum = 1
								Me.nud015XSY050F010.Minimum = 0
'(M) END V4-11002-000 004 20110809
								Me.nud015XSY050F010.Maximum = 999

							Case clsSysMst.ctlEnvData.getEnvString(datEnv.Enum_ENV.ENV_00006)
								'○入院(開始)日と退院(終了)日が同じ場合の在院日数の初期値[00006]
								Me.nud015XSY050F010.Minimum = 0
								Me.nud015XSY050F010.Maximum = 1

							Case Else
								Me.nud015XSY050F010.Minimum = 0
								Me.nud015XSY050F010.Maximum = 999
						End Select
					Case Enum_EnvInputType.InputFilePath
					Case Enum_EnvInputType.InputPath
					Case Enum_EnvInputType.InputDate
				End Select

				Me.setSetVal(.Item(sqlXSY050F010.itmSET_VAL).ToString)						'選択時の設定値を設定
			End With
		Catch ex As Exception
			Throw
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 更新後の画面表示制御
	''' </summary>
	''' <remarks>
	''' 2010/11/16 新規作成 FJSK)荒川
	''' </remarks>
	'''---------------------------------------------
	Private Sub SetUpdedScreen()
		log(clsSysMst.logLevel.DBG, MethodBase.GetCurrentMethod.Name, "更新後の画面表示制御 START")
		Try
			'設定名・説明欄をクリアする
			Me.lbl005XSY050F010.Text = Nothing
			Me.lbl007XSY050F010.Text = Nothing

			'コンボを初期設定
			Me.SetInputStatus(Enum_EnvInputType.InputCmb)
			Me.SetCmb()
			Me.cmb010XSY050F010.Focus()

			'グリッドの設定
			Me.setGrid()
			Me.tab019XSY050F010.SelectedTab = Me.tab019XSY050F010.TabPages(Me.selTpg.Name)
			Me.selDgv.Select()

			'更新した行を選択状態とする
			For Each dgvRow As DataGridViewRow In Me.selDgv.Rows
				With CType(dgvRow.DataBoundItem, DataRowView).Row
					If .Item(sqlXSY050F010.itmOPERATING_SET_CD).ToString = Me.selEnvCd Then
						Me.selDgv.CurrentCell = dgvRow.Cells(0)
						Exit For
					End If
				End With
			Next
		Catch ex As Exception
			Throw
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' コンボボックスの設定
	''' </summary>
	''' <param name="dRow">一覧選択行</param>
	''' <remarks>
	''' 2010/11/16 新規作成 FJSK)荒川
	''' </remarks>
	'''---------------------------------------------
	Private Sub SetCmb(Optional ByVal dRow As DataGridViewRow = Nothing)
		log(clsSysMst.logLevel.DBG, MethodBase.GetCurrentMethod.Name, "コンボボックスの設定 START")
		Dim dtRet As DataTable = Nothing
		Dim dtrow As DataRow = Nothing
		Dim spExplanation As String()
		Dim spStr As String()
		Try
			dtRet = New DataTable

			'列定義
			dtRet.Columns.Add(CST_SET_VAL_CD)
			dtRet.Columns.Add(CST_SET_VAL_NM)

			If dRow IsNot Nothing Then
				'コンボボックスで値を選択するような項目は初期DBにて空白区切りで説明が登録されている
				'さらにコードと説明は必ず:で区切られている
				'一覧が選択されている場合はコンボのデータソースに設定する
				With CType(dRow.DataBoundItem, DataRowView).Row
					'説明を半角空白で区切る
					spExplanation = Split(.Item(sqlXSY050F010.itmEXPLANATION).ToString, Space(1))

					For Each Str As String In spExplanation
						dtrow = dtRet.NewRow

						'各説明毎に:で区切り、コードと説明で切り分ける
						spStr = Split(Str, ":")
						If spStr.Length > 1 Then
							dtrow.Item(0) = spStr(0)			'コード
							dtrow.Item(1) = spStr(1)			'説明

							'行追加
							dtRet.Rows.Add(dtrow)
						End If
					Next
				End With
			End If

			If Me.cmb010XSY050F010.DataSource IsNot Nothing Then CType(Me.cmb010XSY050F010.DataSource, DataTable).Dispose()
			Me.cmb010XSY050F010.DataSource = Nothing
			Me.cmb010XSY050F010.DisplayMember = CST_SET_VAL_CD
			Me.cmb010XSY050F010.DisplayMemberEx = CST_SET_VAL_NM
			Me.cmb010XSY050F010.ValueMember = CST_SET_VAL_CD
			Me.cmb010XSY050F010.MaxLength = 1
			Me.cmb010XSY050F010.DataSource = dtRet.Copy
			Me.cmb010XSY050F010.setDropDownWidth()
		Catch ex As Exception
			Throw
		Finally
			dtRet = Nothing
			dtrow = Nothing
			spExplanation = Nothing
			spStr = Nothing
		End Try
	End Sub

	'''---------------------------------------------
	''' <summary>
	''' 画面の設定値の取得
	''' </summary>
	''' <returns>入力値</returns>
	''' <remarks>
	''' 2010/11/17 新規作成 FJSK)荒川<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function getSetVal() As String
		log(clsSysMst.logLevel.DBG, MethodBase.GetCurrentMethod.Name, "画面の設定値の取得 START")
		Try
			Select Case Me.selEnvInputType
				Case Enum_EnvInputType.InputCmb
					'コンボ入力
					Return Me.cmb010XSY050F010.Text
				Case Enum_EnvInputType.InputText
					'フリーテキスト入力
					Return Me.txt013XSY050F010.Text
				Case Enum_EnvInputType.InputNum
					'数値入力
					Return Me.nud015XSY050F010.Text
				Case Enum_EnvInputType.InputFilePath
					'ファイルパス入力
					Return Me.txt017XSY050F010.Text
				Case Enum_EnvInputType.InputPath
					'パス入力
					Return Me.txt029XSY050F010.Text
				Case Else
					'日付入力
					Return Me.dte032XSY050F010.DateValue.ToString(clsConst.CST_YYYYMMDD_FORMAT)
			End Select
		Catch ex As Exception
			Throw
		End Try
	End Function

	'''---------------------------------------------
	''' <summary>
	''' 画面の設定値の未入力チェック
	''' </summary>
	''' <returns>入力値</returns>
	''' <remarks>
	''' 2010/11/17 新規作成 FJSK)荒川<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function chkNullSetVal() As Boolean
		log(clsSysMst.logLevel.DBG, MethodBase.GetCurrentMethod.Name, "画面の設定値の未入力チェック START")
		Try
			Select Case Me.selEnvInputType
				Case Enum_EnvInputType.InputCmb
					'コンボ入力
					Return String.IsNullOrEmpty(Me.cmb010XSY050F010.Text)
				Case Enum_EnvInputType.InputText
					'フリーテキスト入力
					Return String.IsNullOrEmpty(Me.txt013XSY050F010.Text)
				Case Enum_EnvInputType.InputNum
					'数値入力
					Return String.IsNullOrEmpty(Me.nud015XSY050F010.Text)
				Case Enum_EnvInputType.InputFilePath
					'ファイルパス入力
					Return String.IsNullOrEmpty(Me.txt017XSY050F010.Text)
				Case Enum_EnvInputType.InputPath
					'パス入力
					Return String.IsNullOrEmpty(Me.txt029XSY050F010.Text)
				Case Else
					'日付入力
					Return Me.dte032XSY050F010.DateValue.Equals(Nothing)
			End Select
		Catch ex As Exception
			Throw
		End Try
	End Function

	'''---------------------------------------------
	''' <summary>
	''' 画面の設定値のコントロ-ル
	''' </summary>
	''' <returns>入力値</returns>
	''' <remarks>
	''' 2010/11/17 新規作成 FJSK)荒川<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Function getSetValCtl() As Control
		log(clsSysMst.logLevel.DBG, MethodBase.GetCurrentMethod.Name, "画面の設定値の取得 START")
		Try
			Select Case Me.selEnvInputType
				Case Enum_EnvInputType.InputCmb
					'コンボ入力
					Return Me.cmb010XSY050F010
				Case Enum_EnvInputType.InputText
					'フリーテキスト入力
					Return Me.txt013XSY050F010
				Case Enum_EnvInputType.InputNum
					'数値入力
					Return Me.nud015XSY050F010
				Case Enum_EnvInputType.InputFilePath
					'ファイルパス入力
					Return Me.txt017XSY050F010
				Case Enum_EnvInputType.InputPath
					'パス入力
					Return Me.txt029XSY050F010
				Case Else
					'日付入力
					Return Me.dte032XSY050F010
			End Select
		Catch ex As Exception
			Throw
		End Try
	End Function

	'''---------------------------------------------
	''' <summary>
	''' 画面の設定値の設定
	''' </summary>
	''' <param name="value">設定する値</param>
	''' <remarks>
	''' 2010/11/17 新規作成 FJSK)荒川<BR/>
	''' </remarks>
	'''---------------------------------------------
	Private Sub setSetVal(ByVal value As String)
		log(clsSysMst.logLevel.DBG, MethodBase.GetCurrentMethod.Name, "画面の設定値の設定 START")
		Try
			Select Case Me.selEnvInputType
				Case Enum_EnvInputType.InputCmb
					'コンボ入力
					Me.cliCom.setComboValue(Me.cmb010XSY050F010, value)
				Case Enum_EnvInputType.InputText
					'フリーテキスト入力
					Me.txt013XSY050F010.Text = value
				Case Enum_EnvInputType.InputNum
					'数値入力
					Me.nud015XSY050F010.Text = value
				Case Enum_EnvInputType.InputFilePath
					'ファイルパス入力
					Me.txt017XSY050F010.Text = value
				Case Enum_EnvInputType.InputPath
					'パス入力
					Me.txt029XSY050F010.Text = value
				Case Else
					'日付入力
					Me.dte032XSY050F010.DateValue = CDate(value)
			End Select
		Catch ex As Exception
			Throw
		End Try
	End Sub

#End Region

#Region "オーバーライドメソッド"

	'''---------------------------------------------
	''' <summary>
	''' ENTER押下
	''' </summary>
	''' <returns></returns>
	''' <remarks>
	''' 2010/11/16 新規作成 FJSK)荒川
	''' </remarks>
	'''---------------------------------------------
	Public Overrides Function EnterProc() As Boolean
		log(clsSysMst.logLevel.NRM, MethodBase.GetCurrentMethod.Name, "ENTER押下 START")
		Try
			If Me.ActiveControl IsNot Nothing AndAlso TypeOf Me.ActiveControl Is DataGridView Then
				'データグリッドViewでENTER押下時はダブルクリックと同処理をする
				Me.SetRowData(Me.ActiveControl)
			End If
			Return MyBase.EnterProc()
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' F7キークリック
	''' </summary>
	''' <returns></returns>
	''' <remarks>
	''' 2010/10/26 新規作成 CS)荒川 <BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Overrides Function F7KeyProc() As Boolean
		log(XCM.clsSysMst.logLevel.NRM, MethodBase.GetCurrentMethod.Name, "F7キークリック START")
		Try
			'パスワード更新処理
			MyBase.F7KeyProc()
			Me.UpdProc()
			Return True
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' F12キークリック
	''' </summary>
	''' <returns></returns>
	''' <remarks>
	''' 2010/10/26 新規作成 CS)荒川 <BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Overrides Function F12KeyProc() As Boolean
		log(XCM.clsSysMst.logLevel.NRM, MethodBase.GetCurrentMethod.Name, "F12キークリック START")
		Try
			'終了処理
			MyBase.F12KeyProc()
			MyBase.EndProc()
			Return True
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Ｆ10キークリック
	''' </summary>
	''' <returns></returns>
	''' <remarks>
	''' 2010/10/26 新規作成 CS)荒川 <BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Overrides Function F10KeyProc() As Boolean
		log(clsSysMst.logLevel.NRM, MethodBase.GetCurrentMethod.Name, "Ｆ10キークリック START")
		Try
			If Me.tab019XSY050F010.SelectedIndex >= Me.tab019XSY050F010.TabPages.Count - 1 Then
				Me.tab019XSY050F010.SelectedIndex = 0
			Else
				Me.tab019XSY050F010.SelectedIndex += 1
			End If
		Catch ex As Exception
			Throw
		End Try
		Return True
	End Function

#End Region

End Class
