﻿Imports XCM

'''---------------------------------------------
''' <summary>
''' バージョン４．１７．０．ＸバージョンUP（新規作成：貸出管理レベルアップ２次開発）
''' </summary>
''' <remarks>
''' Copyright 2013 FUJITSU SYSTEMS WEST LIMITED All rights reserved.<BR/>
''' FUJITSU SYSTEMS WEST LIMITED CONFIDENTIAL<BR/>
''' </remarks>
'''---------------------------------------------
Public Class sqlVer4_17_0_0

	'バージョン情報更新　（！！！すべてのバージョンにこのSQLが必要！！！）
	'MIN_VERのみ変更をしていってください。sqlVer4_XX_0_0のXXをMIN_VERに設定するように！
	Public Shared ReadOnly sqlInsVersion As String = _
	"IF EXISTS (SELECT ID FROM XTM_VERSION ) DELETE FROM XTM_VERSION" & vbCrLf & vbCrLf _
	& "INSERT INTO XTM_VERSION" _
	& "(ID,MEG_VER,MIN_VER,BLD_VER,REV_VER,REMARKS,LASTUPDUSER_CD,LASTUPD_DT) VALUES(" _
	& "'1',4,17,0,0,NULL,'" & clsConst.CST_ADMIN_USER & "','" & Now.ToString & "')"


	'１．LBCR_印刷テーブルテーブル（桁数変更）を修正
	'LBCR_印刷テーブルテーブルを削除
	Public Shared ReadOnly sql001 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTW_PRINT_TABLE]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTW_PRINT_TABLE]"

	'LBCR_印刷テーブルを新規作成
	Public Shared ReadOnly sql002 As String = _
	"CREATE TABLE [dbo].[LTW_PRINT_TABLE](" _
	& "     [HOST_NM] [nvarchar](64) NOT NULL," _
	& "     [PATIENT_NO] [nvarchar](10)," _
	& "     [BYOREKI_NO] [nvarchar](10)," _
	& "     [PATIENT_KNM] [nvarchar](30)," _
	& "     [PATIENT_NM] [nvarchar](20)," _
	& "     [GENDER_CD] [nvarchar](1)," _
	& "     [GENDER_NM] [nvarchar](2)," _
	& "     [BIRTH_DT] [datetime]," _
	& "     [MNGITEM_CD] [nvarchar](3)," _
	& "     [MNGITEM_NM] [nvarchar](10)," _
	& "     [DIV1_CD] [nvarchar](10)," _
	& "     [DIV1_NM] [nvarchar](10)," _
	& "     [DIV2_CD] [nvarchar](10)," _
	& "     [DIV2_NM] [nvarchar](10)," _
	& "     [DATE1] [datetime]," _
	& "     [DATE2] [datetime]," _
	& "     [FIRSTRECEIVING_DT] [datetime]," _
	& "     [LASTRECEIVING_DT] [datetime]," _
	& "     [RECIPIENT_CD] [nvarchar](8)," _
	& "     [RECIPIENT_NM] [nvarchar](20)," _
	& "     [MNGSTATUS_CD] [nvarchar](2)," _
	& "     [MNGSTATUS_NM] [nvarchar](10)," _
	& "     [KEEPLCT_CD] [nvarchar](3)," _
	& "     [KEEPLCT_NM] [nvarchar](10)," _
	& "     [DOCTOR_CD] [nvarchar](8)," _
	& "     [DOCTOR_NM] [nvarchar](20)," _
	& "     [MNGITEMCMB1_CD] [nvarchar](2)," _
	& "     [MNGITEMCMB1_NM] [nvarchar](10)," _
	& "     [MNGITEMCMB2_CD] [nvarchar](2)," _
	& "     [MNGITEMCMB2_NM] [nvarchar](10)," _
	& "     [MNGITEMTEXT1] [nvarchar](10)," _
	& "     [MNGITEMTEXT2] [nvarchar](10)," _
	& "     [MNGITEMCHK1] [int]," _
	& "     [MNGITEMCHK2] [int]," _
	& "     [MNGITEMCHK3] [int]," _
	& "     [MNGITEMCHK4] [int]," _
	& "     [VOLUMEKEY_NM] [nvarchar](1)," _
	& "     [MNGITEM_REMARKS] [nvarchar](100)," _
	& "     [BARCODE] [nvarchar](255)," _
	& "     [CHECK_FLG] [int]," _
	& "     [DSPORDER] [int] NOT NULL," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTW_PRINT_TABLE_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [HOST_NM] ASC," _
	& "     [DSPORDER] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LBCR_印刷テーブルテーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql003 As String = _
	"ALTER TABLE [dbo].[LTW_PRINT_TABLE] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LBCR_印刷テーブルテーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql004 As String = _
	"ALTER TABLE [dbo].[LTW_PRINT_TABLE] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"


	'２．LTI_管理物情報テーブル（桁数変更）を修正
	'テーブルの内容を退避
	Public Shared ReadOnly sql005 As String = _
	"SELECT * INTO [dbo].[LTI_MNGITEMINFO_TEMP] FROM [dbo].[LTI_MNGITEMINFO]"

	'LTI_管理物情報テーブルを削除
	Public Shared ReadOnly sql006 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTI_MNGITEMINFO]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTI_MNGITEMINFO]"

	'LTI_管理物情報を新規作成
	Public Shared ReadOnly sql007 As String = _
	"CREATE TABLE [dbo].[LTI_MNGITEMINFO](" _
	& "     [PATIENT_NO] [nvarchar](10) NOT NULL," _
	& "     [MNGITEM_CD] [nvarchar](3) NOT NULL," _
	& "     [SERIAL_NO] [int] NOT NULL," _
	& "     [BYOREKI_NO] [nvarchar](10)," _
	& "     [DIV1_CD] [nvarchar](10)," _
	& "     [DIV2_CD] [nvarchar](10)," _
	& "     [FIRSTRECEIVING_DT] [datetime]," _
	& "     [LASTRECEIVING_DT] [datetime]," _
	& "     [RECIPIENT_CD] [nvarchar](8)," _
	& "     [KEEPLCT_CD] [nvarchar](3)," _
	& "     [MNGSTATUS_CD] [nvarchar](2)," _
	& "     [REMARKS] [nvarchar](100)," _
	& "     [DATE1] [datetime]," _
	& "     [DATE2] [datetime]," _
	& "     [DOCTOR_CD] [nvarchar](8)," _
	& "     [MNGITEMCMB1] [nvarchar](5)," _
	& "     [MNGITEMCMB2] [nvarchar](5)," _
	& "     [MNGITEMTEXT1] [nvarchar](10)," _
	& "     [MNGITEMTEXT2] [nvarchar](10)," _
	& "     [MNGITEMCHK1] [int]," _
	& "     [MNGITEMCHK2] [int]," _
	& "     [MNGITEMCHK3] [int]," _
	& "     [MNGITEMCHK4] [int]," _
	& "     [VOLUMEKEY] [nvarchar](20)," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTI_MNGITEMINFO_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [PATIENT_NO] ASC," _
	& "     [MNGITEM_CD] ASC," _
	& "     [SERIAL_NO] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTI_管理物情報テーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql008 As String = _
	"ALTER TABLE [dbo].[LTI_MNGITEMINFO] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTI_管理物情報テーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql009 As String = _
	"ALTER TABLE [dbo].[LTI_MNGITEMINFO] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"

	'新しい LTI_管理物情報に退避したデータを代入
	Public Shared ReadOnly sql010 As String = _
	"INSERT INTO [dbo].[LTI_MNGITEMINFO] (" _
	& "[PATIENT_NO],[MNGITEM_CD],[SERIAL_NO],[BYOREKI_NO],[DIV1_CD],[DIV2_CD],[FIRSTRECEIVING_DT],[LASTRECEIVING_DT],[RECIPIENT_CD],[KEEPLCT_CD],[MNGSTATUS_CD],[REMARKS],[DATE1],[DATE2],[DOCTOR_CD],[MNGITEMCMB1],[MNGITEMCMB2],[MNGITEMTEXT1],[MNGITEMTEXT2],[MNGITEMCHK1],[MNGITEMCHK2],[MNGITEMCHK3],[MNGITEMCHK4],[VOLUMEKEY],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& ") " _
	& "SELECT " _
	& "[PATIENT_NO],[MNGITEM_CD],[SERIAL_NO],[BYOREKI_NO],[DIV1_CD],[DIV2_CD],[FIRSTRECEIVING_DT],[LASTRECEIVING_DT],[RECIPIENT_CD],[KEEPLCT_CD],[MNGSTATUS_CD],[REMARKS],[DATE1],[DATE2],[DOCTOR_CD],[MNGITEMCMB1],[MNGITEMCMB2],[MNGITEMTEXT1],[MNGITEMTEXT2],[MNGITEMCHK1],[MNGITEMCHK2],[MNGITEMCHK3],[MNGITEMCHK4],[VOLUMEKEY],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& " FROM [dbo].[LTI_MNGITEMINFO_TEMP]" _
	& " ORDER BY [PATIENT_NO],[MNGITEM_CD],[SERIAL_NO]"

	'退避したデータを削除
	Public Shared ReadOnly sql011 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTI_MNGITEMINFO_TEMP]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTI_MNGITEMINFO_TEMP]"


	'３．LTI_貸出情報テーブル（桁数変更）を修正
	'テーブルの内容を退避
	Public Shared ReadOnly sql012 As String = _
	"SELECT * INTO [dbo].[LTI_LENDINFO_TEMP] FROM [dbo].[LTI_LENDINFO]"

	'LTI_貸出情報テーブルを削除
	Public Shared ReadOnly sql013 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTI_LENDINFO]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTI_LENDINFO]"

	'LTI_貸出情報を新規作成
	Public Shared ReadOnly sql014 As String = _
	"CREATE TABLE [dbo].[LTI_LENDINFO](" _
	& "     [PATIENT_NO] [nvarchar](10) NOT NULL," _
	& "     [MNGITEM_CD] [nvarchar](3) NOT NULL," _
	& "     [SERIAL_NO] [int] NOT NULL," _
	& "     [LENDSERIAL_NO] [int] NOT NULL," _
	& "     [SLIP_CD] [nvarchar](10)," _
	& "     [LENDAIM_CD] [nvarchar](2)," _
	& "     [LCT_CD] [nvarchar](3)," _
	& "     [LCT_NM] [nvarchar](10)," _
	& "     [ISSUE_DT] [datetime]," _
	& "     [EXPECTBACK_DT] [datetime]," _
	& "     [URGEDBACK_DT] [datetime]," _
	& "     [BACK_DT] [datetime]," _
	& "     [BORROWER_CD] [nvarchar](8)," _
	& "     [BORROWER_NM] [nvarchar](20)," _
	& "     [TAKER_CD] [nvarchar](8)," _
	& "     [TAKER_NM] [nvarchar](20)," _
	& "     [LENDCLERK_CD] [nvarchar](8)," _
	& "     [PERSONOFBACK_CD] [nvarchar](8)," _
	& "     [PERSONOFBACK_NM] [nvarchar](20)," _
	& "     [BACKCLERK_CD] [nvarchar](8)," _
	& "     [REMARKS] [nvarchar](100)," _
	& "     [LENDCMB1] [nvarchar](5)," _
	& "     [LENDCMB2] [nvarchar](5)," _
	& "     [LENDTEXT1] [nvarchar](10)," _
	& "     [LENDTEXT2] [nvarchar](10)," _
	& "     [LENDCHK1] [int]," _
	& "     [LENDCHK2] [int]," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTI_LENDINFO_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [PATIENT_NO] ASC," _
	& "     [MNGITEM_CD] ASC," _
	& "     [SERIAL_NO] ASC," _
	& "     [LENDSERIAL_NO] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTI_貸出情報テーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql015 As String = _
	"ALTER TABLE [dbo].[LTI_LENDINFO] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTI_貸出情報テーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql016 As String = _
	"ALTER TABLE [dbo].[LTI_LENDINFO] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"

	'新しい LTI_貸出情報に退避したデータを代入
	Public Shared ReadOnly sql017 As String = _
	"INSERT INTO [dbo].[LTI_LENDINFO] (" _
	& "[PATIENT_NO],[MNGITEM_CD],[SERIAL_NO],[LENDSERIAL_NO],[SLIP_CD],[LENDAIM_CD],[LCT_CD],[LCT_NM],[ISSUE_DT],[EXPECTBACK_DT],[URGEDBACK_DT],[BACK_DT],[BORROWER_CD],[BORROWER_NM],[TAKER_CD],[TAKER_NM],[LENDCLERK_CD],[PERSONOFBACK_CD],[PERSONOFBACK_NM],[BACKCLERK_CD],[REMARKS],[LENDCMB1],[LENDCMB2],[LENDTEXT1],[LENDTEXT2],[LENDCHK1],[LENDCHK2],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& ") " _
	& "SELECT " _
	& "[PATIENT_NO],[MNGITEM_CD],[SERIAL_NO],[LENDSERIAL_NO],[SLIP_CD],[LENDAIM_CD],[LCT_CD],[LCT_NM],[ISSUE_DT],[EXPECTBACK_DT],[URGEDBACK_DT],[BACK_DT],[BORROWER_CD],[BORROWER_NM],[TAKER_CD],[TAKER_NM],[LENDCLERK_CD],[PERSONOFBACK_CD],[PERSONOFBACK_NM],[BACKCLERK_CD],[REMARKS],[LENDCMB1],[LENDCMB2],[LENDTEXT1],[LENDTEXT2],[LENDCHK1],[LENDCHK2],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& " FROM [dbo].[LTI_LENDINFO_TEMP]" _
	& " ORDER BY [PATIENT_NO],[MNGITEM_CD],[SERIAL_NO],[LENDSERIAL_NO]"

	'退避したデータを削除
	Public Shared ReadOnly sql018 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTI_LENDINFO_TEMP]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTI_LENDINFO_TEMP]"


	'４．LTI_保持項目選択テーブル（桁数変更）を修正
	'テーブルの内容を退避
	Public Shared ReadOnly sql019 As String = _
	"SELECT * INTO [dbo].[LTI_MNGITEM_RETVALUE_TEMP] FROM [dbo].[LTI_MNGITEM_RETVALUE]"

	'LTI_保持項目選択テーブルを削除
	Public Shared ReadOnly sql020 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTI_MNGITEM_RETVALUE]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTI_MNGITEM_RETVALUE]"

	'LTI_保持項目選択を新規作成
	Public Shared ReadOnly sql021 As String = _
	"CREATE TABLE [dbo].[LTI_MNGITEM_RETVALUE](" _
	& "     [USER_CD] [nvarchar](8) NOT NULL," _
	& "     [SCREEN_CD] [nvarchar](10) NOT NULL," _
	& "     [MNGITEM_CD] [nvarchar](3) NOT NULL," _
	& "     [OBJECT_NM] [nvarchar](16) NOT NULL," _
	& "     [SAVE_FLG] [int] NOT NULL," _
	& "     [START_FLG] [nvarchar](1) NOT NULL," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTI_MNGITEM_RETVALUE_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [USER_CD] ASC," _
	& "     [SCREEN_CD] ASC," _
	& "     [MNGITEM_CD] ASC," _
	& "     [OBJECT_NM] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTI_保持項目選択テーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql022 As String = _
	"ALTER TABLE [dbo].[LTI_MNGITEM_RETVALUE] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTI_保持項目選択テーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql023 As String = _
	"ALTER TABLE [dbo].[LTI_MNGITEM_RETVALUE] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"

	'新しい LTI_保持項目選択に退避したデータを代入
	Public Shared ReadOnly sql024 As String = _
	"INSERT INTO [dbo].[LTI_MNGITEM_RETVALUE] (" _
	& "[USER_CD],[SCREEN_CD],[MNGITEM_CD],[OBJECT_NM],[SAVE_FLG],[START_FLG],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& ") " _
	& "SELECT " _
	& "[USER_CD],[SCREEN_CD],[MNGITEM_CD],[OBJECT_NM],[SAVE_FLG],[START_FLG],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& " FROM [dbo].[LTI_MNGITEM_RETVALUE_TEMP]" _
	& " ORDER BY [USER_CD],[SCREEN_CD],[MNGITEM_CD],[OBJECT_NM]"

	'退避したデータを削除
	Public Shared ReadOnly sql025 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTI_MNGITEM_RETVALUE_TEMP]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTI_MNGITEM_RETVALUE_TEMP]"


	'５．LTM_管理物テーブル（桁数変更）を修正
	'テーブルの内容を退避
	Public Shared ReadOnly sql026 As String = _
	"SELECT * INTO [dbo].[LTM_MNGITEM_TEMP] FROM [dbo].[LTM_MNGITEM]"

	'LTM_管理物テーブルを削除
	Public Shared ReadOnly sql027 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_MNGITEM]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_MNGITEM]"

	'LTM_管理物を新規作成
	Public Shared ReadOnly sql028 As String = _
	"CREATE TABLE [dbo].[LTM_MNGITEM](" _
	& "     [MNGITEM_CD] [nvarchar](3) NOT NULL," _
	& "     [MNGITEM_NM] [nvarchar](10) NOT NULL," _
	& "     [MNGITEM_RNM] [nvarchar](5) NOT NULL," _
	& "     [MNGITEM_GRP_CD] [nvarchar](3)," _
	& "     [DIV1TITLE] [nvarchar](5)," _
	& "     [DIV1TITLE_RNM] [nvarchar](3)," _
	& "     [DIV1TEXT_FLG] [nvarchar](1)," _
	& "     [DIV2TITLE] [nvarchar](5)," _
	& "     [DIV2TITLE_RNM] [nvarchar](3)," _
	& "     [DIV2TEXT_FLG] [nvarchar](1)," _
	& "     [DATE1TITLE] [nvarchar](5)," _
	& "     [DATE1TITLE_RNM] [nvarchar](3)," _
	& "     [DATE1NEED_FLG] [int]," _
	& "     [DATE2TITLE] [nvarchar](5)," _
	& "     [DATE2TITLE_RNM] [nvarchar](3)," _
	& "     [DATE2NEED_FLG] [int]," _
	& "     [DOCTORDSP_FLG] [int]," _
	& "     [BYOREKITITLE] [nvarchar](4)," _
	& "     [BYOREKITITLE_RNM] [nvarchar](3)," _
	& "     [BYOREKINONEED_FLG] [int]," _
	& "     [MNGITEMCMB1TITLE] [nvarchar](5)," _
	& "     [MNGITEMCMB1TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCMB2TITLE] [nvarchar](5)," _
	& "     [MNGITEMCMB2TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMTEXT1TITLE] [nvarchar](5)," _
	& "     [MNGITEMTEXT1TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMTEXT2TITLE] [nvarchar](5)," _
	& "     [MNGITEMTEXT2TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMTEXT3TITLE] [nvarchar](5)," _
	& "     [MNGITEMTEXT3TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCHK1TITLE] [nvarchar](5)," _
	& "     [MNGITEMCHK1TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCHK1TITLE1] [nvarchar](1)," _
	& "     [MNGITEMCHK2TITLE] [nvarchar](5)," _
	& "     [MNGITEMCHK2TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCHK2TITLE1] [nvarchar](1)," _
	& "     [MNGITEMCHK3TITLE] [nvarchar](5)," _
	& "     [MNGITEMCHK3TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCHK3TITLE1] [nvarchar](1)," _
	& "     [MNGITEMCHK4TITLE] [nvarchar](5)," _
	& "     [MNGITEMCHK4TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCHK4TITLE1] [nvarchar](1)," _
	& "     [COLOR_CD_R] [int]," _
	& "     [COLOR_CD_G] [int]," _
	& "     [COLOR_CD_B] [int]," _
	& "     [DSPORDER] [int]," _
	& "     [FIXED_CD1] [nvarchar](1)," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTM_MNGITEM_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [MNGITEM_CD] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTM_管理物テーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql029 As String = _
	"ALTER TABLE [dbo].[LTM_MNGITEM] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTM_管理物テーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql030 As String = _
	"ALTER TABLE [dbo].[LTM_MNGITEM] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"

	'新しい LTM_管理物に退避したデータを代入
	Public Shared ReadOnly sql031 As String = _
	"INSERT INTO [dbo].[LTM_MNGITEM] (" _
	& "[MNGITEM_CD],[MNGITEM_NM],[MNGITEM_RNM],[MNGITEM_GRP_CD],[DIV1TITLE],[DIV1TITLE_RNM],[DIV1TEXT_FLG],[DIV2TITLE],[DIV2TITLE_RNM],[DIV2TEXT_FLG],[DATE1TITLE],[DATE1TITLE_RNM],[DATE1NEED_FLG],[DATE2TITLE],[DATE2TITLE_RNM],[DATE2NEED_FLG],[DOCTORDSP_FLG],[BYOREKITITLE],[BYOREKITITLE_RNM],[BYOREKINONEED_FLG],[MNGITEMCMB1TITLE],[MNGITEMCMB1TITLE_RNM],[MNGITEMCMB2TITLE],[MNGITEMCMB2TITLE_RNM],[MNGITEMTEXT1TITLE],[MNGITEMTEXT1TITLE_RNM],[MNGITEMTEXT2TITLE],[MNGITEMTEXT2TITLE_RNM],[MNGITEMTEXT3TITLE],[MNGITEMTEXT3TITLE_RNM],[MNGITEMCHK1TITLE],[MNGITEMCHK1TITLE_RNM],[MNGITEMCHK1TITLE1],[MNGITEMCHK2TITLE],[MNGITEMCHK2TITLE_RNM],[MNGITEMCHK2TITLE1],[MNGITEMCHK3TITLE],[MNGITEMCHK3TITLE_RNM],[MNGITEMCHK3TITLE1],[MNGITEMCHK4TITLE],[MNGITEMCHK4TITLE_RNM],[MNGITEMCHK4TITLE1],[COLOR_CD_R],[COLOR_CD_G],[COLOR_CD_B],[DSPORDER],[FIXED_CD1],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& ") " _
	& "SELECT " _
	& "[MNGITEM_CD],[MNGITEM_NM],[MNGITEM_RNM],NULL,[DIV1TITLE],[DIV1TITLE_RNM],[DIV1TEXT_FLG],[DIV2TITLE],[DIV2TITLE_RNM],[DIV2TEXT_FLG],[DATE1TITLE],[DATE1TITLE_RNM],[DATE1NEED_FLG],[DATE2TITLE],[DATE2TITLE_RNM],[DATE2NEED_FLG],[DOCTORDSP_FLG],[BYOREKITITLE],[BYOREKITITLE_RNM],[BYOREKINONEED_FLG],[MNGITEMCMB1TITLE],[MNGITEMCMB1TITLE_RNM],[MNGITEMCMB2TITLE],[MNGITEMCMB2TITLE_RNM],[MNGITEMTEXT1TITLE],[MNGITEMTEXT1TITLE_RNM],[MNGITEMTEXT2TITLE],[MNGITEMTEXT2TITLE_RNM],[MNGITEMTEXT3TITLE],[MNGITEMTEXT3TITLE_RNM],[MNGITEMCHK1TITLE],[MNGITEMCHK1TITLE_RNM],[MNGITEMCHK1TITLE1],[MNGITEMCHK2TITLE],[MNGITEMCHK2TITLE_RNM],[MNGITEMCHK2TITLE1],[MNGITEMCHK3TITLE],[MNGITEMCHK3TITLE_RNM],[MNGITEMCHK3TITLE1],[MNGITEMCHK4TITLE],[MNGITEMCHK4TITLE_RNM],[MNGITEMCHK4TITLE1],[COLOR_CD_R],[COLOR_CD_G],[COLOR_CD_B],[DSPORDER],[FIXED_CD1],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& " FROM [dbo].[LTM_MNGITEM_TEMP]" _
	& " ORDER BY [MNGITEM_CD]"

	'退避したデータを削除
	Public Shared ReadOnly sql032 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_MNGITEM_TEMP]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_MNGITEM_TEMP]"


	'６．LTM_管理物管理状況テーブル（桁数変更）を修正
	'テーブルの内容を退避
	Public Shared ReadOnly sql033 As String = _
	"SELECT * INTO [dbo].[LTM_MNGITEMMNGSTATUS_TEMP] FROM [dbo].[LTM_MNGITEMMNGSTATUS]"

	'LTM_管理物管理状況テーブルを削除
	Public Shared ReadOnly sql034 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_MNGITEMMNGSTATUS]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_MNGITEMMNGSTATUS]"

	'LTM_管理物管理状況を新規作成
	Public Shared ReadOnly sql035 As String = _
	"CREATE TABLE [dbo].[LTM_MNGITEMMNGSTATUS](" _
	& "     [MNGITEM_CD] [nvarchar](3) NOT NULL," _
	& "     [MNGSTATUS_CD] [nvarchar](2) NOT NULL," _
	& "     [MNGSTATUS_NM] [nvarchar](10) NOT NULL," _
	& "     [MNGSTATUS_RNM] [nvarchar](5) NOT NULL," _
	& "     [COLOR_CD_R] [int]," _
	& "     [COLOR_CD_G] [int]," _
	& "     [COLOR_CD_B] [int]," _
	& "     [DSPORDER] [int]," _
	& "     [FIXED_CD1] [nvarchar](1)," _
	& "     [FIXED_CD2] [nvarchar](1)," _
	& "     [FIXED_CD3] [nvarchar](1)," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTM_MNGITEMMNGSTATUS_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [MNGITEM_CD] ASC," _
	& "     [MNGSTATUS_CD] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTM_管理物管理状況テーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql036 As String = _
	"ALTER TABLE [dbo].[LTM_MNGITEMMNGSTATUS] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTM_管理物管理状況テーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql037 As String = _
	"ALTER TABLE [dbo].[LTM_MNGITEMMNGSTATUS] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"

	'新しい LTM_管理物管理状況に退避したデータを代入
	Public Shared ReadOnly sql038 As String = _
	"INSERT INTO [dbo].[LTM_MNGITEMMNGSTATUS] (" _
	& "[MNGITEM_CD],[MNGSTATUS_CD],[MNGSTATUS_NM],[MNGSTATUS_RNM],[COLOR_CD_R],[COLOR_CD_G],[COLOR_CD_B],[DSPORDER],[FIXED_CD1],[FIXED_CD2],[FIXED_CD3],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& ") " _
	& "SELECT " _
	& "[MNGITEM_CD],[MNGSTATUS_CD],[MNGSTATUS_NM],[MNGSTATUS_RNM],[COLOR_CD_R],[COLOR_CD_G],[COLOR_CD_B],[DSPORDER],[FIXED_CD1],[FIXED_CD2],[FIXED_CD3],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& " FROM [dbo].[LTM_MNGITEMMNGSTATUS_TEMP]" _
	& " ORDER BY [MNGITEM_CD],[MNGSTATUS_CD]"

	'退避したデータを削除
	Public Shared ReadOnly sql039 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_MNGITEMMNGSTATUS_TEMP]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_MNGITEMMNGSTATUS_TEMP]"


	'７．LTM_管理物所在場所テーブル（桁数変更）を修正
	'テーブルの内容を退避
	Public Shared ReadOnly sql040 As String = _
	"SELECT * INTO [dbo].[LTM_MNGITEMLCT_TEMP] FROM [dbo].[LTM_MNGITEMLCT]"

	'LTM_管理物所在場所テーブルを削除
	Public Shared ReadOnly sql041 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_MNGITEMLCT]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_MNGITEMLCT]"

	'LTM_管理物所在場所を新規作成
	Public Shared ReadOnly sql042 As String = _
	"CREATE TABLE [dbo].[LTM_MNGITEMLCT](" _
	& "     [LCT_CD] [nvarchar](3) NOT NULL," _
	& "     [LCT_NM] [nvarchar](10) NOT NULL," _
	& "     [LCT_RNM] [nvarchar](5) NOT NULL," _
	& "     [DSPORDER] [int]," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTM_MNGITEMLCT_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [LCT_CD] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTM_管理物所在場所テーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql043 As String = _
	"ALTER TABLE [dbo].[LTM_MNGITEMLCT] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTM_管理物所在場所テーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql044 As String = _
	"ALTER TABLE [dbo].[LTM_MNGITEMLCT] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"

	'新しい LTM_管理物所在場所に退避したデータを代入
	Public Shared ReadOnly sql045 As String = _
	"INSERT INTO [dbo].[LTM_MNGITEMLCT] (" _
	& "[LCT_CD],[LCT_NM],[LCT_RNM],[DSPORDER],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& ") " _
	& "SELECT " _
	& "[LCT_CD],[LCT_NM],[LCT_RNM],[DSPORDER],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& " FROM [dbo].[LTM_MNGITEMLCT_TEMP]" _
	& " ORDER BY [LCT_CD]"

	'退避したデータを削除
	Public Shared ReadOnly sql046 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_MNGITEMLCT_TEMP]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_MNGITEMLCT_TEMP]"


	'８．LTM_管理物保管場所テーブル（桁数変更）を修正
	'テーブルの内容を退避
	Public Shared ReadOnly sql047 As String = _
	"SELECT * INTO [dbo].[LTM_MNGITEMKEEPLCT_TEMP] FROM [dbo].[LTM_MNGITEMKEEPLCT]"

	'LTM_管理物保管場所テーブルを削除
	Public Shared ReadOnly sql048 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_MNGITEMKEEPLCT]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_MNGITEMKEEPLCT]"

	'LTM_管理物保管場所を新規作成
	Public Shared ReadOnly sql049 As String = _
	"CREATE TABLE [dbo].[LTM_MNGITEMKEEPLCT](" _
	& "     [MNGITEM_CD] [nvarchar](3) NOT NULL," _
	& "     [KEEPLCT_CD] [nvarchar](3) NOT NULL," _
	& "     [KEEPLCT_NM] [nvarchar](10) NOT NULL," _
	& "     [KEEPLCT_RNM] [nvarchar](5) NOT NULL," _
	& "     [DSPORDER] [int]," _
	& "     [FIXED_CD1] [nvarchar](1)," _
	& "     [FIXED_CD2] [nvarchar](1)," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTM_MNGITEMKEEPLCT_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [MNGITEM_CD] ASC," _
	& "     [KEEPLCT_CD] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTM_管理物保管場所テーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql050 As String = _
	"ALTER TABLE [dbo].[LTM_MNGITEMKEEPLCT] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTM_管理物保管場所テーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql051 As String = _
	"ALTER TABLE [dbo].[LTM_MNGITEMKEEPLCT] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"

	'新しい LTM_管理物保管場所に退避したデータを代入
	Public Shared ReadOnly sql052 As String = _
	"INSERT INTO [dbo].[LTM_MNGITEMKEEPLCT] (" _
	& "[MNGITEM_CD],[KEEPLCT_CD],[KEEPLCT_NM],[KEEPLCT_RNM],[DSPORDER],[FIXED_CD1],[FIXED_CD2],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& ") " _
	& "SELECT " _
	& "[MNGITEM_CD],[KEEPLCT_CD],[KEEPLCT_NM],[KEEPLCT_RNM],[DSPORDER],[FIXED_CD1],[FIXED_CD2],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& " FROM [dbo].[LTM_MNGITEMKEEPLCT_TEMP]" _
	& " ORDER BY [MNGITEM_CD],[KEEPLCT_CD]"

	'退避したデータを削除
	Public Shared ReadOnly sql053 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_MNGITEMKEEPLCT_TEMP]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_MNGITEMKEEPLCT_TEMP]"


	'９．LTM_区分１テーブル（桁数変更）を修正
	'テーブルの内容を退避
	Public Shared ReadOnly sql054 As String = _
	"SELECT * INTO [dbo].[LTM_DIV1_TEMP] FROM [dbo].[LTM_DIV1]"

	'LTM_区分１テーブルを削除
	Public Shared ReadOnly sql055 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_DIV1]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_DIV1]"

	'LTM_区分１を新規作成
	Public Shared ReadOnly sql056 As String = _
	"CREATE TABLE [dbo].[LTM_DIV1](" _
	& "     [MNGITEM_CD] [nvarchar](3) NOT NULL," _
	& "     [DIV1_CD] [nvarchar](4) NOT NULL," _
	& "     [DIV1_NM] [nvarchar](10) NOT NULL," _
	& "     [DIV1_RNM] [nvarchar](5) NOT NULL," _
	& "     [DIV1_GRP_CD] [nvarchar](3)," _
	& "     [DSPORDER] [int]," _
	& "     [FIXED_CD1] [nvarchar](1)," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTM_DIV1_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [MNGITEM_CD] ASC," _
	& "     [DIV1_CD] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTM_区分１テーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql057 As String = _
	"ALTER TABLE [dbo].[LTM_DIV1] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTM_区分１テーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql058 As String = _
	"ALTER TABLE [dbo].[LTM_DIV1] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"

	'新しい LTM_区分１に退避したデータを代入
	Public Shared ReadOnly sql059 As String = _
	"INSERT INTO [dbo].[LTM_DIV1] (" _
	& "[MNGITEM_CD],[DIV1_CD],[DIV1_NM],[DIV1_RNM],[DIV1_GRP_CD],[DSPORDER],[FIXED_CD1],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& ") " _
	& "SELECT " _
	& "[MNGITEM_CD],[DIV1_CD],[DIV1_NM],[DIV1_RNM],NULL,[DSPORDER],[FIXED_CD1],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& " FROM [dbo].[LTM_DIV1_TEMP]" _
	& " ORDER BY [MNGITEM_CD],[DIV1_CD]"

	'退避したデータを削除
	Public Shared ReadOnly sql060 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_DIV1_TEMP]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_DIV1_TEMP]"


	'１０．LTM_区分２テーブル（桁数変更）を修正
	'テーブルの内容を退避
	Public Shared ReadOnly sql061 As String = _
	"SELECT * INTO [dbo].[LTM_DIV2_TEMP] FROM [dbo].[LTM_DIV2]"

	'LTM_区分２テーブルを削除
	Public Shared ReadOnly sql062 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_DIV2]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_DIV2]"

	'LTM_区分２を新規作成
	Public Shared ReadOnly sql063 As String = _
	"CREATE TABLE [dbo].[LTM_DIV2](" _
	& "     [MNGITEM_CD] [nvarchar](3) NOT NULL," _
	& "     [DIV2_CD] [nvarchar](4) NOT NULL," _
	& "     [DIV2_NM] [nvarchar](10) NOT NULL," _
	& "     [DIV2_RNM] [nvarchar](5) NOT NULL," _
	& "     [DIV2_GRP_CD] [nvarchar](3)," _
	& "     [DSPORDER] [int]," _
	& "     [FIXED_CD1] [nvarchar](1)," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTM_DIV2_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [MNGITEM_CD] ASC," _
	& "     [DIV2_CD] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTM_区分２テーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql064 As String = _
	"ALTER TABLE [dbo].[LTM_DIV2] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTM_区分２テーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql065 As String = _
	"ALTER TABLE [dbo].[LTM_DIV2] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"

	'新しい LTM_区分２に退避したデータを代入
	Public Shared ReadOnly sql066 As String = _
	"INSERT INTO [dbo].[LTM_DIV2] (" _
	& "[MNGITEM_CD],[DIV2_CD],[DIV2_NM],[DIV2_RNM],[DIV2_GRP_CD],[DSPORDER],[FIXED_CD1],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& ") " _
	& "SELECT " _
	& "[MNGITEM_CD],[DIV2_CD],[DIV2_NM],[DIV2_RNM],NULL,[DSPORDER],[FIXED_CD1],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& " FROM [dbo].[LTM_DIV2_TEMP]" _
	& " ORDER BY [MNGITEM_CD],[DIV2_CD]"

	'退避したデータを削除
	Public Shared ReadOnly sql067 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_DIV2_TEMP]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_DIV2_TEMP]"


	'１１．LTM_貸出コンボテーブル（桁数変更）を修正
	'テーブルの内容を退避
	Public Shared ReadOnly sql068 As String = _
	"SELECT * INTO [dbo].[LTM_LENDCMB_TEMP] FROM [dbo].[LTM_LENDCMB]"

	'LTM_貸出コンボテーブルを削除
	Public Shared ReadOnly sql069 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_LENDCMB]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_LENDCMB]"

	'LTM_貸出コンボを新規作成
	Public Shared ReadOnly sql070 As String = _
	"CREATE TABLE [dbo].[LTM_LENDCMB](" _
	& "     [MNGITEM_CD] [nvarchar](3) NOT NULL," _
	& "     [DIV_CD] [nvarchar](1) NOT NULL," _
	& "     [CMB_CD] [nvarchar](2) NOT NULL," _
	& "     [CMBCNT_NM] [nvarchar](10) NOT NULL," _
	& "     [CMBCNT_RNM] [nvarchar](5) NOT NULL," _
	& "     [DSPORDER] [int]," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTM_LENDCMB_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [MNGITEM_CD] ASC," _
	& "     [DIV_CD] ASC," _
	& "     [CMB_CD] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTM_貸出コンボテーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql071 As String = _
	"ALTER TABLE [dbo].[LTM_LENDCMB] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTM_貸出コンボテーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql072 As String = _
	"ALTER TABLE [dbo].[LTM_LENDCMB] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"

	'新しい LTM_貸出コンボに退避したデータを代入
	Public Shared ReadOnly sql073 As String = _
	"INSERT INTO [dbo].[LTM_LENDCMB] (" _
	& "[MNGITEM_CD],[DIV_CD],[CMB_CD],[CMBCNT_NM],[CMBCNT_RNM],[DSPORDER],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& ") " _
	& "SELECT " _
	& "[MNGITEM_CD],[DIV_CD],[CMB_CD],[CMBCNT_NM],[CMBCNT_RNM],[DSPORDER],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& " FROM [dbo].[LTM_LENDCMB_TEMP]" _
	& " ORDER BY [MNGITEM_CD],[DIV_CD],[CMB_CD]"

	'退避したデータを削除
	Public Shared ReadOnly sql074 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_LENDCMB_TEMP]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_LENDCMB_TEMP]"


	'１２．LTM_貸出目的テーブル（桁数変更）を修正
	'テーブルの内容を退避
	Public Shared ReadOnly sql075 As String = _
	"SELECT * INTO [dbo].[LTM_LENDAIM_TEMP] FROM [dbo].[LTM_LENDAIM]"

	'LTM_貸出目的テーブルを削除
	Public Shared ReadOnly sql076 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_LENDAIM]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_LENDAIM]"

	'LTM_貸出目的を新規作成
	Public Shared ReadOnly sql077 As String = _
	"CREATE TABLE [dbo].[LTM_LENDAIM](" _
	& "     [LENDAIM_CD] [nvarchar](2) NOT NULL," _
	& "     [LENDAIM_NM] [nvarchar](10) NOT NULL," _
	& "     [LENDAIM_RNM] [nvarchar](5) NOT NULL," _
	& "     [LENDDAYS] [int] NOT NULL," _
	& "     [DSPORDER] [int]," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTM_LENDAIM_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [LENDAIM_CD] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTM_貸出目的テーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql078 As String = _
	"ALTER TABLE [dbo].[LTM_LENDAIM] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTM_貸出目的テーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql079 As String = _
	"ALTER TABLE [dbo].[LTM_LENDAIM] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"

	'新しい LTM_貸出目的に退避したデータを代入
	Public Shared ReadOnly sql080 As String = _
	"INSERT INTO [dbo].[LTM_LENDAIM] (" _
	& "[LENDAIM_CD],[LENDAIM_NM],[LENDAIM_RNM],[LENDDAYS],[DSPORDER],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& ") " _
	& "SELECT " _
	& "[LENDAIM_CD],[LENDAIM_NM],[LENDAIM_RNM],[LENDDAYS],[DSPORDER],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& " FROM [dbo].[LTM_LENDAIM_TEMP]" _
	& " ORDER BY [LENDAIM_CD]"

	'退避したデータを削除
	Public Shared ReadOnly sql081 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_LENDAIM_TEMP]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_LENDAIM_TEMP]"


	'１３．LTW_管理物一覧ワークテーブル（桁数変更）を修正
	'LTW_管理物一覧ワークテーブルを削除
	Public Shared ReadOnly sql082 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTW_MNGITEMLIST_WORK]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTW_MNGITEMLIST_WORK]"

	'LTW_管理物一覧ワークを新規作成
	Public Shared ReadOnly sql083 As String = _
	"CREATE TABLE [dbo].[LTW_MNGITEMLIST_WORK](" _
	& "     [HOST_NM] [nvarchar](64) NOT NULL," _
	& "     [PRT_ID] [nvarchar](10) NOT NULL," _
	& "     [SORTKEY1] [int] NOT NULL," _
	& "     [PATIENT_NO] [nvarchar](10)," _
	& "     [BYOREKI_NO] [nvarchar](10)," _
	& "     [PATIENT_KNM] [nvarchar](30)," _
	& "     [PATIENT_NM] [nvarchar](20)," _
	& "     [GENDER_CD] [nvarchar](1)," _
	& "     [GENDER_NM] [nvarchar](2)," _
	& "     [BIRTH_DT] [datetime]," _
	& "     [FIRSTHSPVST_DT] [datetime]," _
	& "     [LASTHSPVST_DT] [datetime]," _
	& "     [LASTLEFTHSP_DT] [datetime]," _
	& "     [PATIENT_REMARKS] [nvarchar](100)," _
	& "     [MNGITEM_CD] [nvarchar](3)," _
	& "     [MNGITEM_NM] [nvarchar](10)," _
	& "     [MNGITEM_RNM] [nvarchar](5)," _
	& "     [MNGITEM_DSPORDER] [int]," _
	& "     [DIV1_CD] [nvarchar](10)," _
	& "     [DIV1_NM] [nvarchar](10)," _
	& "     [DIV1_RNM] [nvarchar](10)," _
	& "     [DIV1_DSPORDER] [int]," _
	& "     [DIV2_CD] [nvarchar](10)," _
	& "     [DIV2_NM] [nvarchar](10)," _
	& "     [DIV2_RNM] [nvarchar](10)," _
	& "     [DIV2_DSPORDER] [int]," _
	& "     [DATE1] [datetime]," _
	& "     [DATE2] [datetime]," _
	& "     [FIRSTRECEIVING_DT] [datetime]," _
	& "     [LASTRECEIVING_DT] [datetime]," _
	& "     [RECIPIENT_CD] [nvarchar](8)," _
	& "     [RECIPIENT_NM] [nvarchar](20)," _
	& "     [RECIPIENT_DSPORDER] [int]," _
	& "     [MNGSTATUS_CD] [nvarchar](2)," _
	& "     [MNGSTATUS_NM] [nvarchar](10)," _
	& "     [MNGSTATUS_RNM] [nvarchar](5)," _
	& "     [MNGSTATUS_DSPORDER] [int]," _
	& "     [KEEPLCT_CD] [nvarchar](3)," _
	& "     [KEEPLCT_NM] [nvarchar](10)," _
	& "     [KEEPLCT_RNM] [nvarchar](5)," _
	& "     [KEEPLCT_DSPORDER] [int]," _
	& "     [DOCTOR_CD] [nvarchar](8)," _
	& "     [DOCTOR_NM] [nvarchar](20)," _
	& "     [DOCTOR_DSPORDER] [int]," _
	& "     [MNGITEMCMB1_CD] [nvarchar](2)," _
	& "     [MNGITEMCMB1_NM] [nvarchar](10)," _
	& "     [MNGITEMCMB1_RNM] [nvarchar](5)," _
	& "     [MNGITEMCMB1_DSPORDER] [int]," _
	& "     [MNGITEMCMB2_CD] [nvarchar](2)," _
	& "     [MNGITEMCMB2_NM] [nvarchar](10)," _
	& "     [MNGITEMCMB2_RNM] [nvarchar](5)," _
	& "     [MNGITEMCMB2_DSPORDER] [int]," _
	& "     [MNGITEMTEXT1] [nvarchar](10)," _
	& "     [MNGITEMTEXT2] [nvarchar](10)," _
	& "     [MNGITEMCHK1] [int]," _
	& "     [MNGITEMCHK2] [int]," _
	& "     [MNGITEMCHK3] [int]," _
	& "     [MNGITEMCHK4] [int]," _
	& "     [VOLUMEKEY_NM] [nvarchar](1)," _
	& "     [MNGITEM_REMARKS] [nvarchar](100)," _
	& "     [SLIP_CD] [nvarchar](10)," _
	& "     [LENDAIM_CD] [nvarchar](2)," _
	& "     [LENDAIM_NM] [nvarchar](10)," _
	& "     [LENDAIM_RNM] [nvarchar](5)," _
	& "     [LENDAIM_DSPORDER] [int]," _
	& "     [LCT_CD] [nvarchar](3)," _
	& "     [LCT_NM] [nvarchar](10)," _
	& "     [LCT_RNM] [nvarchar](5)," _
	& "     [LCT_DSPORDER] [int]," _
	& "     [ISSUE_DT] [datetime]," _
	& "     [EXPECTBACK_DT] [datetime]," _
	& "     [URGEDBACK_DT] [datetime]," _
	& "     [BACK_DT] [datetime]," _
	& "     [BORROWER_DIV_CD] [nvarchar](3)," _
	& "     [BORROWER_DIV_NM] [nvarchar](20)," _
	& "     [BORROWER_DIV_RNM] [nvarchar](6)," _
	& "     [BORROWER_DIV_DSPORDER] [int]," _
	& "     [BORROWER_CD] [nvarchar](8)," _
	& "     [BORROWER_NM] [nvarchar](20)," _
	& "     [BORROWER_DSPORDER] [int]," _
	& "     [TAKER_DIV_CD] [nvarchar](3)," _
	& "     [TAKER_DIV_NM] [nvarchar](20)," _
	& "     [TAKER_DIV_RNM] [nvarchar](6)," _
	& "     [TAKER_DIV_DSPORDER] [int]," _
	& "     [TAKER_CD] [nvarchar](8)," _
	& "     [TAKER_NM] [nvarchar](20)," _
	& "     [TAKER_DSPORDER] [int]," _
	& "     [LENDCLERK_CD] [nvarchar](8)," _
	& "     [LENDCLERK_NM] [nvarchar](20)," _
	& "     [LENDCLERK_DSPORDER] [int]," _
	& "     [PERSONOFBACK_CD] [nvarchar](8)," _
	& "     [PERSONOFBACK_NM] [nvarchar](20)," _
	& "     [PERSONOFBACK_DSPORDER] [int]," _
	& "     [BACKCLERK_CD] [nvarchar](8)," _
	& "     [BACKCLERK_NM] [nvarchar](20)," _
	& "     [BACKCLERK_DSPORDER] [int]," _
	& "     [LENDCMB1_CD] [nvarchar](2)," _
	& "     [LENDCMB1_NM] [nvarchar](10)," _
	& "     [LENDCMB1_RNM] [nvarchar](5)," _
	& "     [LENDCMB1_DSPORDER] [int]," _
	& "     [LENDCMB2_CD] [nvarchar](2)," _
	& "     [LENDCMB2_NM] [nvarchar](10)," _
	& "     [LENDCMB2_RNM] [nvarchar](5)," _
	& "     [LENDCMB2_DSPORDER] [int]," _
	& "     [LENDTEXT1] [nvarchar](10)," _
	& "     [LENDTEXT2] [nvarchar](10)," _
	& "     [LENDCHK1] [int]," _
	& "     [LENDCHK2] [int]," _
	& "     [LEND_REMARKS] [nvarchar](100)," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTW_MNGITEMLIST_WORK_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [HOST_NM] ASC," _
	& "     [PRT_ID] ASC," _
	& "     [SORTKEY1] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTW_管理物一覧ワークテーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql084 As String = _
	"ALTER TABLE [dbo].[LTW_MNGITEMLIST_WORK] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTW_管理物一覧ワークテーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql085 As String = _
	"ALTER TABLE [dbo].[LTW_MNGITEMLIST_WORK] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"


	'１４．LTW_検索処理結果情報テーブル（桁数変更）を修正
	'テーブルの内容を退避
	Public Shared ReadOnly sql086 As String = _
	"SELECT * INTO [dbo].[LTT_RESULT_INFO_TEMP] FROM [dbo].[LTT_RESULT_INFO]"

	'LTW_検索処理結果情報テーブルを削除
	Public Shared ReadOnly sql087 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTT_RESULT_INFO]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTT_RESULT_INFO]"

	'LTW_検索処理結果情報を新規作成
	Public Shared ReadOnly sql088 As String = _
	"CREATE TABLE [dbo].[LTT_RESULT_INFO](" _
	& "     [USER_CD] [nvarchar](8) NOT NULL," _
	& "     [SEARCH_NO] [int] NOT NULL," _
	& "     [PATIENT_NO] [nvarchar](10) NOT NULL," _
	& "     [MNGITEM_CD] [nvarchar](3) NOT NULL," _
	& "     [SERIAL_NO] [int] NOT NULL," _
	& "     [LENDSERIAL_NO] [int] NOT NULL," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTT_RESULT_INFO_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [USER_CD] ASC," _
	& "     [SEARCH_NO] ASC," _
	& "     [PATIENT_NO] ASC," _
	& "     [MNGITEM_CD] ASC," _
	& "     [SERIAL_NO] ASC," _
	& "     [LENDSERIAL_NO] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTW_検索処理結果情報テーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql089 As String = _
	"ALTER TABLE [dbo].[LTT_RESULT_INFO] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTW_検索処理結果情報テーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql090 As String = _
	"ALTER TABLE [dbo].[LTT_RESULT_INFO] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"

	'新しい LTW_検索処理結果情報に退避したデータを代入
	Public Shared ReadOnly sql091 As String = _
	"INSERT INTO [dbo].[LTT_RESULT_INFO] (" _
	& "[USER_CD],[SEARCH_NO],[PATIENT_NO],[MNGITEM_CD],[SERIAL_NO],[LENDSERIAL_NO],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& ") " _
	& "SELECT " _
	& "[USER_CD],[SEARCH_NO],[PATIENT_NO],[MNGITEM_CD],[SERIAL_NO],[LENDSERIAL_NO],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& " FROM [dbo].[LTT_RESULT_INFO_TEMP]" _
	& " ORDER BY [USER_CD],[SEARCH_NO],[PATIENT_NO],[MNGITEM_CD],[SERIAL_NO],[LENDSERIAL_NO]"

	'退避したデータを削除
	Public Shared ReadOnly sql092 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTT_RESULT_INFO_TEMP]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTT_RESULT_INFO_TEMP]"


	'１５．LTW_検索処理検索テーブル（桁数変更）を修正
	'LTW_検索処理検索テーブルを削除
	Public Shared ReadOnly sql093 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTW_SEARCH_WORK]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTW_SEARCH_WORK]"

	'LTW_検索処理検索を新規作成
	Public Shared ReadOnly sql094 As String = _
	"CREATE TABLE [dbo].[LTW_SEARCH_WORK](" _
	& "     [USER_CD] [nvarchar](8) NOT NULL," _
	& "     [TABLE_CD] [int] NOT NULL," _
	& "     [PATIENT_NO] [nvarchar](10) NOT NULL," _
	& "     [MNGITEM_CD] [nvarchar](3) NOT NULL," _
	& "     [SERIAL_NO] [int] NOT NULL," _
	& "     [LENDSERIAL_NO] [int] NOT NULL," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTW_SEARCH_WORK_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [USER_CD] ASC," _
	& "     [TABLE_CD] ASC," _
	& "     [PATIENT_NO] ASC," _
	& "     [MNGITEM_CD] ASC," _
	& "     [SERIAL_NO] ASC," _
	& "     [LENDSERIAL_NO] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTW_検索処理検索テーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql095 As String = _
	"ALTER TABLE [dbo].[LTW_SEARCH_WORK] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTW_検索処理検索テーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql096 As String = _
	"ALTER TABLE [dbo].[LTW_SEARCH_WORK] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"


	'１６．LTW_更新一覧ワークテーブル（桁数変更）を修正
	'LTW_更新一覧ワークテーブルを削除
	Public Shared ReadOnly sql097 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTW_UPDLIST_WORK]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTW_UPDLIST_WORK]"

	'LTW_更新一覧ワークを新規作成
	Public Shared ReadOnly sql098 As String = _
	"CREATE TABLE [dbo].[LTW_UPDLIST_WORK](" _
	& "     [HOST_NM] [nvarchar](64) NOT NULL," _
	& "     [PRT_ID] [nvarchar](10) NOT NULL," _
	& "     [SORTKEY1] [int] NOT NULL," _
	& "     [MNGITEM_CD] [nvarchar](3)," _
	& "     [MNGITEM_NM] [nvarchar](10)," _
	& "     [MNGITEM_RNM] [nvarchar](5)," _
	& "     [BYOREKI_NO] [nvarchar](10)," _
	& "     [PATIENT_NO] [nvarchar](10)," _
	& "     [PATIENT_NM] [nvarchar](20)," _
	& "     [PATIENT_KNM] [nvarchar](30)," _
	& "     [GENDER_NM] [nvarchar](2)," _
	& "     [DIV1_NM] [nvarchar](10)," _
	& "     [DIV1_RNM] [nvarchar](10)," _
	& "     [DIV2_NM] [nvarchar](10)," _
	& "     [DIV2_RNM] [nvarchar](10)," _
	& "     [DATE1] [datetime]," _
	& "     [DATE2] [datetime]," _
	& "     [DOC_STAFF_NM] [nvarchar](30)," _
	& "     [FIRSTRECEIVING_DT] [datetime]," _
	& "     [LASTRECEIVING_DT] [datetime]," _
	& "     [RECIPIENT_NM] [nvarchar](20)," _
	& "     [MNGSTATUS_NM] [nvarchar](20)," _
	& "     [MNGSTATUS_RNM] [nvarchar](5)," _
	& "     [KEEPLCT_NM] [nvarchar](20)," _
	& "     [KEEPLCT_RNM] [nvarchar](6)," _
	& "     [VOLUMEKEY_NM] [nvarchar](1)," _
	& "     [MNGITEMCMB1_NM] [nvarchar](10)," _
	& "     [MNGITEMCMB1_RNM] [nvarchar](5)," _
	& "     [MNGITEMCMB2_NM] [nvarchar](10)," _
	& "     [MNGITEMCMB2_RNM] [nvarchar](5)," _
	& "     [MNGITEMTEXT1] [nvarchar](10)," _
	& "     [MNGITEMTEXT2] [nvarchar](10)," _
	& "     [MNGITEMCHK1_NM] [nvarchar](1)," _
	& "     [MNGITEMCHK2_NM] [nvarchar](1)," _
	& "     [MNGITEMCHK3_NM] [nvarchar](1)," _
	& "     [MNGITEMCHK4_NM] [nvarchar](1)," _
	& "     [REMARKS] [nvarchar](100)," _
	& "     [USER_NM] [nvarchar](30)," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTW_UPDLIST_WORK_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [HOST_NM] ASC," _
	& "     [PRT_ID] ASC," _
	& "     [SORTKEY1] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTW_更新一覧ワークテーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql099 As String = _
	"ALTER TABLE [dbo].[LTW_UPDLIST_WORK] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTW_更新一覧ワークテーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql100 As String = _
	"ALTER TABLE [dbo].[LTW_UPDLIST_WORK] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"


	'１７．LTW_貸出一覧_帳票_ワークテーブル（桁数変更）を修正
	'LTW_貸出一覧_帳票_ワークテーブルを削除
	Public Shared ReadOnly sql101 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTW_LENDING_LIST_WORK]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTW_LENDING_LIST_WORK]"

	'LTW_貸出一覧_帳票_ワークを新規作成
	Public Shared ReadOnly sql102 As String = _
	"CREATE TABLE [dbo].[LTW_LENDING_LIST_WORK](" _
	& "     [HOST_NM] [nvarchar](64) NOT NULL," _
	& "     [PRT_ID] [nvarchar](10) NOT NULL," _
	& "     [SORTKEY1] [int] NOT NULL," _
	& "     [MNGITEM_CD] [nvarchar](3)," _
	& "     [MNGITEM_NM] [nvarchar](10)," _
	& "     [MNGITEM_RNM] [nvarchar](5)," _
	& "     [MNGITEM_DSPORDER] [int]," _
	& "     [PATIENT_NO] [nvarchar](10)," _
	& "     [BYOREKI_NO] [nvarchar](10)," _
	& "     [PATIENT_NM] [nvarchar](20)," _
	& "     [PATIENT_KNM] [nvarchar](30)," _
	& "     [GENDER_CD] [nvarchar](1)," _
	& "     [GENDER_NM] [nvarchar](2)," _
	& "     [DIV1TITLE] [nvarchar](5)," _
	& "     [DIV1TITLE_RNM] [nvarchar](3)," _
	& "     [DIV1_CD] [nvarchar](10)," _
	& "     [DIV1_NM] [nvarchar](10)," _
	& "     [DIV1_RNM] [nvarchar](10)," _
	& "     [DIV1_DSPORDER] [int]," _
	& "     [DIV2TITLE] [nvarchar](5)," _
	& "     [DIV2TITLE_RNM] [nvarchar](3)," _
	& "     [DIV2_CD] [nvarchar](10)," _
	& "     [DIV2_NM] [nvarchar](10)," _
	& "     [DIV2_RNM] [nvarchar](10)," _
	& "     [DIV2_DSPORDER] [int]," _
	& "     [DATE1TITLE] [nvarchar](5)," _
	& "     [DATE1TITLE_RNM] [nvarchar](3)," _
	& "     [DATE1] [datetime]," _
	& "     [DATE2TITLE] [nvarchar](5)," _
	& "     [DATE2TITLE_RNM] [nvarchar](3)," _
	& "     [DATE2] [datetime]," _
	& "     [DOCTOR_CD] [nvarchar](8)," _
	& "     [DOCTOR_NM] [nvarchar](20)," _
	& "     [DOCTOR_DSPORDER] [int]," _
	& "     [FIRSTRECEIVING_DT] [datetime]," _
	& "     [LASTRECEIVING_DT] [datetime]," _
	& "     [RECIPIENT_CD] [nvarchar](8)," _
	& "     [RECIPIENT_NM] [nvarchar](20)," _
	& "     [RECIPIENT_DSPORDER] [int]," _
	& "     [MNGSTATUS_CD] [nvarchar](2)," _
	& "     [MNGSTATUS_NM] [nvarchar](10)," _
	& "     [MNGSTATUS_RNM] [nvarchar](5)," _
	& "     [MNGSTATUS_DSPORDER] [int]," _
	& "     [KEEPLCT_CD] [nvarchar](3)," _
	& "     [KEEPLCT_NM] [nvarchar](10)," _
	& "     [KEEPLCT_RNM] [nvarchar](5)," _
	& "     [KEEPLCT_DSPORDER] [int]," _
	& "     [VOLUMEKEY] [nvarchar](20)," _
	& "     [VOLUMEKEY_NM] [nvarchar](1)," _
	& "     [MNGITEMCMB1TITLE] [nvarchar](5)," _
	& "     [MNGITEMCMB1TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCMB1_CD] [nvarchar](2)," _
	& "     [MNGITEMCMB1_NM] [nvarchar](10)," _
	& "     [MNGITEMCMB1_RNM] [nvarchar](5)," _
	& "     [MNGITEMCMB1_DSPORDER] [int]," _
	& "     [MNGITEMCMB2TITLE] [nvarchar](5)," _
	& "     [MNGITEMCMB2TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCMB2_CD] [nvarchar](2)," _
	& "     [MNGITEMCMB2_NM] [nvarchar](10)," _
	& "     [MNGITEMCMB2_RNM] [nvarchar](5)," _
	& "     [MNGITEMCMB2_DSPORDER] [int]," _
	& "     [MNGITEMTEXT1] [nvarchar](10)," _
	& "     [MNGITEMTEXT1TITLE] [nvarchar](5)," _
	& "     [MNGITEMTEXT1TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMTEXT2] [nvarchar](10)," _
	& "     [MNGITEMTEXT2TITLE] [nvarchar](5)," _
	& "     [MNGITEMTEXT2TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCHK1TITLE] [nvarchar](5)," _
	& "     [MNGITEMCHK1TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCHK1TITLE1] [nvarchar](1)," _
	& "     [MNGITEMCHK1] [int]," _
	& "     [MNGITEMCHK2TITLE] [nvarchar](5)," _
	& "     [MNGITEMCHK2TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCHK2TITLE1] [nvarchar](1)," _
	& "     [MNGITEMCHK2] [int]," _
	& "     [MNGITEMCHK3TITLE] [nvarchar](5)," _
	& "     [MNGITEMCHK3TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCHK3TITLE1] [nvarchar](1)," _
	& "     [MNGITEMCHK3] [int]," _
	& "     [MNGITEMCHK4TITLE] [nvarchar](5)," _
	& "     [MNGITEMCHK4TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCHK4TITLE1] [nvarchar](1)," _
	& "     [MNGITEMCHK4] [int]," _
	& "     [REMARKS] [nvarchar](100)," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTW_LENDING_LIST_WORK_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [HOST_NM] ASC," _
	& "     [PRT_ID] ASC," _
	& "     [SORTKEY1] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTW_貸出一覧_帳票_ワークテーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql103 As String = _
	"ALTER TABLE [dbo].[LTW_LENDING_LIST_WORK] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTW_貸出一覧_帳票_ワークテーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql104 As String = _
	"ALTER TABLE [dbo].[LTW_LENDING_LIST_WORK] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"


	'１８．LTW_貸出一覧ワークテーブル（桁数変更）を修正
	'LTW_貸出一覧ワークテーブルを削除
	Public Shared ReadOnly sql105 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTW_LENDLIST_WORK]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTW_LENDLIST_WORK]"

	'LTW_貸出一覧ワークを新規作成
	Public Shared ReadOnly sql106 As String = _
	"CREATE TABLE [dbo].[LTW_LENDLIST_WORK](" _
	& "     [HOST_NM] [nvarchar](64) NOT NULL," _
	& "     [PRT_ID] [nvarchar](10) NOT NULL," _
	& "     [SORTKEY1] [int] NOT NULL," _
	& "     [PATIENT_NO] [nvarchar](10)," _
	& "     [BYOREKI_NO] [nvarchar](10)," _
	& "     [PATIENT_KNM] [nvarchar](30)," _
	& "     [PATIENT_NM] [nvarchar](20)," _
	& "     [GENDER_CD] [nvarchar](1)," _
	& "     [GENDER_NM] [nvarchar](2)," _
	& "     [BIRTH_DT] [datetime]," _
	& "     [FIRSTHSPVST_DT] [datetime]," _
	& "     [LASTHSPVST_DT] [datetime]," _
	& "     [LASTLEFTHSP_DT] [datetime]," _
	& "     [PATIENT_REMARKS] [nvarchar](100)," _
	& "     [MNGITEM_CD] [nvarchar](3)," _
	& "     [MNGITEM_NM] [nvarchar](10)," _
	& "     [MNGITEM_RNM] [nvarchar](5)," _
	& "     [MNGITEM_DSPORDER] [int]," _
	& "     [DIV1_CD] [nvarchar](10)," _
	& "     [DIV1_NM] [nvarchar](10)," _
	& "     [DIV1_RNM] [nvarchar](10)," _
	& "     [DIV1_DSPORDER] [int]," _
	& "     [DIV2_CD] [nvarchar](10)," _
	& "     [DIV2_NM] [nvarchar](10)," _
	& "     [DIV2_RNM] [nvarchar](10)," _
	& "     [DIV2_DSPORDER] [int]," _
	& "     [DATE1] [datetime]," _
	& "     [DATE2] [datetime]," _
	& "     [FIRSTRECEIVING_DT] [datetime]," _
	& "     [LASTRECEIVING_DT] [datetime]," _
	& "     [RECIPIENT_CD] [nvarchar](8)," _
	& "     [RECIPIENT_NM] [nvarchar](20)," _
	& "     [RECIPIENT_DSPORDER] [int]," _
	& "     [MNGSTATUS_CD] [nvarchar](2)," _
	& "     [MNGSTATUS_NM] [nvarchar](10)," _
	& "     [MNGSTATUS_RNM] [nvarchar](5)," _
	& "     [MNGSTATUS_DSPORDER] [int]," _
	& "     [KEEPLCT_CD] [nvarchar](3)," _
	& "     [KEEPLCT_NM] [nvarchar](10)," _
	& "     [KEEPLCT_RNM] [nvarchar](5)," _
	& "     [KEEPLCT_DSPORDER] [int]," _
	& "     [DOCTOR_CD] [nvarchar](8)," _
	& "     [DOCTOR_NM] [nvarchar](20)," _
	& "     [DOCTOR_DSPORDER] [int]," _
	& "     [MNGITEMCMB1_CD] [nvarchar](2)," _
	& "     [MNGITEMCMB1_NM] [nvarchar](10)," _
	& "     [MNGITEMCMB1_RNM] [nvarchar](5)," _
	& "     [MNGITEMCMB1_DSPORDER] [int]," _
	& "     [MNGITEMCMB2_CD] [nvarchar](2)," _
	& "     [MNGITEMCMB2_NM] [nvarchar](10)," _
	& "     [MNGITEMCMB2_RNM] [nvarchar](5)," _
	& "     [MNGITEMCMB2_DSPORDER] [int]," _
	& "     [MNGITEMTEXT1] [nvarchar](10)," _
	& "     [MNGITEMTEXT2] [nvarchar](10)," _
	& "     [MNGITEMCHK1] [int]," _
	& "     [MNGITEMCHK2] [int]," _
	& "     [MNGITEMCHK3] [int]," _
	& "     [MNGITEMCHK4] [int]," _
	& "     [MNGITEM_REMARKS] [nvarchar](100)," _
	& "     [SLIP_CD] [nvarchar](10)," _
	& "     [LENDAIM_CD] [nvarchar](2)," _
	& "     [LENDAIM_NM] [nvarchar](10)," _
	& "     [LENDAIM_RNM] [nvarchar](5)," _
	& "     [LENDAIM_DSPORDER] [int]," _
	& "     [LCT_CD] [nvarchar](3)," _
	& "     [LCT_NM] [nvarchar](10)," _
	& "     [LCT_RNM] [nvarchar](5)," _
	& "     [LCT_DSPORDER] [int]," _
	& "     [ISSUE_DT] [datetime]," _
	& "     [EXPECTBACK_DT] [datetime]," _
	& "     [URGEDBACK_DT] [datetime]," _
	& "     [BACK_DT] [datetime]," _
	& "     [BORROWER_DIV_CD] [nvarchar](3)," _
	& "     [BORROWER_DIV_NM] [nvarchar](20)," _
	& "     [BORROWER_DIV_RNM] [nvarchar](6)," _
	& "     [BORROWER_DIV_DSPORDER] [int]," _
	& "     [BORROWER_CD] [nvarchar](8)," _
	& "     [BORROWER_NM] [nvarchar](20)," _
	& "     [BORROWER_DSPORDER] [int]," _
	& "     [TAKER_DIV_CD] [nvarchar](3)," _
	& "     [TAKER_DIV_NM] [nvarchar](20)," _
	& "     [TAKER_DIV_RNM] [nvarchar](6)," _
	& "     [TAKER_DIV_DSPORDER] [int]," _
	& "     [TAKER_CD] [nvarchar](8)," _
	& "     [TAKER_NM] [nvarchar](20)," _
	& "     [TAKER_DSPORDER] [int]," _
	& "     [LENDCLERK_CD] [nvarchar](8)," _
	& "     [LENDCLERK_NM] [nvarchar](20)," _
	& "     [LENDCLERK_DSPORDER] [int]," _
	& "     [PERSONOFBACK_CD] [nvarchar](8)," _
	& "     [PERSONOFBACK_NM] [nvarchar](20)," _
	& "     [PERSONOFBACK_DSPORDER] [int]," _
	& "     [BACKCLERK_CD] [nvarchar](8)," _
	& "     [BACKCLERK_NM] [nvarchar](20)," _
	& "     [BACKCLERK_DSPORDER] [int]," _
	& "     [LEND_REMARKS] [nvarchar](100)," _
	& "     [LENDCMB1_CD] [nvarchar](2)," _
	& "     [LENDCMB1_NM] [nvarchar](10)," _
	& "     [LENDCMB1_RNM] [nvarchar](5)," _
	& "     [LENDCMB1_DSPORDER] [int]," _
	& "     [LENDCMB2_CD] [nvarchar](2)," _
	& "     [LENDCMB2_NM] [nvarchar](10)," _
	& "     [LENDCMB2_RNM] [nvarchar](5)," _
	& "     [LENDCMB2_DSPORDER] [int]," _
	& "     [LENDTEXT1] [nvarchar](10)," _
	& "     [LENDTEXT2] [nvarchar](10)," _
	& "     [LENDCHK1] [int]," _
	& "     [LENDCHK2] [int]," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTW_LENDLIST_WORK_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [HOST_NM] ASC," _
	& "     [PRT_ID] ASC," _
	& "     [SORTKEY1] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTW_貸出一覧ワークテーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql107 As String = _
	"ALTER TABLE [dbo].[LTW_LENDLIST_WORK] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTW_貸出一覧ワークテーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql108 As String = _
	"ALTER TABLE [dbo].[LTW_LENDLIST_WORK] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"


	'１９．LTW_返却一覧ワークテーブル（桁数変更）を修正
	'LTW_返却一覧ワークテーブルを削除
	Public Shared ReadOnly sql109 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTW_BACKLIST_WORK]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTW_BACKLIST_WORK]"

	'LTW_返却一覧ワークを新規作成
	Public Shared ReadOnly sql110 As String = _
	"CREATE TABLE [dbo].[LTW_BACKLIST_WORK](" _
	& "     [HOST_NM] [nvarchar](64) NOT NULL," _
	& "     [PRT_ID] [nvarchar](10) NOT NULL," _
	& "     [SORTKEY1] [int] NOT NULL," _
	& "     [SLIP_CD] [nvarchar](10)," _
	& "     [MNGITEM_CD] [nvarchar](3)," _
	& "     [MNGITEM_NM] [nvarchar](10)," _
	& "     [MNGITEM_RNM] [nvarchar](5)," _
	& "     [BYOREKI_NO] [nvarchar](10)," _
	& "     [PATIENT_NO] [nvarchar](10)," _
	& "     [PATIENT_NM] [nvarchar](20)," _
	& "     [PATIENT_KNM] [nvarchar](30)," _
	& "     [GENDER_NM] [nvarchar](2)," _
	& "     [DIV1_NM] [nvarchar](10)," _
	& "     [DIV1_RNM] [nvarchar](10)," _
	& "     [DIV2_NM] [nvarchar](10)," _
	& "     [DIV2_RNM] [nvarchar](10)," _
	& "     [DATE1] [datetime]," _
	& "     [DATE2] [datetime]," _
	& "     [DOC_STAFF_NM] [nvarchar](30)," _
	& "     [FIRSTRECEIVING_DT] [datetime]," _
	& "     [LASTRECEIVING_DT] [datetime]," _
	& "     [RECIPIENT_NM] [nvarchar](20)," _
	& "     [MNGSTATUS_NM] [nvarchar](20)," _
	& "     [MNGSTATUS_RNM] [nvarchar](5)," _
	& "     [KEEPLCT_NM] [nvarchar](20)," _
	& "     [KEEPLCT_RNM] [nvarchar](6)," _
	& "     [VOLUMEKEY_NM] [nvarchar](1)," _
	& "     [MNGITEMCMB1_NM] [nvarchar](10)," _
	& "     [MNGITEMCMB1_RNM] [nvarchar](5)," _
	& "     [MNGITEMCMB2_NM] [nvarchar](10)," _
	& "     [MNGITEMCMB2_RNM] [nvarchar](5)," _
	& "     [MNGITEMTEXT1] [nvarchar](10)," _
	& "     [MNGITEMTEXT2] [nvarchar](10)," _
	& "     [MNGITEMCHK1_NM] [nvarchar](1)," _
	& "     [MNGITEMCHK2_NM] [nvarchar](1)," _
	& "     [MNGITEMCHK3_NM] [nvarchar](1)," _
	& "     [MNGITEMCHK4_NM] [nvarchar](1)," _
	& "     [REMARKS] [nvarchar](100)," _
	& "     [LENDAIM_NM] [nvarchar](20)," _
	& "     [LENDAIM_RNM] [nvarchar](6)," _
	& "     [LCT_NM] [nvarchar](20)," _
	& "     [LCT_RNM] [nvarchar](6)," _
	& "     [ISSUE_DT] [datetime]," _
	& "     [EXPECTBACK_DT] [datetime]," _
	& "     [URGEDBACK_DT] [datetime]," _
	& "     [BACK_DT] [datetime]," _
	& "     [STD_BOR_STAFFDIV_NM] [nvarchar](20)," _
	& "     [STD_BOR_STAFFDIV_RNM] [nvarchar](6)," _
	& "     [BORROWER_NM] [nvarchar](30)," _
	& "     [STD_TAK_STAFFDIV_NM] [nvarchar](20)," _
	& "     [STD_TAK_STAFFDIV_RNM] [nvarchar](6)," _
	& "     [TAKER_NM] [nvarchar](30)," _
	& "     [ST_LDC_STAFF_NM] [nvarchar](30)," _
	& "     [PERSONOFBACK_NM] [nvarchar](30)," _
	& "     [BACKCLERK_NM] [nvarchar](30)," _
	& "     [LDCMB1_CMBCNT_NM] [nvarchar](10)," _
	& "     [LDCMB1_CMBCNT_RNM] [nvarchar](5)," _
	& "     [LDCMB2_CMBCNT_NM] [nvarchar](10)," _
	& "     [LDCMB2_CMBCNT_RNM] [nvarchar](5)," _
	& "     [LENDTEXT1] [nvarchar](10)," _
	& "     [LENDTEXT2] [nvarchar](10)," _
	& "     [LENDCHK1_NM] [nvarchar](1)," _
	& "     [LENDCHK2_NM] [nvarchar](1)," _
	& "     [LENDINFO_REMARKS] [nvarchar](100)," _
	& "     [USER_NM] [nvarchar](30)," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTW_BACKLIST_WORK_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [HOST_NM] ASC," _
	& "     [PRT_ID] ASC," _
	& "     [SORTKEY1] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTW_返却一覧ワークテーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql111 As String = _
	"ALTER TABLE [dbo].[LTW_BACKLIST_WORK] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTW_返却一覧ワークテーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql112 As String = _
	"ALTER TABLE [dbo].[LTW_BACKLIST_WORK] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"


	'２０．LTW_返却督促_帳票_ワークテーブル（桁数変更）を修正
	'LTW_返却督促_帳票_ワークテーブルを削除
	Public Shared ReadOnly sql113 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTW_URGEDBACK_LIST_WORK]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTW_URGEDBACK_LIST_WORK]"

	'LTW_返却督促_帳票_ワークを新規作成
	Public Shared ReadOnly sql114 As String = _
	"CREATE TABLE [dbo].[LTW_URGEDBACK_LIST_WORK](" _
	& "     [HOST_NM] [nvarchar](64) NOT NULL," _
	& "     [PRT_ID] [nvarchar](10) NOT NULL," _
	& "     [SORTKEY1] [int] NOT NULL," _
	& "     [GROOPKEY1] [nvarchar](20)," _
	& "     [GROOPKEY2] [nvarchar](20)," _
	& "     [GROOPKEY3] [nvarchar](20)," _
	& "     [URGED_NM] [nvarchar](40)," _
	& "     [MNGITEM_CD] [nvarchar](3)," _
	& "     [MNGITEM_NM] [nvarchar](10)," _
	& "     [MNGITEM_RNM] [nvarchar](5)," _
	& "     [MNGITEM_DSPORDER] [int]," _
	& "     [PATIENT_NO] [nvarchar](10)," _
	& "     [BYOREKI_NO] [nvarchar](10)," _
	& "     [PATIENT_NM] [nvarchar](20)," _
	& "     [PATIENT_KNM] [nvarchar](30)," _
	& "     [GENDER_CD] [nvarchar](1)," _
	& "     [GENDER_NM] [nvarchar](2)," _
	& "     [DIV1TITLE] [nvarchar](5)," _
	& "     [DIV1TITLE_RNM] [nvarchar](3)," _
	& "     [DIV1_CD] [nvarchar](10)," _
	& "     [DIV1_NM] [nvarchar](10)," _
	& "     [DIV1_RNM] [nvarchar](10)," _
	& "     [DIV1_DSPORDER] [int]," _
	& "     [DIV2TITLE] [nvarchar](5)," _
	& "     [DIV2TITLE_RNM] [nvarchar](3)," _
	& "     [DIV2_CD] [nvarchar](10)," _
	& "     [DIV2_NM] [nvarchar](10)," _
	& "     [DIV2_RNM] [nvarchar](10)," _
	& "     [DIV2_DSPORDER] [int]," _
	& "     [DATE1TITLE] [nvarchar](5)," _
	& "     [DATE1TITLE_RNM] [nvarchar](3)," _
	& "     [DATE1] [datetime]," _
	& "     [DATE2TITLE] [nvarchar](5)," _
	& "     [DATE2TITLE_RNM] [nvarchar](3)," _
	& "     [DATE2] [datetime]," _
	& "     [DOCTOR_CD] [nvarchar](8)," _
	& "     [DOCTOR_NM] [nvarchar](20)," _
	& "     [DOCTOR_DSPORDER] [int]," _
	& "     [FIRSTRECEIVING_DT] [datetime]," _
	& "     [LASTRECEIVING_DT] [datetime]," _
	& "     [RECIPIENT_CD] [nvarchar](8)," _
	& "     [RECIPIENT_NM] [nvarchar](20)," _
	& "     [RECIPIENT_DSPORDER] [int]," _
	& "     [MNGSTATUS_CD] [nvarchar](2)," _
	& "     [MNGSTATUS_NM] [nvarchar](10)," _
	& "     [MNGSTATUS_RNM] [nvarchar](5)," _
	& "     [MNGSTATUS_DSPORDER] [int]," _
	& "     [KEEPLCT_CD] [nvarchar](3)," _
	& "     [KEEPLCT_NM] [nvarchar](10)," _
	& "     [KEEPLCT_RNM] [nvarchar](5)," _
	& "     [KEEPLCT_DSPORDER] [int]," _
	& "     [VOLUMEKEY] [nvarchar](20)," _
	& "     [VOLUMEKEY_NM] [nvarchar](1)," _
	& "     [MNGITEMCMB1TITLE] [nvarchar](5)," _
	& "     [MNGITEMCMB1TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCMB1_CD] [nvarchar](2)," _
	& "     [MNGITEMCMB1_NM] [nvarchar](10)," _
	& "     [MNGITEMCMB1_RNM] [nvarchar](5)," _
	& "     [MNGITEMCMB1_DSPORDER] [int]," _
	& "     [MNGITEMCMB2TITLE] [nvarchar](5)," _
	& "     [MNGITEMCMB2TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCMB2_CD] [nvarchar](2)," _
	& "     [MNGITEMCMB2_NM] [nvarchar](10)," _
	& "     [MNGITEMCMB2_RNM] [nvarchar](5)," _
	& "     [MNGITEMCMB2_DSPORDER] [int]," _
	& "     [MNGITEMTEXT1] [nvarchar](10)," _
	& "     [MNGITEMTEXT1TITLE] [nvarchar](5)," _
	& "     [MNGITEMTEXT1TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMTEXT2] [nvarchar](10)," _
	& "     [MNGITEMTEXT2TITLE] [nvarchar](5)," _
	& "     [MNGITEMTEXT2TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCHK1TITLE] [nvarchar](5)," _
	& "     [MNGITEMCHK1TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCHK1TITLE1] [nvarchar](1)," _
	& "     [MNGITEMCHK1] [int]," _
	& "     [MNGITEMCHK2TITLE] [nvarchar](5)," _
	& "     [MNGITEMCHK2TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCHK2TITLE1] [nvarchar](1)," _
	& "     [MNGITEMCHK2] [int]," _
	& "     [MNGITEMCHK3TITLE] [nvarchar](5)," _
	& "     [MNGITEMCHK3TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCHK3TITLE1] [nvarchar](1)," _
	& "     [MNGITEMCHK3] [int]," _
	& "     [MNGITEMCHK4TITLE] [nvarchar](5)," _
	& "     [MNGITEMCHK4TITLE_RNM] [nvarchar](3)," _
	& "     [MNGITEMCHK4TITLE1] [nvarchar](1)," _
	& "     [MNGITEMCHK4] [int]," _
	& "     [REMARKS] [nvarchar](100)," _
	& "     [SLIP_CD] [nvarchar](10)," _
	& "     [LENDAIM_CD] [nvarchar](2)," _
	& "     [LENDAIM_NM] [nvarchar](10)," _
	& "     [LENDAIM_RNM] [nvarchar](5)," _
	& "     [LENDAIM_DSPORDER] [int]," _
	& "     [LCT_CD] [nvarchar](3)," _
	& "     [LCT_NM] [nvarchar](10)," _
	& "     [LCT_RNM] [nvarchar](5)," _
	& "     [LCT_DSPORDER] [int]," _
	& "     [ISSUE_DT] [datetime]," _
	& "     [EXPECTBACK_DT] [datetime]," _
	& "     [URGEDBACK_DT] [datetime]," _
	& "     [BACK_DT] [datetime]," _
	& "     [BORROWER_CD] [nvarchar](8)," _
	& "     [BORROWER_NM] [nvarchar](20)," _
	& "     [BORROWER_DSPORDER] [int]," _
	& "     [BORROWER_DIV_CD] [nvarchar](3)," _
	& "     [BORROWER_DIV_NM] [nvarchar](20)," _
	& "     [BORROWER_DIV_RNM] [nvarchar](6)," _
	& "     [BORROWER_DIV_DSPORDER] [int]," _
	& "     [TAKER_CD] [nvarchar](8)," _
	& "     [TAKER_NM] [nvarchar](20)," _
	& "     [TAKER_DSPORDER] [int]," _
	& "     [TAKER_DIV_CD] [nvarchar](3)," _
	& "     [TAKER_DIV_NM] [nvarchar](20)," _
	& "     [TAKER_DIV_RNM] [nvarchar](6)," _
	& "     [TAKER_DIV_DSPORDER] [int]," _
	& "     [LENDCLERK_CD] [nvarchar](8)," _
	& "     [LENDCLERK_NM] [nvarchar](20)," _
	& "     [LENDCLERK_DSPORDER] [int]," _
	& "     [PERSONOFBACK_CD] [nvarchar](8)," _
	& "     [PERSONOFBACK_NM] [nvarchar](20)," _
	& "     [PERSONOFBACK_DSPORDER] [int]," _
	& "     [BACKCLERK_CD] [nvarchar](8)," _
	& "     [BACKCLERK_NM] [nvarchar](20)," _
	& "     [BACKCLERK_DSPORDER] [int]," _
	& "     [LEND_REMARKS] [nvarchar](100)," _
	& "     [LENDCMB1TITLE_NM] [nvarchar](5)," _
	& "     [LENDCMB1TITLE_RNM] [nvarchar](3)," _
	& "     [LENDCMB1_CD] [nvarchar](2)," _
	& "     [LENDCMB1_NM] [nvarchar](10)," _
	& "     [LENDCMB1_RNM] [nvarchar](5)," _
	& "     [LENDCMB1_DSPORDER] [int]," _
	& "     [LENDCMB2TITLE_NM] [nvarchar](5)," _
	& "     [LENDCMB2TITLE_RNM] [nvarchar](3)," _
	& "     [LENDCMB2_CD] [nvarchar](2)," _
	& "     [LENDCMB2_NM] [nvarchar](10)," _
	& "     [LENDCMB2_RNM] [nvarchar](5)," _
	& "     [LENDCMB2_DSPORDER] [int]," _
	& "     [LENDTEXT1TITLE_NM] [nvarchar](5)," _
	& "     [LENDTEXT1TITLE_RNM] [nvarchar](3)," _
	& "     [LENDTEXT1] [nvarchar](10)," _
	& "     [LENDTEXT2TITLE_NM] [nvarchar](5)," _
	& "     [LENDTEXT2TITLE_RNM] [nvarchar](3)," _
	& "     [LENDTEXT2] [nvarchar](10)," _
	& "     [LENDCHK1TITLE_NM] [nvarchar](5)," _
	& "     [LENDCHK1TITLE_RNM] [nvarchar](3)," _
	& "     [LENDCHK1] [int]," _
	& "     [LENDCHK2TITLE_NM] [nvarchar](5)," _
	& "     [LENDCHK2TITLE_RNM] [nvarchar](3)," _
	& "     [LENDCHK2] [int]," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTW_URGEDBACK_LIST_WORK_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [HOST_NM] ASC," _
	& "     [PRT_ID] ASC," _
	& "     [SORTKEY1] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTW_返却督促_帳票_ワークテーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql115 As String = _
	"ALTER TABLE [dbo].[LTW_URGEDBACK_LIST_WORK] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTW_返却督促_帳票_ワークテーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql116 As String = _
	"ALTER TABLE [dbo].[LTW_URGEDBACK_LIST_WORK] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"


	'２１．LTW_明細登録一覧ワークテーブル（桁数変更）を修正
	'LTW_明細登録一覧ワークテーブルを削除
	Public Shared ReadOnly sql117 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTW_ADDLIST_WORK]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTW_ADDLIST_WORK]"

	'LTW_明細登録一覧ワークを新規作成
	Public Shared ReadOnly sql118 As String = _
	"CREATE TABLE [dbo].[LTW_ADDLIST_WORK](" _
	& "     [HOST_NM] [nvarchar](64) NOT NULL," _
	& "     [PRT_ID] [nvarchar](10) NOT NULL," _
	& "     [SORTKEY1] [int] NOT NULL," _
	& "     [MNGITEM_CD] [nvarchar](3)," _
	& "     [MNGITEM_NM] [nvarchar](10)," _
	& "     [MNGITEM_RNM] [nvarchar](5)," _
	& "     [BYOREKI_NO] [nvarchar](10)," _
	& "     [PATIENT_NO] [nvarchar](10)," _
	& "     [PATIENT_NM] [nvarchar](20)," _
	& "     [PATIENT_KNM] [nvarchar](30)," _
	& "     [GENDER_NM] [nvarchar](2)," _
	& "     [DIV1_NM] [nvarchar](10)," _
	& "     [DIV1_RNM] [nvarchar](10)," _
	& "     [DIV2_NM] [nvarchar](10)," _
	& "     [DIV2_RNM] [nvarchar](10)," _
	& "     [DATE1] [datetime]," _
	& "     [DATE2] [datetime]," _
	& "     [DOC_STAFF_NM] [nvarchar](30)," _
	& "     [FIRSTRECEIVING_DT] [datetime]," _
	& "     [LASTRECEIVING_DT] [datetime]," _
	& "     [RECIPIENT_NM] [nvarchar](20)," _
	& "     [MNGSTATUS_NM] [nvarchar](20)," _
	& "     [MNGSTATUS_RNM] [nvarchar](5)," _
	& "     [KEEPLCT_NM] [nvarchar](20)," _
	& "     [KEEPLCT_RNM] [nvarchar](6)," _
	& "     [VOLUMEKEY_NM] [nvarchar](1)," _
	& "     [MNGITEMCMB1_NM] [nvarchar](10)," _
	& "     [MNGITEMCMB1_RNM] [nvarchar](5)," _
	& "     [MNGITEMCMB2_NM] [nvarchar](10)," _
	& "     [MNGITEMCMB2_RNM] [nvarchar](5)," _
	& "     [MNGITEMTEXT1] [nvarchar](10)," _
	& "     [MNGITEMTEXT2] [nvarchar](10)," _
	& "     [MNGITEMCHK1_NM] [nvarchar](1)," _
	& "     [MNGITEMCHK2_NM] [nvarchar](1)," _
	& "     [MNGITEMCHK3_NM] [nvarchar](1)," _
	& "     [MNGITEMCHK4_NM] [nvarchar](1)," _
	& "     [REMARKS] [nvarchar](100)," _
	& "     [USER_NM] [nvarchar](30)," _
	& "     [UPDMODE] [nvarchar](2)," _
	& "     [DIV1TITLE] [nvarchar](5)," _
	& "     [DIV2TITLE] [nvarchar](5)," _
	& "     [BYOREKITITLE] [nvarchar](4)," _
	& "     [DATE1TITLE] [nvarchar](5)," _
	& "     [DATE2TITLE] [nvarchar](5)," _
	& "     [DOCTORTITLE] [nvarchar](2)," _
	& "     [MNGITEMCMB1TITLE] [nvarchar](5)," _
	& "     [MNGITEMCMB2TITLE] [nvarchar](5)," _
	& "     [MNGITEMTEXT1TITLE] [nvarchar](5)," _
	& "     [MNGITEMTEXT2TITLE] [nvarchar](5)," _
	& "     [MNGITEMCHK1TITLE] [nvarchar](5)," _
	& "     [MNGITEMCHK2TITLE] [nvarchar](5)," _
	& "     [MNGITEMCHK3TITLE] [nvarchar](5)," _
	& "     [MNGITEMCHK4TITLE] [nvarchar](5)," _
	& "     [MNGITEMTEXT3TITLE] [nvarchar](5)," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTW_ADDLIST_WORK_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [HOST_NM] ASC," _
	& "     [PRT_ID] ASC," _
	& "     [SORTKEY1] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTW_明細登録一覧ワークテーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql119 As String = _
	"ALTER TABLE [dbo].[LTW_ADDLIST_WORK] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTW_明細登録一覧ワークテーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql120 As String = _
	"ALTER TABLE [dbo].[LTW_ADDLIST_WORK] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"


	'２２．LTW_受領一覧テーブル（桁数変更）を修正
	'LTW_受領一覧テーブルを削除
	Public Shared ReadOnly sql121 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTW_RCVLIST_WORK]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTW_RCVLIST_WORK]"

	'LTW_受領一覧を新規作成
	Public Shared ReadOnly sql122 As String = _
	"CREATE TABLE [dbo].[LTW_RCVLIST_WORK](" _
	& "     [HOST_NM] [nvarchar](64) NOT NULL," _
	& "     [PRT_ID] [nvarchar](10) NOT NULL," _
	& "     [SORTKEY1] [int] NOT NULL," _
	& "     [MNGITEM_CD] [nvarchar](3)," _
	& "     [MNGITEM_NM] [nvarchar](10)," _
	& "     [MNGITEM_RNM] [nvarchar](5)," _
	& "     [BYOREKI_NO] [nvarchar](10)," _
	& "     [PATIENT_NO] [nvarchar](10)," _
	& "     [PATIENT_NM] [nvarchar](20)," _
	& "     [PATIENT_KNM] [nvarchar](30)," _
	& "     [GENDER_NM] [nvarchar](2)," _
	& "     [DIV1_NM] [nvarchar](10)," _
	& "     [DIV1_RNM] [nvarchar](10)," _
	& "     [DIV2_NM] [nvarchar](10)," _
	& "     [DIV2_RNM] [nvarchar](10)," _
	& "     [DATE1] [datetime]," _
	& "     [DATE2] [datetime]," _
	& "     [DOC_STAFF_NM] [nvarchar](30)," _
	& "     [FIRSTRECEIVING_DT] [datetime]," _
	& "     [LASTRECEIVING_DT] [datetime]," _
	& "     [RECIPIENT_NM] [nvarchar](20)," _
	& "     [MNGSTATUS_NM] [nvarchar](20)," _
	& "     [MNGSTATUS_RNM] [nvarchar](5)," _
	& "     [KEEPLCT_NM] [nvarchar](20)," _
	& "     [KEEPLCT_RNM] [nvarchar](6)," _
	& "     [VOLUMEKEY_NM] [nvarchar](1)," _
	& "     [MNGITEMCMB1_NM] [nvarchar](10)," _
	& "     [MNGITEMCMB1_RNM] [nvarchar](5)," _
	& "     [MNGITEMCMB2_NM] [nvarchar](10)," _
	& "     [MNGITEMCMB2_RNM] [nvarchar](5)," _
	& "     [MNGITEMTEXT1] [nvarchar](10)," _
	& "     [MNGITEMTEXT2] [nvarchar](10)," _
	& "     [MNGITEMCHK1_NM] [nvarchar](1)," _
	& "     [MNGITEMCHK2_NM] [nvarchar](1)," _
	& "     [MNGITEMCHK3_NM] [nvarchar](1)," _
	& "     [MNGITEMCHK4_NM] [nvarchar](1)," _
	& "     [REMARKS] [nvarchar](100)," _
	& "     [USER_NM] [nvarchar](30)," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTW_RCVLIST_WORK_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [HOST_NM] ASC," _
	& "     [PRT_ID] ASC," _
	& "     [SORTKEY1] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTW_受領一覧テーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql123 As String = _
	"ALTER TABLE [dbo].[LTW_RCVLIST_WORK] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTW_受領一覧テーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql124 As String = _
	"ALTER TABLE [dbo].[LTW_RCVLIST_WORK] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"


	'２３．LTM_目的別保管場所テーブル（桁数変更）を修正
	'LTM_目的別保管場所テーブルを削除
	Public Shared ReadOnly sql125 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_LENDAIM_KEEPLCT]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_LENDAIM_KEEPLCT]"

	'LTM_目的別保管場所を新規作成
	Public Shared ReadOnly sql126 As String = _
	"CREATE TABLE [dbo].[LTM_LENDAIM_KEEPLCT](" _
	& "     [MNGITEM_CD] [nvarchar](3) NOT NULL," _
	& "     [LENDAIM_CD] [nvarchar](2) NOT NULL," _
	& "     [KEEPLCT_CD] [nvarchar](3) NOT NULL," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTM_LENDAIM_KEEPLCT_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [MNGITEM_CD] ASC," _
	& "     [LENDAIM_CD] ASC," _
	& "     [KEEPLCT_CD] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTM_目的別保管場所テーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql127 As String = _
	"ALTER TABLE [dbo].[LTM_LENDAIM_KEEPLCT] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTM_目的別保管場所テーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql128 As String = _
	"ALTER TABLE [dbo].[LTM_LENDAIM_KEEPLCT] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"


	'２４．LTM_目的別所在場所テーブル（桁数変更）を修正
	'LTM_目的別所在場所テーブルを削除
	Public Shared ReadOnly sql129 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_LENDAIM_LCT]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_LENDAIM_LCT]"

	'LTM_目的別所在場所を新規作成
	Public Shared ReadOnly sql130 As String = _
	"CREATE TABLE [dbo].[LTM_LENDAIM_LCT](" _
	& "     [LENDAIM_CD] [nvarchar](2) NOT NULL," _
	& "     [LCT_CD] [nvarchar](3) NOT NULL," _
	& "     [DSPORDER] [int]," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTM_LENDAIM_LCT_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [LENDAIM_CD] ASC," _
	& "     [LCT_CD] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTM_目的別所在場所テーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql131 As String = _
	"ALTER TABLE [dbo].[LTM_LENDAIM_LCT] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTM_目的別所在場所テーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql132 As String = _
	"ALTER TABLE [dbo].[LTM_LENDAIM_LCT] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"


	'２５．LTM_管理物グループテーブル（桁数変更）を修正
	'LTM_管理物グループテーブルを削除
	Public Shared ReadOnly sql133 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_MNGITEM_GRP]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_MNGITEM_GRP]"

	'LTM_管理物グループを新規作成
	Public Shared ReadOnly sql134 As String = _
	"CREATE TABLE [dbo].[LTM_MNGITEM_GRP](" _
	& "     [MNGITEM_GRP_CD] [nvarchar](3) NOT NULL," _
	& "     [MNGITEM_GRP_NM] [nvarchar](10) NOT NULL," _
	& "     [MNGITEM_GRP_RNM] [nvarchar](5) NOT NULL," _
	& "     [DSPORDER] [int]," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTM_MNGITEM_GRP_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [MNGITEM_GRP_CD] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTM_管理物グループテーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql135 As String = _
	"ALTER TABLE [dbo].[LTM_MNGITEM_GRP] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTM_管理物グループテーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql136 As String = _
	"ALTER TABLE [dbo].[LTM_MNGITEM_GRP] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"


	'２６．LTM_区分１グループテーブル（桁数変更）を修正
	'LTM_区分１グループテーブルを削除
	Public Shared ReadOnly sql137 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_DIV1_GRP]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_DIV1_GRP]"

	'LTM_区分１グループを新規作成
	Public Shared ReadOnly sql138 As String = _
	"CREATE TABLE [dbo].[LTM_DIV1_GRP](" _
	& "     [MNGITEM_CD] [nvarchar](3) NOT NULL," _
	& "     [DIV1_GRP_CD] [nvarchar](3) NOT NULL," _
	& "     [DIV1_GRP_NM] [nvarchar](10) NOT NULL," _
	& "     [DIV1_GRP_RNM] [nvarchar](5) NOT NULL," _
	& "     [DSPORDER] [int]," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTM_DIV1_GRP_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [MNGITEM_CD] ASC," _
	& "     [DIV1_GRP_CD] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTM_区分１グループテーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql139 As String = _
	"ALTER TABLE [dbo].[LTM_DIV1_GRP] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTM_区分１グループテーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql140 As String = _
	"ALTER TABLE [dbo].[LTM_DIV1_GRP] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"


	'２７．LTM_区分２グループテーブル（桁数変更）を修正
	'LTM_区分２グループテーブルを削除
	Public Shared ReadOnly sql141 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[LTM_DIV2_GRP]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[LTM_DIV2_GRP]"

	'LTM_区分２グループを新規作成
	Public Shared ReadOnly sql142 As String = _
	"CREATE TABLE [dbo].[LTM_DIV2_GRP](" _
	& "     [MNGITEM_CD] [nvarchar](3) NOT NULL," _
	& "     [DIV2_GRP_CD] [nvarchar](3) NOT NULL," _
	& "     [DIV2_GRP_NM] [nvarchar](10) NOT NULL," _
	& "     [DIV2_GRP_RNM] [nvarchar](5) NOT NULL," _
	& "     [DSPORDER] [int]," _
	& "     [LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& "     [LASTUPD_DT] [datetime] NOT NULL," _
	& " CONSTRAINT [PK_LTM_DIV2_GRP_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& "     [MNGITEM_CD] ASC," _
	& "     [DIV2_GRP_CD] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'LTM_区分２グループテーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql143 As String = _
	"ALTER TABLE [dbo].[LTM_DIV2_GRP] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'LTM_区分２グループテーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql144 As String = _
	"ALTER TABLE [dbo].[LTM_DIV2_GRP] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"


	' ２８．XTM_印刷設定ACCESS（XTM_PRINTSETTING_ACCESS）にデータを追加
	'目的別保管場所（レポート）用データを追加
	Public Shared ReadOnly sql145 As String = _
	"IF NOT EXISTS (SELECT * FROM [dbo].[XTM_PRINTSETTING_ACCESS] WHERE [SCREEN_CD] = 'LMS120F010' AND [LEDGERSHEET_CD] = 'LMS120R010')" & _
	" INSERT INTO [dbo].[XTM_PRINTSETTING_ACCESS] ([SCREEN_CD],[LEDGERSHEET_CD],[FILE_NM],[REPORT_NM],[NUMBERPRINTED],[LASTUPDUSER_CD]) VALUES ('LMS120F010','LMS120R010','BT4mdb.mde','LMS120R010',1,'" & clsConst.CST_ADMIN_USER & "')"

	'目的別所在場所（レポート）用データを追加
	Public Shared ReadOnly sql146 As String = _
	"IF NOT EXISTS (SELECT * FROM [dbo].[XTM_PRINTSETTING_ACCESS] WHERE [SCREEN_CD] = 'LMS130F010' AND [LEDGERSHEET_CD] = 'LMS130R010')" & _
	" INSERT INTO [dbo].[XTM_PRINTSETTING_ACCESS] ([SCREEN_CD],[LEDGERSHEET_CD],[FILE_NM],[REPORT_NM],[NUMBERPRINTED],[LASTUPDUSER_CD]) VALUES ('LMS130F010','LMS130R010','BT4mdb.mde','LMS130R010',1,'" & clsConst.CST_ADMIN_USER & "')"

	'管理物グループマスタ（レポート）用データを追加
	Public Shared ReadOnly sql147 As String = _
	"IF NOT EXISTS (SELECT * FROM [dbo].[XTM_PRINTSETTING_ACCESS] WHERE [SCREEN_CD] = 'LMS020F020' AND [LEDGERSHEET_CD] = 'LMS020R020')" & _
	" INSERT INTO [dbo].[XTM_PRINTSETTING_ACCESS] ([SCREEN_CD],[LEDGERSHEET_CD],[FILE_NM],[REPORT_NM],[NUMBERPRINTED],[LASTUPDUSER_CD]) VALUES ('LMS020F020','LMS020R020','BT4mdb.mde','LMS020R020',1,'" & clsConst.CST_ADMIN_USER & "')"

	'区分１グループ（レポート）用データを追加
	Public Shared ReadOnly sql148 As String = _
	"IF NOT EXISTS (SELECT * FROM [dbo].[XTM_PRINTSETTING_ACCESS] WHERE [SCREEN_CD] = 'LMS080F020' AND [LEDGERSHEET_CD] = 'LMS080R020')" & _
	" INSERT INTO [dbo].[XTM_PRINTSETTING_ACCESS] ([SCREEN_CD],[LEDGERSHEET_CD],[FILE_NM],[REPORT_NM],[NUMBERPRINTED],[LASTUPDUSER_CD]) VALUES ('LMS080F020','LMS080R020','BT4mdb.mde','LMS080R020',1,'" & clsConst.CST_ADMIN_USER & "')"

	'区分２グループ（レポート）用データを追加
	Public Shared ReadOnly sql149 As String = _
	"IF NOT EXISTS (SELECT * FROM [dbo].[XTM_PRINTSETTING_ACCESS] WHERE [SCREEN_CD] = 'LMS080F030' AND [LEDGERSHEET_CD] = 'LMS080R030')" & _
	" INSERT INTO [dbo].[XTM_PRINTSETTING_ACCESS] ([SCREEN_CD],[LEDGERSHEET_CD],[FILE_NM],[REPORT_NM],[NUMBERPRINTED],[LASTUPDUSER_CD]) VALUES ('LMS080F030','LMS080R030','BT4mdb.mde','LMS080R030',1,'" & clsConst.CST_ADMIN_USER & "')"

	'２９．使用者明細テーブルの追加
	'XTM_使用者明細テーブルを削除
	Public Shared ReadOnly sql150 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[XTM_USER_DETAIL]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[XTM_USER_DETAIL]"

	'XTM_使用者明細テーブルを新規作成
	Public Shared ReadOnly sql151 As String = _
	"CREATE TABLE [dbo].[XTM_USER_DETAIL](" _
	& "		[USER_CD] [nchar](8) NOT NULL," _
	& "		[FNC_NO] [int] NOT NULL," _
	& "		[ENABLED_FLG] [nchar](20) NOT NULL," _
	& "		[LASTUPDUSER_CD] [nchar](8) NULL," _
	& "		[LASTUPD_DT] [datetime] NULL," _
	& "	CONSTRAINT [PK_XTM_USER_DETAIL1] PRIMARY KEY CLUSTERED " _
	& "	(" _
	& "		[USER_CD] ASC," _
	& "		[FNC_NO] ASC" _
	& "	)WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& "	) ON [PRIMARY]"

	'XTM_使用者明細テーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql152 As String = _
	"ALTER TABLE [dbo].[XTM_USER_DETAIL] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	''XTM_使用者明細テーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql153 As String = _
	"ALTER TABLE [dbo].[XTM_USER_DETAIL] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"

	'３０．XTM_機能テーブル（項目追加）を修正
	'テーブルの内容を退避
	Public Shared ReadOnly sql154 As String = _
	"SELECT * INTO [dbo].[XTM_FUNCTION_TEMP] FROM [dbo].[XTM_FUNCTION]"

	'XTM_機能テーブルを削除
	Public Shared ReadOnly sql155 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[XTM_FUNCTION]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[XTM_FUNCTION]"

	'XTM_機能テーブルを新規作成
	Public Shared ReadOnly sql156 As String = _
	"CREATE TABLE [dbo].[XTM_FUNCTION](" _
	& "     [FNC_NO] [int] NOT NULL," _
	& " 	[FNC_CD] [nvarchar](10) NOT NULL," _
	& " 	[FNC_NM] [nvarchar](50) NOT NULL," _
	& " 	[PRD_NO] [int] NOT NULL," _
	& " 	[PRD_NO_TRUE] [int] ," _
	& " 	[ICON_ID] [int] NULL," _
	& " 	[DLL_CD] [nvarchar](8) NOT NULL," _
	& " 	[DSPORDER] [int] NOT NULL," _
	& " 	[LASTUPDUSER_CD] [nvarchar](8) NOT NULL," _
	& " 	[LASTUPD_DT] [datetime] NOT NULL," _
	& "  CONSTRAINT [PK_XTM_FUNCTION_IDX] PRIMARY KEY CLUSTERED " _
	& " (" _
	& " 	[FNC_NO] ASC" _
	& " )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]" _
	& " ) ON [PRIMARY]"

	'XTM_使用者明細テーブルに初期値を定義（最終更新者コードのデフォルトをZZZZにする）
	Public Shared ReadOnly sql157 As String = _
	"ALTER TABLE [dbo].[XTM_FUNCTION] ADD DEFAULT ('" & clsConst.CST_ADMIN_USER & "') FOR [LASTUPDUSER_CD]"

	'XTM_使用者明細テーブルに初期値を定義（最終更新日のデフォルトをサーバのシステム日付にする）
	Public Shared ReadOnly sql158 As String = _
	"ALTER TABLE [dbo].[XTM_FUNCTION] ADD  DEFAULT (getdate()) FOR [LASTUPD_DT]"

	'新しい XTM_使用者明細テーブルに退避したデータを代入
	Public Shared ReadOnly sql159 As String = _
	"INSERT INTO [dbo].[XTM_FUNCTION] (" _
	& "[FNC_NO],[FNC_CD],[FNC_NM],[PRD_NO],[PRD_NO_TRUE],[ICON_ID],[DLL_CD],[DSPORDER],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& ") " _
	& "SELECT " _
	& "[FNC_NO],[FNC_CD],[FNC_NM],[PRD_NO],[PRD_NO],[ICON_ID],[DLL_CD],[DSPORDER],[LASTUPDUSER_CD],[LASTUPD_DT]" _
	& " FROM [dbo].[XTM_FUNCTION_TEMP]" _
	& " ORDER BY [FNC_NO],[FNC_CD]"

	'退避したデータを削除
	Public Shared ReadOnly sql160 As String = _
	"IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[XTM_FUNCTION_TEMP]') AND type in (N'U'))" _
	& " DROP TABLE [dbo].[XTM_FUNCTION_TEMP]"

End Class
