﻿Imports XCM
''' ---------------------------------------------
''' <summary>
''' 診療情報管理 連携 貸出物一覧（レポート）
''' </summary>
''' <remarks>
''' Copyright 2010 FUJITSU SHIKOKU SYSTEMS LIMITED All rights reserved.<BR/>
''' FUJITSU SHIKOKU SYSTEMS LIMITED CONFIDENTIAL<BR/>
''' </remarks>
''' ---------------------------------------------
Public Class XSI010R110
    Inherits XSI010R000

#Region "コンスタント"

    Private Const CST_LOG_CLASS As String = "貸出物一覧"

#End Region

#Region "コンストラクタ"

    ''' ---------------------------------------------
    ''' <summary>
    ''' コンストラクタ
    ''' </summary>
    ''' <param name="pForm">呼出画面</param>
    ''' <remarks>
    ''' 2010/12/06 新規作成 ACS)牟禮<BR/>
    ''' </remarks>
    ''' ---------------------------------------------
    Public Sub New(ByVal pForm As XCM.frmBase)
        'IN項目引き継ぎ
        MyBase.New(pForm)
    End Sub

#End Region

#Region "オーバーライドメソッド"

    ''' ---------------------------------------------
    ''' <summary>
    ''' ワークデータ確認
    ''' </summary>
    ''' <param name="pDb">DBクラス</param>
    ''' <returns>True:データ有/False:データ無</returns>
    ''' <remarks>
    ''' 2010/12/10 新規作成 ACS)牟禮<BR/>
    ''' </remarks>
    ''' ---------------------------------------------
    Protected Overrides Function getWorkData(ByVal pDb As clsDB) As Boolean
        clsSysMst.logEx(clsSysMst.logLevel.DBG, Me.GetType.Assembly.GetName.Name, Me.GetType.Name, "getWorkData", CST_LOG_PRODUCT, CST_LOG_CLASS, "ワークデータ確認 START")
        Dim result As Boolean
        Try
            result = False
            pDb.setSQLDa(sqlXSI010R110.sqlSel_MTT_IMP_LOG_LENDITM)
			pDb.setParamDa(sqlXSI010R110.prmERR_FLG, clsDB.Enum_dbType.dbInt)
			'正常
            If result = False AndAlso Me.pOkPrint = True Then
                pDb.setValDa(sqlXSI010R110.prmERR_FLG, 0, False)
                Using dt As New DataTable()
                    pDb.execQueryDa(dt)
                    If dt.Rows.Count > 0 Then result = True
                End Using
            End If
            'エラー
            If result = False AndAlso Me.pErrprint = True Then
                pDb.setValDa(sqlXSI010R110.prmERR_FLG, 1, False)
                Using dt As New DataTable()
                    pDb.execQueryDa(dt)
                    If dt.Rows.Count > 0 Then result = True
                End Using
            End If

            Return result
        Catch ex As Exception
            Throw
        End Try
    End Function

#End Region

End Class
