Imports XCM
Imports System.Reflection

''' ---------------------------------------------
''' <summary>
''' aANZXNX
''' </summary>
''' <remarks>
''' Copyright 2010 FUJITSU SHIKOKU SYSTEMS LIMITED All rights reserved.<BR/>
''' FUJITSU SHIKOKU SYSTEMS LIMITED CONFIDENTIAL<BR/>
''' </remarks>
''' ---------------------------------------------
Public NotInheritable Class clsMTI_DISEASE
	Implements IDisposable

#Region "ϐ"

	' aꗗёւݒ
	Private strOrderBy As String = sqlMTI_DISEASE.sqlOrder_By_Default

#End Region

#Region ""

	'gp
	Protected disposed As Boolean = False

	''' ---------------------------------------------	
	''' <summary>
	''' DisposeijO͂΂Ȃ
	''' </summary>
	''' <param name="disposing"></param>
	''' <remarks>
	''' 2010/11/26 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Protected Overloads Sub Dispose(ByVal disposing As Boolean)
		If Not Me.disposed Then
		End If
		Me.disposed = True
	End Sub

	''' ---------------------------------------------	
	''' <summary>
	''' Finalizeij
	''' </summary>
	''' <remarks>
	''' 2010/11/26 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Overloads Sub Dispose() Implements IDisposable.Dispose
		Dispose(True)
		GC.SuppressFinalize(Me)
	End Sub

	''' ---------------------------------------------	
	''' <summary>
	''' FinalizeijO͂΂Ȃ
	''' </summary>
	''' <remarks>
	''' 2010/11/26 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Protected Overrides Sub Finalize()
		Dispose(False)
		MyBase.Finalize()
	End Sub
#End Region

	''' ---------------------------------------------
	''' <summary>
	''' RXgN^
	''' </summary>
	''' <remarks>
	''' 2010/11/26 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Sub New()
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' RXgN^
	''' </summary>
	''' <param name="pSort">aꗗёւݒ</param>
	''' <remarks>
	''' 2011/03/25 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Sub New(ByVal pSort As clsConst.Enum_SortDisease)
		Me.New()
		Select Case pSort
			Case clsConst.Enum_SortDisease.Sort
				strOrderBy = sqlMTI_DISEASE.sqlOrder_By_Sort
			Case clsConst.Enum_SortDisease.NoSort
				strOrderBy = sqlMTI_DISEASE.sqlOrder_By_NoSort
			Case Else
		End Select
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' p[^̐̃`FbN
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <returns>True:</returns>
	''' <remarks>
	''' 2010/11/26 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function chkParam(ByVal pPatientNo As String) As Boolean
		Try
			Return Not String.IsNullOrWhiteSpace(pPatientNo)
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' p[^̐̃`FbN
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <returns>True:</returns>
	''' <remarks>
	''' 2010/11/26 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function chkParam(ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer) As Boolean
		Try
			Return chkParam(pPatientNo) AndAlso (pHspHistoryNo > 0)
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' p[^̐̃`FbN
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <returns>True:</returns>
	''' <remarks>
	''' 2010/11/26 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function chkParam(ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer) As Boolean
		Try
			Return chkParam(pPatientNo, pHspHistoryNo) AndAlso (pChNo > 0)
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' p[^̐̃`FbN
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <param name="pDiseaseSerialNo">aA</param>
	''' <returns>True:</returns>
	''' <remarks>
	''' 2010/11/26 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function chkParam(ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer, ByVal pDiseaseSerialNo As Integer) As Boolean
		Try
			Return chkParam(pPatientNo, pHspHistoryNo, pChNo) AndAlso (pDiseaseSerialNo > 0)
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' `FbN{bNX\e̎擾
	''' </summary>
	''' <param name="flg">
	''' `FbN{bNXONOFFtO
	''' 0:OFF
	''' -1:ON
	''' </param>
	''' <returns>`FbNtO\e</returns>
	''' <remarks>
	''' 2010/10/26 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function getCheckFlgDisp(ByVal flg As clsConst.Enum_CheckBox_Flg) As String
		Dim row() As DataRow = Nothing
		Dim iflg As Integer = flg
		Try
			Using dt As DataTable = clsConst.getCheckBox
				row = dt.Select(clsConst.CHK_CD & " = '" & iflg.ToString & "'")
				If row Is Nothing OrElse row.Length = 0 Then
					Return String.Empty
				Else
					Return row(0).Item(clsConst.CHK_NM)
				End If
			End Using
		Catch ex As Exception
			Throw
		Finally
			row = Nothing
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' SQL̎擾
	''' </summary>
	''' <param name="strSQL">SQL</param>
	''' <returns>ORDER BYύXSQL</returns>
	''' <remarks>
	''' 2011/03/25 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Private Function getSQL(ByVal strSQL As String) As String
		Try
			Return strSQL.Replace(sqlMTI_DISEASE.strORDER_BY, strOrderBy)
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' DataRow aNX쐬
	''' </summary>
	''' <param name="pRow">a DataRow</param>
	''' <returns>aNX</returns>
	''' <remarks>
	''' 2010/12/07 VK쐬@CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseaseRecFromDataRow(ByVal pRow As DataRow) As datMTI_DISEASE_OneRec
		clsSysMst.logEx(clsSysMst.logLevel.DBG, Me.GetType.Assembly.GetName.Name, Me.GetType.Name, MethodBase.GetCurrentMethod.Name, "ʊ", "aANZXNX", "DataRow aNX쐬 Start")
		Dim retDat As datMTI_DISEASE_OneRec
		Dim hType As Type = Nothing
		Dim hFieldInfos As FieldInfo() = Nothing
		Dim objValue As Object = Nothing
		Dim bSetValue As Boolean = False
		Try
			' DataRow ̏ꍇ
			If pRow Is Nothing OrElse pRow.Table.Columns.Count = 0 Then
				Return Nothing
			End If

			' CX^X
			retDat = New datMTI_DISEASE_OneRec

			' NXvf̎擾
			hType = retDat.GetType
			hFieldInfos = hType.GetFields(BindingFlags.GetField Or BindingFlags.Public Or BindingFlags.Instance Or BindingFlags.DeclaredOnly)

			' l̎擾ѐݒ
			For Each aFieldInfo As FieldInfo In hFieldInfos
				' l擾
				If Not pRow.Table.Columns.Contains(aFieldInfo.Name) Then
					Continue For
				End If
				objValue = pRow(aFieldInfo.Name)
				' lݒ
				If objValue IsNot Nothing AndAlso objValue IsNot DBNull.Value Then
					hType.InvokeMember(aFieldInfo.Name, _
					 BindingFlags.SetField Or BindingFlags.Public Or BindingFlags.Instance Or BindingFlags.DeclaredOnly, _
					 Nothing, _
					 retDat, _
					 New Object() {objValue})
					bSetValue = True
				End If
			Next
			If bSetValue Then
				Return retDat
			Else
				Return Nothing
			End If
		Catch ex As Exception
			Throw
		Finally
			hType = Nothing
			hFieldInfos = Nothing
			objValue = Nothing
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' DataRow a{̃NX쐬
	''' </summary>
	''' <param name="pRow">a DataRow</param>
	''' <returns>a{̃NX</returns>
	''' <remarks>
	''' 2010/12/07 VK쐬@CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePlusRecFromDataRow(ByVal pRow As DataRow) As datMTI_DISEASE_PLUS_OneRec
		clsSysMst.logEx(clsSysMst.logLevel.DBG, Me.GetType.Assembly.GetName.Name, Me.GetType.Name, MethodBase.GetCurrentMethod.Name, "ʊ", "aANZXNX", "DataRow a{̃NX쐬 Start")
		Dim retDat As datMTI_DISEASE_PLUS_OneRec
		Dim hType As Type = Nothing
		Dim hFieldInfos As FieldInfo() = Nothing
		Dim objValue As Object = Nothing
		Dim bSetValue As Boolean = False
		Try
			' DataRow ̏ꍇ
			If pRow Is Nothing OrElse pRow.Table.Columns.Count = 0 Then
				Return Nothing
			End If

			' CX^X
			retDat = New datMTI_DISEASE_PLUS_OneRec

			' NXvf̎擾
			hType = retDat.GetType
			hFieldInfos = hType.GetFields(BindingFlags.GetField Or BindingFlags.Public Or BindingFlags.Instance Or BindingFlags.DeclaredOnly)

			' l̎擾ѐݒ
			For Each aFieldInfo As FieldInfo In hFieldInfos
				' l擾
				If Not pRow.Table.Columns.Contains(aFieldInfo.Name) Then
					Continue For
				End If
				objValue = pRow(aFieldInfo.Name)
				' lݒ
				If objValue IsNot Nothing AndAlso objValue IsNot DBNull.Value Then
					hType.InvokeMember(aFieldInfo.Name, _
					 BindingFlags.SetField Or BindingFlags.Public Or BindingFlags.Instance Or BindingFlags.DeclaredOnly, _
					 Nothing, _
					 retDat, _
					 New Object() {objValue})
					bSetValue = True
				End If
			Next
			If bSetValue Then
				Return retDat
			Else
				Return Nothing
			End If
		Catch ex As Exception
			Throw
		Finally
			hType = Nothing
			hFieldInfos = Nothing
			objValue = Nothing
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pҕ̕a擾܂if[^NXj
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <returns>Pҕ̕aiArrayListdatMTI_DISEASE_OneRecNXj</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePatient(ByVal pPatientNo As String) As ArrayList
		Try
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				Return getDiseasePatient(db, pPatientNo)
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pҕ̕a擾܂if[^NXj
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <returns>Pҕ̕aiArrayListdatMTI_DISEASE_OneRecNXj</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePatient(ByVal db As clsDB, ByVal pPatientNo As String) As ArrayList
		Dim retData As ArrayList = Nothing
		Dim iRet As Long = 0
		Try
			retData = New ArrayList()

			'L[`FbN
			If Not chkParam(pPatientNo) Then
				Return Nothing
			End If

			db.setSQL(getSQL(sqlMTI_DISEASE.sqlSelDisease_Patient))	'SELECTݒ
			db.setParam(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
			db.setVal(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
			iRet = db.execQuery(GetType(datMTI_DISEASE_OneRec), retData)	'l擾
		Catch ex As Exception
			Throw
		End Try
		'Ԃlݒ
		Return retData
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pҕ̕a擾܂if[^e[uj
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <returns>Pҕ̕a</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePatientDa(ByVal pPatientNo As String) As DataTable
		Try
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				Return getDiseasePatientDa(db, pPatientNo)
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pҕ̕a擾܂if[^e[uj
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <returns>Pҕ̕a</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePatientDa(ByVal db As clsDB, ByVal pPatientNo As String) As DataTable
		Dim retDat As DataTable = Nothing
		Try
			retDat = New DataTable

			'SQLݒ
			db.setSQLDa(getSQL(sqlMTI_DISEASE.sqlSelDisease_Patient))	'SELECTݒ

			db.setParamDa(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
			db.setValDa(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
			db.execQueryDa(retDat)	'l擾
		Catch ex As Exception
			Throw
		End Try
		'Ԃlݒ
		Return retDat
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pމ@̕a擾܂if[^NXj
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <returns>Pމ@̕aiArrayListdatMTI_DISEASE_OneRecNXj</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseaseHsp(ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer) As ArrayList
		Try
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				Return getDiseaseHsp(db, pPatientNo, pHspHistoryNo)
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pމ@̕a擾܂if[^NXj
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <returns>Pމ@̕aiArrayListdatMTI_DISEASE_OneRecNXj</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseaseHsp(ByVal db As clsDB, ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer) As ArrayList
		Dim retData As ArrayList = Nothing
		Dim iRet As Long = 0
		Try
			retData = New ArrayList()

			'L[`FbN
			If Not chkParam(pPatientNo, pHspHistoryNo) Then
				Return Nothing
			End If

			db.setSQL(getSQL(sqlMTI_DISEASE.sqlSelDisease_Hsp))	'SELECTݒ
			db.setParam(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
			db.setParam(sqlMTI_DISEASE.prmHSP_HISTORY_NO, clsDB.Enum_dbType.dbInt)		'މ@ԍ
			db.setVal(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
			db.setVal(sqlMTI_DISEASE.prmHSP_HISTORY_NO, pHspHistoryNo, False)
			iRet = db.execQuery(GetType(datMTI_DISEASE_OneRec), retData)	'l擾
		Catch ex As Exception
			Throw
		End Try
		'Ԃlݒ
		Return retData
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pމ@̕a擾܂if[^e[uj
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <returns>Pމ@̕a</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseaseHspDa(ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer) As DataTable
		Try
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				Return getDiseaseHspDa(db, pPatientNo, pHspHistoryNo)
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pމ@̕a擾܂if[^e[uj
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <returns>Pމ@̕a</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseaseHspDa(ByVal db As clsDB, ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer) As DataTable
		Dim retDat As DataTable = Nothing
		Try
			retDat = New DataTable

			'SQLݒ
			db.setSQLDa(getSQL(sqlMTI_DISEASE.sqlSelDisease_Hsp))	'SELECTݒ

			db.setParamDa(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
			db.setParamDa(sqlMTI_DISEASE.prmHSP_HISTORY_NO, clsDB.Enum_dbType.dbInt)		'މ@ԍ
			db.setValDa(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
			db.setValDa(sqlMTI_DISEASE.prmHSP_HISTORY_NO, pHspHistoryNo, False)
			db.execQueryDa(retDat)	'l擾
		Catch ex As Exception
			Throw
		End Try
		'Ԃlݒ
		Return retDat
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pȗ𕪂̕a擾܂if[^NXj
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <returns>Pȗ𕪂̕aiArrayListdatMTI_DISEASE_OneRecNXj</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseaseCh(ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer) As ArrayList
		Try
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				Return getDiseaseCh(db, pPatientNo, pHspHistoryNo, pChNo)
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pȗ𕪂̕a擾܂if[^NXj
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <returns>Pȗ𕪂̕aiArrayListdatMTI_DISEASE_OneRecNXj</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseaseCh(ByVal db As clsDB, ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer) As ArrayList
		Dim retData As ArrayList = Nothing
		Dim iRet As Long = 0
		Try
			retData = New ArrayList()

			'L[`FbN
			If Not chkParam(pPatientNo, pHspHistoryNo, pChNo) Then
				Return Nothing
			End If

			db.setSQL(getSQL(sqlMTI_DISEASE.sqlSelDisease_Ch))	'SELECTݒ
			db.setParam(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
			db.setParam(sqlMTI_DISEASE.prmHSP_HISTORY_NO, clsDB.Enum_dbType.dbInt)		'މ@ԍ
			db.setParam(sqlMTI_DISEASE.prmCH_NO, clsDB.Enum_dbType.dbInt)				'ȗԍ
			db.setVal(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
			db.setVal(sqlMTI_DISEASE.prmHSP_HISTORY_NO, pHspHistoryNo, False)
			db.setVal(sqlMTI_DISEASE.prmCH_NO, pChNo, False)
			iRet = db.execQuery(GetType(datMTI_DISEASE_OneRec), retData)	'l擾
		Catch ex As Exception
			Throw
		End Try
		'Ԃlݒ
		Return retData
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pȗ𕪂̕a擾܂if[^e[uj
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <returns>Pȗ𕪂̕a</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseaseChDa(ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer) As DataTable
		Try
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				Return getDiseaseChDa(db, pPatientNo, pHspHistoryNo, pChNo)
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pȗ𕪂̕a擾܂if[^e[uj
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <returns>Pȗ𕪂̕a</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseaseChDa(ByVal db As clsDB, ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer) As DataTable
		Dim retDat As DataTable = Nothing
		Try
			retDat = New DataTable

			'SQLݒ
			db.setSQLDa(getSQL(sqlMTI_DISEASE.sqlSelDisease_Ch))	'SELECTݒ

			db.setParamDa(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
			db.setParamDa(sqlMTI_DISEASE.prmHSP_HISTORY_NO, clsDB.Enum_dbType.dbInt)		'މ@ԍ
			db.setParamDa(sqlMTI_DISEASE.prmCH_NO, clsDB.Enum_dbType.dbInt)				'ȗԍ
			db.setValDa(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
			db.setValDa(sqlMTI_DISEASE.prmHSP_HISTORY_NO, pHspHistoryNo, False)
			db.setValDa(sqlMTI_DISEASE.prmCH_NO, pChNo, False)
			db.execQueryDa(retDat)	'l擾
		Catch ex As Exception
			Throw
		End Try
		'Ԃlݒ
		Return retDat
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' aP擾܂if[^NXj
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <param name="pDiseaseSerialNo">aA</param>
	''' <returns>aNX</returns>
	''' <remarks>
	''' 2010/11/26 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseaseOneRec(ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer, ByVal pDiseaseSerialNo As Integer) As datMTI_DISEASE_OneRec
		Try
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				Return getDiseaseOneRec(db, pPatientNo, pHspHistoryNo, pChNo, pDiseaseSerialNo)
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' aP擾܂if[^NXj
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <param name="pDiseaseSerialNo">aA</param>
	''' <returns>aNX</returns>
	''' <remarks>
	''' 2010/11/26 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseaseOneRec(ByVal db As clsDB, ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer, ByVal pDiseaseSerialNo As Integer) As datMTI_DISEASE_OneRec
		Dim retDat As datMTI_DISEASE_OneRec = Nothing
		Dim arData As ArrayList = Nothing
		Dim iRet As Long = 0
		Try
			arData = New ArrayList()

			'L[`FbN
			If Not chkParam(pPatientNo, pHspHistoryNo, pChNo, pDiseaseSerialNo) Then
				Return Nothing
			End If

			db.setSQL(getSQL(sqlMTI_DISEASE.sqlSelDisease_OneRec))	'SELECTݒ
			db.setParam(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
			db.setParam(sqlMTI_DISEASE.prmHSP_HISTORY_NO, clsDB.Enum_dbType.dbInt)		'މ@ԍ
			db.setParam(sqlMTI_DISEASE.prmCH_NO, clsDB.Enum_dbType.dbInt)				'ȗԍ
			db.setParam(sqlMTI_DISEASE.prmDISEASE_SERIAL_NO, clsDB.Enum_dbType.dbInt)	'aA
			db.setVal(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
			db.setVal(sqlMTI_DISEASE.prmHSP_HISTORY_NO, pHspHistoryNo, False)
			db.setVal(sqlMTI_DISEASE.prmCH_NO, pChNo, False)
			db.setVal(sqlMTI_DISEASE.prmDISEASE_SERIAL_NO, pDiseaseSerialNo, False)
			iRet = db.execQuery(GetType(datMTI_DISEASE_OneRec), arData)	'l擾
			If iRet > 0 Then									   'R[h
				retDat = DirectCast(arData(0), datMTI_DISEASE_OneRec)
			Else
				retDat = Nothing
			End If
		Catch ex As Exception
			Throw
		Finally
			'
			arData = Nothing
		End Try
		'Ԃlݒ
		Return retDat
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' aP擾܂if[^e[uj
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <param name="pDiseaseSerialNo">aA</param>
	''' <returns>a</returns>
	''' <remarks>
	''' 2010/11/26 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseaseOneRecDa(ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer, ByVal pDiseaseSerialNo As Integer) As DataTable
		Try
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				Return getDiseaseOneRecDa(db, pPatientNo, pHspHistoryNo, pChNo, pDiseaseSerialNo)
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' aP擾܂if[^e[uj
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <param name="pDiseaseSerialNo">aA</param>
	''' <returns>a</returns>
	''' <remarks>
	''' 2010/11/26 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseaseOneRecDa(ByVal db As clsDB, ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer, ByVal pDiseaseSerialNo As Integer) As DataTable
		Dim retDat As DataTable = Nothing
		Try
			retDat = New DataTable

			'SQLݒ
			db.setSQLDa(getSQL(sqlMTI_DISEASE.sqlSelDisease_OneRec))

			db.setParamDa(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
			db.setParamDa(sqlMTI_DISEASE.prmHSP_HISTORY_NO, clsDB.Enum_dbType.dbInt)		'މ@ԍ
			db.setParamDa(sqlMTI_DISEASE.prmCH_NO, clsDB.Enum_dbType.dbInt)				'ȗԍ
			db.setParamDa(sqlMTI_DISEASE.prmDISEASE_SERIAL_NO, clsDB.Enum_dbType.dbInt)	'aA
			db.setValDa(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
			db.setValDa(sqlMTI_DISEASE.prmHSP_HISTORY_NO, pHspHistoryNo, False)
			db.setValDa(sqlMTI_DISEASE.prmCH_NO, pChNo, False)
			db.setValDa(sqlMTI_DISEASE.prmDISEASE_SERIAL_NO, pDiseaseSerialNo, False)

			'l擾
			db.execQueryDa(retDat)
		Catch ex As Exception
			Throw
		End Try
		'Ԃlݒ
		Return retDat
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pҕ̕a{̂擾܂if[^NXj
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <returns>Pҕ̕a{́iArrayListdatMTI_DISEASE_PLUS_OneRecNXj</returns>
	''' <remarks>
	''' 2010/11/29 VK쐬 CS)<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePlusPatient(ByVal pPatientNo As String) As ArrayList
		Try
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				Return getDiseasePlusPatient(db, pPatientNo)
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pҕ̕a{̂擾܂if[^NXj
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <returns>Pҕ̕a{́iArrayListdatMTI_DISEASE_PLUS_OneRecNXj</returns>
	''' <remarks>
	''' 2010/11/29 VK쐬 CS)<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePlusPatient(ByVal db As clsDB, ByVal pPatientNo As String) As ArrayList
		Dim retData As ArrayList = Nothing
		Dim iRet As Long = 0
		Try
			retData = New ArrayList()

			'L[`FbN
			If Not chkParam(pPatientNo) Then
				Return Nothing
			End If

			db.setSQL(getSQL(sqlMTI_DISEASE.sqlSelDisease_Plus_Patient))	'SELECTݒ
			db.setParam(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
			db.setParam(sqlMTI_DISEASE.prmCheckOff, clsDB.Enum_dbType.dbInt)				'`FbN{bNXOFFtO
			db.setParam(sqlMTI_DISEASE.prmCheckOn, clsDB.Enum_dbType.dbInt)				'`FbN{bNXONtO
			db.setParam(sqlMTI_DISEASE.prmCheckOffDisp, clsDB.Enum_dbType.dbNVarChar)		'`FbN{bNXOFF̕\
			db.setParam(sqlMTI_DISEASE.prmCheckOnDisp, clsDB.Enum_dbType.dbNVarChar)		'`FbN{bNXON̕\
			db.setVal(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
			db.setVal(sqlMTI_DISEASE.prmCheckOff, clsConst.Enum_CheckBox_Flg.CheckOff, False)
			db.setVal(sqlMTI_DISEASE.prmCheckOn, clsConst.Enum_CheckBox_Flg.CheckOn, False)
			db.setVal(sqlMTI_DISEASE.prmCheckOffDisp, getCheckFlgDisp(clsConst.Enum_CheckBox_Flg.CheckOff))
			db.setVal(sqlMTI_DISEASE.prmCheckOnDisp, getCheckFlgDisp(clsConst.Enum_CheckBox_Flg.CheckOn))
			iRet = db.execQuery(GetType(datMTI_DISEASE_PLUS_OneRec), retData)	'l擾
		Catch ex As Exception
			Throw
		End Try
		'Ԃlݒ
		Return retData
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pҕ̕a{̂擾܂if[^e[uj
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <returns>Pҕ̕a{</returns>
	''' <remarks>
	''' 2010/11/29 VK쐬 CS)<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePlusPatientDa(ByVal pPatientNo As String) As DataTable
		Try
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				Return getDiseasePlusPatientDa(db, pPatientNo)
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pҕ̕a{̂擾܂if[^e[uj
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <returns>Pҕ̕a{</returns>
	''' <remarks>
	''' 2010/11/29 VK쐬 CS)<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePlusPatientDa(ByVal db As clsDB, ByVal pPatientNo As String) As DataTable
		Dim retDat As DataTable = Nothing
		Try
			retDat = New DataTable

			'SQLݒ
			db.setSQLDa(getSQL(sqlMTI_DISEASE.sqlSelDisease_Plus_Patient))	'SELECTݒ

			db.setParamDa(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
			db.setParamDa(sqlMTI_DISEASE.prmCheckOff, clsDB.Enum_dbType.dbInt)			'`FbN{bNXOFFtO
			db.setParamDa(sqlMTI_DISEASE.prmCheckOn, clsDB.Enum_dbType.dbInt)			'`FbN{bNXONtO
			db.setParamDa(sqlMTI_DISEASE.prmCheckOffDisp, clsDB.Enum_dbType.dbNVarChar)	'`FbN{bNXOFF̕\
			db.setParamDa(sqlMTI_DISEASE.prmCheckOnDisp, clsDB.Enum_dbType.dbNVarChar)	'`FbN{bNXON̕\
			db.setValDa(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
			db.setValDa(sqlMTI_DISEASE.prmCheckOff, clsConst.Enum_CheckBox_Flg.CheckOff, False)
			db.setValDa(sqlMTI_DISEASE.prmCheckOn, clsConst.Enum_CheckBox_Flg.CheckOn, False)
			db.setValDa(sqlMTI_DISEASE.prmCheckOffDisp, getCheckFlgDisp(clsConst.Enum_CheckBox_Flg.CheckOff))
			db.setValDa(sqlMTI_DISEASE.prmCheckOnDisp, getCheckFlgDisp(clsConst.Enum_CheckBox_Flg.CheckOn))
			db.execQueryDa(retDat)	'l擾
		Catch ex As Exception
			Throw
		End Try
		'Ԃlݒ
		Return retDat
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pމ@̕a{̂擾܂if[^NXj
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <returns>Pމ@̕a{́iArrayListdatMTI_DISEASE_PLUS_OneRecNXj</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePlusHsp(ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer) As ArrayList
		Try
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				Return getDiseasePlusHsp(db, pPatientNo, pHspHistoryNo)
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pމ@̕a{̂擾܂if[^NXj
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <returns>Pމ@̕a{́iArrayListdatMTI_DISEASE_PLUS_OneRecNXj</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePlusHsp(ByVal db As clsDB, ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer) As ArrayList
		Dim retData As ArrayList = Nothing
		Dim iRet As Long = 0
		Try
			retData = New ArrayList()

			'L[`FbN
			If Not chkParam(pPatientNo, pHspHistoryNo) Then
				Return Nothing
			End If

			db.setSQL(getSQL(sqlMTI_DISEASE.sqlSelDisease_Plus_Hsp))	'SELECTݒ
			db.setParam(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
			db.setParam(sqlMTI_DISEASE.prmHSP_HISTORY_NO, clsDB.Enum_dbType.dbInt)		'މ@ԍ
			db.setParam(sqlMTI_DISEASE.prmCheckOff, clsDB.Enum_dbType.dbInt)				'`FbN{bNXOFFtO
			db.setParam(sqlMTI_DISEASE.prmCheckOn, clsDB.Enum_dbType.dbInt)				'`FbN{bNXONtO
			db.setParam(sqlMTI_DISEASE.prmCheckOffDisp, clsDB.Enum_dbType.dbNVarChar)		'`FbN{bNXOFF̕\
			db.setParam(sqlMTI_DISEASE.prmCheckOnDisp, clsDB.Enum_dbType.dbNVarChar)		'`FbN{bNXON̕\
			db.setVal(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
			db.setVal(sqlMTI_DISEASE.prmHSP_HISTORY_NO, pHspHistoryNo, False)
			db.setVal(sqlMTI_DISEASE.prmCheckOff, clsConst.Enum_CheckBox_Flg.CheckOff, False)
			db.setVal(sqlMTI_DISEASE.prmCheckOn, clsConst.Enum_CheckBox_Flg.CheckOn, False)
			db.setVal(sqlMTI_DISEASE.prmCheckOffDisp, getCheckFlgDisp(clsConst.Enum_CheckBox_Flg.CheckOff))
			db.setVal(sqlMTI_DISEASE.prmCheckOnDisp, getCheckFlgDisp(clsConst.Enum_CheckBox_Flg.CheckOn))
			iRet = db.execQuery(GetType(datMTI_DISEASE_PLUS_OneRec), retData)	'l擾
		Catch ex As Exception
			Throw
		End Try
		'Ԃlݒ
		Return retData
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pމ@̕a{̂擾܂if[^e[uj
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <returns>Pމ@̕a{</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePlusHspDa(ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer) As DataTable
		Try
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				Return getDiseasePlusHspDa(db, pPatientNo, pHspHistoryNo)
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pމ@̕a{̂擾܂if[^e[uj
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <returns>Pމ@̕a{</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePlusHspDa(ByVal db As clsDB, ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer) As DataTable
		Dim retDat As DataTable = Nothing
		Try
			retDat = New DataTable

			'SQLݒ
			db.setSQLDa(getSQL(sqlMTI_DISEASE.sqlSelDisease_Plus_Hsp))	'SELECTݒ

			db.setParamDa(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
			db.setParamDa(sqlMTI_DISEASE.prmHSP_HISTORY_NO, clsDB.Enum_dbType.dbInt)		'މ@ԍ
			db.setParamDa(sqlMTI_DISEASE.prmCheckOff, clsDB.Enum_dbType.dbInt)			'`FbN{bNXOFFtO
			db.setParamDa(sqlMTI_DISEASE.prmCheckOn, clsDB.Enum_dbType.dbInt)			'`FbN{bNXONtO
			db.setParamDa(sqlMTI_DISEASE.prmCheckOffDisp, clsDB.Enum_dbType.dbNVarChar)	'`FbN{bNXOFF̕\
			db.setParamDa(sqlMTI_DISEASE.prmCheckOnDisp, clsDB.Enum_dbType.dbNVarChar)	'`FbN{bNXON̕\
			db.setValDa(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
			db.setValDa(sqlMTI_DISEASE.prmHSP_HISTORY_NO, pHspHistoryNo, False)
			db.setValDa(sqlMTI_DISEASE.prmCheckOff, clsConst.Enum_CheckBox_Flg.CheckOff, False)
			db.setValDa(sqlMTI_DISEASE.prmCheckOn, clsConst.Enum_CheckBox_Flg.CheckOn, False)
			db.setValDa(sqlMTI_DISEASE.prmCheckOffDisp, getCheckFlgDisp(clsConst.Enum_CheckBox_Flg.CheckOff))
			db.setValDa(sqlMTI_DISEASE.prmCheckOnDisp, getCheckFlgDisp(clsConst.Enum_CheckBox_Flg.CheckOn))
			db.execQueryDa(retDat)	'l擾
		Catch ex As Exception
			Throw
		End Try
		'Ԃlݒ
		Return retDat
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pȗ𕪂̕a{̂擾܂if[^NXj
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <returns>Pȗ𕪂̕a{́iArrayListdatMTI_DISEASE_PLUS_OneRecNXj</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePlusCh(ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer) As ArrayList
		Try
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				Return getDiseasePlusCh(db, pPatientNo, pHspHistoryNo, pChNo)
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pȗ𕪂̕a{̂擾܂if[^NXj
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <returns>Pȗ𕪂̕a{́iArrayListdatMTI_DISEASE_PLUS_OneRecNXj</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePlusCh(ByVal db As clsDB, ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer) As ArrayList
		Dim retData As ArrayList = Nothing
		Dim iRet As Long = 0
		Try
			retData = New ArrayList()

			'L[`FbN
			If Not chkParam(pPatientNo, pHspHistoryNo, pChNo) Then
				Return Nothing
			End If

			db.setSQL(getSQL(sqlMTI_DISEASE.sqlSelDisease_Plus_Ch))	'SELECTݒ
			db.setParam(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
			db.setParam(sqlMTI_DISEASE.prmHSP_HISTORY_NO, clsDB.Enum_dbType.dbInt)		'މ@ԍ
			db.setParam(sqlMTI_DISEASE.prmCH_NO, clsDB.Enum_dbType.dbInt)				'ȗԍ
			db.setParam(sqlMTI_DISEASE.prmCheckOff, clsDB.Enum_dbType.dbInt)				'`FbN{bNXOFFtO
			db.setParam(sqlMTI_DISEASE.prmCheckOn, clsDB.Enum_dbType.dbInt)				'`FbN{bNXONtO
			db.setParam(sqlMTI_DISEASE.prmCheckOffDisp, clsDB.Enum_dbType.dbNVarChar)		'`FbN{bNXOFF̕\
			db.setParam(sqlMTI_DISEASE.prmCheckOnDisp, clsDB.Enum_dbType.dbNVarChar)		'`FbN{bNXON̕\
			db.setVal(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
			db.setVal(sqlMTI_DISEASE.prmHSP_HISTORY_NO, pHspHistoryNo, False)
			db.setVal(sqlMTI_DISEASE.prmCH_NO, pChNo, False)
			db.setVal(sqlMTI_DISEASE.prmCheckOff, clsConst.Enum_CheckBox_Flg.CheckOff, False)
			db.setVal(sqlMTI_DISEASE.prmCheckOn, clsConst.Enum_CheckBox_Flg.CheckOn, False)
			db.setVal(sqlMTI_DISEASE.prmCheckOffDisp, getCheckFlgDisp(clsConst.Enum_CheckBox_Flg.CheckOff))
			db.setVal(sqlMTI_DISEASE.prmCheckOnDisp, getCheckFlgDisp(clsConst.Enum_CheckBox_Flg.CheckOn))
			iRet = db.execQuery(GetType(datMTI_DISEASE_PLUS_OneRec), retData)	'l擾
		Catch ex As Exception
			Throw
		End Try
		'Ԃlݒ
		Return retData
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pȗ𕪂̕a{̂擾܂if[^e[uj
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <returns>Pȗ𕪂̕a{</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePlusChDa(ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer) As DataTable
		Try
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				Return getDiseasePlusChDa(db, pPatientNo, pHspHistoryNo, pChNo)
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pȗ𕪂̕a{̂擾܂if[^e[uj
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <returns>Pȗ𕪂̕a{</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePlusChDa(ByVal db As clsDB, ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer) As DataTable
		Dim retDat As DataTable = Nothing
		Try
			retDat = New DataTable

			'SQLݒ
			db.setSQLDa(getSQL(sqlMTI_DISEASE.sqlSelDisease_Plus_Ch))	'SELECTݒ

			db.setParamDa(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
			db.setParamDa(sqlMTI_DISEASE.prmHSP_HISTORY_NO, clsDB.Enum_dbType.dbInt)		'މ@ԍ
			db.setParamDa(sqlMTI_DISEASE.prmCH_NO, clsDB.Enum_dbType.dbInt)				'ȗԍ
			db.setParamDa(sqlMTI_DISEASE.prmCheckOff, clsDB.Enum_dbType.dbInt)			'`FbN{bNXOFFtO
			db.setParamDa(sqlMTI_DISEASE.prmCheckOn, clsDB.Enum_dbType.dbInt)			'`FbN{bNXONtO
			db.setParamDa(sqlMTI_DISEASE.prmCheckOffDisp, clsDB.Enum_dbType.dbNVarChar)	'`FbN{bNXOFF̕\
			db.setParamDa(sqlMTI_DISEASE.prmCheckOnDisp, clsDB.Enum_dbType.dbNVarChar)	'`FbN{bNXON̕\
			db.setValDa(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
			db.setValDa(sqlMTI_DISEASE.prmHSP_HISTORY_NO, pHspHistoryNo, False)
			db.setValDa(sqlMTI_DISEASE.prmCH_NO, pChNo, False)
			db.setValDa(sqlMTI_DISEASE.prmCheckOff, clsConst.Enum_CheckBox_Flg.CheckOff, False)
			db.setValDa(sqlMTI_DISEASE.prmCheckOn, clsConst.Enum_CheckBox_Flg.CheckOn, False)
			db.setValDa(sqlMTI_DISEASE.prmCheckOffDisp, getCheckFlgDisp(clsConst.Enum_CheckBox_Flg.CheckOff))
			db.setValDa(sqlMTI_DISEASE.prmCheckOnDisp, getCheckFlgDisp(clsConst.Enum_CheckBox_Flg.CheckOn))
			db.execQueryDa(retDat)	'l擾
		Catch ex As Exception
			Throw
		End Try
		'Ԃlݒ
		Return retDat
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' a{̂P擾܂if[^NXj
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <param name="pDiseaseSerialNo">aA</param>
	''' <returns>a{̃NX</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePlusOneRec(ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer, ByVal pDiseaseSerialNo As Integer) As datMTI_DISEASE_PLUS_OneRec
		Try
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				Return getDiseasePlusOneRec(db, pPatientNo, pHspHistoryNo, pChNo, pDiseaseSerialNo)
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' a{̂P擾܂if[^NXj
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <param name="pDiseaseSerialNo">aA</param>
	''' <returns>a{̃NX</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePlusOneRec(ByVal db As clsDB, ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer, ByVal pDiseaseSerialNo As Integer) As datMTI_DISEASE_PLUS_OneRec
		Dim retDat As datMTI_DISEASE_PLUS_OneRec = Nothing
		Dim arData As ArrayList = Nothing
		Dim iRet As Long = 0
		Try
			arData = New ArrayList()

			'L[`FbN
			If Not chkParam(pPatientNo, pHspHistoryNo, pChNo, pDiseaseSerialNo) Then
				Return Nothing
			End If

			db.setSQL(getSQL(sqlMTI_DISEASE.sqlSelDisease_Plus_OneRec))	'SELECTݒ
			db.setParam(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
			db.setParam(sqlMTI_DISEASE.prmHSP_HISTORY_NO, clsDB.Enum_dbType.dbInt)		'މ@ԍ
			db.setParam(sqlMTI_DISEASE.prmCH_NO, clsDB.Enum_dbType.dbInt)				'ȗԍ
			db.setParam(sqlMTI_DISEASE.prmDISEASE_SERIAL_NO, clsDB.Enum_dbType.dbInt)	'aA
			db.setParam(sqlMTI_DISEASE.prmCheckOff, clsDB.Enum_dbType.dbInt)				'`FbN{bNXOFFtO
			db.setParam(sqlMTI_DISEASE.prmCheckOn, clsDB.Enum_dbType.dbInt)				'`FbN{bNXONtO
			db.setParam(sqlMTI_DISEASE.prmCheckOffDisp, clsDB.Enum_dbType.dbNVarChar)		'`FbN{bNXOFF̕\
			db.setParam(sqlMTI_DISEASE.prmCheckOnDisp, clsDB.Enum_dbType.dbNVarChar)		'`FbN{bNXON̕\
			db.setVal(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
			db.setVal(sqlMTI_DISEASE.prmHSP_HISTORY_NO, pHspHistoryNo, False)
			db.setVal(sqlMTI_DISEASE.prmCH_NO, pChNo, False)
			db.setVal(sqlMTI_DISEASE.prmDISEASE_SERIAL_NO, pDiseaseSerialNo, False)
			db.setVal(sqlMTI_DISEASE.prmCheckOff, clsConst.Enum_CheckBox_Flg.CheckOff, False)
			db.setVal(sqlMTI_DISEASE.prmCheckOn, clsConst.Enum_CheckBox_Flg.CheckOn, False)
			db.setVal(sqlMTI_DISEASE.prmCheckOffDisp, getCheckFlgDisp(clsConst.Enum_CheckBox_Flg.CheckOff))
			db.setVal(sqlMTI_DISEASE.prmCheckOnDisp, getCheckFlgDisp(clsConst.Enum_CheckBox_Flg.CheckOn))
			iRet = db.execQuery(GetType(datMTI_DISEASE_PLUS_OneRec), arData)	'l擾
			If iRet > 0 Then									   'R[h
				retDat = DirectCast(arData(0), datMTI_DISEASE_PLUS_OneRec)
			Else
				retDat = Nothing
			End If
		Catch ex As Exception
			Throw
		Finally
			'
			arData = Nothing
		End Try
		'Ԃlݒ
		Return retDat
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' a{̂P擾܂if[^e[uj
	''' </summary>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <param name="pDiseaseSerialNo">aA</param>
	''' <returns>a{</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePlusOneRecDa(ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer, ByVal pDiseaseSerialNo As Integer) As DataTable
		Try
			Using db As clsDB = New clsDB(clsSysMst.ctlConfigData)
				Return getDiseasePlusOneRecDa(db, pPatientNo, pHspHistoryNo, pChNo, pDiseaseSerialNo)
			End Using
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' a{̂P擾܂if[^e[uj
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <param name="pDiseaseSerialNo">aA</param>
	''' <returns>a{</returns>
	''' <remarks>
	''' 2010/12/24 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function getDiseasePlusOneRecDa(ByVal db As clsDB, ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer, ByVal pDiseaseSerialNo As Integer) As DataTable
		Dim retDat As DataTable = Nothing
		Try
			retDat = New DataTable

			'SQLݒ
			db.setSQLDa(getSQL(sqlMTI_DISEASE.sqlSelDisease_Plus_OneRec))

			db.setParamDa(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
			db.setParamDa(sqlMTI_DISEASE.prmHSP_HISTORY_NO, clsDB.Enum_dbType.dbInt)		'މ@ԍ
			db.setParamDa(sqlMTI_DISEASE.prmCH_NO, clsDB.Enum_dbType.dbInt)				'ȗԍ
			db.setParamDa(sqlMTI_DISEASE.prmDISEASE_SERIAL_NO, clsDB.Enum_dbType.dbInt)	'aA
			db.setParamDa(sqlMTI_DISEASE.prmCheckOff, clsDB.Enum_dbType.dbInt)			'`FbN{bNXOFFtO
			db.setParamDa(sqlMTI_DISEASE.prmCheckOn, clsDB.Enum_dbType.dbInt)			'`FbN{bNXONtO
			db.setParamDa(sqlMTI_DISEASE.prmCheckOffDisp, clsDB.Enum_dbType.dbNVarChar)	'`FbN{bNXOFF̕\
			db.setParamDa(sqlMTI_DISEASE.prmCheckOnDisp, clsDB.Enum_dbType.dbNVarChar)	'`FbN{bNXON̕\
			db.setValDa(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
			db.setValDa(sqlMTI_DISEASE.prmHSP_HISTORY_NO, pHspHistoryNo, False)
			db.setValDa(sqlMTI_DISEASE.prmCH_NO, pChNo, False)
			db.setValDa(sqlMTI_DISEASE.prmDISEASE_SERIAL_NO, pDiseaseSerialNo, False)
			db.setValDa(sqlMTI_DISEASE.prmCheckOff, clsConst.Enum_CheckBox_Flg.CheckOff, False)
			db.setValDa(sqlMTI_DISEASE.prmCheckOn, clsConst.Enum_CheckBox_Flg.CheckOn, False)
			db.setValDa(sqlMTI_DISEASE.prmCheckOffDisp, getCheckFlgDisp(clsConst.Enum_CheckBox_Flg.CheckOff))
			db.setValDa(sqlMTI_DISEASE.prmCheckOnDisp, getCheckFlgDisp(clsConst.Enum_CheckBox_Flg.CheckOn))

			'l擾
			db.execQueryDa(retDat)
		Catch ex As Exception
			Throw
		End Try
		'Ԃlݒ
		Return retDat
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' Pҕ̕a폜܂
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <remarks>
	''' 2010/12/07 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Sub execDelDiseasePatient(ByVal db As clsDB, ByVal pPatientNo As String)
		clsSysMst.logEx(clsSysMst.logLevel.DBG, Me.GetType.Assembly.GetName.Name, Me.GetType.Name, MethodBase.GetCurrentMethod.Name, "ʊ", "aANZXNX", "Pҕ̕a폜 Start")
		Try
			'L[`FbN
			If chkParam(pPatientNo) Then
				' 폜s
				db.setSQL(sqlMTI_DISEASE.sqlDelDisease_Patient)	'DELETEݒ
				db.setParam(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
				db.setVal(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
				db.execNonQuery(False)
			End If
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' Pމ@̕a폜܂
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <remarks>
	''' 2010/12/07 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Sub execDelDiseaseHsp(ByVal db As clsDB, ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer)
		clsSysMst.logEx(clsSysMst.logLevel.DBG, Me.GetType.Assembly.GetName.Name, Me.GetType.Name, MethodBase.GetCurrentMethod.Name, "ʊ", "aANZXNX", "Pމ@̕a폜 Start")
		Try
			'L[`FbN
			If chkParam(pPatientNo, pHspHistoryNo) Then
				' 폜s
				db.setSQL(sqlMTI_DISEASE.sqlDelDisease_Hsp)	'DELETEݒ
				db.setParam(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
				db.setParam(sqlMTI_DISEASE.prmHSP_HISTORY_NO, clsDB.Enum_dbType.dbInt)		'މ@ԍ
				db.setVal(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
				db.setVal(sqlMTI_DISEASE.prmHSP_HISTORY_NO, pHspHistoryNo, False)
				db.execNonQuery(False)
			End If
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' Pȗ𕪂̕a폜܂
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <remarks>
	''' 2010/12/07 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Sub execDelDiseaseCh(ByVal db As clsDB, ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer)
		clsSysMst.logEx(clsSysMst.logLevel.DBG, Me.GetType.Assembly.GetName.Name, Me.GetType.Name, MethodBase.GetCurrentMethod.Name, "ʊ", "aANZXNX", "Pȗ𕪂̕a폜 Start")
		Try
			'L[`FbN
			If chkParam(pPatientNo, pHspHistoryNo, pChNo) Then
				' 폜s
				db.setSQL(sqlMTI_DISEASE.sqlDelDisease_Ch)	'DELETEݒ
				db.setParam(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
				db.setParam(sqlMTI_DISEASE.prmHSP_HISTORY_NO, clsDB.Enum_dbType.dbInt)		'މ@ԍ
				db.setParam(sqlMTI_DISEASE.prmCH_NO, clsDB.Enum_dbType.dbInt)				'ȗԍ
				db.setVal(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
				db.setVal(sqlMTI_DISEASE.prmHSP_HISTORY_NO, pHspHistoryNo, False)
				db.setVal(sqlMTI_DISEASE.prmCH_NO, pChNo, False)
				db.execNonQuery(False)
			End If
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' aPf[^폜܂
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pPatientNo">Ҕԍ</param>
	''' <param name="pHspHistoryNo">މ@ԍ</param>
	''' <param name="pChNo">ȗԍ</param>
	''' <param name="pDiseaseSerialNo">aA</param>
	''' <remarks>
	''' 2010/12/07 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Sub execDelDiseaseOneRec(ByVal db As clsDB, ByVal pPatientNo As String, ByVal pHspHistoryNo As Integer, ByVal pChNo As Integer, ByVal pDiseaseSerialNo As Integer)
		clsSysMst.logEx(clsSysMst.logLevel.DBG, Me.GetType.Assembly.GetName.Name, Me.GetType.Name, MethodBase.GetCurrentMethod.Name, "ʊ", "aANZXNX", "aPf[^폜 Start")
		Try
			'L[`FbN
			If chkParam(pPatientNo, pHspHistoryNo, pChNo, pDiseaseSerialNo) Then
				' 폜s
				db.setSQL(sqlMTI_DISEASE.sqlDelDisease_OneRec)	'DELETEݒ
				db.setParam(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)		'Ҕԍ
				db.setParam(sqlMTI_DISEASE.prmHSP_HISTORY_NO, clsDB.Enum_dbType.dbInt)		'މ@ԍ
				db.setParam(sqlMTI_DISEASE.prmCH_NO, clsDB.Enum_dbType.dbInt)				'ȗԍ
				db.setParam(sqlMTI_DISEASE.prmDISEASE_SERIAL_NO, clsDB.Enum_dbType.dbInt)	'aA
				db.setVal(sqlMTI_DISEASE.prmPATIENT_NO, pPatientNo)
				db.setVal(sqlMTI_DISEASE.prmHSP_HISTORY_NO, pHspHistoryNo, False)
				db.setVal(sqlMTI_DISEASE.prmCH_NO, pChNo, False)
				db.setVal(sqlMTI_DISEASE.prmDISEASE_SERIAL_NO, pDiseaseSerialNo, False)
				db.execNonQuery(False)
			End If
		Catch ex As Exception
			Throw
		End Try
	End Sub

	''' ---------------------------------------------
	''' <summary>
	''' aPf[^ǉ܂
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pDiseaseRec">aNX</param>
	''' <remarks>
	''' 2010/12/07 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function execInsDiseaseOneRec(ByVal db As clsDB, ByVal pDiseaseRec As datMTI_DISEASE_OneRec) As Integer
		Try
			Return execInsDiseaseOneRec(db, pDiseaseRec, True)
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' aPf[^ǉ܂
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pRow">a DataRow</param>
	''' <remarks>
	''' 2010/12/07 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function execInsDiseaseOneRec(ByVal db As clsDB, ByVal pRow As DataRow) As Integer
		Try
			Return execInsDiseaseOneRec(db, pRow, True)
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' aPf[^ǉ܂
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pRow">a DataRow</param>
	''' <param name="bLastUpdate">ŏIXV̕ύX</param>
	''' <remarks>
	''' 2010/12/07 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function execInsDiseaseOneRec(ByVal db As clsDB, ByVal pRow As DataRow, ByVal bLastUpdate As Boolean) As Integer
		Dim pDiseaseRec As datMTI_DISEASE_OneRec = Nothing
		Try
			pDiseaseRec = getDiseaseRecFromDataRow(pRow)
			Return execInsDiseaseOneRec(db, pDiseaseRec, bLastUpdate)
		Catch ex As Exception
			Throw
		Finally
			pDiseaseRec = Nothing
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' aPf[^ǉ܂
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pDiseasePlusRec">a{̃NX</param>
	''' <remarks>
	''' 2010/12/07 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function execInsDiseaseOneRec(ByVal db As clsDB, ByVal pDiseasePlusRec As datMTI_DISEASE_PLUS_OneRec) As Integer
		Try
			Return execInsDiseaseOneRec(db, pDiseasePlusRec, True)
		Catch ex As Exception
			Throw
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' aPf[^ǉ܂
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pDiseasePlusRec">a{̃NX</param>
	''' <param name="bLastUpdate">ŏIXV̕ύX</param>
	''' <remarks>
	''' 2010/12/07 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function execInsDiseaseOneRec(ByVal db As clsDB, ByVal pDiseasePlusRec As datMTI_DISEASE_PLUS_OneRec, ByVal bLastUpdate As Boolean) As Integer
		Dim pDiseaseRec As datMTI_DISEASE_OneRec = Nothing
		Try
			If pDiseasePlusRec IsNot Nothing Then
				pDiseaseRec = pDiseasePlusRec.OrgCopy
			End If
			Return execInsDiseaseOneRec(db, pDiseaseRec, bLastUpdate)
		Catch ex As Exception
			Throw
		Finally
			pDiseaseRec = Nothing
		End Try
	End Function

	''' ---------------------------------------------
	''' <summary>
	''' aPf[^ǉ܂
	''' </summary>
	''' <param name="db">caNX</param>
	''' <param name="pDiseaseRec">aNX</param>
	''' <param name="bLastUpdate">ŏIXV̕ύX</param>
	''' <remarks>
	''' 2010/12/07 VK쐬 CS)a<BR/>
	''' </remarks>
	''' ---------------------------------------------
	Public Function execInsDiseaseOneRec(ByVal db As clsDB, ByVal pDiseaseRec As datMTI_DISEASE_OneRec, ByVal bLastUpdate As Boolean) As Integer
		clsSysMst.logEx(clsSysMst.logLevel.DBG, Me.GetType.Assembly.GetName.Name, Me.GetType.Name, MethodBase.GetCurrentMethod.Name, "ʊ", "aANZXNX", "aPf[^ǉ Start")
		Try
			If pDiseaseRec Is Nothing Then
				Return 0
			End If
			' INSERTݒ
			db.setSQL(sqlMTI_DISEASE.sqlInsDisease_OneRec)
			' Ҕԍ
			db.setParam(sqlMTI_DISEASE.prmPATIENT_NO, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmPATIENT_NO, pDiseaseRec.PATIENT_NO)
			' މ@ԍ
			db.setParam(sqlMTI_DISEASE.prmHSP_HISTORY_NO, clsDB.Enum_dbType.dbInt)
			db.setVal(sqlMTI_DISEASE.prmHSP_HISTORY_NO, pDiseaseRec.HSP_HISTORY_NO, False)
			' ȗԍ
			db.setParam(sqlMTI_DISEASE.prmCH_NO, clsDB.Enum_dbType.dbInt)
			db.setVal(sqlMTI_DISEASE.prmCH_NO, pDiseaseRec.CH_NO, False)
			' aA
			db.setParam(sqlMTI_DISEASE.prmDISEASE_SERIAL_NO, clsDB.Enum_dbType.dbInt)
			db.setVal(sqlMTI_DISEASE.prmDISEASE_SERIAL_NO, pDiseaseRec.DISEASE_SERIAL_NO, False)
			' @_@atO
			db.setParam(sqlMTI_DISEASE.prmHSP_CHANCE_DISEASE_FLG, clsDB.Enum_dbType.dbInt)
			db.setVal(sqlMTI_DISEASE.prmHSP_CHANCE_DISEASE_FLG, pDiseaseRec.HSP_CHANCE_DISEASE_FLG, False)
			' ÎatOP
			db.setParam(sqlMTI_DISEASE.prmDISEASE_MED_RES_FLG1, clsDB.Enum_dbType.dbInt)
			db.setVal(sqlMTI_DISEASE.prmDISEASE_MED_RES_FLG1, pDiseaseRec.DISEASE_MED_RES_FLG1, False)
			' ÎatOQ
			db.setParam(sqlMTI_DISEASE.prmDISEASE_MED_RES_FLG2, clsDB.Enum_dbType.dbInt)
			db.setVal(sqlMTI_DISEASE.prmDISEASE_MED_RES_FLG2, pDiseaseRec.DISEASE_MED_RES_FLG2, False)
			' atO
			db.setParam(sqlMTI_DISEASE.prmDEATH_DISEASE_FLG, clsDB.Enum_dbType.dbInt)
			db.setVal(sqlMTI_DISEASE.prmDEATH_DISEASE_FLG, pDiseaseRec.DEATH_DISEASE_FLG, False)
			' a敪R[h
			db.setParam(sqlMTI_DISEASE.prmDISEASE_DIV, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmDISEASE_DIV, pDiseaseRec.DISEASE_DIV)
			' a
			db.setParam(sqlMTI_DISEASE.prmDISEASE, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmDISEASE, pDiseaseRec.DISEASE)
			' ff
			db.setParam(sqlMTI_DISEASE.prmDIAGNOSIS_DT, clsDB.Enum_dbType.dbDateTime)
			db.setVal(sqlMTI_DISEASE.prmDIAGNOSIS_DT, pDiseaseRec.DIAGNOSIS_DT)
			' Ǔ
			db.setParam(sqlMTI_DISEASE.prmONSET_DT, clsDB.Enum_dbType.dbDateTime)
			db.setVal(sqlMTI_DISEASE.prmONSET_DT, pDiseaseRec.ONSET_DT)
			' I
			db.setParam(sqlMTI_DISEASE.prmEND_DT, clsDB.Enum_dbType.dbDateTime)
			db.setVal(sqlMTI_DISEASE.prmEND_DT, pDiseaseRec.END_DT)
			' hbcPOR[h
			db.setParam(sqlMTI_DISEASE.prmICD10_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmICD10_CD, pDiseaseRec.ICD10_CD)
			' a]AR[h
			db.setParam(sqlMTI_DISEASE.prmDISEASE_OUTCOME_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmDISEASE_OUTCOME_CD, pDiseaseRec.DISEASE_OUTCOME_CD)
			' ރR[h
			db.setParam(sqlMTI_DISEASE.prmPLURAL_GRP_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmPLURAL_GRP_CD, pDiseaseRec.PLURAL_GRP_CD)
			' lP
			db.setParam(sqlMTI_DISEASE.prmREMARKS1, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmREMARKS1, pDiseaseRec.REMARKS1)
			' lQ
			db.setParam(sqlMTI_DISEASE.prmREMARKS2, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmREMARKS2, pDiseaseRec.REMARKS2)
			' @aR[h
			db.setParam(sqlMTI_DISEASE.prmHSP_DISEASE_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmHSP_DISEASE_CD, pDiseaseRec.HSP_DISEASE_CD)
			' hbcXR[h
			db.setParam(sqlMTI_DISEASE.prmICD9_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmICD9_CD, pDiseaseRec.ICD9_CD)
			' OރR[h
			db.setParam(sqlMTI_DISEASE.prmCAUSE_GRP_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmCAUSE_GRP_CD, pDiseaseRec.CAUSE_GRP_CD)
			' OtO
			db.setParam(sqlMTI_DISEASE.prmDEATH_CAUSE_FLG, clsDB.Enum_dbType.dbInt)
			db.setVal(sqlMTI_DISEASE.prmDEATH_CAUSE_FLG, pDiseaseRec.DEATH_CAUSE_FLG, False)
			' W{ԍ
			db.setParam(sqlMTI_DISEASE.prmSPECIMEN_NO, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmSPECIMEN_NO, pDiseaseRec.SPECIMEN_NO)
			' hbcnP
			db.setParam(sqlMTI_DISEASE.prmICDO_FORM_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmICDO_FORM_CD, pDiseaseRec.ICDO_FORM_CD)
			' hbcnPQ
			db.setParam(sqlMTI_DISEASE.prmICDO_FORM_6DIGS_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmICDO_FORM_6DIGS_CD, pDiseaseRec.ICDO_FORM_6DIGS_CD)
			' 啪ރR[h
			db.setParam(sqlMTI_DISEASE.prmL_GRP_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmL_GRP_CD, pDiseaseRec.L_GRP_CD)
			' ރR[h
			db.setParam(sqlMTI_DISEASE.prmM_GRP_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmM_GRP_CD, pDiseaseRec.M_GRP_CD)
			' ރR[h
			db.setParam(sqlMTI_DISEASE.prmS_GRP_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmS_GRP_CD, pDiseaseRec.S_GRP_CD)
			' ROOރR[h
			db.setParam(sqlMTI_DISEASE.prmGRP300_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmGRP300_CD, pDiseaseRec.GRP300_CD)
			' ރR[h
			db.setParam(sqlMTI_DISEASE.prmA_GRP_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmA_GRP_CD, pDiseaseRec.A_GRP_CD)
			' ރR[h
			db.setParam(sqlMTI_DISEASE.prmB_GRP_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmB_GRP_CD, pDiseaseRec.B_GRP_CD)
			' ރR[h
			db.setParam(sqlMTI_DISEASE.prmC_GRP_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmC_GRP_CD, pDiseaseRec.C_GRP_CD)
			' ރR[h
			db.setParam(sqlMTI_DISEASE.prmDEATH_GRP_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmDEATH_GRP_CD, pDiseaseRec.DEATH_GRP_CD)
			' O啪ރR[h
			db.setParam(sqlMTI_DISEASE.prmCAUSE_L_GRP_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmCAUSE_L_GRP_CD, pDiseaseRec.CAUSE_L_GRP_CD)
			' OރR[h
			db.setParam(sqlMTI_DISEASE.prmCAUSE_DEATH_GRP_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmCAUSE_DEATH_GRP_CD, pDiseaseRec.CAUSE_DEATH_GRP_CD)
			' OSוރp^[
			db.setParam(sqlMTI_DISEASE.prmCAUSE_4GRP_PTN, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmCAUSE_4GRP_PTN, pDiseaseRec.CAUSE_4GRP_PTN)
			' OSڃR[h
			db.setParam(sqlMTI_DISEASE.prmCAUSE_4DIGS_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmCAUSE_4DIGS_CD, pDiseaseRec.CAUSE_4DIGS_CD)
			' hbcX啪ރR[h
			db.setParam(sqlMTI_DISEASE.prmICD9_L_GRP_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmICD9_L_GRP_CD, pDiseaseRec.ICD9_L_GRP_CD)
			' hbcXރR[h
			db.setParam(sqlMTI_DISEASE.prmICD9_M_GRP_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmICD9_M_GRP_CD, pDiseaseRec.ICD9_M_GRP_CD)
			' hbcX⏕ރR[hP
			db.setParam(sqlMTI_DISEASE.prmICD9_ASST_GRP1_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmICD9_ASST_GRP1_CD, pDiseaseRec.ICD9_ASST_GRP1_CD)
			' hbcX⏕ރR[hQ
			db.setParam(sqlMTI_DISEASE.prmICD9_ASST_GRP2_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmICD9_ASST_GRP2_CD, pDiseaseRec.ICD9_ASST_GRP2_CD)
			' hbcX⏕ރR[hR
			db.setParam(sqlMTI_DISEASE.prmICD9_ASST_GRP3_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmICD9_ASST_GRP3_CD, pDiseaseRec.ICD9_ASST_GRP3_CD)
			' ǗL
			db.setParam(sqlMTI_DISEASE.prmDISEASE_MNG_DIV, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmDISEASE_MNG_DIV, pDiseaseRec.DISEASE_MNG_DIV)
			' Ǘԍ
			db.setParam(sqlMTI_DISEASE.prmDISEASE_MNG_NO, clsDB.Enum_dbType.dbInt)
			db.setVal(sqlMTI_DISEASE.prmDISEASE_MNG_NO, pDiseaseRec.DISEASE_MNG_NO, False)
			' @ǖtO
			db.setParam(sqlMTI_DISEASE.prmHSP_DISEASE_FLG, clsDB.Enum_dbType.dbInt)
			db.setVal(sqlMTI_DISEASE.prmHSP_DISEASE_FLG, pDiseaseRec.HSP_DISEASE_FLG, False)
			' @㔭ǎtO
			db.setParam(sqlMTI_DISEASE.prmAFTER_HSP_DISEASE_FLG, clsDB.Enum_dbType.dbInt)
			db.setVal(sqlMTI_DISEASE.prmAFTER_HSP_DISEASE_FLG, pDiseaseRec.AFTER_HSP_DISEASE_FLG, False)
			' o^󋵃R[h
			db.setParam(sqlMTI_DISEASE.prmCNR_REG_STATUS_CD, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmCNR_REG_STATUS_CD, pDiseaseRec.CNR_REG_STATUS_CD)
			' o^o
			db.setParam(sqlMTI_DISEASE.prmCNR_REG_EXTRACT_DT, clsDB.Enum_dbType.dbDateTime)
			db.setVal(sqlMTI_DISEASE.prmCNR_REG_EXTRACT_DT, pDiseaseRec.CNR_REG_EXTRACT_DT)
			' hbcnPǗL
			db.setParam(sqlMTI_DISEASE.prmICDO_MNG_DIV, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmICDO_MNG_DIV, pDiseaseRec.ICDO_MNG_DIV)
			' hbcnPǗԍ
			db.setParam(sqlMTI_DISEASE.prmICDO_MNG_NO, clsDB.Enum_dbType.dbInt)
			db.setVal(sqlMTI_DISEASE.prmICDO_MNG_NO, pDiseaseRec.ICDO_MNG_NO, False)
			' hbcnP`Ԗ
			db.setParam(sqlMTI_DISEASE.prmICDO_FORM_NM, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmICDO_FORM_NM, pDiseaseRec.ICDO_FORM_NM)
			' ڎatO
			db.setParam(sqlMTI_DISEASE.prmDIRECT_DEATH_DISEASE_FLG, clsDB.Enum_dbType.dbInt)
			db.setVal(sqlMTI_DISEASE.prmDIRECT_DEATH_DISEASE_FLG, pDiseaseRec.DIRECT_DEATH_DISEASE_FLG, False)
			' ڎOtO
			db.setParam(sqlMTI_DISEASE.prmDIRECT_DEATH_CAUSE_FLG_V3, clsDB.Enum_dbType.dbInt)
			db.setVal(sqlMTI_DISEASE.prmDIRECT_DEATH_CAUSE_FLG_V3, pDiseaseRec.DIRECT_DEATH_CAUSE_FLG_V3, False)
			' Oޖ
			db.setParam(sqlMTI_DISEASE.prmCAUSE_GRP_NM, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmCAUSE_GRP_NM, pDiseaseRec.CAUSE_GRP_NM)
			' OSוޖ
			db.setParam(sqlMTI_DISEASE.prmCAUSE_4GRP_NM, clsDB.Enum_dbType.dbNVarChar)
			db.setVal(sqlMTI_DISEASE.prmCAUSE_4GRP_NM, pDiseaseRec.CAUSE_4GRP_NM)
			' f[^捞
			db.setParam(sqlMTI_DISEASE.prmDATA_CAPTURE_DT, clsDB.Enum_dbType.dbDateTime)
			db.setVal(sqlMTI_DISEASE.prmDATA_CAPTURE_DT, pDiseaseRec.DATA_CAPTURE_DT)
			' VKo^
			db.setParam(sqlMTI_DISEASE.prmNEW_REG_DT, clsDB.Enum_dbType.dbDateTime)
			db.setVal(sqlMTI_DISEASE.prmNEW_REG_DT, pDiseaseRec.NEW_REG_DT)
			' XV҃R[h
			db.setParam(sqlMTI_DISEASE.prmLASTUPDUSER_CD, clsDB.Enum_dbType.dbNVarChar)
			If bLastUpdate OrElse String.IsNullOrEmpty(pDiseaseRec.LASTUPDUSER_CD) Then
				' XV҃R[hOChc
				db.setVal(sqlMTI_DISEASE.prmLASTUPDUSER_CD, clsSysMst.getLoginId)
			Else
				db.setVal(sqlMTI_DISEASE.prmLASTUPDUSER_CD, pDiseaseRec.LASTUPDUSER_CD)
			End If
			' ŏIXV
			db.setParam(sqlMTI_DISEASE.prmLASTUPD_DT, clsDB.Enum_dbType.dbDateTime)
			If bLastUpdate OrElse pDiseaseRec.LASTUPD_DT.Equals(Nothing) Then
				' ŏIXVVXet
				db.setVal(sqlMTI_DISEASE.prmLASTUPD_DT, Now())
			Else
				db.setVal(sqlMTI_DISEASE.prmLASTUPD_DT, pDiseaseRec.LASTUPD_DT)
			End If
			' ǉs
			Return db.execNonQuery(False)
		Catch ex As Exception
			Throw
		End Try
	End Function
End Class
