﻿''' ---------------------------------------------
''' <summary>
''' 明細一括作成マスタデータクラス　新規作成（修正番号：V4-14030）
''' </summary>
''' <remarks>
''' Copyright 2013 FUJITSU SYSTEMS WEST LIMITED All rights reserved.<BR/>
''' FUJITSU SYSTEMS WEST LIMITED CONFIDENTIAL<BR/>
''' </remarks>
''' ---------------------------------------------
Public NotInheritable Class datLTM_MNGITEM_DEFINITION_OneRec
	Public MNGITEM_CD As String = Nothing								'管理物コード
	Public PRE_CD As String = Nothing									'作成元
	Public UNIT_CD As String = Nothing									'管理単位
	Public DATATYPE_CD As String = Nothing								'データ種別
	Public COPYSTOP_FLG As Integer = Nothing							'複写停止フラグ
	Public IMPSTOP_FLG As Integer = Nothing								'連携停止フラグ
	Public BYOREKI_FLG As String = Nothing								'病歴番号フラグ
	Public BYOREKI_NO As String = Nothing								'病歴番号
	Public DIV1_FLG As String = Nothing									'区分１フラグ
	Public DIV1_CD As String = Nothing									'区分１コード
	Public DIV2_FLG As String = Nothing									'区分２フラグ
	Public DIV2_CD As String = Nothing									'区分２コード
	Public FIRSTRECEIVING_FLG As String = Nothing						'初回受領日フラグ
	Public FIRSTRECEIVING_DT As String = Nothing						'初回受領日
	Public RECIPIENT_FLG As String = Nothing							'受領者フラグ
	Public RECIPIENT_CD As String = Nothing								'受領者コード
	Public KEEPLCT_CD As String = Nothing								'保管場所コード
	Public MNGSTATUS_CD As String = Nothing								'管理状況コード
	Public REMARKS_FLG As String = Nothing								'備考フラグ
	Public REMARKS As String = Nothing									'備考
	Public DATE1_FLG As String = Nothing								'日付１フラグ
	Public DATE1 As String = Nothing									'日付１
	Public DATE2_FLG As String = Nothing								'日付２フラグ
	Public DATE2 As String = Nothing									'日付２
	Public DOCTOR_FLG As String = Nothing								'医師フラグ
	Public DOCTOR_CD As String = Nothing								'医師コード
	Public MNGITEMCMB1_FLG As String = Nothing							'管理物コンボ１フラグ
	Public MNGITEMCMB1 As String = Nothing								'管理物コンボ１
	Public MNGITEMCMB2_FLG As String = Nothing							'管理物コンボ２フラグ
	Public MNGITEMCMB2 As String = Nothing								'管理物コンボ２
	Public MNGITEMTEXT1_FLG As String = Nothing							'管理物テキスト１フラグ
	Public MNGITEMTEXT1 As String = Nothing								'管理物テキスト１
	Public MNGITEMTEXT2_FLG As String = Nothing							'管理物テキスト２フラグ
	Public MNGITEMTEXT2 As String = Nothing								'管理物テキスト２
	Public MNGITEMCHK1_FLG As String = Nothing							'管理物チェック１フラグ
	Public MNGITEMCHK1 As Integer = Nothing								'管理物チェック１
	Public MNGITEMCHK2_FLG As String = Nothing							'管理物チェック２フラグ
	Public MNGITEMCHK2 As Integer = Nothing								'管理物チェック２
	Public MNGITEMCHK3_FLG As String = Nothing							'管理物チェック３フラグ
	Public MNGITEMCHK3 As Integer = Nothing								'管理物チェック３
	Public MNGITEMCHK4_FLG As String = Nothing							'管理物チェック４フラグ
	Public MNGITEMCHK4 As Integer = Nothing								'管理物チェック４
	Public LASTUPDUSER_CD As String = Nothing							'更新者コード
	Public LASTUPD_DT As String = Nothing								'更新日
End Class

''' ---------------------------------------------
''' <summary>
''' 明細一括作成マスタＳＱＬクラス
''' </summary>
''' <remarks>
''' Copyright 2013 FUJITSU SYSTEMS WEST LIMITED All rights reserved.<BR/>
''' FUJITSU SYSTEMS WEST LIMITED CONFIDENTIAL<BR/>
''' </remarks>
''' ---------------------------------------------
Public Class sqlLTM_MNGITEM_DEFINITION

	Public Const itmMNGITEM_CD As String = "MNGITEM_CD"						'管理物コード
	Public Const itmPRE_CD As String = "PRE_CD"								'作成元
	Public Const itmUNIT_CD As String = "UNIT_CD"							'管理単位
	Public Const itmDATATYPE_CD As String = "DATATYPE_CD"					'データ種別
	Public Const itmCOPYSTOP_FLG As String = "COPYSTOP_FLG"					'複写停止フラグ
	Public Const itmIMPSTOP_FLG As String = "IMPSTOP_FLG"					'連携停止フラグ
	Public Const itmBYOREKI_FLG As String = "BYOREKI_FLG"					'病歴番号フラグ
	Public Const itmBYOREKI_NO As String = "BYOREKI_NO"						'病歴番号
	Public Const itmDIV1_FLG As String = "DIV1_FLG"							'区分１フラグ
	Public Const itmDIV1_CD As String = "DIV1_CD"							'区分１コード
	Public Const itmDIV2_FLG As String = "DIV2_FLG"							'区分２フラグ
	Public Const itmDIV2_CD As String = "DIV2_CD"							'区分２コード
	Public Const itmFIRSTRECEIVING_FLG As String = "FIRSTRECEIVING_FLG"		'初回受領日フラグ
	Public Const itmFIRSTRECEIVING_DT As String = "FIRSTRECEIVING_DT"		'初回受領日
	Public Const itmRECIPIENT_FLG As String = "RECIPIENT_FLG"				'受領者フラグ
	Public Const itmRECIPIENT_CD As String = "RECIPIENT_CD"					'受領者コード
	Public Const itmKEEPLCT_CD As String = "KEEPLCT_CD"						'保管場所コード
	Public Const itmMNGSTATUS_CD As String = "MNGSTATUS_CD"					'管理状況コード
	Public Const itmREMARKS_FLG As String = "REMARKS_FLG"					'備考フラグ
	Public Const itmREMARKS As String = "REMARKS"							'備考
	Public Const itmDATE1_FLG As String = "DATE1_FLG"						'日付１フラグ
	Public Const itmDATE1 As String = "DATE1"								'日付１
	Public Const itmDATE2_FLG As String = "DATE2_FLG"						'日付２フラグ
	Public Const itmDATE2 As String = "DATE2"								'日付２
	Public Const itmDOCTOR_FLG As String = "DOCTOR_FLG"						'医師フラグ
	Public Const itmDOCTOR_CD As String = "DOCTOR_CD"						'医師コード
	Public Const itmMNGITEMCMB1_FLG As String = "MNGITEMCMB1_FLG"			'管理物コンボ１フラグ
	Public Const itmMNGITEMCMB1 As String = "MNGITEMCMB1"					'管理物コンボ１
	Public Const itmMNGITEMCMB2_FLG As String = "MNGITEMCMB2_FLG"			'管理物コンボ２フラグ
	Public Const itmMNGITEMCMB2 As String = "MNGITEMCMB2"					'管理物コンボ２
	Public Const itmMNGITEMTEXT1_FLG As String = "MNGITEMTEXT1_FLG"			'管理物テキスト１フラグ
	Public Const itmMNGITEMTEXT1 As String = "MNGITEMTEXT1"					'管理物テキスト１
	Public Const itmMNGITEMTEXT2_FLG As String = "MNGITEMTEXT2_FLG"			'管理物テキスト２フラグ
	Public Const itmMNGITEMTEXT2 As String = "MNGITEMTEXT2"					'管理物テキスト２
	Public Const itmMNGITEMCHK1_FLG As String = "MNGITEMCHK1_FLG"			'管理物チェック１フラグ
	Public Const itmMNGITEMCHK1 As String = "MNGITEMCHK1"					'管理物チェック１
	Public Const itmMNGITEMCHK2_FLG As String = "MNGITEMCHK2_FLG"			'管理物チェック２フラグ
	Public Const itmMNGITEMCHK2 As String = "MNGITEMCHK2"					'管理物チェック２
	Public Const itmMNGITEMCHK3_FLG As String = "MNGITEMCHK3_FLG"			'管理物チェック３フラグ
	Public Const itmMNGITEMCHK3 As String = "MNGITEMCHK3"					'管理物チェック３
	Public Const itmMNGITEMCHK4_FLG As String = "MNGITEMCHK4_FLG"			'管理物チェック４フラグ
	Public Const itmMNGITEMCHK4 As String = "MNGITEMCHK4"					'管理物チェック４
	Public Const itmLASTUPDUSER_CD As String = "LASTUPDUSER_CD"				'更新者コード
	Public Const itmLASTUPD_DT As String = "LASTUPD_DT"						'更新日

	'ＣＳＶファイル項目名
	Public Const CSV_DATA_TYPE As String = "DATA_TYPE"						'データ種別
	Public Const CSV_BYOREKI_NO As String = "BYOREKI_NO"					'病歴番号
	Public Const CSV_DEPT_CD As String = "DEPT_CD"							'診療科コード
	Public Const CSV_HSP_DT As String = "HSP_DT"							'入院日（開始日）
	Public Const CSV_OUT_HSP_DT As String = "OUT_HSP_DT"					'退院日（終了日）
	Public Const CSV_DOCTOR_CD As String = "DOCTOR_CD"						'医師コード
	Public Const CSV_TO_DEPT_DOCTOR_CD As String = "TO_DEPT_DOCTOR_CD"		'転科先医師コード
	Public Const CSV_TO_DEPT_BYOREKI_NO As String = "TO_DEPT_BYOREKI_NO"	'転科先病歴番号

	Public Const CSV_DATA_TYPE_HSP As String = "A"							'入院
	Public Const CSV_DATA_TYPE_OUT_HSP As String = "B"						'退院
	Public Const CSV_DATA_TYPE_MOVE As String = "C"							'移動

	''' <summary>
	''' LTM_明細一括作成　取得
	''' </summary>
	''' <remarks></remarks>
	Public Const sqlSel_LTM_MNGITEM_ALL As String =
	" SELECT " _
	& " 0 AS SELECTED," _
	& " MI.MNGITEM_CD," _
	& " MI.MNGITEM_NM," _
	& " 0 AS ALL_COUNT," _
	& " 0 AS NORMAL_COUNT," _
	& " 0 AS ERROR_COUNT," _
	& " 0 AS SLIGHT_COUNT," _
	& " MD.PRE_CD," _
	& " MD.UNIT_CD," _
	& " MD.DATATYPE_CD," _
	& " MD.COPYSTOP_FLG," _
	& " MD.IMPSTOP_FLG," _
	& " MD.BYOREKI_FLG," _
	& " MD.BYOREKI_NO," _
	& " MD.DIV1_FLG," _
	& " MD.DIV1_CD," _
	& " MD.DIV2_FLG," _
	& " MD.DIV2_CD," _
	& " MD.FIRSTRECEIVING_FLG," _
	& " MD.FIRSTRECEIVING_DT," _
	& " MD.RECIPIENT_FLG," _
	& " MD.RECIPIENT_CD," _
	& " MD.KEEPLCT_CD," _
	& " MD.MNGSTATUS_CD," _
	& " MD.REMARKS_FLG," _
	& " MD.REMARKS," _
	& " MD.DATE1_FLG," _
	& " MD.DATE1," _
	& " MD.DATE2_FLG," _
	& " MD.DATE2," _
	& " MD.DOCTOR_FLG," _
	& " MD.DOCTOR_CD," _
	& " MD.MNGITEMCMB1_FLG," _
	& " MD.MNGITEMCMB1," _
	& " MD.MNGITEMCMB2_FLG," _
	& " MD.MNGITEMCMB2," _
	& " MD.MNGITEMTEXT1_FLG," _
	& " MD.MNGITEMTEXT1," _
	& " MD.MNGITEMTEXT2_FLG," _
	& " MD.MNGITEMTEXT2," _
	& " MD.MNGITEMCHK1_FLG," _
	& " MD.MNGITEMCHK1," _
	& " MD.MNGITEMCHK2_FLG," _
	& " MD.MNGITEMCHK2," _
	& " MD.MNGITEMCHK3_FLG," _
	& " MD.MNGITEMCHK3," _
	& " MD.MNGITEMCHK4_FLG," _
	& " MD.MNGITEMCHK4," _
	& " MI.MNGITEM_RNM," _
	& " MI.DIV1TITLE," _
	& " MI.DIV1TITLE_RNM," _
	& " MI.DIV1TEXT_FLG," _
	& " MI.DIV2TITLE," _
	& " MI.DIV2TITLE_RNM," _
	& " MI.DIV2TEXT_FLG," _
	& " MI.DATE1TITLE," _
	& " MI.DATE1TITLE_RNM," _
	& " MI.DATE1NEED_FLG," _
	& " MI.DATE2TITLE," _
	& " MI.DATE2TITLE_RNM," _
	& " MI.DATE2NEED_FLG," _
	& " MI.DOCTORDSP_FLG," _
	& " MI.BYOREKITITLE," _
	& " MI.BYOREKITITLE_RNM," _
	& " MI.BYOREKINONEED_FLG," _
	& " MI.MNGITEMCMB1TITLE," _
	& " MI.MNGITEMCMB1TITLE_RNM," _
	& " MI.MNGITEMCMB2TITLE," _
	& " MI.MNGITEMCMB2TITLE_RNM," _
	& " MI.MNGITEMTEXT1TITLE," _
	& " MI.MNGITEMTEXT1TITLE_RNM," _
	& " MI.MNGITEMTEXT2TITLE," _
	& " MI.MNGITEMTEXT2TITLE_RNM," _
	& " MI.MNGITEMTEXT3TITLE," _
	& " MI.MNGITEMTEXT3TITLE_RNM," _
	& " MI.MNGITEMCHK1TITLE," _
	& " MI.MNGITEMCHK1TITLE_RNM," _
	& " MI.MNGITEMCHK1TITLE1," _
	& " MI.MNGITEMCHK2TITLE," _
	& " MI.MNGITEMCHK2TITLE_RNM," _
	& " MI.MNGITEMCHK2TITLE1," _
	& " MI.MNGITEMCHK3TITLE," _
	& " MI.MNGITEMCHK3TITLE_RNM," _
	& " MI.MNGITEMCHK3TITLE1," _
	& " MI.MNGITEMCHK4TITLE," _
	& " MI.MNGITEMCHK4TITLE_RNM," _
	& " MI.MNGITEMCHK4TITLE1," _
	& " MI.COLOR_CD_R," _
	& " MI.COLOR_CD_G," _
	& " MI.COLOR_CD_B," _
	& " MI.DSPORDER," _
	& " MI.FIXED_CD1" _
	& " FROM LTM_MNGITEM MI" _
	& " LEFT JOIN LTM_MNGITEM_DEFINITION MD" _
	& "    ON MD.MNGITEM_CD = MI.MNGITEM_CD" _
	& " ORDER BY MI.DSPORDER, MI.MNGITEM_CD"

End Class
