﻿''' ---------------------------------------------
''' <summary>
''' 共通処理_救命救急情報＿データクラス
''' </summary>
''' <remarks>
''' Copyright 2010 FUJITSU SHIKOKU SYSTEMS LIMITED All rights reserved.<BR/>
''' FUJITSU SHIKOKU SYSTEMS LIMITED CONFIDENTIAL<BR/>
''' </remarks>
''' ---------------------------------------------
Public NotInheritable Class datMTI_EMERGENCY_OneRec
	Public PATIENT_NO As String = Nothing				'患者番号
	Public HSP_HISTORY_NO As Integer = Nothing			'入退院歴番号
	Public CH_NO As Integer = Nothing					'科歴番号
	Public EMERGENCY_SERIAL_NO As Integer = Nothing		'救命救急連番
	Public IN_METHOD_CD As String = Nothing				'入法コード
	Public OUT_METHOD_CD As String = Nothing			'出法コード
	Public ENTERING_DT As Date = Nothing				'入室日
	Public ENTERING_TIME As String = Nothing			'入室時刻
	Public LEAVING_DT As Date = Nothing					'退室日
	Public LEAVING_TIME As String = Nothing				'退室時刻
	Public ENTERING_AGE As Integer = Nothing			'入室時年齢
	Public ENTERING_MONTH_AGE As Integer = Nothing		'入室時月齢
	Public ENTERING_DAY_AGE As Integer = Nothing		'入室時日齢
	Public LEAVING_AGE As Integer = Nothing				'退室時年齢
	Public LEAVING_MONTH_AGE As Integer = Nothing		'退室時月齢
	Public LEAVING_DAY_AGE As Integer = Nothing			'退室時日齢
	Public IN_ROOM_DAYS As Integer = Nothing			'在室日数
	Public SEVERE_CD As String = Nothing				'重症コード
	Public MED_REQUIRED_TIME As String = Nothing		'救命所要時間
	Public LASTUPDUSER_CD As String = Nothing			'更新者コード
	Public LASTUPD_DT As Date = Nothing					'最終更新日

	''' ----------------------------------------
	''' <summary>
	''' オブジェクトコピー
	''' </summary>
	''' <returns>datMTI_EMERGENCY_OneRec(救命救急情報１レコード）</returns>
	''' <remarks>
	''' 2010/12/07 新規作成 CS)溝渕<BR/>
	''' </remarks>
	''' ----------------------------------------
	Public Function Copy() As datMTI_EMERGENCY_OneRec
		Dim ret As datMTI_EMERGENCY_OneRec = New datMTI_EMERGENCY_OneRec
		With ret
			.PATIENT_NO = Me.PATIENT_NO
			.HSP_HISTORY_NO = Me.HSP_HISTORY_NO
			.CH_NO = Me.CH_NO
			.EMERGENCY_SERIAL_NO = Me.EMERGENCY_SERIAL_NO
			.IN_METHOD_CD = Me.IN_METHOD_CD
			.OUT_METHOD_CD = Me.OUT_METHOD_CD
			.ENTERING_DT = Me.ENTERING_DT
			.ENTERING_TIME = Me.ENTERING_TIME
			.LEAVING_DT = Me.LEAVING_DT
			.LEAVING_TIME = Me.LEAVING_TIME
			.ENTERING_AGE = Me.ENTERING_AGE
			.ENTERING_MONTH_AGE = Me.ENTERING_MONTH_AGE
			.ENTERING_DAY_AGE = Me.ENTERING_DAY_AGE
			.LEAVING_AGE = Me.LEAVING_AGE
			.LEAVING_MONTH_AGE = Me.LEAVING_MONTH_AGE
			.LEAVING_DAY_AGE = Me.LEAVING_DAY_AGE
			.IN_ROOM_DAYS = Me.IN_ROOM_DAYS
			.SEVERE_CD = Me.SEVERE_CD
			.MED_REQUIRED_TIME = Me.MED_REQUIRED_TIME
			.LASTUPDUSER_CD = Me.LASTUPDUSER_CD
			.LASTUPD_DT = Me.LASTUPD_DT
		End With
		Return ret
	End Function
End Class

''' ---------------------------------------------
''' <summary>
''' 共通処理_救命救急情報＋名称＋名称＿データクラス
''' </summary>
''' ---------------------------------------------
Public NotInheritable Class datMTI_EMERGENCY_PLUS_OneRec
	' 救命救急情報
	Public PATIENT_NO As String = Nothing				'患者番号
	Public HSP_HISTORY_NO As Integer = Nothing			'入退院歴番号
	Public CH_NO As Integer = Nothing					'科歴番号
	Public EMERGENCY_SERIAL_NO As Integer = Nothing		'救命救急連番
	Public IN_METHOD_CD As String = Nothing				'入法コード
	Public OUT_METHOD_CD As String = Nothing			'出法コード
	Public ENTERING_DT As Date = Nothing				'入室日
	Public ENTERING_TIME As String = Nothing			'入室時刻
	Public LEAVING_DT As Date = Nothing					'退室日
	Public LEAVING_TIME As String = Nothing				'退室時刻
	Public ENTERING_AGE As Integer = Nothing			'入室時年齢
	Public ENTERING_MONTH_AGE As Integer = Nothing		'入室時月齢
	Public ENTERING_DAY_AGE As Integer = Nothing		'入室時日齢
	Public LEAVING_AGE As Integer = Nothing				'退室時年齢
	Public LEAVING_MONTH_AGE As Integer = Nothing		'退室時月齢
	Public LEAVING_DAY_AGE As Integer = Nothing			'退室時日齢
	Public IN_ROOM_DAYS As Integer = Nothing			'在室日数
	Public SEVERE_CD As String = Nothing				'重症コード
	Public MED_REQUIRED_TIME As String = Nothing		'救命所要時間
	Public LASTUPDUSER_CD As String = Nothing			'更新者コード
	Public LASTUPD_DT As Date = Nothing					'最終更新日
	' 救命救急入法マスタ
	Public IN_METHOD_NM As String = Nothing				'入法名
	Public IN_METHOD_RNM As String = Nothing			'入法略称名
	' 救命救急出法マスタ
	Public OUT_METHOD_NM As String = Nothing			'出法名
	Public OUT_METHOD_RNM As String = Nothing			'出法略称名
	' 救命救急重症区分マスタ
	Public SEVERE_DIV_NM As String = Nothing			'重症区分名

	''' ----------------------------------------
	''' <summary>
	''' オブジェクトコピー
	''' </summary>
	''' <returns>datMTI_EMERGENCY_PLUS_OneRec(救命救急情報＋名称１レコード）</returns>
	''' <remarks>
	''' 2010/12/07 新規作成 CS)溝渕<BR/>
	''' </remarks>
	''' ----------------------------------------
	Public Function Copy() As datMTI_EMERGENCY_PLUS_OneRec
		Dim ret As datMTI_EMERGENCY_PLUS_OneRec = New datMTI_EMERGENCY_PLUS_OneRec
		With ret
			.PATIENT_NO = Me.PATIENT_NO
			.HSP_HISTORY_NO = Me.HSP_HISTORY_NO
			.CH_NO = Me.CH_NO
			.EMERGENCY_SERIAL_NO = Me.EMERGENCY_SERIAL_NO
			.IN_METHOD_CD = Me.IN_METHOD_CD
			.OUT_METHOD_CD = Me.OUT_METHOD_CD
			.ENTERING_DT = Me.ENTERING_DT
			.ENTERING_TIME = Me.ENTERING_TIME
			.LEAVING_DT = Me.LEAVING_DT
			.LEAVING_TIME = Me.LEAVING_TIME
			.ENTERING_AGE = Me.ENTERING_AGE
			.ENTERING_MONTH_AGE = Me.ENTERING_MONTH_AGE
			.ENTERING_DAY_AGE = Me.ENTERING_DAY_AGE
			.LEAVING_AGE = Me.LEAVING_AGE
			.LEAVING_MONTH_AGE = Me.LEAVING_MONTH_AGE
			.LEAVING_DAY_AGE = Me.LEAVING_DAY_AGE
			.IN_ROOM_DAYS = Me.IN_ROOM_DAYS
			.SEVERE_CD = Me.SEVERE_CD
			.MED_REQUIRED_TIME = Me.MED_REQUIRED_TIME
			.LASTUPDUSER_CD = Me.LASTUPDUSER_CD
			.LASTUPD_DT = Me.LASTUPD_DT

			.IN_METHOD_NM = Me.IN_METHOD_NM
			.IN_METHOD_RNM = Me.IN_METHOD_RNM
			.OUT_METHOD_NM = Me.OUT_METHOD_NM
			.OUT_METHOD_RNM = Me.OUT_METHOD_RNM
			.SEVERE_DIV_NM = Me.SEVERE_DIV_NM
		End With
		Return ret
	End Function

	''' ----------------------------------------
	''' <summary>
	''' オブジェクトコピー（救命救急情報）
	''' </summary>
	''' <returns>datMTI_EMERGENCY_OneRec(救命救急情報１レコード）</returns>
	''' <remarks>
	''' 2010/12/07 新規作成 CS)溝渕<BR/>
	''' </remarks>
	''' ----------------------------------------
	Public Function OrgCopy() As datMTI_EMERGENCY_OneRec
		Dim ret As datMTI_EMERGENCY_OneRec = New datMTI_EMERGENCY_OneRec
		With ret
			.PATIENT_NO = Me.PATIENT_NO
			.HSP_HISTORY_NO = Me.HSP_HISTORY_NO
			.CH_NO = Me.CH_NO
			.EMERGENCY_SERIAL_NO = Me.EMERGENCY_SERIAL_NO
			.IN_METHOD_CD = Me.IN_METHOD_CD
			.OUT_METHOD_CD = Me.OUT_METHOD_CD
			.ENTERING_DT = Me.ENTERING_DT
			.ENTERING_TIME = Me.ENTERING_TIME
			.LEAVING_DT = Me.LEAVING_DT
			.LEAVING_TIME = Me.LEAVING_TIME
			.ENTERING_AGE = Me.ENTERING_AGE
			.ENTERING_MONTH_AGE = Me.ENTERING_MONTH_AGE
			.ENTERING_DAY_AGE = Me.ENTERING_DAY_AGE
			.LEAVING_AGE = Me.LEAVING_AGE
			.LEAVING_MONTH_AGE = Me.LEAVING_MONTH_AGE
			.LEAVING_DAY_AGE = Me.LEAVING_DAY_AGE
			.IN_ROOM_DAYS = Me.IN_ROOM_DAYS
			.SEVERE_CD = Me.SEVERE_CD
			.MED_REQUIRED_TIME = Me.MED_REQUIRED_TIME
			.LASTUPDUSER_CD = Me.LASTUPDUSER_CD
			.LASTUPD_DT = Me.LASTUPD_DT
		End With
		Return ret
	End Function
End Class

''' ---------------------------------------------
''' <summary>
''' 救命救急情報キー項目取得
''' </summary>
''' ---------------------------------------------
Public NotInheritable Class datMTI_EMERGENCY_KeyRec
	Public PATIENT_NO As String = Nothing				'患者番号
	Public HSP_HISTORY_NO As Integer = Nothing			'入退院歴番号
	Public CH_NO As Integer = Nothing					'科歴番号
	Public EMERGENCY_SERIAL_NO As Integer = Nothing		'救命救急連番
End Class

''' ---------------------------------------------
''' <summary>
''' 救命救急情報取得SQLクラス（共通クラス）
''' </summary>
''' ---------------------------------------------
Public Class sqlMTI_EMERGENCY
	Public Const prmPATIENT_NO As String = "@PATIENT_NO"					'患者番号
	Public Const prmHSP_HISTORY_NO As String = "@HSP_HISTORY_NO"			'入退院歴番号
	Public Const prmCH_NO As String = "@CH_NO"								'科歴番号
	Public Const prmEMERGENCY_SERIAL_NO As String = "@EMERGENCY_SERIAL_NO"	'救命救急連番
	Public Const prmIN_METHOD_CD As String = "@IN_METHOD_CD"				'入法コード
	Public Const prmOUT_METHOD_CD As String = "@OUT_METHOD_CD"				'出法コード
	Public Const prmENTERING_DT As String = "@ENTERING_DT"					'入室日
	Public Const prmENTERING_TIME As String = "@ENTERING_TIME"				'入室時刻
	Public Const prmLEAVING_DT As String = "@LEAVING_DT"					'退室日
	Public Const prmLEAVING_TIME As String = "@LEAVING_TIME"				'退室時刻
	Public Const prmENTERING_AGE As String = "@ENTERING_AGE"				'入室時年齢
	Public Const prmENTERING_MONTH_AGE As String = "@ENTERING_MONTH_AGE"	'入室時月齢
	Public Const prmENTERING_DAY_AGE As String = "@ENTERING_DAY_AGE"		'入室時日齢
	Public Const prmLEAVING_AGE As String = "@LEAVING_AGE"					'退室時年齢
	Public Const prmLEAVING_MONTH_AGE As String = "@LEAVING_MONTH_AGE"		'退室時月齢
	Public Const prmLEAVING_DAY_AGE As String = "@LEAVING_DAY_AGE"			'退室時日齢
	Public Const prmIN_ROOM_DAYS As String = "@IN_ROOM_DAYS"				'在室日数
	Public Const prmSEVERE_CD As String = "@SEVERE_CD"						'重症コード
	Public Const prmMED_REQUIRED_TIME As String = "@MED_REQUIRED_TIME"		'救命所要時間
	Public Const prmLASTUPDUSER_CD As String = "@LASTUPDUSER_CD"			'更新者コード
	Public Const prmLASTUPD_DT As String = "@LASTUPD_DT"					'最終更新日

	Public Const itmPATIENT_NO As String = "PATIENT_NO"						'患者番号
	Public Const itmHSP_HISTORY_NO As String = "HSP_HISTORY_NO"				'入退院歴番号
	Public Const itmCH_NO As String = "CH_NO"								'科歴番号
	Public Const itmEMERGENCY_SERIAL_NO As String = "EMERGENCY_SERIAL_NO"	'救命救急連番
	Public Const itmIN_METHOD_CD As String = "IN_METHOD_CD"					'入法コード
	Public Const itmOUT_METHOD_CD As String = "OUT_METHOD_CD"				'出法コード
	Public Const itmENTERING_DT As String = "ENTERING_DT"					'入室日
	Public Const itmENTERING_TIME As String = "ENTERING_TIME"				'入室時刻
	Public Const itmLEAVING_DT As String = "LEAVING_DT"						'退室日
	Public Const itmLEAVING_TIME As String = "LEAVING_TIME"					'退室時刻
	Public Const itmENTERING_AGE As String = "ENTERING_AGE"					'入室時年齢
	Public Const itmENTERING_MONTH_AGE As String = "ENTERING_MONTH_AGE"		'入室時月齢
	Public Const itmENTERING_DAY_AGE As String = "ENTERING_DAY_AGE"			'入室時日齢
	Public Const itmLEAVING_AGE As String = "LEAVING_AGE"					'退室時年齢
	Public Const itmLEAVING_MONTH_AGE As String = "LEAVING_MONTH_AGE"		'退室時月齢
	Public Const itmLEAVING_DAY_AGE As String = "LEAVING_DAY_AGE"			'退室時日齢
	Public Const itmIN_ROOM_DAYS As String = "IN_ROOM_DAYS"					'在室日数
	Public Const itmSEVERE_CD As String = "SEVERE_CD"						'重症コード
	Public Const itmMED_REQUIRED_TIME As String = "MED_REQUIRED_TIME"		'救命所要時間
	Public Const itmLASTUPDUSER_CD As String = "LASTUPDUSER_CD"				'更新者コード
	Public Const itmLASTUPD_DT As String = "LASTUPD_DT"						'最終更新日

	Public Const itmIN_METHOD_NM As String = "IN_METHOD_NM"					'入法名
	Public Const itmIN_METHOD_RNM As String = "IN_METHOD_RNM"				'入法略称名
	Public Const itmOUT_METHOD_NM As String = "OUT_METHOD_NM"				'出法名
	Public Const itmOUT_METHOD_RNM As String = "OUT_METHOD_RNM"				'出法略称名
	Public Const itmSEVERE_DIV_NM As String = "SEVERE_DIV_NM"				'重症区分名

	' 救命救急情報取得用SQLのSELECT句
	Private Const sqlSelect_Emergency As String = _
	 "SELECT" _
	  & " PATIENT_NO, HSP_HISTORY_NO, CH_NO, EMERGENCY_SERIAL_NO," _
	  & " IN_METHOD_CD, OUT_METHOD_CD, ENTERING_DT, ENTERING_TIME, LEAVING_DT, LEAVING_TIME," _
	  & " ENTERING_AGE, ENTERING_MONTH_AGE, ENTERING_DAY_AGE, LEAVING_AGE, LEAVING_MONTH_AGE, LEAVING_DAY_AGE," _
	  & " IN_ROOM_DAYS, SEVERE_CD, MED_REQUIRED_TIME," _
	  & " LASTUPDUSER_CD, LASTUPD_DT" _
	  & " FROM MTI_EMERGENCY"

	' 救命救急情報＋名称取得用SQLのSELECT句
	Public Const sqlSelect_Emergency_Plus As String = _
	 "SELECT" _
	  & " A.PATIENT_NO, A.HSP_HISTORY_NO, A.CH_NO, A.EMERGENCY_SERIAL_NO," _
	  & " A.IN_METHOD_CD, A.OUT_METHOD_CD, A.ENTERING_DT, A.ENTERING_TIME, A.LEAVING_DT, A.LEAVING_TIME," _
	  & " A.ENTERING_AGE, A.ENTERING_MONTH_AGE, A.ENTERING_DAY_AGE, A.LEAVING_AGE, A.LEAVING_MONTH_AGE, A.LEAVING_DAY_AGE," _
	  & " A.IN_ROOM_DAYS, A.SEVERE_CD, A.MED_REQUIRED_TIME," _
	  & " A.LASTUPDUSER_CD, A.LASTUPD_DT," _
	  & " B.IN_METHOD_NM, B.IN_METHOD_RNM," _
	  & " C.OUT_METHOD_NM, C.OUT_METHOD_RNM," _
	  & " D.SEVERE_DIV_NM" _
	  & " FROM MTI_EMERGENCY AS A" _
	  & " LEFT OUTER JOIN MTM_EMERGENCY_IN_METHOD AS B ON A.IN_METHOD_CD = B.IN_METHOD_CD" _
	  & " LEFT OUTER JOIN MTM_EMERGENCY_OUT_METHOD AS C ON A.OUT_METHOD_CD = C.OUT_METHOD_CD" _
	  & " LEFT OUTER JOIN MTM_EMERGENCY_SEVERE_DIV AS D ON A.SEVERE_CD = D.SEVERE_DIV_CD"

	' １科歴分の救命救急情報を取得
	Public Const sqlSelEmergency_Ch As String = sqlSelect_Emergency _
	  & " WHERE PATIENT_NO = " & prmPATIENT_NO _
	  & " AND HSP_HISTORY_NO = " & prmHSP_HISTORY_NO _
	  & " AND CH_NO = " & prmCH_NO _
	  & " ORDER BY EMERGENCY_SERIAL_NO"

	' 救命救急情報１データを取得
	Public Const sqlSelEmergency_OneRec As String = sqlSelect_Emergency _
	  & " WHERE PATIENT_NO = " & prmPATIENT_NO _
	  & " AND HSP_HISTORY_NO = " & prmHSP_HISTORY_NO _
	  & " AND CH_NO = " & prmCH_NO _
	  & " AND EMERGENCY_SERIAL_NO = " & prmEMERGENCY_SERIAL_NO

	' １科歴分の救命救急情報＋名称を取得
	Public Const sqlSelEmergency_Plus_Ch As String = sqlSelect_Emergency_Plus _
	  & " WHERE A.PATIENT_NO = " & prmPATIENT_NO _
	  & " AND A.HSP_HISTORY_NO = " & prmHSP_HISTORY_NO _
	  & " AND A.CH_NO = " & prmCH_NO _
	  & " ORDER BY A.EMERGENCY_SERIAL_NO"

	' 救命救急情報＋名称１データを取得
	Public Const sqlSelEmergency_Plus_OneRec As String = sqlSelect_Emergency_Plus _
	  & " WHERE A.PATIENT_NO = " & prmPATIENT_NO _
	  & " AND A.HSP_HISTORY_NO = " & prmHSP_HISTORY_NO _
	  & " AND A.CH_NO = " & prmCH_NO _
	  & " AND A.EMERGENCY_SERIAL_NO = " & prmEMERGENCY_SERIAL_NO

	' １科歴中の救命救急連番の最大値を取得
	Public Const sqlSelMaxSerialNo_Ch As String = _
	 "SELECT" _
	  & " PATIENT_NO, HSP_HISTORY_NO, CH_NO, MAX(EMERGENCY_SERIAL_NO) AS EMERGENCY_SERIAL_NO" _
	  & " FROM MTI_EMERGENCY" _
	  & " WHERE PATIENT_NO = " & prmPATIENT_NO _
	  & " AND HSP_HISTORY_NO = " & prmHSP_HISTORY_NO _
	  & " AND CH_NO = " & prmCH_NO _
	  & " GROUP BY PATIENT_NO, HSP_HISTORY_NO, CH_NO"

	' 病棟情報から救命救急情報を追加するためのキー項目を取得
	Public Const sqlSelEmergency_Key_From_Ward As String = _
	 "SELECT" _
	  & " PATIENT_NO, HSP_HISTORY_NO, CH_NO, EMERGENCY_SERIAL_NO" _
	  & " FROM MTI_EMERGENCY" _
	  & " WHERE PATIENT_NO = " & prmPATIENT_NO _
	  & " AND HSP_HISTORY_NO = " & prmHSP_HISTORY_NO _
	  & " AND CH_NO = " & prmCH_NO _
	  & " AND ENTERING_DT = " & prmENTERING_DT _
	  & " AND LEAVING_DT = " & prmLEAVING_DT _
	  & " AND SEVERE_CD = " & prmSEVERE_CD _
	  & " ORDER BY EMERGENCY_SERIAL_NO"

	' １患者分の救命救急情報を削除
	Public Const sqlDelEmergency_Patient As String = _
	 "DELETE FROM MTI_EMERGENCY" _
	  & " WHERE PATIENT_NO = " & prmPATIENT_NO

	' １入退院分の救命救急情報を削除
	Public Const sqlDelEmergency_Hsp As String = _
	 "DELETE FROM MTI_EMERGENCY" _
	  & " WHERE PATIENT_NO = " & prmPATIENT_NO _
	  & " AND HSP_HISTORY_NO = " & prmHSP_HISTORY_NO

	' １科歴分の救命救急情報を削除
	Public Const sqlDelEmergency_Ch As String = _
	 "DELETE FROM MTI_EMERGENCY" _
	  & " WHERE PATIENT_NO = " & prmPATIENT_NO _
	  & " AND HSP_HISTORY_NO = " & prmHSP_HISTORY_NO _
	  & " AND CH_NO = " & prmCH_NO

	' 救命救急情報１データを削除
	Public Const sqlDelEmergency_OneRec As String = _
	 "DELETE FROM MTI_EMERGENCY" _
	  & " WHERE PATIENT_NO = " & prmPATIENT_NO _
	  & " AND HSP_HISTORY_NO = " & prmHSP_HISTORY_NO _
	  & " AND CH_NO = " & prmCH_NO _
	  & " AND EMERGENCY_SERIAL_NO = " & prmEMERGENCY_SERIAL_NO

	' 救命救急情報１データを追加
	Public Const sqlInsEmergency_OneRec As String = _
	 "INSERT INTO MTI_EMERGENCY (" _
	  & " PATIENT_NO, HSP_HISTORY_NO, CH_NO, EMERGENCY_SERIAL_NO," _
	  & " IN_METHOD_CD, OUT_METHOD_CD, ENTERING_DT, ENTERING_TIME, LEAVING_DT, LEAVING_TIME," _
	  & " ENTERING_AGE, ENTERING_MONTH_AGE, ENTERING_DAY_AGE, LEAVING_AGE, LEAVING_MONTH_AGE, LEAVING_DAY_AGE," _
	  & " IN_ROOM_DAYS, SEVERE_CD, MED_REQUIRED_TIME," _
	  & " LASTUPDUSER_CD, LASTUPD_DT" _
	  & ") VALUES (" _
	  & prmPATIENT_NO & "," _
	  & prmHSP_HISTORY_NO & "," _
	  & prmCH_NO & "," _
	  & prmEMERGENCY_SERIAL_NO & "," _
	  & prmIN_METHOD_CD & "," _
	  & prmOUT_METHOD_CD & "," _
	  & prmENTERING_DT & "," _
	  & prmENTERING_TIME & "," _
	  & prmLEAVING_DT & "," _
	  & prmLEAVING_TIME & "," _
	  & prmENTERING_AGE & "," _
	  & prmENTERING_MONTH_AGE & "," _
	  & prmENTERING_DAY_AGE & "," _
	  & prmLEAVING_AGE & "," _
	  & prmLEAVING_MONTH_AGE & "," _
	  & prmLEAVING_DAY_AGE & "," _
	  & prmIN_ROOM_DAYS & "," _
	  & prmSEVERE_CD & "," _
	  & prmMED_REQUIRED_TIME & "," _
	  & prmLASTUPDUSER_CD & "," _
	  & prmLASTUPD_DT & ")"

End Class
