﻿Imports XCM
''' ---------------------------------------------
''' <summary>
''' 医療費項目マスタクラス
''' </summary>
''' <remarks>
''' Copyright 2010 FUJITSU SHIKOKU SYSTEMS LIMITED All rights reserved.<BR/>
''' FUJITSU SHIKOKU SYSTEMS LIMITED CONFIDENTIAL<BR/>
''' </remarks>
''' ---------------------------------------------
Public NotInheritable Class datMTM_MED_COST_ITM
	'医療費項目マスタ
	Public MED_COST_CD As String = Nothing			'医療費項目コード
	Public MED_COST_NM As String = Nothing			'医療費項目名
	Public TOTAL_OBJECT_FLG As Integer = Nothing	'合計対象フラグ
End Class

''' ---------------------------------------------
''' <summary>
''' 医療費項目マスタSQLクラス
''' </summary>
''' ---------------------------------------------
Public Class sqlMTM_MED_COST_ITM

	Public Const prmMED_COST_CD As String = "@MED_COST_CD"				'医療費項目コード
	Public Const prmMED_COST_NM As String = "@MED_COST_NM"				'医療費項目名
	Public Const prmTOTAL_OBJECT_FLG As String = "@TOTAL_OBJECT_FLG"	'合計対象フラグ
	Public Const prmLASTUPDUSER_CD As String = "@LASTUPDUSER_CD"		'更新者コード
	Public Const prmLASTUPD_DT As String = "@LASTUPD_DT"				'最終更新日

	Public Const itmMED_COST_CD As String = "MED_COST_CD"				'医療費項目コード
	Public Const itmMED_COST_NM As String = "MED_COST_NM"				'医療費項目名
	Public Const itmTOTAL_OBJECT_FLG As String = "TOTAL_OBJECT_FLG"		'合計対象フラグ
	Public Const itmLASTUPDUSER_CD As String = "LASTUPDUSER_CD"			'更新者コード
	Public Const itmLASTUPD_DT As String = "LASTUPD_DT"					'最終更新日

	'医療費項目マスタ取得用
	Public Const sqlSelMedCostItm As String = "SELECT" _
	& "  MED_COST_CD, MED_COST_NM, TOTAL_OBJECT_FLG" _
	& " FROM MTM_MED_COST_ITM" _
	& " ORDER BY MED_COST_CD"

End Class
