﻿Imports XCM
'''---------------------------------------------
''' <summary>
''' 使用者マスタ取得クラス
''' </summary>
''' <remarks>
''' Copyright 2010 FUJITSU SHIKOKU SYSTEMS LIMITED All rights reserved.<BR/>
''' FUJITSU SHIKOKU SYSTEMS LIMITED CONFIDENTIAL<BR/>
''' </remarks>
'''---------------------------------------------
Public NotInheritable Class datXTM_USER_PASS
	Public PASSWORD As String = Nothing
	Public LASTPASSWDUPD_DT As DateTime = Nothing
End Class

'''---------------------------------------------
''' <summary>
''' 使用者マスタ取得クラス（全項目）
''' </summary>
'''---------------------------------------------
Public NotInheritable Class datXTM_USER_REC

	Public USER_CD As String				'使用者コード
	Public PASSWORD As String				'パスワード
	Public ENABLED_FLG As String			'使用可能フラグ
	Public ENABLED_FLG2 As String			'使用可能フラグ２
	Public ENABLED_FLG3 As String			'使用可能フラグ３
	Public ENABLED_FLG4 As String			'使用可能フラグ４
	Public ENABLED_FLG5 As String			'使用可能フラグ５
	Public LASTPASSWDUPD_DT As Date			'前回パスワード更新日時

End Class

'''---------------------------------------------
''' <summary>
''' 使用者マスタＳＱＬクラス
''' </summary>
'''---------------------------------------------
Public Class sqlXTM_USER
	'データテーブル使用時のITEM名
	Public Const itmUSER_CD As String = "USER_CD"
	Public Const itmPASSWORD As String = "PASSWORD"
	Public Const itmENABLED_FLG As String = "ENABLED_FLG"
	Public Const itmENABLED_FLG2 As String = "ENABLED_FLG2"
	Public Const itmENABLED_FLG3 As String = "ENABLED_FLG3"
	Public Const itmENABLED_FLG4 As String = "ENABLED_FLG4"
	Public Const itmENABLED_FLG5 As String = "ENABLED_FLG5"
	Public Const itmENABLED_FLG6 As String = "ENABLED_FLG6"
	Public Const itmENABLED_FLG7 As String = "ENABLED_FLG7"
	Public Const itmENABLED_FLG8 As String = "ENABLED_FLG8"
	Public Const itmENABLED_FLG9 As String = "ENABLED_FLG9"
	Public Const itmENABLED_FLG10 As String = "ENABLED_FLG10"
	Public Const itmENABLED_FLG11 As String = "ENABLED_FLG11"
	Public Const itmENABLED_FLG12 As String = "ENABLED_FLG12"
	Public Const itmENABLED_FLG13 As String = "ENABLED_FLG13"
	Public Const itmENABLED_FLG14 As String = "ENABLED_FLG14"
	Public Const itmENABLED_FLG15 As String = "ENABLED_FLG15"
	Public Const itmENABLED_FLG16 As String = "ENABLED_FLG16"
	Public Const itmENABLED_FLG17 As String = "ENABLED_FLG17"
	Public Const itmENABLED_FLG18 As String = "ENABLED_FLG18"
	Public Const itmENABLED_FLG19 As String = "ENABLED_FLG19"
	Public Const itmENABLED_FLG20 As String = "ENABLED_FLG20"
	Public Const itmDETAIL_FLG As String = "DETAIL_FLG"

	'パラメータ
	Public Const prmUSER_CD As String = "@USER_CD"

	'権限取得ＳＱＬ
	Public Const sqlGetAuthority As String = _
	 "SELECT" _
	 & " USER_CD, PASSWORD," _
	 & " ENABLED_FLG,ENABLED_FLG2,ENABLED_FLG3,ENABLED_FLG4,ENABLED_FLG5" _
	 & " ,ENABLED_FLG6,ENABLED_FLG7,ENABLED_FLG8,ENABLED_FLG9,ENABLED_FLG10" _
	 & " ,ENABLED_FLG11,ENABLED_FLG12,ENABLED_FLG13,ENABLED_FLG14,ENABLED_FLG15" _
	 & " ,ENABLED_FLG16,ENABLED_FLG17,ENABLED_FLG18,ENABLED_FLG19,ENABLED_FLG20" _
	 & " ,DETAIL_FLG" _
	 & " FROM XTM_USER" _
	 & " WHERE USER_CD=" & prmUSER_CD

	'前回パスワード更新日時取得用
	Public Const sqlSelUser = _
	 "SELECT PASSWORD, LASTPASSWDUPD_DT FROM XTM_USER" _
	 & " WHERE" _
	 & " USER_CD=" & prmUSER_CD

	'使用者マスタ更新時1件検索用
	Public Const sqlSelUserUpd_PKey = _
	 "SELECT USER_CD,PASSWORD,ENABLED_FLG,ENABLED_FLG2,ENABLED_FLG3,ENABLED_FLG4,ENABLED_FLG5,LASTPASSWDUPD_DT" + _
	 " FROM XTM_USER " + _
	 clsSysMst.forUpdate + _
	 " WHERE USER_CD=" + prmUSER_CD

End Class
